/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
(function(){
var e,t=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/event","vs/base/common/uri","vs/nls","vs/nls!vs/server/entry","vs/base/common/network","vs/base/common/types","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/base/common/objects","fs","vs/platform/environment/common/environment","vs/base/common/cancellation","vs/platform/files/common/files","vs/base/common/map","vs/base/common/uuid","os","vs/platform/product/common/product","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/extpath","@coder/logger","vs/base/parts/ipc/common/ipc","vs/base/common/json","util","child_process","vs/platform/extensions/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/base/common/process","vs/base/common/stream","vs/base/common/labels","path","vs/base/common/errorMessage","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/base/node/zip","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.net","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogService","vs/platform/request/common/request","vs/server/node/logger","vs/server/node/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/glob","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/ipc/common/ipc.net","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/localizations/common/localizations","vs/platform/files/common/fileService","vs/platform/localizations/node/localizations","vs/platform/environment/node/environmentService","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/commonProperties","vs/server/node/util","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminal","vs/workbench/contrib/terminal/node/terminal","vs/workbench/contrib/terminal/node/terminalEnvironment","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/severity","vs/base/common/amd","vs/base/common/console","vs/base/common/marshalling","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/id","vs/base/node/paths","vs/base/node/extpath","vs/base/node/proxy_agent","vs/base/node/watcher","crypto","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/code/node/cliProcessMain","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/node/marketplace","vs/nls!vs/server/node/server","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/terminal/common/terminal","vs/nls!vs/workbench/contrib/terminal/node/terminalProcess","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/log/common/bufferLog","vs/platform/log/common/fileLogService","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/browser/errorTelemetry","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/telemetry","vs/platform/workspaces/common/workspaces","vs/platform/workspace/common/workspace","vs/server/common/nodeProxy","vs/server/common/telemetry","vs/server/node/insights","vs/server/node/connection","vs/server/node/protocol","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalDataBuffering","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProcess","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/node/extensionPoints","vs/server/node/channel","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionsScanner","vs/server/node/marketplace","vs/code/node/cliProcessMain","vs/server/node/server","string_decoder","vs/base/common/performance","proxy-agent","proxy-from-env","net","applicationinsights","https","http","@coder/node-browser","yauzl","yazl","tar-stream","zlib","vs/server/entry"],i=function(e){
for(var i=[],r=0,n=e.length;r<n;r++)i[r]=t[e[r]];return i};function r(e){e.MonacoPerformanceMarks=e.MonacoPerformanceMarks||[];const t=2,i="function"==typeof console.timeStamp?console.timeStamp.bind(console):()=>{};return{mark:function(t){e.MonacoPerformanceMarks.push(t,Date.now()),i(t)},getEntries:function(){const i=[],r=e.MonacoPerformanceMarks;for(let e=0;e<r.length;e+=t)i.push({name:r[e],startTime:r[e+1]});return i},getDuration:function(i,r){const n=e.MonacoPerformanceMarks;let s=r,o=0;for(let e=n.length-t;e>=0;e-=t)if(n[e]===s){if(s!==r)return n[o+1]-n[e+1];o=e,s=i}return 0},importEntries:function(t){e.MonacoPerformanceMarks.splice(0,0,...t)},exportEntries:function(){return e.MonacoPerformanceMarks.slice(0)}}}function n(e,t,i,r){function n(e){return new Promise(t=>i.exists(e,t))}function s(e){return(r=e,new Promise((e,t)=>i.lstat(r,(i,r)=>i?t(i):e(r)))).then(r=>r.isDirectory()&&!r.isSymbolicLink()?function(e){return new Promise((t,r)=>i.readdir(e,(e,i)=>e?r(e):t(i)))
}(e).then(i=>Promise.all(i.map(i=>s(t.join(e,i))))).then(()=>(function(e){return new Promise((t,r)=>i.rmdir(e,e=>e?r(e):t(void 0)))})(e)):function(e){return new Promise((t,r)=>i.unlink(e,e=>e?r(e):t(void 0)))}(e),e=>{if("ENOENT"!==e.code)throw e});var r}function o(e){return new Promise((function(t,r){i.readFile(e,"utf8",(function(e,i){e?r(e):t(i)}))}))}function a(e,t){return new Promise((function(r,n){i.writeFile(e,t,"utf8",(function(e){e?n(e):r()}))}))}return{getNLSConfiguration:function(e,l,c,u){if("pseudo"===u)return Promise.resolve({locale:u,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:u,availableLanguages:{}});if(u&&("en"===u||"en-us"===u))return Promise.resolve({locale:u,availableLanguages:{}});const h=u;r.mark("nlsGeneration:start");const d=function(e){return r.mark("nlsGeneration:end"),Promise.resolve({locale:e,availableLanguages:{}})};try{if(!e)return d(h);const f=function(e){const r=t.join(e,"languagepacks.json");try{
return JSON.parse(i.readFileSync(r,"utf8"))}catch(e){}}(l);if(!f)return d(h);if(!(u=function(e,t){try{for(;t;){if(e[t])return t;{const e=t.lastIndexOf("-");if(!(e>0))return;t=t.substring(0,e)}}}catch(e){console.error("Resolving language pack configuration failed.",e)}}(f,u)))return d(h);const p=f[u];let g;return p&&"string"==typeof p.hash&&p.translations&&"string"==typeof(g=p.translations.vscode)?n(g).then(f=>{if(!f)return d(h);const m=p.hash+"."+u,v=t.join(l,"clp",m),y=t.join(v,e),E=t.join(v,"tcf.json"),w=t.join(v,"corrupted.info"),_={locale:h,availableLanguages:{"*":u},_languagePackId:m,_translationsConfigFile:E,_cacheRoot:v,_resolvedLanguagePackCoreLocation:y,_corruptedFile:w};return n(w).then(e=>{let l;return(l=e?s(v):Promise.resolve(void 0)).then(()=>n(y).then(e=>e?(function(e){return new Promise((t,r)=>{const n=new Date;i.utimes(e,n,n,e=>e?r(e):t())})}(y).catch(()=>{}),r.mark("nlsGeneration:end"),_):function(e){return new Promise((t,r)=>i.mkdir(e,{recursive:!0},i=>i&&"EEXIST"!==i.code?r(i):t(e)))
}(y).then(()=>Promise.all([o(c),o(g)])).then(e=>{const i=JSON.parse(e[0]),r=JSON.parse(e[1]).contents,n=Object.keys(i.bundles),s=[];for(const e of n){const n=i.bundles[e],o=Object.create(null);for(const e of n){const t=i.keys[e],n=i.messages[e],s=r[e];let a;if(s){a=[];for(let e=0;e<t.length;e++){const i=t[e];let r=s["string"==typeof i?i:i.key];void 0===r&&(r=n[e]),a.push(r)}}else a=n;o[e]=a}s.push(a(t.join(y,e.replace(/\//g,"!")+".nls.json"),JSON.stringify(o)))}return s.push(a(E,JSON.stringify(p.translations))),Promise.all(s)}).then(()=>(r.mark("nlsGeneration:end"),_)).catch(e=>(console.error("Generating translation files failed.",e),d(u)))))})}):d(h)}catch(e){return console.error("Generating translation files failed.",e),d(u)}}}}if(define(t[91],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0,t.ok=function(e,t){if(!e)throw new Error(t?`Assertion failed (${t})`:"Assertion Failed")}})),define(t[92],i([0,1]),(function(e,t){"use strict";function i(e){
return(t,i,r)=>{let n=null,s=null;if("function"==typeof r.value?(n="value",s=r.value):"function"==typeof r.get&&(n="get",s=r.get),!s)throw new Error("not supported");r[n]=e(s,i)}}Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0,t.createDecorator=i;let r=0;function n(){const e=`$memoize${r++}`;let t=void 0;const i=function(i,r,n){let s=null,o=null;if("function"==typeof n.value?(s="value",0!==(o=n.value).length&&console.warn("Memoize should only be used in functions with zero parameters")):"function"==typeof n.get&&(s="get",o=n.get),!o)throw new Error("not supported");const a=`${e}:${r}`;n[s]=function(...e){return t=this,this.hasOwnProperty(a)||Object.defineProperty(this,a,{configurable:!0,enumerable:!1,writable:!0,value:o.apply(this,e)}),this[a]}};return i.clear=()=>{void 0!==t&&Object.getOwnPropertyNames(t).forEach(i=>{0===i.indexOf(e)&&delete t[i]})},i}t.createMemoizer=n,t.memoize=function(e,t,i){return n()(e,t,i)},
t.debounce=function(e,t,r){return i((i,n)=>{const s=`$debounce$${n}`,o=`$debounce$result$${n}`;return function(...n){this[o]||(this[o]=r?r():void 0),clearTimeout(this[s]),t&&(this[o]=t(this[o],...n),n=[this[o]]),this[s]=setTimeout(()=>{i.apply(this,n),this[o]=r?r():void 0},e)}})},t.throttle=function(e,t,r){return i((i,n)=>{const s=`$throttle$timer$${n}`,o=`$throttle$result$${n}`,a=`$throttle$lastRun$${n}`,l=`$throttle$pending$${n}`;return function(...n){if(this[o]||(this[o]=r?r():void 0),null!==this[a]&&void 0!==this[a]||(this[a]=-Number.MAX_VALUE),t&&(this[o]=t(this[o],...n)),this[l])return;const c=this[a]+e;c<=Date.now()?(this[a]=Date.now(),i.apply(this,[this[o]]),this[o]=r?r():void 0):(this[l]=!0,this[s]=setTimeout(()=>{this[l]=!1,this[a]=Date.now(),i.apply(this,[this[o]]),this[o]=r?r():void 0},c-Date.now()))}})}})),define(t[14],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(()=>{if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}addListener(e){return this.listeners.push(e),()=>{this._removeListener(e)}}emit(e){this.listeners.forEach(t=>{t(e)})}_removeListener(e){this.listeners.splice(this.listeners.indexOf(e),1)}setUnexpectedErrorHandler(e){this.unexpectedErrorHandler=e}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(e){this.unexpectedErrorHandler(e),this.emit(e)}onUnexpectedExternalError(e){this.unexpectedErrorHandler(e)}}t.ErrorHandler=i,t.errorHandler=new i,t.setUnexpectedErrorHandler=function(e){t.errorHandler.setUnexpectedErrorHandler(e)},
t.onUnexpectedError=function(e){n(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){n(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error){let{name:t,message:i}=e;return{$isError:!0,name:t,message:i,stack:e.stacktrace||e.stack}}return e};const r="Canceled";function n(e){return e instanceof Error&&e.name===r&&e.message===r}t.isPromiseCanceledError=n,t.canceled=function(){const e=new Error(r);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error(`Illegal argument: ${e}`):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error(`Illegal state: ${e}`):new Error("Illegal state")},t.readonly=function(e){return e?new Error(`readonly property '${e} cannot be changed'`):new Error("readonly property cannot be changed")},t.disposed=function(e){const t=new Error(`${e} has been disposed`);return t.name="DISPOSED",t},t.getErrorMessage=function(e){
return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"};class s extends Error{constructor(e){super("NotImplemented"),e&&(this.message=e)}}t.NotImplementedError=s;class o extends Error{constructor(e){super("NotSupported"),e&&(this.message=e)}}t.NotSupportedError=o})),define(t[19],i([0,1,14]),(function(e,t,i){"use strict";function r(e,t){let i=0,r=e.length;if(0===r)return 0;for(;i<r;){const n=Math.floor((i+r)/2);t(e[n])?r=n:i=n+1}return i}function n(e,t){return function e(t,i,r,n,s){if(n<=r)return;const o=r+(n-r)/2|0;e(t,i,r,o,s);e(t,i,o+1,n,s);if(i(t[o],t[o+1])<=0)return;!function(e,t,i,r,n,s){let o=i,a=r+1;for(let t=i;t<=n;t++)s[t]=e[t];for(let l=i;l<=n;l++)o>r?e[l]=s[a++]:a>n?e[l]=s[o++]:t(s[a],s[o])<0?e[l]=s[a++]:e[l]=s[o++]}(t,i,r,o,n,s)}(e,t,0,e.length-1,[]),e}function s(e,t,i){const r=[];function n(e,t,i){if(0===t&&0===i.length)return;const n=r[r.length-1];n&&n.start+n.deleteCount===e?(n.deleteCount+=t,n.toInsert.push(...i)):r.push({start:e,deleteCount:t,toInsert:i})}let s=0,o=0
;for(;;){if(s===e.length){n(s,0,t.slice(o));break}if(o===t.length){n(s,e.length-s,[]);break}const r=e[s],a=t[o],l=i(r,a);0===l?(s+=1,o+=1):l<0?(n(s,1,[]),s+=1):l>0&&(n(s,0,[a]),o+=1)}return r}function o(e,t,i,n,s){for(const o=i.length;n<s;n++){const s=e[n];if(t(s,i[o-1])<0){i.pop();const e=r(i,e=>t(s,e)<0);i.splice(e,0,s)}}}function a(e,t){const i=e.indexOf(t);if(i>-1)return e.splice(i,1),t}Object.defineProperty(t,"__esModule",{value:!0}),t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.mergeSort=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0,t.tail=function(e,t=0){return e[e.length-(1+t)]},t.tail2=function(e){if(0===e.length)throw new Error("Invalid tail call")
;return[e.slice(0,e.length-1),e[e.length-1]]},t.equals=function(e,t,i=((e,t)=>e===t)){if(e===t)return!0;if(!e||!t)return!1;if(e.length!==t.length)return!1;for(let r=0,n=e.length;r<n;r++)if(!i(e[r],t[r]))return!1;return!0},t.binarySearch=function(e,t,i){let r=0,n=e.length-1;for(;r<=n;){const s=(r+n)/2|0,o=i(e[s],t);if(o<0)r=s+1;else{if(!(o>0))return s;n=s-1}}return-(r+1)},t.findFirstInSorted=r,t.quickSelect=function e(t,i,r){if((t|=0)>=i.length)throw new TypeError("invalid index");let n=i[Math.floor(i.length*Math.random())],s=[],o=[],a=[];for(let e of i){const t=r(e,n);t<0?s.push(e):t>0?o.push(e):a.push(e)}return t<s.length?e(t,s,r):t<s.length+a.length?a[0]:e(t-(s.length+a.length),o,r)},t.mergeSort=n,t.groupBy=function(e,t){const i=[];let r=void 0;for(const s of n(e.slice(0),t))r&&0===t(r[0],s)?r.push(s):(r=[s],i.push(r));return i},t.sortedDiff=s,t.delta=function(e,t,i){const r=s(e,t,i),n=[],o=[];for(const t of r)n.push(...e.slice(t.start,t.start+t.deleteCount)),o.push(...t.toInsert);return{removed:n,added:o}
},t.top=function(e,t,i){if(0===i)return[];const r=e.slice(0,i).sort(t);return o(e,t,r,i,e.length),r},t.topAsync=function(e,t,r,n,s){return 0===r?Promise.resolve([]):new Promise((a,l)=>{(async()=>{const a=e.length,l=e.slice(0,r).sort(t);for(let c=r,u=Math.min(r+n,a);c<a;c=u,u=Math.min(u+n,a)){if(c>r&&await new Promise(e=>setTimeout(e)),s&&s.isCancellationRequested)throw i.canceled();o(e,t,l,c,u)}return l})().then(a,l)})},t.coalesce=function(e){return e.filter(e=>!!e)},t.coalesceInPlace=function(e){let t=0;for(let i=0;i<e.length;i++)e[i]&&(e[t]=e[i],t+=1);e.length=t},t.move=function(e,t,i){e.splice(i,0,e.splice(t,1)[0])},t.isFalsyOrEmpty=function(e){return!Array.isArray(e)||0===e.length},t.isNonEmptyArray=function(e){return Array.isArray(e)&&e.length>0},t.distinct=function(e,t){if(!t)return e.filter((t,i)=>e.indexOf(t)===i);const i=Object.create(null);return e.filter(e=>{const r=t(e);return!i[r]&&(i[r]=!0,!0)})},t.distinctES6=function(e){const t=new Set;return e.filter(e=>!t.has(e)&&(t.add(e),!0))},
t.uniqueFilter=function(e){const t=Object.create(null);return i=>{const r=e(i);return!t[r]&&(t[r]=!0,!0)}},t.lastIndex=function(e,t){for(let i=e.length-1;i>=0;i--){if(t(e[i]))return i}return-1},t.firstOrDefault=function(e,t){return e.length>0?e[0]:t},t.commonPrefixLength=function(e,t,i=((e,t)=>e===t)){let r=0;for(let n=0,s=Math.min(e.length,t.length);n<s&&i(e[n],t[n]);n++)r++;return r},t.flatten=function(e){return[].concat(...e)},t.range=function(e,t){let i="number"==typeof t?e:0;"number"==typeof t?i=e:(i=0,t=e);const r=[];if(i<=t)for(let e=i;e<t;e++)r.push(e);else for(let e=i;e>t;e--)r.push(e);return r},t.index=function(e,t,i){return e.reduce((e,r)=>(e[t(r)]=i?i(r):r,e),Object.create(null))},t.insert=function(e,t){return e.push(t),()=>a(e,t)},t.remove=a,t.arrayInsert=function(e,t,i){const r=e.slice(0,t),n=e.slice(t);return r.concat(i,n)},t.shuffle=function(e,t){let i;if("number"==typeof t){let e=t;i=()=>{const t=179426549*Math.sin(e++);return t-Math.floor(t)}}else i=Math.random
;for(let t=e.length-1;t>0;t-=1){const r=Math.floor(i()*(t+1)),n=e[t];e[t]=e[r],e[r]=n}},t.pushToStart=function(e,t){const i=e.indexOf(t);i>-1&&(e.splice(i,1),e.unshift(t))},t.pushToEnd=function(e,t){const i=e.indexOf(t);i>-1&&(e.splice(i,1),e.push(t))},t.mapArrayOrNot=function(e,t){return Array.isArray(e)?e.map(t):t(e)},t.asArray=function(e){return Array.isArray(e)?e:[e]},t.getRandomElement=function(e){return e[Math.floor(Math.random()*e.length)]}})),define(t[61],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0,t.once=function(e){const t=this;let i,r=!1;return function(){return r?i:(r=!0,i=e.apply(t,arguments))}}})),define(t[62],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0,function(e){e.is=function(e){return e&&"object"==typeof e&&"function"==typeof e[Symbol.iterator]};const t=Object.freeze([]);e.empty=function(){return t},e.single=function*(e){yield e},e.from=function(e){return e||t},
e.first=function(e){return e[Symbol.iterator]().next().value},e.some=function(e,t){for(const i of e)if(t(i))return!0;return!1},e.filter=function*(e,t){for(const i of e)t(i)&&(yield i)},e.map=function*(e,t){for(const i of e)yield t(i)},e.concat=function*(...e){for(const t of e)for(const e of t)yield e},e.consume=function(t,i=Number.POSITIVE_INFINITY){const r=[];if(0===i)return[r,t];const n=t[Symbol.iterator]();for(let t=0;t<i;t++){const t=n.next();if(t.done)return[r,e.empty()];r.push(t.value)}return[r,{[Symbol.iterator]:()=>n}]}}(t.Iterable||(t.Iterable={}))})),define(t[36],i([0,1]),(function(e,t){"use strict";var i,r;function n(e,t=!1){let i=0,r=e.length,n="",l=0,c=16,u=0;function h(t){let r=0,n=0;for(;r<t;){const t=e.charCodeAt(i);if(t>=48&&t<=57)n=16*n+t-48;else if(t>=65&&t<=70)n=16*n+t-65+10;else{if(!(t>=97&&t<=102))break;n=16*n+t-97+10}i++,r++}return r<t&&(n=-1),n}function d(){if(n="",u=0,l=i,i>=r)return l=r,c=17;let t=e.charCodeAt(i);if(s(t)){do{i++,n+=String.fromCharCode(t),t=e.charCodeAt(i)}while(s(t))
;return c=15}if(o(t))return i++,n+=String.fromCharCode(t),13===t&&10===e.charCodeAt(i)&&(i++,n+="\n"),c=14;switch(t){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,n=function(){let t="",n=i;for(;;){if(i>=r){t+=e.substring(n,i),u=2;break}const s=e.charCodeAt(i);if(34===s){t+=e.substring(n,i),i++;break}if(92!==s){if(s>=0&&s<=31){if(o(s)){t+=e.substring(n,i),u=2;break}u=6}i++}else{if(t+=e.substring(n,i),++i>=r){u=2;break}switch(e.charCodeAt(i++)){case 34:t+='"';break;case 92:t+="\\";break;case 47:t+="/";break;case 98:t+="\b";break;case 102:t+="\f";break;case 110:t+="\n";break;case 114:t+="\r";break;case 116:t+="\t";break;case 117:const e=h(4);e>=0?t+=String.fromCharCode(e):u=4;break;default:u=5}n=i}}return t}(),c=10;case 47:const s=i-1;if(47===e.charCodeAt(i+1)){for(i+=2;i<r&&!o(e.charCodeAt(i));)i++;return n=e.substring(s,i),c=12}if(42===e.charCodeAt(i+1)){i+=2;const t=r-1;let o=!1;for(;i<t;){
if(42===e.charCodeAt(i)&&47===e.charCodeAt(i+1)){i+=2,o=!0;break}i++}return o||(i++,u=1),n=e.substring(s,i),c=13}return n+=String.fromCharCode(t),i++,c=16;case 45:if(n+=String.fromCharCode(t),++i===r||!a(e.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=function(){const t=i;if(48===e.charCodeAt(i))i++;else for(i++;i<e.length&&a(e.charCodeAt(i));)i++;if(i<e.length&&46===e.charCodeAt(i)){if(!(++i<e.length&&a(e.charCodeAt(i))))return u=3,e.substring(t,i);for(i++;i<e.length&&a(e.charCodeAt(i));)i++}let r=i;if(i<e.length&&(69===e.charCodeAt(i)||101===e.charCodeAt(i)))if((++i<e.length&&43===e.charCodeAt(i)||45===e.charCodeAt(i))&&i++,i<e.length&&a(e.charCodeAt(i))){for(i++;i<e.length&&a(e.charCodeAt(i));)i++;r=i}else u=3;return e.substring(t,r)}(),c=11;default:for(;i<r&&f(t);)i++,t=e.charCodeAt(i);if(l!==i){switch(n=e.substring(l,i)){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(t),
i++,c=16}}function f(e){if(s(e)||o(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}return{setPosition:function(e){i=e,n="",l=0,c=16,u=0},getPosition:()=>i,scan:t?function(){let e;do{e=d()}while(e>=12&&e<=15);return e}:d,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>u}}function s(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&e<=8203||8239===e||8287===e||12288===e||65279===e}function o(e){return 10===e||13===e||8232===e||8233===e}function a(e){return e>=48&&e<=57}function l(e,t,i=!1){return t>=e.offset&&t<e.offset+e.length||i&&t===e.offset+e.length}function c(e,t,r=i.DEFAULT){const s=n(e,!1);function o(e){return e?()=>e(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(e){return e?t=>e(t,s.getTokenOffset(),s.getTokenLength()):()=>!0}
const l=o(t.onObjectBegin),c=a(t.onObjectProperty),u=o(t.onObjectEnd),h=o(t.onArrayBegin),d=o(t.onArrayEnd),f=a(t.onLiteralValue),p=a(t.onSeparator),g=o(t.onComment),m=a(t.onError),v=r&&r.disallowComments,y=r&&r.allowTrailingComma;function E(){for(;;){const e=s.scan();switch(s.getTokenError()){case 4:w(14);break;case 5:w(15);break;case 3:w(13);break;case 1:v||w(11);break;case 2:w(12);break;case 6:w(16)}switch(e){case 12:case 13:v?w(10):g();break;case 16:w(1);break;case 15:case 14:break;default:return e}}}function w(e,t=[],i=[]){if(m(e),t.length+i.length>0){let e=s.getToken();for(;17!==e;){if(-1!==t.indexOf(e)){E();break}if(-1!==i.indexOf(e))break;e=E()}}}function _(e){const t=s.getTokenValue();return e?f(t):c(t),E(),!0}function b(){switch(s.getToken()){case 3:return function(){h(),E();let e=!1;for(;4!==s.getToken()&&17!==s.getToken();){if(5===s.getToken()){if(e||w(4,[],[]),p(","),E(),4===s.getToken()&&y)break}else e&&w(6,[],[]);b()||w(4,[],[4,5]),e=!0}return d(),4!==s.getToken()?w(8,[4],[]):E(),!0}();case 1:
return function(){l(),E();let e=!1;for(;2!==s.getToken()&&17!==s.getToken();){if(5===s.getToken()){if(e||w(4,[],[]),p(","),E(),2===s.getToken()&&y)break}else e&&w(6,[],[]);(10!==s.getToken()?(w(3,[],[2,5]),0):(_(!1),6===s.getToken()?(p(":"),E(),b()||w(4,[],[2,5])):w(5,[],[2,5]),1))||w(4,[],[2,5]),e=!0}return u(),2!==s.getToken()?w(7,[2],[]):E(),!0}();case 10:return _(!0);default:return function(){switch(s.getToken()){case 11:let e=0;try{"number"!=typeof(e=JSON.parse(s.getTokenValue()))&&(w(2),e=0)}catch(e){w(2)}f(e);break;case 7:f(null);break;case 8:f(!0);break;case 9:f(!1);break;default:return!1}return E(),!0}()}}return E(),17===s.getToken()?!!r.allowEmptyContent||(w(4,[],[]),!1):b()?(17!==s.getToken()&&w(9,[],[]),!0):(w(4,[],[]),!1)}function u(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":return e?Array.isArray(e)?"array":"object":"null";default:return"null"}}Object.defineProperty(t,"__esModule",{value:!0}),
t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"}(t.ScanError||(t.ScanError={})),function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",
e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"}(t.SyntaxKind||(t.SyntaxKind={})),function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"
}(t.ParseErrorCode||(t.ParseErrorCode={})),function(e){e.DEFAULT={allowTrailingComma:!0}}(i=t.ParseOptions||(t.ParseOptions={})),t.createScanner=n,function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",
e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",
e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"}(r||(r={})),t.getLocation=function(e,t){const i=[],r=new Object;let n=void 0;const s={value:{},offset:0,length:0,
type:"object",parent:void 0};let o=!1;function a(e,t,i,r){s.value=e,s.offset=t,s.length=i,s.type=r,s.colonOffset=void 0,n=s}try{c(e,{onObjectBegin:(e,s)=>{if(t<=e)throw r;n=void 0,o=t>e,i.push("")},onObjectProperty:(e,n,s)=>{if(t<n)throw r;if(a(e,n,s,"property"),i[i.length-1]=e,t<=n+s)throw r},onObjectEnd:(e,s)=>{if(t<=e)throw r;n=void 0,i.pop()},onArrayBegin:(e,s)=>{if(t<=e)throw r;n=void 0,i.push(0)},onArrayEnd:(e,s)=>{if(t<=e)throw r;n=void 0,i.pop()},onLiteralValue:(e,i,n)=>{if(t<i)throw r;if(a(e,i,n,u(e)),t<=i+n)throw r},onSeparator:(e,s,a)=>{if(t<=s)throw r;if(":"===e&&n&&"property"===n.type)n.colonOffset=s,o=!1,n=void 0;else if(","===e){const e=i[i.length-1];"number"==typeof e?i[i.length-1]=e+1:(o=!0,i[i.length-1]=""),n=void 0}}})}catch(e){if(e!==r)throw e}return{path:i,previousNode:n,isAtPropertyKey:o,matches:e=>{let t=0;for(let r=0;t<e.length&&r<i.length;r++)if(e[t]===i[r]||"*"===e[t])t++;else if("**"!==e[t])return!1;return t===e.length}}},t.parse=function(e,t=[],r=i.DEFAULT){let n=null,s=[]
;const o=[];function a(e){Array.isArray(s)?s.push(e):null!==n&&(s[n]=e)}return c(e,{onObjectBegin:()=>{const e={};a(e),o.push(s),s=e,n=null},onObjectProperty:e=>{n=e},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const e=[];a(e),o.push(s),s=e,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:a,onError:(e,i,r)=>{t.push({error:e,offset:i,length:r})}},r),s[0]},t.parseTree=function(e,t=[],r=i.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(e){"property"===n.type&&(n.length=e-n.offset,n=n.parent)}function o(e){return n.children.push(e),e}c(e,{onObjectBegin:e=>{n=o({type:"object",offset:e,length:-1,parent:n,children:[]})},onObjectProperty:(e,t,i)=>{(n=o({type:"property",offset:t,length:-1,parent:n,children:[]})).children.push({type:"string",value:e,offset:t,length:i,parent:n})},onObjectEnd:(e,t)=>{n.length=e+t-n.offset,n=n.parent,s(e+t)},onArrayBegin:(e,t)=>{n=o({type:"array",offset:e,length:-1,parent:n,children:[]})},onArrayEnd:(e,t)=>{n.length=e+t-n.offset,n=n.parent,s(e+t)
},onLiteralValue:(e,t,i)=>{o({type:u(e),offset:t,length:i,parent:n,value:e}),s(t+i)},onSeparator:(e,t,i)=>{"property"===n.type&&(":"===e?n.colonOffset=t:","===e&&s(t))},onError:(e,i,r)=>{t.push({error:e,offset:i,length:r})}},r);const a=n.children[0];return a&&delete a.parent,a},t.findNodeAtLocation=function(e,t){if(!e)return;let i=e;for(let e of t)if("string"==typeof e){if("object"!==i.type||!Array.isArray(i.children))return;let t=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===e){i=r.children[1],t=!0;break}if(!t)return}else{const t=e;if("array"!==i.type||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i},t.getNodePath=function e(t){if(!t.parent||!t.parent.children)return[];const i=e(t.parent);if("property"===t.parent.type){const e=t.parent.children[0].value;i.push(e)}else if("array"===t.parent.type){const e=t.parent.children.indexOf(t);-1!==e&&i.push(e)}return i},t.getNodeValue=function e(t){switch(t.type){case"array":
return t.children.map(e);case"object":const i=Object.create(null);for(let r of t.children){const t=r.children[1];t&&(i[r.children[0].value]=e(t))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}},t.contains=l,t.findNodeAtOffset=function e(t,i,r=!1){if(l(t,i,r)){const n=t.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=i;t++){const s=e(n[t],i,r);if(s)return s}return t}},t.visit=c,t.stripComments=function(e,t){let i,r,s=n(e),o=[],a=0;do{switch(r=s.getPosition(),i=s.scan()){case 12:case 13:case 17:a!==r&&o.push(e.substring(a,r)),void 0!==t&&o.push(s.getTokenValue().replace(/[^\r\n]/g,t)),a=s.getPosition()}}while(17!==i);return o.join("")},t.getNodeType=u})),define(t[93],i([0,1,36]),(function(e,t,i){"use strict";function r(e,t){let i="";for(let r=0;r<t;r++)i+=e;return i}function n(e,t){for(let e=0;e<t.length;e++){const i=t.charAt(e);if("\r"===i)return e+1<t.length&&"\n"===t.charAt(e+1)?"\r\n":"\r";if("\n"===i)return"\n"}return e&&e.eol||"\n"}
function s(e,t){return-1!=="\r\n".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0}),t.isEOL=t.getEOL=t.format=void 0,t.format=function(e,t,o){let a,l,c,u,h;if(t){for(u=t.offset,h=u+t.length,c=u;c>0&&!s(e,c-1);)c--;let i=h;for(;i<e.length&&!s(e,i);)i++;l=e.substring(c,i),a=function(e,t){let i=0,r=0;const n=t.tabSize||4;for(;i<e.length;){const t=e.charAt(i);if(" "===t)r++;else{if("\t"!==t)break;r+=n}i++}return Math.floor(r/n)}(l,o)}else l=e,a=0,c=0,u=0,h=e.length;const d=n(o,e);let f,p=!1,g=0;f=o.insertSpaces?r(" ",o.tabSize||4):"\t";const m=i.createScanner(l,!1);let v=!1;function y(){return d+r(f,a+g)}function E(){let e=m.scan();for(p=!1;15===e||14===e;)p=p||14===e,e=m.scan();return v=16===e||0!==m.getTokenError(),e}const w=[];function _(t,i,r){!v&&i<h&&r>u&&e.substring(i,r)!==t&&w.push({offset:i,length:r-i,content:t})}let b=E();if(17!==b){const e=m.getTokenOffset()+c;_(r(f,a),c,e)}for(;17!==b;){let e=m.getTokenOffset()+m.getTokenLength()+c,t=E(),i="";for(;!p&&(12===t||13===t);){
_(" ",e,m.getTokenOffset()+c),e=m.getTokenOffset()+m.getTokenLength()+c,i=12===t?y():"",t=E()}if(2===t)1!==b&&(g--,i=y());else if(4===t)3!==b&&(g--,i=y());else{switch(b){case 3:case 1:g++,i=y();break;case 5:case 12:i=y();break;case 13:i=p?y():" ";break;case 6:i=" ";break;case 10:if(6===t){i="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===t||13===t?i=" ":5!==t&&17!==t&&(v=!0);break;case 16:v=!0}!p||12!==t&&13!==t||(i=y())}_(i,e,m.getTokenOffset()+c),b=t}return w},t.getEOL=n,t.isEOL=s})),define(t[94],i([0,1,36,93,19]),(function(e,t,i,r,n){"use strict";function s(e,t,r,n,s){const a=t.slice(),l=i.parseTree(e,[]);let c=void 0,u=void 0;for(;a.length>0&&(u=a.pop(),void 0===(c=i.findNodeAtLocation(l,a))&&void 0!==r);)r="string"==typeof u?{[u]:r}:[r];if(c){if("object"===c.type&&"string"==typeof u&&Array.isArray(c.children)){const t=i.findNodeAtLocation(c,[u]);if(void 0!==t){if(void 0===r){if(!t.parent)throw new Error("Malformed AST");const i=c.children.indexOf(t.parent);let r,s=t.parent.offset+t.parent.length
;if(i>0){const e=c.children[i-1];r=e.offset+e.length}else if(r=c.offset+1,c.children.length>1){s=c.children[1].offset}return o(e,{offset:r,length:s-r,content:""},n)}return o(e,{offset:t.offset,length:t.length,content:JSON.stringify(r)},n)}{if(void 0===r)return[];const t=`${JSON.stringify(u)}: ${JSON.stringify(r)}`,i=s?s(c.children.map(e=>e.children[0].value)):c.children.length;let a;if(i>0){const e=c.children[i-1];a={offset:e.offset+e.length,length:0,content:","+t}}else a=0===c.children.length?{offset:c.offset+1,length:0,content:t}:{offset:c.offset+1,length:0,content:t+","};return o(e,a,n)}}if("array"===c.type&&"number"==typeof u&&Array.isArray(c.children)){if(void 0!==r){const t=`${JSON.stringify(r)}`;let i;if(0===c.children.length||0===u)i={offset:c.offset+1,length:0,content:0===c.children.length?t:t+","};else{const e=-1===u||u>c.children.length?c.children.length:u,r=c.children[e-1];i={offset:r.offset+r.length,length:0,content:","+t}}return o(e,i,n)}{const t=u,i=c.children[t];let r
;if(1===c.children.length)r={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===t){const e=c.children[t-1],i=e.offset+e.length;r={offset:i,length:c.offset+c.length-2-i,content:""}}else r={offset:i.offset,length:c.children[t+1].offset-i.offset,content:""};return o(e,r,n)}}throw new Error(`Can not add ${"number"!=typeof u?"index":"property"} to parent of type ${c.type}`)}if(void 0===r)throw new Error("Can not delete in empty document");return o(e,{offset:l?l.offset:0,length:l?l.length:0,content:JSON.stringify(r)},n)}function o(e,t,i){let n=a(e,t),s=t.offset,o=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;s>0&&!r.isEOL(n,s-1);)s--;for(;o<n.length&&!r.isEOL(n,o);)o++}const l=r.format(n,{offset:s,length:o-s},i);for(let e=l.length-1;e>=0;e--){const t=l[e];n=a(n,t),s=Math.min(s,t.offset),o=Math.max(o,t.offset+t.length),o+=t.content.length-t.length}return[{offset:s,length:e.length-(n.length-o)-s,content:n.substring(s,o)}]}function a(e,t){
return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}Object.defineProperty(t,"__esModule",{value:!0}),t.applyEdits=t.applyEdit=t.withFormatting=t.setProperty=t.removeProperty=void 0,t.removeProperty=function(e,t,i){return s(e,t,void 0,i)},t.setProperty=s,t.withFormatting=o,t.applyEdit=a,t.applyEdits=function(e,t){let i=n.mergeSort(t,(e,t)=>{const i=e.offset-t.offset;return 0===i?e.length-t.length:i}),r=e.length;for(let t=i.length-1;t>=0;t--){let n=i[t];if(!(n.offset+n.length<=r))throw new Error("Overlapping edit");e=a(e,n),r=n.offset}return e}})),define(t[2],i([0,1,61,62]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=void 0;const n=!1,s="__is_disposable_tracked__";function o(e){if(n&&e&&e!==h.None)try{e[s]=!0}catch(e){}}function a(e){if(!n)return e
;const t=new Error("Potentially leaked disposable").stack;return setTimeout(()=>{e[s]||console.log(t)},3e3),e}class l extends Error{constructor(e){super(`Encounter errors while disposing of store. Errors: [${e.join(", ")}]`),this.errors=e}}function c(e){if(r.Iterable.is(e)){let t=[];for(const i of e)if(i){o(i);try{i.dispose()}catch(e){t.push(e)}}if(1===t.length)throw t[0];if(t.length>1)throw new l(t);return Array.isArray(e)?[]:e}if(e)return o(e),e.dispose(),e}t.MultiDisposeError=l,t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=c,t.combinedDisposable=function(...e){return e.forEach(o),a({dispose:()=>c(e)})},t.toDisposable=function(e){const t=a({dispose:()=>{o(t),e()}});return t};class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(e){if(!e)return e
;if(e===this)throw new Error("Cannot register a disposable on itself!");return o(e),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(e),e}}t.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new u,a(this)}dispose(){o(this),this._store.dispose()}_register(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)}}t.Disposable=h,h.None=Object.freeze({dispose(){}});t.MutableDisposable=class{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(e){this._isDisposed||e===this._value||(this._value&&this._value.dispose(),e&&o(e),this._value=e)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,o(this),this._value&&this._value.dispose(),this._value=void 0}};t.ReferenceCollection=class{constructor(){this.references=new Map}
acquire(e,...t){let r=this.references.get(e);r||(r={counter:0,object:this.createReferencedObject(e,...t)},this.references.set(e,r));const{object:n}=r,s=i.once(()=>{0==--r.counter&&(this.destroyReferencedObject(e,r.object),this.references.delete(e))});return r.counter++,{object:n,dispose:s}}};t.ImmortalReference=class{constructor(e){this.object=e}dispose(){}}})),define(t[95],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class i{constructor(e){this.element=e,this.next=i.Undefined,this.prev=i.Undefined}}i.Undefined=new i(void 0);t.LinkedList=class{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(e){return this._insert(e,!1)}push(e){return this._insert(e,!0)}_insert(e,t){const r=new i(e);if(this._first===i.Undefined)this._first=r,this._last=r;else if(t){const e=this._last
;this._last=r,r.prev=e,e.next=r}else{const e=this._first;this._first=r,r.next=e,e.prev=r}this._size+=1;let n=!1;return()=>{n||(n=!0,this._remove(r))}}shift(){if(this._first!==i.Undefined){const e=this._first.element;return this._remove(this._first),e}}pop(){if(this._last!==i.Undefined){const e=this._last.element;return this._remove(this._last),e}}_remove(e){if(e.prev!==i.Undefined&&e.next!==i.Undefined){const t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===i.Undefined&&e.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):e.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):e.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let e=this._first;for(;e!==i.Undefined;)yield e.element,e=e.next}toArray(){const e=[];for(let t=this._first;t!==i.Undefined;t=t.next)e.push(t.element);return e}}})),define(t[6],i([0,1,14,61,2,95]),(function(e,t,i,r,n,s){"use strict";var o;Object.defineProperty(t,"__esModule",{
value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.AsyncEmitter=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0,function(e){function t(e){return(t,i=null,r)=>{let n,s=!1;return n=e(e=>{if(!s)return n?n.dispose():s=!0,t.call(i,e)},null,r),s&&n.dispose(),n}}function i(e,t){return a((i,r=null,n)=>e(e=>i.call(r,t(e)),null,n))}function r(e,t){return a((i,r=null,n)=>e(e=>{t(e),i.call(r,e)},null,n))}function s(e,t){return a((i,r=null,n)=>e(e=>t(e)&&i.call(r,e),null,n))}function o(e,t,r){let n=r;return i(e,e=>n=t(n,e))}function a(e){let t;const i=new c({onFirstListenerAdd(){t=e(i.fire,i)},onLastListenerRemove(){t.dispose()}});return i.event}function l(e,t,i=100,r=!1,n){let s,o=void 0,a=void 0,l=0;const u=new c({leakWarningThreshold:n,onFirstListenerAdd(){s=e(e=>{l++,o=t(o,e),r&&!a&&(u.fire(o),o=void 0),clearTimeout(a),a=setTimeout(()=>{const e=o;o=void 0,a=void 0,(!r||l>1)&&u.fire(e),l=0},i)})},onLastListenerRemove(){s.dispose()}});return u.event}function u(e){let t,i=!0
;return s(e,e=>{const r=i||e!==t;return i=!1,t=e,r})}e.None=()=>n.Disposable.None,e.once=t,e.map=i,e.forEach=r,e.filter=s,e.signal=function(e){return e},e.any=function(...e){return(t,i=null,r)=>n.combinedDisposable(...e.map(e=>e(e=>t.call(i,e),null,r)))},e.reduce=o,e.snapshot=a,e.debounce=l,e.stopwatch=function(e){const r=(new Date).getTime();return i(t(e),e=>(new Date).getTime()-r)},e.latch=u,e.buffer=function(e,t=!1,i=[]){let r=i.slice(),n=e(e=>{r?r.push(e):o.fire(e)});const s=()=>{r&&r.forEach(e=>o.fire(e)),r=null},o=new c({onFirstListenerAdd(){n||(n=e(e=>o.fire(e)))},onFirstListenerDidAdd(){r&&(t?setTimeout(s):s())},onLastListenerRemove(){n&&n.dispose(),n=null}});return o.event};class h{constructor(e){this.event=e}map(e){return new h(i(this.event,e))}forEach(e){return new h(r(this.event,e))}filter(e){return new h(s(this.event,e))}reduce(e,t){return new h(o(this.event,e,t))}latch(){return new h(u(this.event))}debounce(e,t=100,i=!1,r){return new h(l(this.event,e,t,i,r))}on(e,t,i){return this.event(e,t,i)}
once(e,i,r){return t(this.event)(e,i,r)}}e.chain=function(e){return new h(e)},e.fromNodeEventEmitter=function(e,t,i=(e=>e)){const r=(...e)=>n.fire(i(...e)),n=new c({onFirstListenerAdd:()=>e.on(t,r),onLastListenerRemove:()=>e.removeListener(t,r)});return n.event},e.fromDOMEventEmitter=function(e,t,i=(e=>e)){const r=(...e)=>n.fire(i(...e)),n=new c({onFirstListenerAdd:()=>e.addEventListener(t,r),onLastListenerRemove:()=>e.removeEventListener(t,r)});return n.event},e.fromPromise=function(e){const t=new c;let i=!1;return e.then(void 0,()=>null).then(()=>{i?t.fire(void 0):setTimeout(()=>t.fire(void 0),0)}),i=!0,t.event},e.toPromise=function(e){return new Promise(i=>t(e)(i))}}(o=t.Event||(t.Event={}));let a=-1;t.setGlobalLeakWarningThreshold=function(e){const t=a;return a=e,{dispose(){a=t}}};class l{constructor(e,t=Math.random().toString(18).slice(2,5)){this.customThreshold=e,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(e){let t=a
;if("number"==typeof this.customThreshold&&(t=this.customThreshold),t<=0||e<t)return;this._stacks||(this._stacks=new Map);const i=(new Error).stack.split("\n").slice(3).join("\n"),r=this._stacks.get(i)||0;if(this._stacks.set(i,r+1),this._warnCountdown-=1,this._warnCountdown<=0){let i;this._warnCountdown=.5*t;let r=0;for(const[e,t]of this._stacks)(!i||r<t)&&(i=e,r=t);console.warn(`[${this.name}] potential listener LEAK detected, having ${e} listeners already. MOST frequent listener (${r}):`),console.warn(i)}return()=>{const e=this._stacks.get(i)||0;this._stacks.set(i,e-1)}}}class c{constructor(e){this._disposed=!1,this._options=e,this._leakageMon=a>0?new l(this._options&&this._options.leakWarningThreshold):void 0}get event(){return this._event||(this._event=(e,t,i)=>{this._listeners||(this._listeners=new s.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(t?[e,t]:e);let a,l
;return r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,e,t),this._leakageMon&&(a=this._leakageMon.check(this._listeners.size)),l={dispose:()=>{if(a&&a(),l.dispose=c._noop,!this._disposed&&(o(),this._options&&this._options.onLastListenerRemove)){this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)}}},i instanceof n.DisposableStore?i.add(l):Array.isArray(i)&&i.push(l),l}),this._event}fire(e){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,e]);for(;this._deliveryQueue.size>0;){const[e,t]=this._deliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){i.onUnexpectedError(e)}}}}dispose(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),
this._disposed=!0}}t.Emitter=c,c._noop=function(){};t.PauseableEmitter=class extends c{constructor(e){super(e),this._isPaused=0,this._eventQueue=new s.LinkedList,this._mergeFn=e&&e.merge}pause(){this._isPaused++}resume(){if(0!==this._isPaused&&0==--this._isPaused)if(this._mergeFn){const e=this._eventQueue.toArray();this._eventQueue.clear(),super.fire(this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)super.fire(this._eventQueue.shift())}fire(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):super.fire(e))}};t.AsyncEmitter=class extends c{async fireAsync(e,t,r){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new s.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,e]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[e,t]=this._asyncDeliveryQueue.shift(),n=[],s=Object.assign(Object.assign({},t),{waitUntil:t=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous")
;r&&(t=r(t,"function"==typeof e?e:e[0])),n.push(t)}});try{"function"==typeof e?e.call(void 0,s):e[0].call(e[1],s)}catch(e){i.onUnexpectedError(e);continue}Object.freeze(n),await Promise.all(n).catch(e=>i.onUnexpectedError(e))}}}};t.EventMultiplexer=class{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(e){const t={event:e,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);return n.toDisposable(r.once(()=>{this.hasListeners&&this.unhook(t);const e=this.events.indexOf(t);this.events.splice(e,1)}))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(e=>this.hook(e))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(e=>this.unhook(e))}hook(e){e.listener=e.event(e=>this.emitter.fire(e))}unhook(e){e.listener&&e.listener.dispose(),e.listener=null}dispose(){this.emitter.dispose()}};t.EventBufferer=class{
constructor(){this.buffers=[]}wrapEvent(e){return(t,i,r)=>e(e=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>t.call(i,e)):t.call(i,e)},void 0,r)}bufferEvents(e){const t=[];this.buffers.push(t);const i=e();return this.buffers.pop(),t.forEach(e=>e()),i}};t.Relay=class{constructor(){this.listening=!1,this.inputEvent=o.None,this.inputEventListener=n.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}})),define(t[23],i([0,1,6]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0
;const r=Object.freeze((function(e,t){const i=setTimeout(e.bind(t),0);return{dispose(){clearTimeout(i)}}}));var n;!function(e){e.isCancellationToken=function(t){return t===e.None||t===e.Cancelled||(t instanceof s||!(!t||"object"!=typeof t)&&("boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested))},e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})}(n=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}t.CancellationTokenSource=class{constructor(e){
this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=n.Cancelled}dispose(e=!1){e&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof s&&this._token.dispose():this._token=n.None}}})),define(t[15],i([0,1,23,14,6,2]),(function(e,t,i,r,n,s){"use strict";function o(e){return e&&"function"==typeof e.then}function a(e){const t=new i.CancellationTokenSource,n=e(t.token),s=new Promise((e,i)=>{t.token.onCancellationRequested(()=>{i(r.canceled())}),Promise.resolve(n).then(i=>{t.dispose(),e(i)},e=>{t.dispose(),i(e)})});return new class{cancel(){t.cancel()}then(e,t){return s.then(e,t)}catch(e){return this.then(void 0,e)}finally(e){return s.finally(e)}}}Object.defineProperty(t,"__esModule",{value:!0}),
t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.RunOnceWorker=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.first=t.sequence=t.ignoreErrors=t.disposableTimeout=t.timeout=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0,t.isThenable=o,t.createCancelablePromise=a,t.raceCancellation=function(e,t,i){return Promise.race([e,new Promise(e=>t.onCancellationRequested(()=>e(i)))])},t.raceCancellablePromises=async function(e){let t=-1;const i=e.map((e,i)=>e.then(e=>(t=i,e))),r=await Promise.race(i);return e.forEach((e,i)=>{i!==t&&e.cancel()}),r},t.raceTimeout=function(e,t,i){let r=void 0;const n=setTimeout(()=>{null==r||r(void 0),null==i||i()},t);return Promise.race([e.finally(()=>clearTimeout(n)),new Promise(e=>r=e)])},t.asPromise=function(e){return new Promise((t,i)=>{const r=e();o(r)?r.then(t,i):t(r)})}
;class l{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(e){if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){const e=()=>{this.queuedPromise=null;const e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,e};this.queuedPromise=new Promise(t=>{this.activePromise.then(e,e).then(t)})}return new Promise((e,t)=>{this.queuedPromise.then(e,t)})}return this.activePromise=e(),new Promise((e,t)=>{this.activePromise.then(t=>{this.activePromise=null,e(t)},e=>{this.activePromise=null,t(e)})})}}t.Throttler=l;t.Sequencer=class{constructor(){this.current=Promise.resolve(null)}queue(e){return this.current=this.current.then(()=>e())}};t.SequencerByKey=class{constructor(){this.promiseMap=new Map}queue(e,t){var i;const r=(null!==(i=this.promiseMap.get(e))&&void 0!==i?i:Promise.resolve()).catch(()=>{}).then(t).finally(()=>{this.promiseMap.get(e)===r&&this.promiseMap.delete(e)});return this.promiseMap.set(e,r),r}};class c{
constructor(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(e,t=this.defaultDelay){return this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((e,t)=>{this.doResolve=e,this.doReject=t}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const e=this.task;return this.task=null,e()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},t),this.completionPromise}isTriggered(){return null!==this.timeout}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(r.canceled()),this.completionPromise=null)}cancelTimeout(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}t.Delayer=c;t.ThrottledDelayer=class{constructor(e){this.delayer=new c(e),this.throttler=new l}trigger(e,t){return this.delayer.trigger(()=>this.throttler.queue(e),t)}isTriggered(){
return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}};function u(e,t){return t?new Promise((i,n)=>{const s=setTimeout(i,e);t.onCancellationRequested(()=>{clearTimeout(s),n(r.canceled())})}):a(t=>u(e,t))}t.Barrier=class{constructor(){this._isOpen=!1,this._promise=new Promise((e,t)=>{this._completePromise=e})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}},t.timeout=u,t.disposableTimeout=function(e,t=0){const i=setTimeout(e,t);return s.toDisposable(()=>clearTimeout(i))},t.ignoreErrors=function(e){return e.then(void 0,e=>void 0)},t.sequence=function(e){const t=[];let i=0;const r=e.length;return Promise.resolve(null).then((function n(s){null!=s&&t.push(s);const o=i<r?e[i++]():null;return o?o.then(n):Promise.resolve(t)}))},t.first=function(e,t=(e=>!!e),i=null){let r=0;const n=e.length,s=()=>{if(r>=n)return Promise.resolve(i);const o=e[r++];return Promise.resolve(o()).then(e=>t(e)?Promise.resolve(e):s())}
;return s()};class h{constructor(e){this._size=0,this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new n.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(e){return this._size++,new Promise((t,i)=>{this.outstandingPromises.push({factory:e,c:t,e:i}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const e=this.outstandingPromises.shift();this.runningPromises++;const t=e.factory();t.then(e.c,e.e),t.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}t.Limiter=h;class d extends h{constructor(){super(1)}}t.Queue=d;t.ResourceQueue=class{constructor(){this.queues=new Map}queueFor(e){const t=e.toString();if(!this.queues.has(t)){const e=new d;e.onFinished(()=>{e.dispose(),this.queues.delete(t)}),
this.queues.set(t,e)}return this.queues.get(t)}dispose(){this.queues.forEach(e=>e.dispose()),this.queues.clear()}};t.TimeoutTimer=class{constructor(e,t){this._token=-1,"function"==typeof e&&"number"==typeof t&&this.setIfNotSet(e,t)}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setTimeout(()=>{this._token=-1,e()},t)}setIfNotSet(e,t){-1===this._token&&(this._token=setTimeout(()=>{this._token=-1,e()},t))}};t.IntervalTimer=class{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearInterval(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setInterval(()=>{e()},t)}};class f{constructor(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(e=this.timeout){this.cancel(),
this.timeoutToken=setTimeout(this.timeoutHandler,e)}get delay(){return this.timeout}set delay(e){this.timeout=e}isScheduled(){return-1!==this.timeoutToken}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}t.RunOnceScheduler=f;t.RunOnceWorker=class extends f{constructor(e,t){super(e,t),this.units=[]}work(e){this.units.push(e),this.isScheduled()||this.schedule()}doRun(){const e=this.units;this.units=[],this.runner&&this.runner(e)}dispose(){this.units=[],super.dispose()}},function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){const e=Object.freeze({didTimeout:!0,timeRemaining:()=>15});t.runWhenIdle=t=>{const i=setTimeout(()=>t(e));let r=!1;return{dispose(){r||(r=!0,clearTimeout(i))}}}}else t.runWhenIdle=(e,t)=>{const i=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0);let r=!1;return{dispose(){r||(r=!0,cancelIdleCallback(i))}}}}();t.IdleValue=class{constructor(e){this._didRun=!1,this._executor=()=>{try{this._value=e()
}catch(e){this._error=e}finally{this._didRun=!0}},this._handle=t.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}},t.retry=async function(e,t,i){let r;for(let n=0;n<i;n++)try{return await e()}catch(e){r=e,await u(t)}throw r};t.TaskSequentializer=class{hasPending(e){return!!this._pending&&("number"==typeof e?this._pending.taskId===e:!!this._pending)}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var e;null===(e=this._pending)||void 0===e||e.cancel()}setPending(e,t,i){return this._pending={taskId:e,cancel:()=>null==i?void 0:i(),promise:t},t.then(()=>this.donePending(e),()=>this.donePending(e)),t}donePending(e){this._pending&&e===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const e=this._next;this._next=void 0,e.run().then(e.promiseResolve,e.promiseReject)}}setNext(e){
if(this._next)this._next.run=e;else{let t,i;const r=new Promise((e,r)=>{t=e,i=r});this._next={run:e,promise:r,promiseResolve:t,promiseReject:i}}return this._next.promise}};t.IntervalCounter=class{constructor(e){this.interval=e,this.lastIncrementTime=0,this.value=0}increment(){const e=Date.now();return e-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=e,this.value=0),this.value++,this.value}}})),e="object"==typeof global?global:"object"==typeof self?self:{},"function"==typeof define?define("vs/base/common/performance",[],(function(){return r(e)})):"object"==typeof module&&"object"==typeof module.exports?module.exports=r(e):e.perf=r(e),define(t[5],i([0,1]),(function(e,t){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.globals=t.translationsConfigFile=t.locale=t.Language=t.language=t.isRootUser=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=void 0
;let r=!1,n=!1,s=!1,o=!1,a=!1,l=!1,c=void 0,u="en",h=void 0,d=void 0;const f="object"==typeof self?self:"object"==typeof global?global:{};let p=void 0;"undefined"!=typeof process?p=process:void 0!==f.vscode&&(p=f.vscode.process);const g="string"==typeof(null===(i=null==p?void 0:p.versions)||void 0===i?void 0:i.electron)&&"renderer"===p.type;if("object"!=typeof navigator||g)if("object"==typeof p){r="win32"===p.platform,n="darwin"===p.platform,s="linux"===p.platform,c="en",u="en";const e=p.env.VSCODE_NLS_CONFIG;if(e)try{const t=JSON.parse(e),i=t.availableLanguages["*"];c=t.locale,u=i||"en",h=t._translationsConfigFile}catch(e){}o=!0}else console.error("Unable to resolve platform.");else{d=navigator.userAgent,r=d.indexOf("Windows")>=0,n=d.indexOf("Macintosh")>=0,l=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,s=d.indexOf("Linux")>=0,a=!0,u=c=navigator.language
;const e="undefined"!=typeof document&&document.getElementById("vscode-remote-nls-configuration"),t=e&&e.getAttribute("data-settings");if(t)try{const e=JSON.parse(t);c=e.locale,h=e._translationsConfigFile,u=e.availableLanguages["*"]||"en"}catch(e){}}!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={})),t.PlatformToString=function(e){switch(e){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}};let m=0;n?m=1:r?m=3:s&&(m=2),t.isWindows=r,t.isMacintosh=n,t.isLinux=s,t.isNative=o,t.isWeb=a,t.isIOS=l,t.platform=m,t.userAgent=d,t.isRootUser=function(){return!!p&&!r&&0===p.getuid()},t.language=u,function(e){e.value=function(){return t.language},e.isDefaultVariant=function(){return 2===t.language.length?"en"===t.language:t.language.length>=3&&("e"===t.language[0]&&"n"===t.language[1]&&"-"===t.language[2])},e.isDefault=function(){return"en"===t.language}}(t.Language||(t.Language={})),t.locale=c,
t.translationsConfigFile=h,t.globals=f,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if("function"==typeof t.globals.postMessage&&!t.globals.importScripts){let e=[];t.globals.addEventListener("message",t=>{if(t.data&&t.data.vscodeSetImmediateId)for(let i=0,r=e.length;i<r;i++){const r=e[i];if(r.id===t.data.vscodeSetImmediateId)return e.splice(i,1),void r.callback()}});let i=0;return r=>{const n=++i;e.push({id:n,callback:r}),t.globals.postMessage({vscodeSetImmediateId:n},"*")}}if(p)return p.nextTick.bind(p);const e=Promise.resolve();return t=>e.then(t)}(),function(e){e[e.Windows=1]="Windows",e[e.Macintosh=2]="Macintosh",e[e.Linux=3]="Linux"}(t.OperatingSystem||(t.OperatingSystem={})),t.OS=n||l?2:r?1:3;let v=!0,y=!1;t.isLittleEndian=function(){if(!y){y=!0;const e=new Uint8Array(2);e[0]=1,e[1]=2;const t=new Uint16Array(e.buffer);v=513===t[0]}return v}})),define(t[41],i([0,1,5]),(function(e,t,i){"use strict";let r;Object.defineProperty(t,"__esModule",{value:!0}),
t.nextTick=t.platform=t.env=t.cwd=void 0,r="undefined"!=typeof process?process:void 0!==i.globals.vscode?i.globals.vscode.process:{get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},nextTick:e=>i.setImmediate(e),get env(){return Object.create(null)},cwd:()=>"/",getuid:()=>-1},t.cwd=r.cwd,t.env=r.env,t.platform=r.platform,t.nextTick=r.nextTick})),define(t[3],i([0,1,41]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const r=65,n=97,s=90,o=122,a=46,l=47,c=92;class u extends Error{constructor(e,t,i){let r;"string"==typeof t&&0===t.indexOf("not ")?(r="must not be",t=t.replace(/^not /,"")):r="must be";const n=-1!==e.indexOf(".")?"property":"argument";let s=`The "${e}" ${n} ${r} of type ${t}`;super(s+=`. Received type ${typeof i}`),this.code="ERR_INVALID_ARG_TYPE"}}function h(e,t){
if("string"!=typeof e)throw new u(t,"string",e)}function d(e){return e===l||e===c}function f(e){return e===l}function p(e){return e>=r&&e<=s||e>=n&&e<=o}function g(e,t,i,r){let n="",s=0,o=-1,c=0,u=0;for(let h=0;h<=e.length;++h){if(h<e.length)u=e.charCodeAt(h);else{if(r(u))break;u=l}if(r(u)){if(o===h-1||1===c);else if(2===c){if(n.length<2||2!==s||n.charCodeAt(n.length-1)!==a||n.charCodeAt(n.length-2)!==a){if(n.length>2){const e=n.lastIndexOf(i);-1===e?(n="",s=0):s=(n=n.slice(0,e)).length-1-n.lastIndexOf(i),o=h,c=0;continue}if(0!==n.length){n="",s=0,o=h,c=0;continue}}t&&(n+=n.length>0?`${i}..`:"..",s=2)}else n.length>0?n+=`${i}${e.slice(o+1,h)}`:n=e.slice(o+1,h),s=h-o-1;o=h,c=0}else u===a&&-1!==c?++c:c=-1}return n}function m(e,t){if(null===t||"object"!=typeof t)throw new u("pathObject","Object",t);const i=t.dir||t.root,r=t.base||`${t.name||""}${t.ext||""}`;return i?i===t.root?`${i}${r}`:`${i}${e}${r}`:r}t.win32={resolve(...e){let t="",r="",n=!1;for(let s=e.length-1;s>=-1;s--){let o;if(s>=0){if(h(o=e[s],"path"),
0===o.length)continue}else 0===t.length?o=i.cwd():(void 0===(o=i.env[`=${t}`]||i.cwd())||o.slice(0,2).toLowerCase()!==t.toLowerCase()&&o.charCodeAt(2)===c)&&(o=`${t}\\`);const a=o.length;let l=0,u="",f=!1;const g=o.charCodeAt(0);if(1===a)d(g)&&(l=1,f=!0);else if(d(g))if(f=!0,d(o.charCodeAt(1))){let e=2,t=e;for(;e<a&&!d(o.charCodeAt(e));)e++;if(e<a&&e!==t){const i=o.slice(t,e);for(t=e;e<a&&d(o.charCodeAt(e));)e++;if(e<a&&e!==t){for(t=e;e<a&&!d(o.charCodeAt(e));)e++;e!==a&&e===t||(u=`\\\\${i}\\${o.slice(t,e)}`,l=e)}}}else l=1;else p(g)&&58===o.charCodeAt(1)&&(u=o.slice(0,2),l=2,a>2&&d(o.charCodeAt(2))&&(f=!0,l=3));if(u.length>0)if(t.length>0){if(u.toLowerCase()!==t.toLowerCase())continue}else t=u;if(n){if(t.length>0)break}else if(r=`${o.slice(l)}\\${r}`,n=f,f&&t.length>0)break}return r=g(r,!n,"\\",d),n?`${t}\\${r}`:`${t}${r}`||"."},normalize(e){h(e,"path");const t=e.length;if(0===t)return".";let i,r=0,n=!1;const s=e.charCodeAt(0);if(1===t)return f(s)?"\\":e;if(d(s))if(n=!0,d(e.charCodeAt(1))){let n=2,s=n
;for(;n<t&&!d(e.charCodeAt(n));)n++;if(n<t&&n!==s){const o=e.slice(s,n);for(s=n;n<t&&d(e.charCodeAt(n));)n++;if(n<t&&n!==s){for(s=n;n<t&&!d(e.charCodeAt(n));)n++;if(n===t)return`\\\\${o}\\${e.slice(s)}\\`;n!==s&&(i=`\\\\${o}\\${e.slice(s,n)}`,r=n)}}}else r=1;else p(s)&&58===e.charCodeAt(1)&&(i=e.slice(0,2),r=2,t>2&&d(e.charCodeAt(2))&&(n=!0,r=3));let o=r<t?g(e.slice(r),!n,"\\",d):"";return 0!==o.length||n||(o="."),o.length>0&&d(e.charCodeAt(t-1))&&(o+="\\"),void 0===i?n?`\\${o}`:o:n?`${i}\\${o}`:`${i}${o}`},isAbsolute(e){h(e,"path");const t=e.length;if(0===t)return!1;const i=e.charCodeAt(0);return d(i)||t>2&&p(i)&&58===e.charCodeAt(1)&&d(e.charCodeAt(2))},join(...e){if(0===e.length)return".";let i,r;for(let t=0;t<e.length;++t){const n=e[t];h(n,"path"),n.length>0&&(void 0===i?i=r=n:i+=`\\${n}`)}if(void 0===i)return".";let n=!0,s=0;if("string"==typeof r&&d(r.charCodeAt(0))){++s;const e=r.length;e>1&&d(r.charCodeAt(1))&&(++s,e>2&&(d(r.charCodeAt(2))?++s:n=!1))}if(n){for(;s<i.length&&d(i.charCodeAt(s));)s++
;s>=2&&(i=`\\${i.slice(s)}`)}return t.win32.normalize(i)},relative(e,i){if(h(e,"from"),h(i,"to"),e===i)return"";const r=t.win32.resolve(e),n=t.win32.resolve(i);if(r===n)return"";if((e=r.toLowerCase())===(i=n.toLowerCase()))return"";let s=0;for(;s<e.length&&e.charCodeAt(s)===c;)s++;let o=e.length;for(;o-1>s&&e.charCodeAt(o-1)===c;)o--;const a=o-s;let l=0;for(;l<i.length&&i.charCodeAt(l)===c;)l++;let u=i.length;for(;u-1>l&&i.charCodeAt(u-1)===c;)u--;const d=u-l,f=a<d?a:d;let p=-1,g=0;for(;g<f;g++){const t=e.charCodeAt(s+g);if(t!==i.charCodeAt(l+g))break;t===c&&(p=g)}if(g!==f){if(-1===p)return n}else{if(d>f){if(i.charCodeAt(l+g)===c)return n.slice(l+g+1);if(2===g)return n.slice(l+g)}a>f&&(e.charCodeAt(s+g)===c?p=g:2===g&&(p=3)),-1===p&&(p=0)}let m="";for(g=s+p+1;g<=o;++g)g!==o&&e.charCodeAt(g)!==c||(m+=0===m.length?"..":"\\..");return l+=p,m.length>0?`${m}${n.slice(l,u)}`:(n.charCodeAt(l)===c&&++l,n.slice(l,u))},toNamespacedPath(e){if("string"!=typeof e)return e;if(0===e.length)return""
;const i=t.win32.resolve(e);if(i.length<=2)return e;if(i.charCodeAt(0)===c){if(i.charCodeAt(1)===c){const e=i.charCodeAt(2);if(63!==e&&e!==a)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(p(i.charCodeAt(0))&&58===i.charCodeAt(1)&&i.charCodeAt(2)===c)return`\\\\?\\${i}`;return e},dirname(e){h(e,"path");const t=e.length;if(0===t)return".";let i=-1,r=0;const n=e.charCodeAt(0);if(1===t)return d(n)?e:".";if(d(n)){if(i=r=1,d(e.charCodeAt(1))){let n=2,s=n;for(;n<t&&!d(e.charCodeAt(n));)n++;if(n<t&&n!==s){for(s=n;n<t&&d(e.charCodeAt(n));)n++;if(n<t&&n!==s){for(s=n;n<t&&!d(e.charCodeAt(n));)n++;if(n===t)return e;n!==s&&(i=r=n+1)}}}}else p(n)&&58===e.charCodeAt(1)&&(r=i=t>2&&d(e.charCodeAt(2))?3:2);let s=-1,o=!0;for(let i=t-1;i>=r;--i)if(d(e.charCodeAt(i))){if(!o){s=i;break}}else o=!1;if(-1===s){if(-1===i)return".";s=i}return e.slice(0,s)},basename(e,t){void 0!==t&&h(t,"ext"),h(e,"path");let i,r=0,n=-1,s=!0;if(e.length>=2&&p(e.charCodeAt(0))&&58===e.charCodeAt(1)&&(r=2),void 0!==t&&t.length>0&&t.length<=e.length){
if(t===e)return"";let o=t.length-1,a=-1;for(i=e.length-1;i>=r;--i){const l=e.charCodeAt(i);if(d(l)){if(!s){r=i+1;break}}else-1===a&&(s=!1,a=i+1),o>=0&&(l===t.charCodeAt(o)?-1==--o&&(n=i):(o=-1,n=a))}return r===n?n=a:-1===n&&(n=e.length),e.slice(r,n)}for(i=e.length-1;i>=r;--i)if(d(e.charCodeAt(i))){if(!s){r=i+1;break}}else-1===n&&(s=!1,n=i+1);return-1===n?"":e.slice(r,n)},extname(e){h(e,"path");let t=0,i=-1,r=0,n=-1,s=!0,o=0;e.length>=2&&58===e.charCodeAt(1)&&p(e.charCodeAt(0))&&(t=r=2);for(let l=e.length-1;l>=t;--l){const t=e.charCodeAt(l);if(d(t)){if(!s){r=l+1;break}}else-1===n&&(s=!1,n=l+1),t===a?-1===i?i=l:1!==o&&(o=1):-1!==i&&(o=-1)}return-1===i||-1===n||0===o||1===o&&i===n-1&&i===r+1?"":e.slice(i,n)},format:m.bind(null,"\\"),parse(e){h(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const i=e.length;let r=0,n=e.charCodeAt(0);if(1===i)return d(n)?(t.root=t.dir=e,t):(t.base=t.name=e,t);if(d(n)){if(r=1,d(e.charCodeAt(1))){let t=2,n=t;for(;t<i&&!d(e.charCodeAt(t));)t++
;if(t<i&&t!==n){for(n=t;t<i&&d(e.charCodeAt(t));)t++;if(t<i&&t!==n){for(n=t;t<i&&!d(e.charCodeAt(t));)t++;t===i?r=t:t!==n&&(r=t+1)}}}}else if(p(n)&&58===e.charCodeAt(1)){if(i<=2)return t.root=t.dir=e,t;if(r=2,d(e.charCodeAt(2))){if(3===i)return t.root=t.dir=e,t;r=3}}r>0&&(t.root=e.slice(0,r));let s=-1,o=r,l=-1,c=!0,u=e.length-1,f=0;for(;u>=r;--u)if(d(n=e.charCodeAt(u))){if(!c){o=u+1;break}}else-1===l&&(c=!1,l=u+1),n===a?-1===s?s=u:1!==f&&(f=1):-1!==s&&(f=-1);return-1!==l&&(-1===s||0===f||1===f&&s===l-1&&s===o+1?t.base=t.name=e.slice(o,l):(t.name=e.slice(o,s),t.base=e.slice(o,l),t.ext=e.slice(s,l))),t.dir=o>0&&o!==r?e.slice(0,o-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...e){let t="",r=!1;for(let n=e.length-1;n>=-1&&!r;n--){const s=n>=0?e[n]:i.cwd();h(s,"path"),0!==s.length&&(t=`${s}/${t}`,r=s.charCodeAt(0)===l)}return t=g(t,!r,"/",f),r?`/${t}`:t.length>0?t:"."},normalize(e){if(h(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===l,i=e.charCodeAt(e.length-1)===l
;return 0===(e=g(e,!t,"/",f)).length?t?"/":i?"./":".":(i&&(e+="/"),t?`/${e}`:e)},isAbsolute:e=>(h(e,"path"),e.length>0&&e.charCodeAt(0)===l),join(...e){if(0===e.length)return".";let i;for(let t=0;t<e.length;++t){const r=e[t];h(r,"path"),r.length>0&&(void 0===i?i=r:i+=`/${r}`)}return void 0===i?".":t.posix.normalize(i)},relative(e,i){if(h(e,"from"),h(i,"to"),e===i)return"";if((e=t.posix.resolve(e))===(i=t.posix.resolve(i)))return"";const r=e.length,n=r-1,s=i.length-1,o=n<s?n:s;let a=-1,c=0;for(;c<o;c++){const t=e.charCodeAt(1+c);if(t!==i.charCodeAt(1+c))break;t===l&&(a=c)}if(c===o)if(s>o){if(i.charCodeAt(1+c)===l)return i.slice(1+c+1);if(0===c)return i.slice(1+c)}else n>o&&(e.charCodeAt(1+c)===l?a=c:0===c&&(a=0));let u="";for(c=1+a+1;c<=r;++c)c!==r&&e.charCodeAt(c)!==l||(u+=0===u.length?"..":"/..");return`${u}${i.slice(1+a)}`},toNamespacedPath:e=>e,dirname(e){if(h(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===l;let i=-1,r=!0;for(let t=e.length-1;t>=1;--t)if(e.charCodeAt(t)===l){if(!r){i=t;break}
}else r=!1;return-1===i?t?"/":".":t&&1===i?"//":e.slice(0,i)},basename(e,t){void 0!==t&&h(t,"ext"),h(e,"path");let i,r=0,n=-1,s=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let o=t.length-1,a=-1;for(i=e.length-1;i>=0;--i){const c=e.charCodeAt(i);if(c===l){if(!s){r=i+1;break}}else-1===a&&(s=!1,a=i+1),o>=0&&(c===t.charCodeAt(o)?-1==--o&&(n=i):(o=-1,n=a))}return r===n?n=a:-1===n&&(n=e.length),e.slice(r,n)}for(i=e.length-1;i>=0;--i)if(e.charCodeAt(i)===l){if(!s){r=i+1;break}}else-1===n&&(s=!1,n=i+1);return-1===n?"":e.slice(r,n)},extname(e){h(e,"path");let t=-1,i=0,r=-1,n=!0,s=0;for(let o=e.length-1;o>=0;--o){const c=e.charCodeAt(o);if(c!==l)-1===r&&(n=!1,r=o+1),c===a?-1===t?t=o:1!==s&&(s=1):-1!==t&&(s=-1);else if(!n){i=o+1;break}}return-1===t||-1===r||0===s||1===s&&t===r-1&&t===i+1?"":e.slice(t,r)},format:m.bind(null,"/"),parse(e){h(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const i=e.charCodeAt(0)===l;let r;i?(t.root="/",r=1):r=0
;let n=-1,s=0,o=-1,c=!0,u=e.length-1,d=0;for(;u>=r;--u){const t=e.charCodeAt(u);if(t!==l)-1===o&&(c=!1,o=u+1),t===a?-1===n?n=u:1!==d&&(d=1):-1!==n&&(d=-1);else if(!c){s=u+1;break}}if(-1!==o){const r=0===s&&i?1:s;-1===n||0===d||1===d&&n===o-1&&n===s+1?t.base=t.name=e.slice(r,o):(t.name=e.slice(r,n),t.base=e.slice(r,o),t.ext=e.slice(n,o))}return s>0?t.dir=e.slice(0,s-1):i&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize="win32"===i.platform?t.win32.normalize:t.posix.normalize,t.isAbsolute="win32"===i.platform?t.win32.isAbsolute:t.posix.isAbsolute,t.join="win32"===i.platform?t.win32.join:t.posix.join,t.resolve="win32"===i.platform?t.win32.resolve:t.posix.resolve,t.relative="win32"===i.platform?t.win32.relative:t.posix.relative,t.dirname="win32"===i.platform?t.win32.dirname:t.posix.dirname,t.basename="win32"===i.platform?t.win32.basename:t.posix.basename,t.extname="win32"===i.platform?t.win32.extname:t.posix.extname,
t.format="win32"===i.platform?t.win32.format:t.posix.format,t.parse="win32"===i.platform?t.win32.parse:t.posix.parse,t.toNamespacedPath="win32"===i.platform?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep="win32"===i.platform?t.win32.sep:t.posix.sep,t.delimiter="win32"===i.platform?t.win32.delimiter:t.posix.delimiter})),define(t[96],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0,function(e){e[e.stdout=0]="stdout",e[e.stderr=1]="stderr"}(t.Source||(t.Source={})),function(e){e[e.Success=0]="Success",e[e.Unknown=1]="Unknown",e[e.AccessDenied=2]="AccessDenied",e[e.ProcessNotFound=3]="ProcessNotFound"}(t.TerminateResponseCode||(t.TerminateResponseCode={})),t.sanitizeProcessEnvironment=function(e,...t){const i=t.reduce((e,t)=>(e[t]=!0,e),{}),r=[/^ELECTRON_.+$/,/^GOOGLE_API_KEY$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/];Object.keys(e).filter(e=>!i[e]).forEach(t=>{
for(let i=0;i<r.length;i++)if(-1!==t.search(r[i])){delete e[t];break}})}})),function(e,t){if("object"==typeof exports&&"object"==typeof module)module.exports=t();else if("function"==typeof define&&define.amd)define("vs/base/common/semver/semver",[],t);else{var i=t();for(var r in i)("object"==typeof exports?exports:e)[r]=i[r]}}("undefined"!=typeof self?self:this,(function(){return function(e){var t={};function i(r){if(t[r])return t[r].exports;var n=t[r]={i:r,l:!1,exports:{}};return e[r].call(n.exports,n,n.exports,i),n.l=!0,n.exports}return i.m=e,i.c=t,i.d=function(e,t,r){i.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:r})},i.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},i.t=function(e,t){if(1&t&&(e=i(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(i.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),
2&t&&"string"!=typeof e)for(var n in e)i.d(r,n,function(t){return e[t]}.bind(null,n));return r},i.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return i.d(t,"a",t),t},i.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},i.p="",i(i.s=0)}([function(e,t,i){(function(i){var r;t=e.exports=H,r="object"==typeof i&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var e=Array.prototype.slice.call(arguments,0);e.unshift("SEMVER"),console.log.apply(console,e)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var n=256,s=Number.MAX_SAFE_INTEGER||9007199254740991,o=t.re=[],a=t.src=[],l=0,c=l++;a[c]="0|[1-9]\\d*";var u=l++;a[u]="[0-9]+";var h=l++;a[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=l++;a[d]="("+a[c]+")\\.("+a[c]+")\\.("+a[c]+")";var f=l++;a[f]="("+a[u]+")\\.("+a[u]+")\\.("+a[u]+")";var p=l++;a[p]="(?:"+a[c]+"|"+a[h]+")";var g=l++;a[g]="(?:"+a[u]+"|"+a[h]+")";var m=l++;a[m]="(?:-("+a[p]+"(?:\\."+a[p]+")*))";var v=l++
;a[v]="(?:-?("+a[g]+"(?:\\."+a[g]+")*))";var y=l++;a[y]="[0-9A-Za-z-]+";var E=l++;a[E]="(?:\\+("+a[y]+"(?:\\."+a[y]+")*))";var w=l++,_="v?"+a[d]+a[m]+"?"+a[E]+"?";a[w]="^"+_+"$";var b="[v=\\s]*"+a[f]+a[v]+"?"+a[E]+"?",S=l++;a[S]="^"+b+"$";var C=l++;a[C]="((?:<|>)?=?)";var x=l++;a[x]=a[u]+"|x|X|\\*";var I=l++;a[I]=a[c]+"|x|X|\\*";var P=l++;a[P]="[v=\\s]*("+a[I]+")(?:\\.("+a[I]+")(?:\\.("+a[I]+")(?:"+a[m]+")?"+a[E]+"?)?)?";var T=l++;a[T]="[v=\\s]*("+a[x]+")(?:\\.("+a[x]+")(?:\\.("+a[x]+")(?:"+a[v]+")?"+a[E]+"?)?)?";var k=l++;a[k]="^"+a[C]+"\\s*"+a[P]+"$";var L=l++;a[L]="^"+a[C]+"\\s*"+a[T]+"$";var O=l++;a[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=l++;a[D]="(?:~>?)";var R=l++;a[R]="(\\s*)"+a[D]+"\\s+",o[R]=new RegExp(a[R],"g");var A=l++;a[A]="^"+a[D]+a[P]+"$";var F=l++;a[F]="^"+a[D]+a[T]+"$";var N=l++;a[N]="(?:\\^)";var M=l++;a[M]="(\\s*)"+a[N]+"\\s+",o[M]=new RegExp(a[M],"g");var U=l++;a[U]="^"+a[N]+a[P]+"$";var j=l++;a[j]="^"+a[N]+a[T]+"$";var z=l++
;a[z]="^"+a[C]+"\\s*("+b+")$|^$";var B=l++;a[B]="^"+a[C]+"\\s*("+_+")$|^$";var W=l++;a[W]="(\\s*)"+a[C]+"\\s*("+b+"|"+a[P]+")",o[W]=new RegExp(a[W],"g");var V=l++;a[V]="^\\s*("+a[P]+")\\s+-\\s+("+a[P]+")\\s*$";var $=l++;a[$]="^\\s*("+a[T]+")\\s+-\\s+("+a[T]+")\\s*$";var q=l++;a[q]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)r(G,a[G]),o[G]||(o[G]=new RegExp(a[G]));function K(e,t){if(e instanceof H)return e;if("string"!=typeof e)return null;if(e.length>n)return null;if(!(t?o[S]:o[w]).test(e))return null;try{return new H(e,t)}catch(e){return null}}function H(e,t){if(e instanceof H){if(e.loose===t)return e;e=e.version}else if("string"!=typeof e)throw new TypeError("Invalid Version: "+e);if(e.length>n)throw new TypeError("version is longer than "+n+" characters");if(!(this instanceof H))return new H(e,t);r("SemVer",e,t),this.loose=t;var i=e.trim().match(t?o[S]:o[w]);if(!i)throw new TypeError("Invalid Version: "+e);if(this.raw=e,this.major=+i[1],this.minor=+i[2],this.patch=+i[3],
this.major>s||this.major<0)throw new TypeError("Invalid major version");if(this.minor>s||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>s||this.patch<0)throw new TypeError("Invalid patch version");i[4]?this.prerelease=i[4].split(".").map((function(e){if(/^[0-9]+$/.test(e)){var t=+e;if(t>=0&&t<s)return t}return e})):this.prerelease=[],this.build=i[5]?i[5].split("."):[],this.format()}t.parse=K,t.valid=function(e,t){var i=K(e,t);return i?i.version:null},t.clean=function(e,t){var i=K(e.trim().replace(/^[=v]+/,""),t);return i?i.version:null},t.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(e){return r("SemVer.compare",this.version,this.loose,e),e instanceof H||(e=new H(e,this.loose)),this.compareMain(e)||this.comparePre(e)},H.prototype.compareMain=function(e){
return e instanceof H||(e=new H(e,this.loose)),Y(this.major,e.major)||Y(this.minor,e.minor)||Y(this.patch,e.patch)},H.prototype.comparePre=function(e){if(e instanceof H||(e=new H(e,this.loose)),this.prerelease.length&&!e.prerelease.length)return-1;if(!this.prerelease.length&&e.prerelease.length)return 1;if(!this.prerelease.length&&!e.prerelease.length)return 0;var t=0;do{var i=this.prerelease[t],n=e.prerelease[t];if(r("prerelease compare",t,i,n),void 0===i&&void 0===n)return 0;if(void 0===n)return 1;if(void 0===i)return-1;if(i!==n)return Y(i,n)}while(++t)},H.prototype.inc=function(e,t){switch(e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",t);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",t);break;case"prepatch":this.prerelease.length=0,this.inc("patch",t),this.inc("pre",t);break;case"prerelease":0===this.prerelease.length&&this.inc("patch",t),this.inc("pre",t);break;case"major":
0===this.minor&&0===this.patch&&0!==this.prerelease.length||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":0===this.patch&&0!==this.prerelease.length||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":0===this.prerelease.length&&this.patch++,this.prerelease=[];break;case"pre":if(0===this.prerelease.length)this.prerelease=[0];else{for(var i=this.prerelease.length;--i>=0;)"number"==typeof this.prerelease[i]&&(this.prerelease[i]++,i=-2);-1===i&&this.prerelease.push(0)}t&&(this.prerelease[0]===t?isNaN(this.prerelease[1])&&(this.prerelease=[t,0]):this.prerelease=[t,0]);break;default:throw new Error("invalid increment argument: "+e)}return this.format(),this.raw=this.version,this},t.inc=function(e,t,i,r){"string"==typeof i&&(r=i,i=void 0);try{return new H(e,i).inc(t,r).version}catch(e){return null}},t.diff=function(e,t){if(ee(e,t))return null;var i=K(e),r=K(t);if(i.prerelease.length||r.prerelease.length){
for(var n in i)if(("major"===n||"minor"===n||"patch"===n)&&i[n]!==r[n])return"pre"+n;return"prerelease"}for(var n in i)if(("major"===n||"minor"===n||"patch"===n)&&i[n]!==r[n])return n},t.compareIdentifiers=Y;var X=/^[0-9]+$/;function Y(e,t){var i=X.test(e),r=X.test(t);return i&&r&&(e=+e,t=+t),i&&!r?-1:r&&!i?1:e<t?-1:e>t?1:0}function Q(e,t,i){return new H(e,i).compare(new H(t,i))}function J(e,t,i){return Q(e,t,i)>0}function Z(e,t,i){return Q(e,t,i)<0}function ee(e,t,i){return 0===Q(e,t,i)}function te(e,t,i){return 0!==Q(e,t,i)}function ie(e,t,i){return Q(e,t,i)>=0}function re(e,t,i){return Q(e,t,i)<=0}function ne(e,t,i,r){var n;switch(t){case"===":"object"==typeof e&&(e=e.version),"object"==typeof i&&(i=i.version),n=e===i;break;case"!==":"object"==typeof e&&(e=e.version),"object"==typeof i&&(i=i.version),n=e!==i;break;case"":case"=":case"==":n=ee(e,i,r);break;case"!=":n=te(e,i,r);break;case">":n=J(e,i,r);break;case">=":n=ie(e,i,r);break;case"<":n=Z(e,i,r);break;case"<=":n=re(e,i,r);break;default:
throw new TypeError("Invalid operator: "+t)}return n}function se(e,t){if(e instanceof se){if(e.loose===t)return e;e=e.value}if(!(this instanceof se))return new se(e,t);r("comparator",e,t),this.loose=t,this.parse(e),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}t.rcompareIdentifiers=function(e,t){return Y(t,e)},t.major=function(e,t){return new H(e,t).major},t.minor=function(e,t){return new H(e,t).minor},t.patch=function(e,t){return new H(e,t).patch},t.compare=Q,t.compareLoose=function(e,t){return Q(e,t,!0)},t.rcompare=function(e,t,i){return Q(t,e,i)},t.sort=function(e,i){return e.sort((function(e,r){return t.compare(e,r,i)}))},t.rsort=function(e,i){return e.sort((function(e,r){return t.rcompare(e,r,i)}))},t.gt=J,t.lt=Z,t.eq=ee,t.neq=te,t.gte=ie,t.lte=re,t.cmp=ne,t.Comparator=se;var oe={};function ae(e,t){if(e instanceof ae)return e.loose===t?e:new ae(e.raw,t);if(e instanceof se)return new ae(e.value,t);if(!(this instanceof ae))return new ae(e,t);if(this.loose=t,
this.raw=e,this.set=e.split(/\s*\|\|\s*/).map((function(e){return this.parseRange(e.trim())}),this).filter((function(e){return e.length})),!this.set.length)throw new TypeError("Invalid SemVer Range: "+e);this.format()}function le(e){return!e||"x"===e.toLowerCase()||"*"===e}function ce(e,t,i,r,n,s,o,a,l,c,u,h,d){return((t=le(i)?"":le(r)?">="+i+".0.0":le(n)?">="+i+"."+r+".0":">="+t)+" "+(a=le(l)?"":le(c)?"<"+(+l+1)+".0.0":le(u)?"<"+l+"."+(+c+1)+".0":h?"<="+l+"."+c+"."+u+"-"+h:"<="+a)).trim()}function ue(e,t){for(var i=0;i<e.length;i++)if(!e[i].test(t))return!1;if(t.prerelease.length){for(i=0;i<e.length;i++)if(r(e[i].semver),e[i].semver!==oe&&e[i].semver.prerelease.length>0){var n=e[i].semver;if(n.major===t.major&&n.minor===t.minor&&n.patch===t.patch)return!0}return!1}return!0}function he(e,t,i){try{t=new ae(t,i)}catch(e){return!1}return t.test(e)}function de(e,t,i,r){var n,s,o,a,l;switch(e=new H(e,r),t=new ae(t,r),i){case">":n=J,s=re,o=Z,a=">",l=">=";break;case"<":n=Z,s=ie,o=J,a="<",l="<=";break;default:
throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(e,t,r))return!1;for(var c=0;c<t.set.length;++c){var u=t.set[c],h=null,d=null;if(u.forEach((function(e){e.semver===oe&&(e=new se(">=0.0.0")),h=h||e,d=d||e,n(e.semver,h.semver,r)?h=e:o(e.semver,d.semver,r)&&(d=e)})),h.operator===a||h.operator===l)return!1;if((!d.operator||d.operator===a)&&s(e,d.semver))return!1;if(d.operator===l&&o(e,d.semver))return!1}return!0}se.prototype.parse=function(e){var t=this.loose?o[z]:o[B],i=e.match(t);if(!i)throw new TypeError("Invalid comparator: "+e);this.operator=i[1],"="===this.operator&&(this.operator=""),i[2]?this.semver=new H(i[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(e){return r("Comparator.test",e,this.loose),this.semver===oe||("string"==typeof e&&(e=new H(e,this.loose)),ne(e,this.operator,this.semver,this.loose))},se.prototype.intersects=function(e,t){if(!(e instanceof se))throw new TypeError("a Comparator is required");var i
;if(""===this.operator)return i=new ae(e.value,t),he(this.value,i,t);if(""===e.operator)return i=new ae(this.value,t),he(e.semver,i,t);var r=!(">="!==this.operator&&">"!==this.operator||">="!==e.operator&&">"!==e.operator),n=!("<="!==this.operator&&"<"!==this.operator||"<="!==e.operator&&"<"!==e.operator),s=this.semver.version===e.semver.version,o=!(">="!==this.operator&&"<="!==this.operator||">="!==e.operator&&"<="!==e.operator),a=ne(this.semver,"<",e.semver,t)&&(">="===this.operator||">"===this.operator)&&("<="===e.operator||"<"===e.operator),l=ne(this.semver,">",e.semver,t)&&("<="===this.operator||"<"===this.operator)&&(">="===e.operator||">"===e.operator);return r||n||s&&o||a||l},t.Range=ae,ae.prototype.format=function(){return this.range=this.set.map((function(e){return e.join(" ").trim()})).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(e){var t=this.loose;e=e.trim(),r("range",e,t);var i=t?o[$]:o[V];e=e.replace(i,ce),
r("hyphen replace",e),e=e.replace(o[W],"$1$2$3"),r("comparator trim",e,o[W]),e=(e=(e=e.replace(o[R],"$1~")).replace(o[M],"$1^")).split(/\s+/).join(" ");var n=t?o[z]:o[B],s=e.split(" ").map((function(e){return function(e,t){return r("comp",e),e=function(e,t){return e.trim().split(/\s+/).map((function(e){return function(e,t){r("caret",e,t);var i=t?o[j]:o[U];return e.replace(i,(function(t,i,n,s,o){var a;return r("caret",e,t,i,n,s,o),le(i)?a="":le(n)?a=">="+i+".0.0 <"+(+i+1)+".0.0":le(s)?a="0"===i?">="+i+"."+n+".0 <"+i+"."+(+n+1)+".0":">="+i+"."+n+".0 <"+(+i+1)+".0.0":o?(r("replaceCaret pr",o),"-"!==o.charAt(0)&&(o="-"+o),a="0"===i?"0"===n?">="+i+"."+n+"."+s+o+" <"+i+"."+n+"."+(+s+1):">="+i+"."+n+"."+s+o+" <"+i+"."+(+n+1)+".0":">="+i+"."+n+"."+s+o+" <"+(+i+1)+".0.0"):(r("no pr"),a="0"===i?"0"===n?">="+i+"."+n+"."+s+" <"+i+"."+n+"."+(+s+1):">="+i+"."+n+"."+s+" <"+i+"."+(+n+1)+".0":">="+i+"."+n+"."+s+" <"+(+i+1)+".0.0"),r("caret return",a),a}))}(e,t)})).join(" ")}(e,t),r("caret",e),e=function(e,t){
return e.trim().split(/\s+/).map((function(e){return function(e,t){var i=t?o[F]:o[A];return e.replace(i,(function(t,i,n,s,o){var a;return r("tilde",e,t,i,n,s,o),le(i)?a="":le(n)?a=">="+i+".0.0 <"+(+i+1)+".0.0":le(s)?a=">="+i+"."+n+".0 <"+i+"."+(+n+1)+".0":o?(r("replaceTilde pr",o),"-"!==o.charAt(0)&&(o="-"+o),a=">="+i+"."+n+"."+s+o+" <"+i+"."+(+n+1)+".0"):a=">="+i+"."+n+"."+s+" <"+i+"."+(+n+1)+".0",r("tilde return",a),a}))}(e,t)})).join(" ")}(e,t),r("tildes",e),e=function(e,t){return r("replaceXRanges",e,t),e.split(/\s+/).map((function(e){return function(e,t){e=e.trim();var i=t?o[L]:o[k];return e.replace(i,(function(t,i,n,s,o,a){r("xRange",e,t,i,n,s,o,a);var l=le(n),c=l||le(s),u=c||le(o);return"="===i&&u&&(i=""),l?t=">"===i||"<"===i?"<0.0.0":"*":i&&u?(c&&(s=0),u&&(o=0),">"===i?(i=">=",c?(n=+n+1,s=0,o=0):u&&(s=+s+1,o=0)):"<="===i&&(i="<",c?n=+n+1:s=+s+1),t=i+n+"."+s+"."+o):c?t=">="+n+".0.0 <"+(+n+1)+".0.0":u&&(t=">="+n+"."+s+".0 <"+n+"."+(+s+1)+".0"),r("xRange return",t),t}))}(e,t)})).join(" ")}(e,t),
r("xrange",e),e=function(e,t){return r("replaceStars",e,t),e.trim().replace(o[q],"")}(e,t),r("stars",e),e}(e,t)})).join(" ").split(/\s+/);return this.loose&&(s=s.filter((function(e){return!!e.match(n)}))),s.map((function(e){return new se(e,t)}))},ae.prototype.intersects=function(e,t){if(!(e instanceof ae))throw new TypeError("a Range is required");return this.set.some((function(i){return i.every((function(i){return e.set.some((function(e){return e.every((function(e){return i.intersects(e,t)}))}))}))}))},t.toComparators=function(e,t){return new ae(e,t).set.map((function(e){return e.map((function(e){return e.value})).join(" ").trim().split(" ")}))},ae.prototype.test=function(e){if(!e)return!1;"string"==typeof e&&(e=new H(e,this.loose));for(var t=0;t<this.set.length;t++)if(ue(this.set[t],e))return!0;return!1},t.satisfies=he,t.maxSatisfying=function(e,t,i){var r=null,n=null;try{var s=new ae(t,i)}catch(e){return null}return e.forEach((function(e){s.test(e)&&(r&&-1!==n.compare(e)||(n=new H(r=e,i)))})),r},
t.minSatisfying=function(e,t,i){var r=null,n=null;try{var s=new ae(t,i)}catch(e){return null}return e.forEach((function(e){s.test(e)&&(r&&1!==n.compare(e)||(n=new H(r=e,i)))})),r},t.validRange=function(e,t){try{return new ae(e,t).range||"*"}catch(e){return null}},t.ltr=function(e,t,i){return de(e,t,"<",i)},t.gtr=function(e,t,i){return de(e,t,">",i)},t.outside=de,t.prerelease=function(e,t){var i=K(e,t);return i&&i.prerelease.length?i.prerelease:null},t.intersects=function(e,t,i){return e=new ae(e,i),t=new ae(t,i),e.intersects(t)},t.coerce=function(e){if(e instanceof H)return e;if("string"!=typeof e)return null;var t=e.match(o[O]);return null==t?null:K((t[1]||"0")+"."+(t[2]||"0")+"."+(t[3]||"0"))}}).call(this,i(1))},function(e,t){var i,r,n=e.exports={};function s(){throw new Error("setTimeout has not been defined")}function o(){throw new Error("clearTimeout has not been defined")}function a(e){if(i===setTimeout)return setTimeout(e,0);if((i===s||!i)&&setTimeout)return i=setTimeout,setTimeout(e,0);try{
return i(e,0)}catch(t){try{return i.call(null,e,0)}catch(t){return i.call(this,e,0)}}}!function(){try{i="function"==typeof setTimeout?setTimeout:s}catch(e){i=s}try{r="function"==typeof clearTimeout?clearTimeout:o}catch(e){r=o}}();var l,c=[],u=!1,h=-1;function d(){u&&l&&(u=!1,l.length?c=l.concat(c):h=-1,c.length&&f())}function f(){if(!u){var e=a(d);u=!0;for(var t=c.length;t;){for(l=c,c=[];++h<t;)l&&l[h].run();h=-1,t=c.length}l=null,u=!1,function(e){if(r===clearTimeout)return clearTimeout(e);if((r===o||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(e);try{r(e)}catch(t){try{return r.call(null,e)}catch(t){return r.call(this,e)}}}(e)}}function p(e,t){this.fun=e,this.array=t}function g(){}n.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)t[i-1]=arguments[i];c.push(new p(e,t)),1!==c.length||u||a(f)},p.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=g,
n.addListener=g,n.once=g,n.off=g,n.removeListener=g,n.removeAllListeners=g,n.emit=g,n.prependListener=g,n.prependOnceListener=g,n.listeners=function(e){return[]},n.binding=function(e){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(e){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])})),define(t[42],i([0,1,2]),(function(e,t,i){"use strict";function r(e){const t=e;return t&&[t.on,t.pause,t.resume,t.destroy].every(e=>"function"==typeof e)}function n(e,t){return new s(e,t)}Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.toStream=t.peekStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0,t.isReadableStream=r,t.isReadableBufferedStream=function(e){const t=e;return t&&r(t.stream)&&Array.isArray(t.buffer)&&"boolean"==typeof t.ended},t.newWriteableStream=n;class s{constructor(e,t){this.reducer=e,this.options=t,this.state={
flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(e){var t;if(!this.state.destroyed)if(this.state.flowing)this.listeners.data.forEach(t=>t(e));else if(this.buffer.data.push(e),"number"==typeof(null===(t=this.options)||void 0===t?void 0:t.highWaterMark)&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}error(e){this.state.destroyed||(this.state.flowing?this.listeners.error.forEach(t=>t(e)):this.buffer.error.push(e))}end(e){this.state.destroyed||(e instanceof Error?this.error(e):e&&this.write(e),this.state.flowing?(this.listeners.end.forEach(e=>e()),this.destroy()):this.state.ended=!0)}on(e,t){if(!this.state.destroyed)switch(e){case"data":this.listeners.data.push(t),this.resume();break
;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors()}}removeListener(e,t){if(this.state.destroyed)return;let i=void 0;switch(e){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error}if(i){const e=i.indexOf(t);e>=0&&i.splice(e,1)}}flowData(){if(this.buffer.data.length>0){const e=this.reducer(this.buffer.data);this.listeners.data.forEach(t=>t(e)),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const e of this.buffer.error)this.listeners.error.forEach(t=>t(e));this.buffer.error.length=0}}flowEnd(){return!!this.state.ended&&(this.listeners.end.forEach(e=>e()),this.listeners.end.length>0)}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,
this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}t.consumeReadable=function(e,t){const i=[];let r;for(;null!==(r=e.read());)i.push(r);return t(i)},t.peekReadable=function(e,t,i){const r=[];let n=void 0;for(;null!==(n=e.read())&&r.length<i;)r.push(n);return null===n&&r.length>0?t(r):{read:()=>{if(r.length>0)return r.shift();if(void 0!==n){const e=n;return n=void 0,e}return e.read()}}},t.consumeStream=function(e,t){return new Promise((i,r)=>{const n=[];e.on("data",e=>n.push(e)),e.on("error",e=>r(e)),e.on("end",()=>i(t(n)))})},t.peekStream=function(e,t){return new Promise((r,n)=>{const s=new i.DisposableStore,o=[],a=i=>{if(o.push(i),o.length>t)return s.dispose(),e.pause(),r({stream:e,buffer:o,ended:!1})};s.add(i.toDisposable(()=>e.removeListener("data",a))),e.on("data",a);const l=e=>n(e);s.add(i.toDisposable(()=>e.removeListener("error",l))),e.on("error",l);const c=()=>r({stream:e,buffer:o,ended:!0})
;s.add(i.toDisposable(()=>e.removeListener("end",c))),e.on("end",c)})},t.toStream=function(e,t){const i=n(t);return i.end(e),i},t.toReadable=function(e){let t=!1;return{read:()=>t?null:(t=!0,e)}},t.transform=function(e,t,i){const r=n(i);return e.on("data",e=>r.write(t.data(e))),e.on("end",()=>r.end()),e.on("error",e=>r.error(t.error?t.error(e):e)),r}})),define(t[16],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.count=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0,
t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length};const i=/{(\d+)}/g;function r(e){return e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function n(e,t){if(!e||!t)return e;const i=t.length;if(0===i||0===e.length)return e;let r=0;for(;e.indexOf(t,r)===r;)r+=i;return e.substring(r)}function s(e,t){if(!e||!t)return e;const i=t.length,r=e.length;if(0===i||0===r)return e;let n=r,s=-1;for(;-1!==(s=e.lastIndexOf(t,n-1))&&s+i===n;){if(0===s)return"";n=s}return e.substring(0,n)}function o(e,t,i=0,r=e.length,n=0,s=t.length){for(;i<r&&n<s;i++,n++){let r=e.charCodeAt(i),s=t.charCodeAt(n);if(r<s)return-1;if(r>s)return 1}const o=r-i,a=s-n;return o<a?-1:o>a?1:0}function a(e,t,i=0,r=e.length,n=0,s=t.length){for(;i<r&&n<s;i++,n++){let a=e.charCodeAt(i),u=t.charCodeAt(n);if(a===u)continue;const h=a-u;if((32!==h||!c(u))&&(-32!==h||!c(a)))return l(a)&&l(u)?h:o(e.toLowerCase(),t.toLowerCase(),i,r,n,s)}const a=r-i,u=s-n;return a<u?-1:a>u?1:0}function l(e){return e>=97&&e<=122}function c(e){
return e>=65&&e<=90}function u(e){return l(e)||c(e)}function h(e,t,i=e.length){for(let r=0;r<i;r++){const i=e.charCodeAt(r),n=t.charCodeAt(r);if(i!==n)if(u(i)&&u(n)){const e=Math.abs(i-n);if(0!==e&&32!==e)return!1}else if(String.fromCharCode(i).toLowerCase()!==String.fromCharCode(n).toLowerCase())return!1}return!0}function d(e){return 55296<=e&&e<=56319}function f(e){return 56320<=e&&e<=57343}function p(e,t){return t-56320+(e-55296<<10)+65536}function g(e,t,i){const r=e.charCodeAt(i);if(d(r)&&i+1<t){const t=e.charCodeAt(i+1);if(f(t))return p(r,t)}return r}function m(e,t){const i=e.charCodeAt(t-1);if(f(i)&&t>1){const r=e.charCodeAt(t-2);if(d(r))return p(r,i)}return i}function v(e,t){const i=P.getInstance(),r=e.length,n=t,s=g(e,r,t),o=i.getGraphemeBreakType(s);t+=s>=65536?2:1;let a=o;for(;t<r;){const n=g(e,r,t),s=i.getGraphemeBreakType(n);if(I(a,s))break;t+=n>=65536?2:1,a=s}const l=t;for(t=n,a=o;t>0;){const r=m(e,t),n=i.getGraphemeBreakType(r);if(I(n,a))break;t-=r>=65536?2:1,a=n}return[t,l]}
t.format=function(e,...t){return 0===t.length?e:e.replace(i,(function(e,i){const r=parseInt(i,10);return isNaN(r)||r<0||r>=t.length?e:t[r]}))},t.escape=function(e){return e.replace(/[<>&]/g,(function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}}))},t.escapeRegExpCharacters=r,t.count=function(e,t){let i=0;const r=t.charCodeAt(0);for(let t=e.length-1;t>=0;t--)e.charCodeAt(t)===r&&i++;return i},t.trim=function(e,t=" "){return s(n(e,t),t)},t.ltrim=n,t.rtrim=s,t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.stripWildcards=function(e){return e.replace(/\*/g,"")},t.createRegExp=function(e,t,i={}){if(!e)throw new Error("Cannot create regex from empty string");t||(e=r(e)),i.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));let n="";return i.global&&(n+="g"),i.matchCase||(n+="i"),i.multiline&&(n+="m"),i.unicode&&(n+="u"),new RegExp(e,n)},
t.regExpLeadsToEndlessLoop=function(e){return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},t.regExpContainsBackreference=function(e){return!!e.match(/([^\\]|^)(\\\\)*\\\d+/)},t.regExpFlags=function(e){return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.firstNonWhitespaceIndex=function(e){for(let t=0,i=e.length;t<i;t++){const i=e.charCodeAt(t);if(32!==i&&9!==i)return t}return-1},t.getLeadingWhitespace=function(e,t=0,i=e.length){for(let r=t;r<i;r++){const i=e.charCodeAt(r);if(32!==i&&9!==i)return e.substring(t,r)}return e.substring(t,i)},t.lastNonWhitespaceIndex=function(e,t=e.length-1){for(let i=t;i>=0;i--){const t=e.charCodeAt(i);if(32!==t&&9!==t)return i}return-1},t.compare=function(e,t){return e<t?-1:e>t?1:0},t.compareSubstring=o,t.compareIgnoreCase=function(e,t){return a(e,t,0,e.length,0,t.length)},t.compareSubstringIgnoreCase=a,t.isLowerAsciiLetter=l,t.isUpperAsciiLetter=c,t.equalsIgnoreCase=function(e,t){
return e.length===t.length&&h(e,t)},t.startsWithIgnoreCase=function(e,t){const i=t.length;return!(t.length>e.length)&&h(e,t,i)},t.commonPrefixLength=function(e,t){let i,r=Math.min(e.length,t.length);for(i=0;i<r;i++)if(e.charCodeAt(i)!==t.charCodeAt(i))return i;return r},t.commonSuffixLength=function(e,t){let i,r=Math.min(e.length,t.length);const n=e.length-1,s=t.length-1;for(i=0;i<r;i++)if(e.charCodeAt(n-i)!==t.charCodeAt(s-i))return i;return r},t.isHighSurrogate=d,t.isLowSurrogate=f,t.computeCodePoint=p,t.getNextCodePoint=g,t.nextCharLength=function(e,t){const i=P.getInstance(),r=t,n=e.length,s=g(e,n,t);t+=s>=65536?2:1;let o=i.getGraphemeBreakType(s);for(;t<n;){const r=g(e,n,t),s=i.getGraphemeBreakType(r);if(I(o,s))break;t+=r>=65536?2:1,o=s}return t-r},t.prevCharLength=function(e,t){const i=P.getInstance(),r=t,n=m(e,t);t-=n>=65536?2:1;let s=i.getGraphemeBreakType(n);for(;t>0;){const r=m(e,t),n=i.getGraphemeBreakType(r);if(I(n,s))break;t-=r>=65536?2:1,s=n}return r-t},t.getCharContainingOffset=function(e,t){
return t>0&&f(e.charCodeAt(t))?v(e,t-1):v(e,t)},t.encodeUTF8=function(e){const t=e.length;let i=0,r=0;for(;r<t;){const n=g(e,t,r);r+=n>=65536?2:1,i+=n<128?1:n<2048?2:n<65536?3:4}const n=new Uint8Array(i);r=0;let s=0;for(;r<t;){const i=g(e,t,r);r+=i>=65536?2:1,i<128?n[s++]=i:i<2048?(n[s++]=192|(1984&i)>>>6,n[s++]=128|(63&i)>>>0):i<65536?(n[s++]=224|(61440&i)>>>12,n[s++]=128|(4032&i)>>>6,n[s++]=128|(63&i)>>>0):(n[s++]=240|(1835008&i)>>>18,n[s++]=128|(258048&i)>>>12,n[s++]=128|(4032&i)>>>6,n[s++]=128|(63&i)>>>0)}return n},t.decodeUTF8=function(e){const t=e.byteLength,i=[];let r=0;for(;r<t;){const n=e[r];let s;if((s=n>=240&&r+3<t?(7&e[r++])<<18>>>0|(63&e[r++])<<12>>>0|(63&e[r++])<<6>>>0|(63&e[r++])<<0>>>0:n>=224&&r+2<t?(15&e[r++])<<12>>>0|(63&e[r++])<<6>>>0|(63&e[r++])<<0>>>0:n>=192&&r+1<t?(31&e[r++])<<6>>>0|(63&e[r++])<<0>>>0:e[r++])>=0&&s<=55295||s>=57344&&s<=65535)i.push(String.fromCharCode(s));else if(s>=65536&&s<=1114111){const e=s-65536,t=55296+((1047552&e)>>>10),r=56320+((1023&e)>>>0)
;i.push(String.fromCharCode(t)),i.push(String.fromCharCode(r))}else i.push(String.fromCharCode(65533))}return i.join("")};const y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;t.containsRTL=function(e){return y.test(e)};const E=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;t.containsEmoji=function(e){return E.test(e)};const w=/^[\t\n\r\x20-\x7E]*$/;function _(e){
return(e=+e)>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}t.isBasicASCII=function(e){return w.test(e)},t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/,t.containsUnusualLineTerminators=function(e){return t.UNUSUAL_LINE_TERMINATORS.test(e)},t.containsFullWidthCharacter=function(e){for(let t=0,i=e.length;t<i;t++)if(_(e.charCodeAt(t)))return!0;return!1},t.isFullWidthCharacter=_,t.isEmojiImprecise=function(e){return e>=127462&&e<=127487||e>=9728&&e<=10175||e>=127744&&e<=128591||e>=128640&&e<=128764||e>=128992&&e<=129003||e>=129280&&e<=129535||e>=129648&&e<=129651||e>=129656&&e<=129666||e>=129680&&e<=129685},t.lcut=function(e,t){if(e.length<t)return e;const i=/\b/g;let r=0;for(;i.test(e)&&!(e.length-i.lastIndex<t);)r=i.lastIndex,i.lastIndex+=1;return e.substring(r).replace(/^\s/,"")};const b=/\x1B\x5B[12]?K/g,S=/\x1b\[\d+m/g,C=/\x1b\[0?m/g;function x(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))}function I(e,t){
return 0===e?5!==t&&7!==t:(2!==e||3!==t)&&(4===e||2===e||3===e||(4===t||2===t||3===t||(8!==e||8!==t&&9!==t&&11!==t&&12!==t)&&((11!==e&&9!==e||9!==t&&10!==t)&&((12!==e&&10!==e||10!==t)&&(5!==t&&13!==t&&(7!==t&&(1!==e&&((13!==e||14!==t)&&(6!==e||6!==t)))))))))}t.removeAnsiEscapeCodes=function(e){return e&&(e=(e=(e=e.replace(b,"")).replace(S,"")).replace(C,"")),e},t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=x,t.stripUTF8BOM=function(e){return x(e)?e.substr(1):e},t.fuzzyContains=function(e,t){if(!e||!t)return!1;if(e.length<t.length)return!1;const i=t.length,r=e.toLowerCase();let n=0,s=-1;for(;n<i;){const e=r.indexOf(t[n],s+1);if(e<0)return!1;s=e,n++}return!0},t.containsUppercaseCharacter=function(e,t=!1){return!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.uppercaseFirstLetter=function(e){return e.charAt(0).toUpperCase()+e.slice(1)},t.getNLines=function(e,t=1){if(0===t)return"";let i=-1;do{i=e.indexOf("\n",i+1),t--}while(t>0&&i>=0);return i>=0?e.substr(0,i):e},
t.singleLetterHash=function(e){return(e%=52)<26?String.fromCharCode(97+e):String.fromCharCode(65+e-26)},t.getGraphemeBreakType=function(e){return P.getInstance().getGraphemeBreakType(e)},t.breakBetweenGraphemeBreakType=I,function(e){e[e.Other=0]="Other",e[e.Prepend=1]="Prepend",e[e.CR=2]="CR",e[e.LF=3]="LF",e[e.Control=4]="Control",e[e.Extend=5]="Extend",e[e.Regional_Indicator=6]="Regional_Indicator",e[e.SpacingMark=7]="SpacingMark",e[e.L=8]="L",e[e.V=9]="V",e[e.T=10]="T",e[e.LV=11]="LV",e[e.LVT=12]="LVT",e[e.ZWJ=13]="ZWJ",e[e.Extended_Pictographic=14]="Extended_Pictographic"}(t.GraphemeBreakType||(t.GraphemeBreakType={}));class P{constructor(){
this._data=JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")
}static getInstance(){return P._INSTANCE||(P._INSTANCE=new P),P._INSTANCE}getGraphemeBreakType(e){if(e<32)return 10===e?3:13===e?2:4;if(e<127)return 0;const t=this._data,i=t.length/3;let r=1;for(;r<=i;)if(e<t[3*r])r*=2;else{if(!(e>t[3*r+1]))return t[3*r+2];r=2*r+1}return 0}}P._INSTANCE=null})),define(t[17],i([0,1,16,42]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const n="undefined"!=typeof Buffer,s="undefined"!=typeof TextEncoder,o="undefined"!=typeof TextDecoder;let a,l;class c{constructor(e){this.buffer=e,this.byteLength=this.buffer.byteLength}static alloc(e){return new c(n?Buffer.allocUnsafe(e):new Uint8Array(e))}static wrap(e){
return n&&!Buffer.isBuffer(e)&&(e=Buffer.from(e.buffer,e.byteOffset,e.byteLength)),new c(e)}static fromString(e){return n?new c(Buffer.from(e)):s?(a||(a=new TextEncoder),new c(a.encode(e))):new c(i.encodeUTF8(e))}static concat(e,t){if(void 0===t){t=0;for(let i=0,r=e.length;i<r;i++)t+=e[i].byteLength}const i=c.alloc(t);let r=0;for(let t=0,n=e.length;t<n;t++){const n=e[t];i.set(n,r),r+=n.byteLength}return i}toString(){return n?this.buffer.toString():o?(l||(l=new TextDecoder),l.decode(this.buffer)):i.decodeUTF8(this.buffer)}slice(e,t){return new c(this.buffer.subarray(e,t))}set(e,t){e instanceof c?this.buffer.set(e.buffer,t):this.buffer.set(e,t)}readUInt32BE(e){return u(this.buffer,e)}writeUInt32BE(e,t){h(this.buffer,e,t)}readUInt32LE(e){return d(this.buffer,e)}writeUInt32LE(e,t){f(this.buffer,e,t)}readUInt8(e){return p(this.buffer,e)}writeUInt8(e,t){g(this.buffer,e,t)}}function u(e,t){return e[t]*2**24+65536*e[t+1]+256*e[t+2]+e[t+3]}function h(e,t,i){e[i+3]=t,t>>>=8,e[i+2]=t,t>>>=8,e[i+1]=t,t>>>=8,e[i]=t}
function d(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}function f(e,t,i){e[i+0]=255&t,t>>>=8,e[i+1]=255&t,t>>>=8,e[i+2]=255&t,t>>>=8,e[i+3]=255&t}function p(e,t){return e[t]}function g(e,t,i){e[i]=t}function m(e){return r.consumeStream(e,e=>c.concat(e))}t.VSBuffer=c,t.readUInt16LE=function(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0},t.writeUInt16LE=function(e,t,i){e[i+0]=255&t,t>>>=8,e[i+1]=255&t},t.readUInt32BE=u,t.writeUInt32BE=h,t.readUInt32LE=d,t.writeUInt32LE=f,t.readUInt8=p,t.writeUInt8=g,t.readableToBuffer=function(e){return r.consumeReadable(e,e=>c.concat(e))},t.bufferToReadable=function(e){return r.toReadable(e)},t.streamToBuffer=m,t.bufferedStreamToBuffer=async function(e){return e.ended?c.concat(e.buffer):c.concat([...e.buffer,await m(e.stream)])},t.bufferToStream=function(e){return r.toStream(e,e=>c.concat(e))},t.streamToBufferReadableStream=function(e){return r.transform(e,{data:e=>"string"==typeof e?c.fromString(e):c.wrap(e)},e=>c.concat(e))},
t.newWriteableBufferStream=function(e){return r.newWriteableStream(e=>c.concat(e),e)}})),define(t[97],i([0,1,16]),(function(e,t,i){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),function(e){e[e.Ignore=0]="Ignore",e[e.Info=1]="Info",e[e.Warning=2]="Warning",e[e.Error=3]="Error"}(r||(r={})),function(e){const t="error",r="warning",n="warn",s="info";e.fromValue=function(o){return o?i.equalsIgnoreCase(t,o)?e.Error:i.equalsIgnoreCase(r,o)||i.equalsIgnoreCase(n,o)?e.Warning:i.equalsIgnoreCase(s,o)?e.Info:e.Ignore:e.Ignore}}(r||(r={})),t.default=r})),define(t[11],i([0,1]),(function(e,t){"use strict";function i(e){return"string"==typeof e}function r(e){return!("object"!=typeof e||null===e||Array.isArray(e)||e instanceof RegExp||e instanceof Date)}function n(e){return void 0===e}function s(e){return n(e)||null===e}Object.defineProperty(t,"__esModule",{value:!0}),
t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0,t.isArray=function(e){return Array.isArray(e)},t.isString=i,t.isStringArray=function(e){return Array.isArray(e)&&e.every(e=>i(e))},t.isObject=r,t.isNumber=function(e){return"number"==typeof e&&!isNaN(e)},t.isBoolean=function(e){return!0===e||!1===e},t.isUndefined=n,t.isDefined=function(e){return!s(e)},t.isUndefinedOrNull=s,t.assertType=function(e,t){if(!e)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")},t.assertIsDefined=function(e){if(s(e))throw new Error("Assertion Failed: argument is undefined or null");return e},t.assertAllDefined=function(...e){const t=[];for(let i=0;i<e.length;i++){const r=e[i]
;if(s(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(r)}return t};const o=Object.prototype.hasOwnProperty;function a(e){return"function"==typeof e}function l(e,t){if(i(t)){if(typeof e!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(e instanceof t)return}catch(e){}if(!s(e)&&e.constructor===t)return;if(1===t.length&&!0===t.call(void 0,e))return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function c(e){let t=[],i=Object.getPrototypeOf(e);for(;Object.prototype!==i;)t=t.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return t}t.isEmptyObject=function(e){if(!r(e))return!1;for(let t in e)if(o.call(e,t))return!1;return!0},t.isFunction=a,t.areFunctions=function(...e){return e.length>0&&e.every(a)},t.validateConstraints=function(e,t){const i=Math.min(e.length,t.length);for(let r=0;r<i;r++)l(e[r],t[r])},
t.validateConstraint=l,t.getAllPropertyNames=c,t.getAllMethodNames=function(e){const t=[];for(const i of c(e))"function"==typeof e[i]&&t.push(i);return t},t.createProxyObject=function(e,t){const i=e=>(function(){const i=Array.prototype.slice.call(arguments,0);return t(e,i)});let r={};for(const t of e)r[t]=i(t);return r},t.withNullAsUndefined=function(e){return null===e?void 0:e},t.withUndefinedAsNull=function(e){return void 0===e?null:e},t.NotImplementedProxy=function(e){return class{constructor(){return new Proxy({},{get(t,i){if(t[i])return t[i];throw new Error(`Not Implemented: ${e}->${String(i)}`)}})}}}})),define(t[33],i([0,1,5,16,3,11]),(function(e,t,i,r,n,s){"use strict";function o(e){return 47===e||92===e}Object.defineProperty(t,"__esModule",{value:!0}),t.parseLineAndColumnAware=t.indexOfPath=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toSlashes=t.isPathSeparator=void 0,t.isPathSeparator=o,t.toSlashes=function(e){
return e.replace(/[\\/]/g,n.posix.sep)},t.getRoot=function(e,t=n.posix.sep){if(!e)return"";const i=e.length,r=e.charCodeAt(0);if(o(r)){if(o(e.charCodeAt(1))&&!o(e.charCodeAt(2))){let r=3;const n=r;for(;r<i&&!o(e.charCodeAt(r));r++);if(n!==r&&!o(e.charCodeAt(r+1)))for(r+=1;r<i;r++)if(o(e.charCodeAt(r)))return e.slice(0,r+1).replace(/[\\/]/g,t)}return t}if(u(r)&&58===e.charCodeAt(1))return o(e.charCodeAt(2))?e.slice(0,2)+t:e.slice(0,2);let s=e.indexOf("://");if(-1!==s)for(s+=3;s<i;s++)if(o(e.charCodeAt(s)))return e.slice(0,s+1);return""},t.isUNC=function(e){if(!i.isWindows)return!1;if(!e||e.length<5)return!1;let t=e.charCodeAt(0);if(92!==t)return!1;if(92!==(t=e.charCodeAt(1)))return!1;let r=2;const n=r;for(;r<e.length&&92!==(t=e.charCodeAt(r));r++);return n!==r&&(t=e.charCodeAt(r+1),!isNaN(t)&&92!==t)};const a=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(e){return e>=65&&e<=90||e>=97&&e<=122}t.isValidBasename=function(e,t=i.isWindows){const r=t?a:l
;return!(!e||0===e.length||/^\s+$/.test(e))&&(r.lastIndex=0,!r.test(e)&&((!t||!c.test(e))&&("."!==e&&".."!==e&&((!t||"."!==e[e.length-1])&&((!t||e.length===e.trim().length)&&!(e.length>255))))))},t.isEqual=function(e,t,i){const n=e===t;return!i||n?n:!(!e||!t)&&r.equalsIgnoreCase(e,t)},t.isEqualOrParent=function(e,t,i,s=n.sep){if(e===t)return!0;if(!e||!t)return!1;if(t.length>e.length)return!1;if(i){if(!r.startsWithIgnoreCase(e,t))return!1;if(t.length===e.length)return!0;let i=t.length;return t.charAt(t.length-1)===s&&i--,e.charAt(i)===s}return t.charAt(t.length-1)!==s&&(t+=s),0===e.indexOf(t)},t.isWindowsDriveLetter=u,t.sanitizeFilePath=function(e,t){return i.isWindows&&e.endsWith(":")&&(e+=n.sep),n.isAbsolute(e)||(e=n.join(t,e)),e=n.normalize(e),i.isWindows?(e=r.rtrim(e,n.sep)).endsWith(":")&&(e+=n.sep):(e=r.rtrim(e,n.sep))||(e=n.sep),e},t.isRootOrDriveLetter=function(e){const t=n.normalize(e)
;return i.isWindows?!(e.length>3)&&(u(t.charCodeAt(0))&&58===t.charCodeAt(1)&&(2===e.length||92===t.charCodeAt(2))):t===n.posix.sep},t.indexOfPath=function(e,t,i){return t.length>e.length?-1:e===t?0:(i&&(e=e.toLowerCase(),t=t.toLowerCase()),e.indexOf(t))},t.parseLineAndColumnAware=function(e){const t=e.split(":");let i=void 0,r=void 0,n=void 0;if(t.forEach(e=>{const t=Number(e);s.isNumber(t)?void 0===r?r=t:void 0===n&&(n=t):i=i?[i,e].join(":"):e}),!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:void 0!==r?r:void 0,column:void 0!==n?n:void 0!==r?1:void 0}}})),define(t[20],i([0,1,11]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0,t.deepClone=function e(t){if(!t||"object"!=typeof t)return t;if(t instanceof RegExp)return t;const i=Array.isArray(t)?[]:{};return Object.keys(t).forEach(r=>{
t[r]&&"object"==typeof t[r]?i[r]=e(t[r]):i[r]=t[r]}),i},t.deepFreeze=function(e){if(!e||"object"!=typeof e)return e;const t=[e];for(;t.length>0;){const e=t.shift();Object.freeze(e);for(const i in e)if(r.call(e,i)){const r=e[i];"object"!=typeof r||Object.isFrozen(r)||t.push(r)}}return e};const r=Object.prototype.hasOwnProperty;function n(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(typeof e!=typeof t)return!1;if("object"!=typeof e)return!1;if(Array.isArray(e)!==Array.isArray(t))return!1;let i,r;if(Array.isArray(e)){if(e.length!==t.length)return!1;for(i=0;i<e.length;i++)if(!n(e[i],t[i]))return!1}else{const s=[];for(r in e)s.push(r);s.sort();const o=[];for(r in t)o.push(r);if(o.sort(),!n(s,o))return!1;for(i=0;i<s.length;i++)if(!n(e[s[i]],t[s[i]]))return!1}return!0}t.cloneAndChange=function(e,t){return function e(t,n,s){if(i.isUndefinedOrNull(t))return t;const o=n(t);if(void 0!==o)return o;if(i.isArray(t)){const i=[];for(const r of t)i.push(e(r,n,s));return i}if(i.isObject(t)){
if(s.has(t))throw new Error("Cannot clone recursive data-structure");s.add(t);const i={};for(let o in t)r.call(t,o)&&(i[o]=e(t[o],n,s));return s.delete(t),i}return t}(e,t,new Set)},t.mixin=function e(t,r,n=!0){return i.isObject(t)?(i.isObject(r)&&Object.keys(r).forEach(s=>{s in t?n&&(i.isObject(t[s])&&i.isObject(r[s])?e(t[s],r[s],n):t[s]=r[s]):t[s]=r[s]}),t):r},t.equals=n,t.safeStringify=function(e){const t=new Set;return JSON.stringify(e,(e,r)=>{if(i.isObject(r)||Array.isArray(r)){if(t.has(r))return"[Circular]";t.add(r)}return r})},t.getOrDefault=function(e,t,i){const r=t(e);return void 0===r?i:r},t.distinct=function(e,t){const i=Object.create(null);return e&&t?(Object.keys(t).forEach(r=>{const s=e[r],o=t[r];n(s,o)||(i[r]=o)}),i):i},t.getCaseInsensitive=function(e,t){const i=t.toLowerCase(),r=Object.keys(e).find(e=>e.toLowerCase()===i);return r?e[r]:e[t]}})),define(t[7],i([0,1,5,3]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0
;const n=/^\w[\w\d+.-]*$/,s=/^\//,o=/^\/\//;const a="",l="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{constructor(e,t,i,r,c,u=!1){"object"==typeof e?(this.scheme=e.scheme||a,this.authority=e.authority||a,this.path=e.path||a,this.query=e.query||a,this.fragment=e.fragment||a):(this.scheme=function(e,t){return e||t?e:"file"}(e,u),this.authority=t||a,this.path=function(e,t){switch(e){case"https":case"http":case"file":t?t[0]!==l&&(t=l+t):t=l}return t}(this.scheme,i||a),this.query=r||a,this.fragment=c||a,function(e,t){if(!e.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${e.authority}", path: "${e.path}", query: "${e.query}", fragment: "${e.fragment}"}`);if(e.scheme&&!n.test(e.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(e.path)if(e.authority){if(!s.test(e.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')
}else if(o.test(e.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this,u))}static isUri(e){return e instanceof u||!!e&&("string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"function"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString)}get fsPath(){return m(this,!1)}with(e){if(!e)return this;let{scheme:t,authority:i,path:r,query:n,fragment:s}=e;return void 0===t?t=this.scheme:null===t&&(t=a),void 0===i?i=this.authority:null===i&&(i=a),void 0===r?r=this.path:null===r&&(r=a),void 0===n?n=this.query:null===n&&(n=a),void 0===s?s=this.fragment:null===s&&(s=a),t===this.scheme&&i===this.authority&&r===this.path&&n===this.query&&s===this.fragment?this:new d(t,i,r,n,s)}static parse(e,t=!1){const i=c.exec(e);return i?new d(i[2]||a,E(i[4]||a),E(i[5]||a),E(i[7]||a),E(i[9]||a),t):new d(a,a,a,a,a)}static file(e){
let t=a;if(i.isWindows&&(e=e.replace(/\\/g,l)),e[0]===l&&e[1]===l){const i=e.indexOf(l,2);-1===i?(t=e.substring(2),e=l):(t=e.substring(2,i),e=e.substring(i)||l)}return new d("file",t,e,a,a)}static from(e){return new d(e.scheme,e.authority,e.path,e.query,e.fragment)}static joinPath(e,...t){if(!e.path)throw new Error("[UriError]: cannot call joinPaths on URI without path");let n;return n=i.isWindows&&"file"===e.scheme?u.file(r.win32.join(m(e,!0),...t)).path:r.posix.join(e.path,...t),e.with({path:n})}toString(e=!1){return v(this,e)}toJSON(){return this}static revive(e){if(e){if(e instanceof u)return e;{const t=new d(e);return t._formatted=e.external,t._fsPath=e._sep===h?e.fsPath:null,t}}return e}}t.URI=u;const h=i.isWindows?1:void 0;class d extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(e=!1){return e?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const e={
$mid:1};return this._fsPath&&(e.fsPath=this._fsPath,e._sep=h),this._formatted&&(e.external=this._formatted),this.path&&(e.path=this.path),this.scheme&&(e.scheme=this.scheme),this.authority&&(e.authority=this.authority),this.query&&(e.query=this.query),this.fragment&&(e.fragment=this.fragment),e}}const f={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function p(e,t){let i=void 0,r=-1;for(let n=0;n<e.length;n++){const s=e.charCodeAt(n);if(s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57||45===s||46===s||95===s||126===s||t&&47===s)-1!==r&&(i+=encodeURIComponent(e.substring(r,n)),r=-1),void 0!==i&&(i+=e.charAt(n));else{void 0===i&&(i=e.substr(0,n));const t=f[s];void 0!==t?(-1!==r&&(i+=encodeURIComponent(e.substring(r,n)),r=-1),i+=t):-1===r&&(r=n)}}return-1!==r&&(i+=encodeURIComponent(e.substring(r))),void 0!==i?i:e}function g(e){let t=void 0;for(let i=0;i<e.length;i++){const r=e.charCodeAt(i)
;35===r||63===r?(void 0===t&&(t=e.substr(0,i)),t+=f[r]):void 0!==t&&(t+=e[i])}return void 0!==t?t:e}function m(e,t){let r;return r=e.authority&&e.path.length>1&&"file"===e.scheme?`//${e.authority}${e.path}`:47===e.path.charCodeAt(0)&&(e.path.charCodeAt(1)>=65&&e.path.charCodeAt(1)<=90||e.path.charCodeAt(1)>=97&&e.path.charCodeAt(1)<=122)&&58===e.path.charCodeAt(2)?t?e.path.substr(1):e.path[1].toLowerCase()+e.path.substr(2):e.path,i.isWindows&&(r=r.replace(/\//g,"\\")),r}function v(e,t){const i=t?g:p;let r="",{scheme:n,authority:s,path:o,query:a,fragment:c}=e;if(n&&(r+=n,r+=":"),(s||"file"===n)&&(r+=l,r+=l),s){let e=s.indexOf("@");if(-1!==e){const t=s.substr(0,e);s=s.substr(e+1),-1===(e=t.indexOf(":"))?r+=i(t,!1):(r+=i(t.substr(0,e),!1),r+=":",r+=i(t.substr(e+1),!1)),r+="@"}-1===(e=(s=s.toLowerCase()).indexOf(":"))?r+=i(s,!1):(r+=i(s.substr(0,e),!1),r+=s.substr(e))}if(o){if(o.length>=3&&47===o.charCodeAt(0)&&58===o.charCodeAt(2)){const e=o.charCodeAt(1)
;e>=65&&e<=90&&(o=`/${String.fromCharCode(e+32)}:${o.substr(3)}`)}else if(o.length>=2&&58===o.charCodeAt(1)){const e=o.charCodeAt(0);e>=65&&e<=90&&(o=`${String.fromCharCode(e+32)}:${o.substr(2)}`)}r+=i(o,!0)}return a&&(r+="?",r+=i(a,!1)),c&&(r+="#",r+=t?c:p(c,!1)),r}t.uriToFsPath=m;const y=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(e){return e.match(y)?e.replace(y,e=>(function e(t){try{return decodeURIComponent(t)}catch(i){return t.length>3?t.substr(0,3)+e(t.substr(3)):t}})(e)):e}})),define(t[98],i([0,1,7]),(function(e,t,i){"use strict";function r(e,t){return i.URI.parse(e.toUrl(t))}Object.defineProperty(t,"__esModule",{value:!0}),t.getUriFromAmdModule=t.getPathFromAmdModule=void 0,t.getPathFromAmdModule=function(e,t){return r(e,t).fsPath},t.getUriFromAmdModule=r})),define(t[99],i([0,1,7]),(function(e,t,i){"use strict";function r(e){const t=[];let i;try{const r=JSON.parse(e.arguments),n=r[r.length-1];n&&n.__$stack&&(r.pop(),i=n.__$stack),t.push(...r)}catch(i){
t.push("Unable to log remote console arguments",e.arguments)}return{args:t,stack:i}}function n(e){if(!e)return e;const t=e.indexOf("\n");return-1===t?e:e.substring(0,t)}function s(e){return`color: ${e}`}Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0,t.isRemoteConsoleLog=function(e){const t=e;return t&&"string"==typeof t.type&&"string"==typeof t.severity},t.parse=r,t.getFirstFrame=function e(t){if("string"!=typeof t)return e(r(t).stack);if(t){const e=n(t),r=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(e||"");if(r&&4===r.length)return{uri:i.URI.file(r[1]),line:Number(r[2]),column:Number(r[3])}}},t.log=function(e,t){const{args:i,stack:o}=r(e),a="string"==typeof i[0]&&1===i.length;let l=n(o);l&&(l=`(${l.trim()})`);let c=[];if(c="string"==typeof i[0]?l&&a?[`%c[${t}] %c${i[0]} %c${l}`,s("blue"),s(""),s("grey")]:[`%c[${t}] %c${i[0]}`,s("blue"),s(""),...i.slice(1)]:[`%c[${t}]%`,s("blue"),...i],l&&!a&&c.push(l),
"function"!=typeof console[e.severity])throw new Error("Unknown console method");console[e.severity].apply(console,c)}})),define(t[100],i([0,1,17,16,7]),(function(e,t,i,r,n){"use strict";function s(e,t){return t instanceof RegExp?{$mid:2,source:t.source,flags:r.regExpFlags(t)}:t}function o(e,t=0){if(!e||t>200)return e;if("object"==typeof e){switch(e.$mid){case 1:return n.URI.revive(e);case 2:return new RegExp(e.source,e.flags)}if(e instanceof i.VSBuffer||e instanceof Uint8Array)return e;if(Array.isArray(e))for(let i=0;i<e.length;++i)e[i]=o(e[i],t+1);else for(const i in e)Object.hasOwnProperty.call(e,i)&&(e[i]=o(e[i],t+1))}return e}Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0,t.stringify=function(e){return JSON.stringify(e,s)},t.parse=function(e){let t=JSON.parse(e);return t=o(t)},t.revive=o})),define(t[10],i([0,1,7,5]),(function(e,t,i,r){"use strict";var n;Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.Schemas=void 0,function(e){
e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.userData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebook="vscode-notebook",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeSettings="vscode-settings",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.vscodeWebviewResource="vscode-webview-resource",e.extension="extension"}(n=t.Schemas||(t.Schemas={}));t.RemoteAuthorities=new class{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(e){this._preferredWebSchema=e}setDelegate(e){this._delegate=e}set(e,t,i){this._hosts[e]=t,this._ports[e]=i}
setConnectionToken(e,t){this._connectionTokens[e]=t}rewrite(e){if(this._delegate)return this._delegate(e);const t=e.authority;let s=this._hosts[t];s&&-1!==s.indexOf(":")&&(s=`[${s}]`);const o=this._connectionTokens[t];let a=`path=${encodeURIComponent(e.path)}`;return"string"==typeof o&&(a+=`&tkn=${encodeURIComponent(o)}`),i.URI.from({scheme:r.isWeb?this._preferredWebSchema:n.vscodeRemoteResource,authority:window.location.host,path:`${window.location.pathname.replace(/\/+$/,"")}/vscode-remote-resource`,query:a})}};t.FileAccess=new class{asBrowserUri(e,i){const r=this.toUri(e,i);return r.scheme===n.vscodeRemote?t.RemoteAuthorities.rewrite(r):r}asFileUri(e,t){return this.toUri(e,t)}toUri(e,t){return i.URI.isUri(e)?e:i.URI.parse(t.toUrl(e))}}})),define(t[25],i([0,1,7,16,5,10]),(function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.LRUCache=t.LinkedMap=t.Touch=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0,t.getOrSet=function(e,t,i){let r=e.get(t);return void 0===r&&(r=i,e.set(t,r)),r},t.mapToString=function(e){const t=[];return e.forEach((e,i)=>{t.push(`${i} => ${e}`)}),`Map(${e.size}) {${t.join(", ")}}`},t.setToString=function(e){const t=[];return e.forEach(e=>{t.push(e)}),`Set(${e.size}) {${t.join(", ")}}`};class o{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){return e.charCodeAt(0)-this._value.charCodeAt(this._pos)}value(){return this._value[this._pos]}}t.StringIterator=o;class a{constructor(e=!0,t=!0){this._splitOnBackslash=e,this._caseSensitive=t}reset(e){return this._value=e.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0
;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(47===t||this._splitOnBackslash&&92===t){if(!e)break;this._from++}else e=!1}return this}cmp(e){return this._caseSensitive?r.compareSubstring(e,this._value,0,e.length,this._from,this._to):r.compareSubstringIgnoreCase(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}var l;t.PathIterator=a,function(e){e[e.Scheme=1]="Scheme",e[e.Authority=2]="Authority",e[e.Path=3]="Path",e[e.Query=4]="Query",e[e.Fragment=5]="Fragment"}(l||(l={}));class c{constructor(e){this._ignorePathCasing=e,this._states=[],this._stateIdx=0}reset(e){return this._value=e,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new a(!1,void 0===this._ignorePathCasing?e.scheme===s.Schemas.file&&n.isLinux:!this._ignorePathCasing),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(3)),
this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(1===this._states[this._stateIdx])return r.compareIgnoreCase(e,this._value.scheme);if(2===this._states[this._stateIdx])return r.compareIgnoreCase(e,this._value.authority);if(3===this._states[this._stateIdx])return this._pathIterator.cmp(e);if(4===this._states[this._stateIdx])return r.compare(e,this._value.query);if(5===this._states[this._stateIdx])return r.compare(e,this._value.fragment);throw new Error}value(){if(1===this._states[this._stateIdx])return this._value.scheme;if(2===this._states[this._stateIdx])return this._value.authority;if(3===this._states[this._stateIdx])return this._pathIterator.value()
;if(4===this._states[this._stateIdx])return this._value.query;if(5===this._states[this._stateIdx])return this._value.fragment;throw new Error}}t.UriIterator=c;class u{isEmpty(){return!(this.left||this.mid||this.right||this.value)}}class h{constructor(e){this._iter=e}static forUris(e){return new h(new c(e))}static forPaths(){return new h(new a)}static forStrings(){return new h(new o)}clear(){this._root=void 0}set(e,t){const i=this._iter.reset(e);let r;for(this._root||(this._root=new u,this._root.segment=i.value()),r=this._root;;){const e=i.cmp(r.segment);if(e>0)r.left||(r.left=new u,r.left.segment=i.value()),r=r.left;else if(e<0)r.right||(r.right=new u,r.right.segment=i.value()),r=r.right;else{if(!i.hasNext())break;i.next(),r.mid||(r.mid=new u,r.mid.segment=i.value()),r=r.mid}}const n=r.value;return r.value=t,r.key=e,n}get(e){const t=this._iter.reset(e);let i=this._root;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())break;t.next(),i=i.mid}}return i?i.value:void 0}
delete(e){return this._delete(e,!1)}deleteSuperstr(e){return this._delete(e,!0)}_delete(e,t){const i=this._iter.reset(e),r=[];let n=this._root;for(;n;){const e=i.cmp(n.segment);if(e>0)r.push([1,n]),n=n.left;else if(e<0)r.push([-1,n]),n=n.right;else{if(!i.hasNext()){for(n.value=void 0;r.length>0&&(n.isEmpty()||t);){let[e,t]=r.pop();switch(e){case 1:t.left=void 0;break;case 0:t.mid=void 0;break;case-1:t.right=void 0}n=t}break}i.next(),r.push([0,n]),n=n.mid}}}findSubstr(e){const t=this._iter.reset(e);let i=this._root,r=void 0;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())break;t.next(),r=i.value||r,i=i.mid}}return i&&i.value||r}findSuperstr(e){const t=this._iter.reset(e);let i=this._root;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())return i.mid?this._values(i.mid):void 0;t.next(),i=i.mid}}}forEach(e){for(const[t,i]of this)e(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_values(e){
for(const[,t]of this._entries(e))yield t}*_entries(e){e&&(yield*this._entries(e.left),e.value&&(yield[e.key,e.value]),yield*this._entries(e.mid),yield*this._entries(e.right))}}t.TernarySearchTree=h;class d{constructor(e,t){this[Symbol.toStringTag]="ResourceMap",e instanceof d?(this.map=new Map(e.map),this.toKey=null!=t?t:d.defaultToKey):(this.map=new Map,this.toKey=null!=e?e:d.defaultToKey)}set(e,t){return this.map.set(this.toKey(e),t),this}get(e){return this.map.get(this.toKey(e))}has(e){return this.map.has(this.toKey(e))}get size(){return this.map.size}clear(){this.map.clear()}delete(e){return this.map.delete(this.toKey(e))}forEach(e,t){void 0!==t&&(e=e.bind(t));for(let[t,r]of this.map)e(r,i.URI.parse(t),this)}values(){return this.map.values()}*keys(){for(let e of this.map.keys())yield i.URI.parse(e)}*entries(){for(let e of this.map.entries())yield[i.URI.parse(e[0]),e[1]]}*[Symbol.iterator](){for(let e of this.map)yield[i.URI.parse(e[0]),e[1]]}}t.ResourceMap=d,d.defaultToKey=e=>e.toString(),function(e){
e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"}(t.Touch||(t.Touch={}));class f{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var e;return null===(e=this._head)||void 0===e?void 0:e.value}get last(){var e;return null===(e=this._tail)||void 0===e?void 0:e.value}has(e){return this._map.has(e)}get(e,t=0){const i=this._map.get(e);if(i)return 0!==t&&this.touch(i,t),i.value}set(e,t,i=0){let r=this._map.get(e);if(r)r.value=t,0!==i&&this.touch(r,i);else{switch(r={key:e,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:default:this.addItemLast(r)}this._map.set(e,r),this._size++}return this}delete(e){return!!this.remove(e)}remove(e){const t=this._map.get(e);if(t)return this._map.delete(e),
this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const e=this._head;return this._map.delete(e.key),this.removeItem(e),this._size--,e.value}forEach(e,t){const i=this._state;let r=this._head;for(;r;){if(t?e.bind(t)(r.value,r.key,this):e(r.value,r.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const e=this,t=this._state;let i=this._head;const r={[Symbol.iterator]:()=>r,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:i.key,done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return r}values(){const e=this,t=this._state;let i=this._head;const r={[Symbol.iterator]:()=>r,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:i.value,done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return r}entries(){const e=this,t=this._state;let i=this._head;const r={
[Symbol.iterator]:()=>r,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:[i.key,i.value],done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return r}[Symbol.iterator](){return this.entries()}trimOld(e){if(e>=this.size)return;if(0===e)return void this.clear();let t=this._head,i=this.size;for(;t&&i>e;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}addItemFirst(e){if(this._head||this._tail){if(!this._head)throw new Error("Invalid list");e.next=this._head,this._head.previous=e}else this._tail=e;this._head=e,this._state++}addItemLast(e){if(this._head||this._tail){if(!this._tail)throw new Error("Invalid list");e.previous=this._tail,this._tail.next=e}else this._head=e;this._tail=e,this._state++}removeItem(e){if(e===this._head&&e===this._tail)this._head=void 0,this._tail=void 0;else if(e===this._head){if(!e.next)throw new Error("Invalid list");e.next.previous=void 0,this._head=e.next
}else if(e===this._tail){if(!e.previous)throw new Error("Invalid list");e.previous.next=void 0,this._tail=e.previous}else{const t=e.next,i=e.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}e.next=void 0,e.previous=void 0,this._state++}touch(e,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(1===t||2===t)if(1===t){if(e===this._head)return;const t=e.next,i=e.previous;e===this._tail?(i.next=void 0,this._tail=i):(t.previous=i,i.next=t),e.previous=void 0,e.next=this._head,this._head.previous=e,this._head=e,this._state++}else if(2===t){if(e===this._tail)return;const t=e.next,i=e.previous;e===this._head?(t.previous=void 0,this._head=t):(t.previous=i,i.next=t),e.next=void 0,e.previous=this._tail,this._tail.next=e,this._tail=e,this._state++}}toJSON(){const e=[];return this.forEach((t,i)=>{e.push([i,t])}),e}fromJSON(e){this.clear();for(const[t,i]of e)this.set(t,i)}}t.LinkedMap=f;t.LRUCache=class extends f{constructor(e,t=1){super(),this._limit=e,
this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(e){this._limit=e,this.checkTrim()}get ratio(){return this._ratio}set ratio(e){this._ratio=Math.min(Math.max(0,e),1),this.checkTrim()}get(e,t=2){return super.get(e,t)}peek(e){return super.get(e,0)}set(e,t){return super.set(e,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}})),define(t[63],i([0,1,16,33,3,25,15]),(function(e,t,i,r,n,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0,t.getEmptyExpression=function(){return Object.create(null)};const a="**",l="/",c="[/\\\\]",u="[^/\\\\]",h=/\//g;function d(e){switch(e){case 0:return"";case 1:return`${u}*?`;default:return`(?:${c}|${u}+${c}|${c}${u}+)*?`}}function f(e,t){if(!e)return[];const i=[];let r=!1,n=!1,s="";for(const o of e){switch(o){case t:if(!r&&!n){
i.push(s),s="";continue}break;case"{":r=!0;break;case"}":r=!1;break;case"[":n=!0;break;case"]":n=!1}s+=o}return s&&i.push(s),i}t.splitGlobAware=f;const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,w=new s.LRUCache(1e4),_=function(){return!1},b=function(){return null};function S(e,t){if(!e)return b;let r;const n=`${r=(r="string"!=typeof e?e.pattern:e).trim()}_${!!t.trimForExclusions}`;let s,o=w.get(n);if(o)return C(o,e);if(p.test(r)){const e=r.substr(4);o=function(t,i){return"string"==typeof t&&t.endsWith(e)?r:null}}else o=(s=g.exec(x(r,t)))?function(e,t){const i=`/${e}`,r=`\\${e}`,n=function(n,s){return"string"!=typeof n?null:s?s===e?t:null:n===e||n.endsWith(i)||n.endsWith(r)?t:null},s=[e];return n.basenames=s,n.patterns=[t],n.allBasenames=s,n}(s[1],r):(t.trimForExclusions?v:m).test(r)?function(e,t){
const i=L(e.slice(1,-1).split(",").map(e=>S(e,t)).filter(e=>e!==b),e),r=i.length;if(!r)return b;if(1===r)return i[0];const n=function(t,r){for(let n=0,s=i.length;n<s;n++)if(i[n](t,r))return e;return null},s=i.find(e=>!!e.allBasenames);s&&(n.allBasenames=s.allBasenames);const o=i.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);o.length&&(n.allPaths=o);return n}(r,t):(s=y.exec(x(r,t)))?I(s[1].substr(1),r,!0):(s=E.exec(x(r,t)))?I(s[1],r,!1):function(e){try{const t=new RegExp(`^${function e(t){if(!t)return"";let r="";const n=f(t,l);if(n.every(e=>e===a))r=".*";else{let t=!1;n.forEach((s,o)=>{if(s===a)return void(t||(r+=d(2),t=!0));let h=!1,p="",g=!1,m="";for(const t of s)if("}"!==t&&h)p+=t;else if(!g||"]"===t&&m)switch(t){case"{":h=!0;continue;case"[":g=!0;continue;case"}":const n=`(?:${f(p,",").map(t=>e(t)).join("|")})`;r+=n,h=!1,p="";break;case"]":r+="["+m+"]",g=!1,m="";break;case"?":r+=u;continue;case"*":r+=d(1);continue;default:r+=i.escapeRegExpCharacters(t)}else{let e
;m+=e="-"===t?t:"^"!==t&&"!"!==t||m?t===l?"":i.escapeRegExpCharacters(t):"^"}o<n.length-1&&(n[o+1]!==a||o+2<n.length)&&(r+=c),t=!1})}return r}(e)}$`);return function(i){return t.lastIndex=0,"string"==typeof i&&t.test(i)?e:null}}catch(e){return b}}(r);return w.set(n,o),C(o,e)}function C(e,t){return"string"==typeof t?e:function(i,s){return r.isEqualOrParent(i,t.base)?e(n.relative(t.base,i),s):null}}function x(e,t){return t.trimForExclusions&&e.endsWith("/**")?e.substr(0,e.length-2):e}function I(e,t,i){const r=n.sep!==n.posix.sep?e.replace(h,n.sep):e,s=n.sep+r,o=i?function(e,i){return"string"!=typeof e||e!==r&&!e.endsWith(s)?null:t}:function(e,i){return"string"==typeof e&&e===r?t:null};return o.allPaths=[(i?"*/":"./")+e],o}function P(e,t={}){if(!e)return _;if("string"==typeof e||k(e)){const i=S(e,t);if(i===b)return _;const r=function(e,t){return!!i(e,t)};return i.allBasenames&&(r.allBasenames=i.allBasenames),i.allPaths&&(r.allPaths=i.allPaths),r}return function(e,t){
const i=L(Object.getOwnPropertyNames(e).map(i=>(function(e,t,i){if(!1===t)return b;const r=S(e,i);if(r===b)return b;if("boolean"==typeof t)return r;if(t){const i=t.when;if("string"==typeof i){const t=(t,n,s,a)=>{if(!a||!r(t,n))return null;const l=a(i.replace("$(basename)",s));return o.isThenable(l)?l.then(t=>t?e:null):l?e:null};return t.requiresSiblings=!0,t}}return r})(i,e[i],t)).filter(e=>e!==b)),r=i.length;if(!r)return b;if(!i.some(e=>!!e.requiresSiblings)){if(1===r)return i[0];const e=function(e,t){for(let r=0,n=i.length;r<n;r++){const n=i[r](e,t);if(n)return n}return null},t=i.find(e=>!!e.allBasenames);t&&(e.allBasenames=t.allBasenames);const n=i.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);return n.length&&(e.allPaths=n),e}const s=function(e,t,r){let s=void 0;for(let o=0,a=i.length;o<a;o++){const a=i[o];a.requiresSiblings&&r&&(t||(t=n.basename(e)),s||(s=t.substr(0,t.length-n.extname(e).length)));const l=a(e,t,s,r);if(l)return l}return null},a=i.find(e=>!!e.allBasenames)
;a&&(s.allBasenames=a.allBasenames);const l=i.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);l.length&&(s.allPaths=l);return s}(e,t)}function T(e){const t={};for(const i of e)t[i]=!0;return t}function k(e){const t=e;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}function L(e,t){const i=e.filter(e=>!!e.basenames);if(i.length<2)return e;const r=i.reduce((e,t)=>{const i=t.basenames;return i?e.concat(i):e},[]);let n;if(t){n=[];for(let e=0,i=r.length;e<i;e++)n.push(t)}else n=i.reduce((e,t)=>{const i=t.patterns;return i?e.concat(i):e},[]);const s=function(e,t){if("string"!=typeof e)return null;if(!t){let i;for(i=e.length;i>0;i--){const t=e.charCodeAt(i-1);if(47===t||92===t)break}t=e.substr(i)}const i=r.indexOf(t);return-1!==i?n[i]:null};s.basenames=r,s.patterns=n,s.allBasenames=r;const o=e.filter(e=>!e.basenames);return o.push(s),o}t.match=function(e,t,i){return!(!e||"string"!=typeof t)&&P(e)(t,void 0,i)},t.parse=P,t.hasSiblingPromiseFn=function(e){if(!e)return;let t
;return i=>(t||(t=(e()||Promise.resolve([])).then(e=>e?T(e):{})),t.then(e=>!!e[i]))},t.hasSiblingFn=function(e){if(!e)return;let t;return i=>{if(!t){const i=e();t=i?T(i):{}}return!!t[i]}},t.isRelativePattern=k,t.getBasenameTerms=function(e){return e.allBasenames||[]},t.getPathTerms=function(e){return e.allPaths||[]}})),define(t[64],i([0,1,25]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeAccents=t.normalizeNFD=t.normalizeNFC=t.canNormalize=void 0,t.canNormalize="function"==typeof String.prototype.normalize;const r=new i.LRUCache(1e4);t.normalizeNFC=function(e){return a(e,"NFC",r)};const n=new i.LRUCache(1e4);function s(e){return a(e,"NFD",n)}t.normalizeNFD=s;const o=/[^\u0000-\u0080]/;function a(e,i,r){if(!t.canNormalize||!e)return e;const n=r.get(e);if(n)return n;let s;return s=o.test(e)?e.normalize(i):e,r.set(e,s),s}t.removeAccents=function(){if(t.canNormalize){const e=/[\u0300-\u036f]/g;return function(t){return s(t).replace(e,"")}}return function(e){return e}}()
})),define(t[18],i([0,1,33,3,7,16,10,5,63,25]),(function(e,t,i,r,n,s,o,a,l,c){"use strict";function u(e){return n.uriToFsPath(e,!0)}Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.ResourceGlobMatcher=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0,t.originalFSPath=u;class h{constructor(e){this._ignorePathCasing=e}compare(e,t,i=!1){return e===t?0:s.compare(this.getComparisonKey(e,i),this.getComparisonKey(t,i))}isEqual(e,t,i=!1){return e===t||!(!e||!t)&&this.getComparisonKey(e,i)===this.getComparisonKey(t,i)}getComparisonKey(e,t=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}
isEqualOrParent(e,r,n=!1){if(e.scheme===r.scheme){if(e.scheme===o.Schemas.file)return i.isEqualOrParent(u(e),u(r),this._ignorePathCasing(e))&&e.query===r.query&&(n||e.fragment===r.fragment);if(t.isEqualAuthority(e.authority,r.authority))return i.isEqualOrParent(e.path,r.path,this._ignorePathCasing(e),"/")&&e.query===r.query&&(n||e.fragment===r.fragment)}return!1}joinPath(e,...t){return n.URI.joinPath(e,...t)}basenameOrAuthority(e){return t.basename(e)||e.authority}basename(e){return r.posix.basename(e.path)}extname(e){return r.posix.extname(e.path)}dirname(e){if(0===e.path.length)return e;let t;return e.scheme===o.Schemas.file?t=n.URI.file(r.dirname(u(e))).path:(t=r.posix.dirname(e.path),e.authority&&t.length&&47!==t.charCodeAt(0)&&(console.error(`dirname("${e.toString})) resulted in a relative path`),t="/")),e.with({path:t})}normalizePath(e){if(!e.path.length)return e;let t;return t=e.scheme===o.Schemas.file?n.URI.file(r.normalize(u(e))).path:r.posix.normalize(e.path),e.with({path:t})}relativePath(e,n){
if(e.scheme!==n.scheme||!t.isEqualAuthority(e.authority,n.authority))return;if(e.scheme===o.Schemas.file){const t=r.relative(u(e),u(n));return a.isWindows?i.toSlashes(t):t}let s=e.path||"/",l=n.path||"/";if(this._ignorePathCasing(e)){let e=0;for(const t=Math.min(s.length,l.length);e<t&&(s.charCodeAt(e)===l.charCodeAt(e)||s.charAt(e).toLowerCase()===l.charAt(e).toLowerCase());e++);s=l.substr(0,e)+s.substr(e)}return r.posix.relative(s,l)}resolvePath(e,t){if(e.scheme===o.Schemas.file){const i=n.URI.file(r.resolve(u(e),t));return e.with({authority:i.authority,path:i.path})}return-1===t.indexOf("/")&&(t=i.toSlashes(t),/^[a-zA-Z]:(\/|$)/.test(t)&&(t="/"+t)),e.with({path:r.posix.resolve(e.path,t)})}isAbsolutePath(e){return!!e.path&&"/"===e.path[0]}isEqualAuthority(e,t){return e===t||s.equalsIgnoreCase(e,t)}hasTrailingPathSeparator(e,t=r.sep){if(e.scheme===o.Schemas.file){const r=u(e);return r.length>i.getRoot(r).length&&r[r.length-1]===t}{const t=e.path
;return t.length>1&&47===t.charCodeAt(t.length-1)&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,i=r.sep){return t.hasTrailingPathSeparator(e,i)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,n=r.sep){let s=!1;if(e.scheme===o.Schemas.file){const t=u(e);s=void 0!==t&&t.length===i.getRoot(t).length&&t[t.length-1]===n}else{n="/";const t=e.path;s=1===t.length&&47===t.charCodeAt(t.length-1)}return s||t.hasTrailingPathSeparator(e,n)?e:e.with({path:e.path+"/"})}}t.ExtUri=h,t.extUri=new h(()=>!1),t.extUriBiasedIgnorePathCase=new h(e=>e.scheme!==o.Schemas.file||!a.isLinux),t.extUriIgnorePathCase=new h(e=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),
t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri),t.distinctParents=function(e,i){const r=[];for(let n=0;n<e.length;n++){const s=i(e[n]);e.some((e,r)=>r!==n&&t.isEqualOrParent(s,i(e)))||r.push(e[n])}return r},function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime",e.parseMetaData=function(t){const i=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(e=>{const[t,r]=e.split(":");t&&r&&i.set(t,r)})
;const r=t.path.substring(0,t.path.indexOf(";"));return r&&i.set(e.META_DATA_MIME,r),i}}(t.DataUri||(t.DataUri={}));t.ResourceGlobMatcher=class{constructor(e,t){this.expressionsByRoot=c.TernarySearchTree.forUris(),this.globalExpression=l.parse(e);for(const e of t)this.expressionsByRoot.set(e.root,{root:e.root,expression:l.parse(e.expression)})}matches(e){const i=this.expressionsByRoot.findSubstr(e);if(i){const r=t.relativePath(i.root,e);if(r&&i.expression(r))return!0}return!!this.globalExpression(e.path)}},t.toLocalResource=function(e,t,i){if(t){let n=e.path;return n&&n[0]!==r.posix.sep&&(n=r.posix.sep+n),e.with({scheme:i,authority:t,path:n})}return e.with({scheme:i})}})),define(t[43],i([0,1,7,3,16,10,5,18]),(function(e,t,i,r,n,s,o,a){"use strict";function l(e){return!(!o.isWindows||!e||":"!==e[1])}function c(e){return l(e)?e.charAt(0).toUpperCase()+e.slice(1):e}Object.defineProperty(t,"__esModule",{value:!0}),
t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0,t.getPathLabel=function(e,t,n){if("string"==typeof e&&(e=i.URI.file(e)),n){const t=n.getWorkspaceFolder(e);if(t){const i=n.getWorkspace().folders.length>1;let r;if(r=a.isEqual(t.uri,e)?"":a.relativePath(t.uri,e),i){const e=t.name?t.name:a.basename(t.uri);r=r?e+" • "+r:e}return r}}if(e.scheme!==s.Schemas.file&&e.scheme!==s.Schemas.untitled)return e.with({query:null,fragment:null}).toString(!0);if(l(e.fsPath))return r.normalize(c(e.fsPath));let u=r.normalize(e.fsPath);return!o.isWindows&&(null==t?void 0:t.userHome)&&(u=h(u,t.userHome.fsPath)),u},t.getBaseLabel=function(e){if(!e)return;"string"==typeof e&&(e=i.URI.file(e));const t=a.basename(e)||(e.scheme===s.Schemas.file?e.fsPath:e.path);return l(t)?c(t):t},t.normalizeDriveLetter=c;let u=Object.create(null);function h(e,t){if(o.isWindows||!e||!t)return e
;let i=u.original===t?u.normalized:void 0;return i||(i=`${n.rtrim(t,r.posix.sep)}${r.posix.sep}`,u={original:t,normalized:i}),(o.isLinux?e.startsWith(i):n.startsWithIgnoreCase(e,i))&&(e=`~/${e.substr(i.length)}`),e}t.tildify=h,t.untildify=function(e,t){return e.replace(/^~($|\/|\\)/,`${t}$1`)};const d="…",f="\\\\",p="~";var g;t.shorten=function(e,t=r.sep){const i=new Array(e.length);let n=!1;for(let r=0;r<e.length;r++){let s=e[r];if(""===s){i[r]=`.${t}`;continue}if(!s){i[r]=s;continue}n=!0;let o="";0===s.indexOf(f)?(o=s.substr(0,s.indexOf(f)+f.length),s=s.substr(s.indexOf(f)+f.length)):0===s.indexOf(t)?(o=s.substr(0,s.indexOf(t)+t.length),s=s.substr(s.indexOf(t)+t.length)):0===s.indexOf(p)&&(o=s.substr(0,s.indexOf(p)+p.length),s=s.substr(s.indexOf(p)+p.length));const a=s.split(t);for(let s=1;n&&s<=a.length;s++)for(let l=a.length-s;n&&l>=0;l--){n=!1;let c=a.slice(l,l+s).join(t);for(let i=0;!n&&i<e.length;i++)if(i!==r&&e[i]&&e[i].indexOf(c)>-1){
const r=l+s===a.length,o=l>0&&e[i].indexOf(t)>-1?t+c:c,u=e[i].endsWith(o);n=!r||u}if(!n){let e="";(a[0].endsWith(":")||""!==o)&&(1===l&&(l=0,s++,c=a[0]+t+c),l>0&&(e=a[0]+t),e=o+e),l>0&&(e=e+d+t),e+=c,l+s<a.length&&(e=e+t+d),i[r]=e}}n&&(i[r]=s)}return i},function(e){e[e.TEXT=0]="TEXT",e[e.VARIABLE=1]="VARIABLE",e[e.SEPARATOR=2]="SEPARATOR"}(g||(g={})),t.template=function(e,t=Object.create(null)){const i=[];let r=!1,n="";for(const s of e)if("$"===s||r&&"{"===s)n&&i.push({value:n,type:g.TEXT}),n="",r=!0;else if("}"===s&&r){const e=t[n];if("string"==typeof e)e.length&&i.push({value:e,type:g.VARIABLE});else if(e){const t=i[i.length-1];t&&t.type===g.SEPARATOR||i.push({value:e.label,type:g.SEPARATOR})}n="",r=!1}else n+=s;return n&&!r&&i.push({value:n,type:g.TEXT}),i.filter((e,t)=>{if(e.type===g.SEPARATOR){return[i[t-1],i[t+1]].every(e=>e&&(e.type===g.VARIABLE||e.type===g.TEXT)&&e.value.length>0)}return!0}).map(e=>e.value).join("")},t.mnemonicMenuLabel=function(e,t){
return o.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,"").replace(/&/g,o.isMacintosh?"&":"&&"):e.replace(/&&|&/g,e=>"&"===e?"&&":"&")},t.mnemonicButtonLabel=function(e,t){return o.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,""):o.isWindows?e.replace(/&&|&/g,e=>"&"===e?"&&":"&"):e.replace(/&&/g,"_")},t.unmnemonicLabel=function(e){return e.replace(/&/g,"&&")},t.splitName=function(e){const t=-1!==e.indexOf("/")?r.posix:r.win32,i=t.basename(e),n=t.dirname(e);return i.length?{name:i,parentPath:n}:{name:n,parentPath:""}}})),define(t[51],i([0,1,7,10]),(function(e,t,i,r){"use strict";function n(e){return e.toJSON()}Object.defineProperty(t,"__esModule",{value:!0}),t.transformAndReviveIncomingURIs=t.transformIncomingURIs=t.transformOutgoingURIs=t.DefaultURITransformer=t.URITransformer=void 0;function s(e,t,r,n){if(!e||n>200)return null;if("object"==typeof e){if(1===e.$mid)return r?i.URI.revive(t.transformIncoming(e)):t.transformIncoming(e);for(let i in e)if(Object.hasOwnProperty.call(e,i)){const o=s(e[i],t,r,n+1)
;null!==o&&(e[i]=o)}}return null}t.URITransformer=class{constructor(e){this.remoteAuthority=e}transformIncoming(e){return e.scheme===r.Schemas.vscodeRemote?n(i.URI.file(e.path)):e}transformOutgoing(e){return e.scheme===r.Schemas.file?n(i.URI.from({authority:this.remoteAuthority,scheme:r.Schemas.vscodeRemote,path:e.path})):e}transformOutgoingURI(e){return e.scheme===r.Schemas.file?i.URI.from({authority:this.remoteAuthority,scheme:r.Schemas.vscodeRemote,path:e.path}):e}transformOutgoingScheme(e){return e===r.Schemas.file?r.Schemas.vscodeRemote:e}},t.DefaultURITransformer=new class{transformIncoming(e){return e}transformOutgoing(e){return e}transformOutgoingURI(e){return e}transformOutgoingScheme(e){return e}},t.transformOutgoingURIs=function(e,t){const r=function e(t,r,n){if(!t||n>200)return null;if("object"==typeof t){if(t instanceof i.URI)return r.transformOutgoing(t);for(let i in t)if(Object.hasOwnProperty.call(t,i)){const s=e(t[i],r,n+1);null!==s&&(t[i]=s)}}return null}(e,t,0);return null===r?e:r},
t.transformIncomingURIs=function(e,t){const i=s(e,t,!1,0);return null===i?e:i},t.transformAndReviveIncomingURIs=function(e,t){const i=s(e,t,!0,0);return null===i?e:i}})),define(t[26],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;t.isUUID=function(e){return i.test(e)};const r=new Uint8Array(16),n=[];for(let e=0;e<256;e++)n.push(e.toString(16).padStart(2,"0"));const s=function(e){for(let t=0;t<e.length;t++)e[t]=Math.floor(256*Math.random());return e};t.generateUuid=function(){s(r),r[6]=15&r[6]|64,r[8]=63&r[8]|128;let e=0,t="";return t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]],t+="-",t+=n[r[e++]],t+=n[r[e++]],t+="-",t+=n[r[e++]],t+=n[r[e++]],t+="-",t+=n[r[e++]],t+=n[r[e++]],t+="-",t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]]}})),define(t[65],i([0,1,199]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0
}),t.LineDecoder=void 0;t.LineDecoder=class{constructor(e="utf8"){this.stringDecoder=new i.StringDecoder(e),this.remaining=null}write(e){const t=[],i=this.remaining?this.remaining+this.stringDecoder.write(e):this.stringDecoder.write(e);if(i.length<1)return t;let r,n=0,s=n;for(;s<i.length;)if(13===(r=i.charCodeAt(s))||10===r){if(t.push(i.substring(n,s)),++s<i.length){const e=r;r=i.charCodeAt(s),(13===e&&10===r||10===e&&13===r)&&s++}n=s}else s++;return this.remaining=n<i.length?i.substr(n):null,t}end(){return this.remaining}}})),"function"==typeof define)define(t[101],i([44,21,200]),(function(e,t,i){return n(require.__$__nodeRequire,e,t,i)}));else{if("object"!=typeof module||"object"!=typeof module.exports)throw new Error("Unknown context");{const e=require("path"),t=require("fs"),i=require("../common/performance");module.exports=n(require,e,t,i)}}define(t[102],i([0,1,27]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMac=void 0
;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(e){const t=e.replace(/\-/g,":").toLowerCase();return!r.has(t)}t.getMac=function(){return new Promise(async(e,t)=>{const r=setTimeout(()=>t("Unable to retrieve mac address (timeout after 10s)"),1e4);try{e(await new Promise((e,t)=>{try{const r=i.networkInterfaces();for(const[,t]of Object.entries(r))for(const i of t)if(n(i.mac))return e(i.mac);t("Unable to retrieve mac address (unexpected format)")}catch(e){t(e)}}))}catch(e){t(e)}finally{clearTimeout(r)}})}})),define(t[103],i([0,1,14,26,27,25,102]),(function(e,t,i,r,n,s,o){"use strict";let a;Object.defineProperty(t,"__esModule",{value:!0}),t.getMachineId=t.virtualMachineHint=void 0,t.virtualMachineHint=new class{_isVirtualMachineMacAdress(e){return this._virtualMachineOUIs||(this._virtualMachineOUIs=s.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),
this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(e)}value(){if(void 0===this._value){let e=0,t=0;const i=n.networkInterfaces();for(let r in i)if(Object.prototype.hasOwnProperty.call(i,r))for(const{mac:n,internal:s}of i[r])s||(t+=1,this._isVirtualMachineMacAdress(n.toUpperCase())&&(e+=1));this._value=t>0?e/t:0}return this._value}},t.getMachineId=async function(){return a||(a=(async()=>{return await async function(){try{const t=await new Promise((t,i)=>{e(["crypto"],t,i)}),i=await o.getMac()
;return t.createHash("sha256").update(i,"utf8").digest("hex")}catch(e){return void i.onUnexpectedError(e)}}()||r.generateUuid()})()),a}})),define(t[104],i([0,1,10]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getDefaultUserDataPath=t.getAppDataPath=void 0;const r=i.FileAccess.asFileUri("paths",e).fsPath,n=e.__$__nodeRequire(r);t.getAppDataPath=n.getAppDataPath,t.getDefaultUserDataPath=n.getDefaultUserDataPath})),define(t[12],i([0,1,3,15,21,27,5,6,37,33,26,64]),(function(e,t,i,r,n,s,o,a,l,c,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.copy=t.move=t.whenDeleted=t.fileExists=t.dirExists=t.readDirsInDir=t.writeFileSync=t.writeFile=t.mkdirp=t.readFile=t.truncate=t.symlink=t.unlink=t.renameIgnoreError=t.rename=t.lstat=t.statLink=t.stat=t.chmod=t.exists=t.readdirSync=t.readdirWithFileTypes=t.readdir=t.rimrafSync=t.rimraf=t.RimRafMode=t.MAX_HEAP_SIZE=t.MAX_FILE_SIZE=void 0;var d;async function f(e,t=d.UNLINK){
if(c.isRootOrDriveLetter(e))throw new Error("rimraf - will refuse to recursively delete root");return t===d.UNLINK?p(e):async function(e){try{const t=i.join(s.tmpdir(),u.generateUuid());try{await _(e,t)}catch(t){return p(e)}p(t)}catch(e){if("ENOENT"!==e.code)throw e}}(e)}async function p(e){try{const t=await w(e);if(!t.isDirectory()||t.isSymbolicLink()){const i=t.mode;return 128&i||await y(e,128|i),b(e)}{const t=await g(e);await Promise.all(t.map(t=>p(i.join(e,t)))),await l.promisify(n.rmdir)(e)}}catch(e){if("ENOENT"!==e.code)throw e}}async function g(e){return v(await l.promisify(n.readdir)(e))}function m(e){return v(n.readdirSync(e))}function v(e){return o.isMacintosh?e.map(e=>h.normalizeNFC(e)):e}function y(e,t){return l.promisify(n.chmod)(e,t)}function E(e){return l.promisify(n.stat)(e)}function w(e){return l.promisify(n.lstat)(e)}function _(e,t){return l.promisify(n.rename)(e,t)}function b(e){return l.promisify(n.unlink)(e)}async function S(e,t){return l.promisify(n.mkdir)(e,{mode:t,recursive:!0})}
t.MAX_FILE_SIZE="ia32"===process.arch?314572800:17179869184,t.MAX_HEAP_SIZE="ia32"===process.arch?734003200:1468006400,function(e){e[e.UNLINK=0]="UNLINK",e[e.MOVE=1]="MOVE"}(d=t.RimRafMode||(t.RimRafMode={})),t.rimraf=f,t.rimrafSync=function e(t){if(c.isRootOrDriveLetter(t))throw new Error("rimraf - will refuse to recursively delete root");try{const r=n.lstatSync(t);if(!r.isDirectory()||r.isSymbolicLink()){const e=r.mode;return 128&e||n.chmodSync(t,128|e),n.unlinkSync(t)}m(t).map(r=>e(i.join(t,r))),n.rmdirSync(t)}catch(e){if("ENOENT"!==e.code)throw e}},t.readdir=g,t.readdirWithFileTypes=async function(e){const t=await l.promisify(n.readdir)(e,{withFileTypes:!0});if(o.isMacintosh)for(const e of t)e.name=h.normalizeNFC(e.name);return t},t.readdirSync=m,t.exists=function(e){return l.promisify(n.exists)(e)},t.chmod=y,t.stat=E,t.statLink=async function(e){let t;try{if(!(t=await w(e)).isSymbolicLink())return{stat:t}}catch(e){}try{return{stat:await E(e),symbolicLink:(null==t?void 0:t.isSymbolicLink())?{dangling:!1
}:void 0}}catch(e){if("ENOENT"===e.code&&t)return{stat:t,symbolicLink:{dangling:!0}};throw e}},t.lstat=w,t.rename=_,t.renameIgnoreError=function(e,t){return new Promise(i=>n.rename(e,t,()=>i()))},t.unlink=b,t.symlink=function(e,t,i){return l.promisify(n.symlink)(e,t,i)},t.truncate=function(e,t){return l.promisify(n.truncate)(e,t)},t.readFile=function(e,t){return l.promisify(n.readFile)(e,t)},t.mkdirp=S;const C=new Map;t.writeFile=function(e,t,i){return function(e){const t=C.get(e);if(t)return t;const i=new r.Queue;return C.set(e,i),a.Event.once(i.onFinished)(()=>{C.delete(e),i.dispose()}),i}(function(e){let t=e;(o.isWindows||o.isMacintosh)&&(t=t.toLowerCase());return t}(e)).queue(()=>{const r=I(i);return new Promise((i,s)=>(function(e,t,i,r){if(!x)return n.writeFile(e,t,{mode:i.mode,flag:i.flag},r);n.open(e,i.flag,i.mode,(e,i)=>{if(e)return r(e);n.writeFile(i,t,e=>{if(e)return n.close(i,()=>r(e))
;n.fdatasync(i,e=>(e&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",e),x=!1),n.close(i,e=>r(e))))})})})(e,t,r,e=>e?s(e):i()))})};let x=!0;function I(e){return e?{mode:"number"==typeof e.mode?e.mode:438,flag:"string"==typeof e.flag?e.flag:"w"}:{mode:438,flag:"w"}}async function P(e){try{return(await E(e)).isDirectory()}catch(e){return!1}}async function T(e,t,r){const s=r||Object.create(null),o=await E(e);if(!o.isDirectory())return async function(e,t,i){return new Promise((r,s)=>{const o=n.createReadStream(e),a=n.createWriteStream(t,{mode:i});let l=!1;const c=e=>{if(!l){if(l=!0,e)return s(e);n.chmod(t,i,e=>e?s(e):r())}};o.once("error",e=>c(e)),a.once("error",e=>c(e)),a.once("close",()=>c()),o.pipe(a)})}(e,t,511&o.mode);if(s[e])return Promise.resolve();s[e]=!0,await S(t,511&o.mode);const a=await g(e);for(let r=0;r<a.length;r++){const n=a[r];await T(i.join(e,n),i.join(t,n),s)}}t.writeFileSync=function(e,t,i){const r=I(i);if(!x)return n.writeFileSync(e,t,{mode:r.mode,
flag:r.flag});const s=n.openSync(e,r.flag,r.mode);try{n.writeFileSync(s,t);try{n.fdatasyncSync(s)}catch(e){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",e),x=!1}}finally{n.closeSync(s)}},t.readDirsInDir=async function(e){const t=await g(e),r=[];for(const n of t)await P(i.join(e,n))&&r.push(n);return r},t.dirExists=P,t.fileExists=async function(e){try{return(await E(e)).isFile()}catch(e){return!1}},t.whenDeleted=function(e){return new Promise(t=>{let i=!1;const r=setInterval(()=>{i||(i=!0,n.exists(e,e=>{i=!1,e||(clearInterval(r),t(void 0))}))},1e3)})},t.move=async function(e,t){if(e===t)return Promise.resolve();async function i(e){const t=await w(e);if(t.isDirectory()||t.isSymbolicLink())return Promise.resolve();const i=await l.promisify(n.open)(e,"a");try{await l.promisify(n.futimes)(i,t.atime,new Date)}catch(e){}return l.promisify(n.close)(i)}try{await _(e,t),await i(t)}catch(r){if(!(e.toLowerCase()!==t.toLowerCase()&&"EXDEV"===r.code||e.endsWith(".")))throw r
;await T(e,t),await f(e,d.MOVE),await i(t)}},t.copy=T})),define(t[105],i([0,1,21,16,3,12,37]),(function(e,t,i,r,n,s,o){"use strict";function a(e){return r.rtrim(n.normalize(e),n.sep)}Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0,t.realcaseSync=function e(t){const i=n.dirname(t);if(t===i)return t;const r=(n.basename(t)||t).toLowerCase();try{const t=s.readdirSync(i).filter(e=>e.toLowerCase()===r);if(1===t.length){const r=e(i);if(r)return n.join(r,t[0])}else if(t.length>1){const s=t.indexOf(r);if(s>=0){const r=e(i);if(r)return n.join(r,t[s])}}}catch(e){}return null},t.realpath=async function(e){try{return await o.promisify(i.realpath)(e)}catch(t){const r=a(e);return await o.promisify(i.access)(r,i.constants.R_OK),r}},t.realpathSync=function(e){try{return i.realpathSync(e)}catch(t){const r=a(e);return i.accessSync(r,i.constants.R_OK),r}}})),define(t[106],i([0,1,34,201,202]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.monkeyPatch=void 0,t.monkeyPatch=function(t){if(function(){let e=!1;const t=n.getProxyForUrl("http://example.com");t&&(e=!0,i.logger.debug(`using $HTTP_PROXY ${t}`));const r=n.getProxyForUrl("https://example.com");r&&(e=!0,i.logger.debug(`using $HTTPS_PROXY ${r}`));return e}()){const i=e("http"),n=e("https"),s=function(e){return e?new r:new r.default}(t);i.globalAgent=s,n.globalAgent=s}}})),define(t[107],i([0,1,3,21,5,64,2,12]),(function(e,t,i,r,n,s,o,a){"use strict";function l(e,c,u){const h=i.basename(e.path),d=new Map;let f=!1,p=[o.toDisposable(()=>{d.forEach(e=>o.dispose(e)),d.clear()})];try{const g=r.watch(e.path);p.push(o.toDisposable(()=>{g.removeAllListeners(),g.close()}));const m=new Set;e.isDirectory&&a.readdir(e.path).then(e=>e.forEach(e=>m.add(e))),g.on("error",(t,i)=>{f||u(`Failed to watch ${e.path} for changes using fs.watch() (${t}, ${i})`)}),g.on("change",(r,g)=>{if(f)return;let v="";if(g&&(v=g.toString(),n.isMacintosh&&(v=s.normalizeNFC(v))),!v||"change"!==r&&"rename"!==r)return
;const y=e.isDirectory?i.join(e.path,v):e.path;if(e.isDirectory)if("rename"===r){const e=d.get(y);e&&o.dispose(e);const i=setTimeout(async()=>{d.delete(y);const e=await a.exists(y);if(f)return;let t;e?m.has(v)?t="changed":(t="added",m.add(v)):(m.delete(v),t="deleted"),c(t,y)},t.CHANGE_BUFFER_DELAY);d.set(y,o.toDisposable(()=>clearTimeout(i)))}else{let e;m.has(v)?e="changed":(e="added",m.add(v)),c(e,y)}else if("rename"===r||v!==h){const i=setTimeout(async()=>{const t=await a.exists(y);f||(t?(c("changed",y),p=[l(e,c,u)]):c("deleted",y))},t.CHANGE_BUFFER_DELAY);o.dispose(p),p=[o.toDisposable(()=>clearTimeout(i))]}else c("changed",y)})}catch(t){a.exists(e.path).then(i=>{i&&!f&&u(`Failed to watch ${e.path} for changes using fs.watch() (${t.toString()})`)})}return o.toDisposable(()=>{f=!0,p=o.dispose(p)})}Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0,t.watchFile=function(e,t,i){return l({path:e,isDirectory:!1},t,i)},t.watchFolder=function(e,t,i){return l({
path:e,isDirectory:!0},t,i)},t.CHANGE_BUFFER_DELAY=100})),define(t[35],i([0,1,6,2,15,23,14,17,19,11,100,16]),(function(e,t,i,r,n,s,o,a,l,c,u,h){"use strict";var d,f;function p(e){switch(e){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}function g(e){switch(e){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.createChannelSender=t.createChannelReceiver=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0,function(e){e[e.Promise=100]="Promise",e[e.PromiseCancel=101]="PromiseCancel",e[e.EventListen=102]="EventListen",e[e.EventDispose=103]="EventDispose"}(t.RequestType||(t.RequestType={})),function(e){e[e.Initialize=200]="Initialize",e[e.PromiseSuccess=201]="PromiseSuccess",e[e.PromiseError=202]="PromiseError",
e[e.PromiseErrorObj=203]="PromiseErrorObj",e[e.EventFire=204]="EventFire"}(t.ResponseType||(t.ResponseType={})),function(e){e[e.Uninitialized=0]="Uninitialized",e[e.Idle=1]="Idle"}(d||(d={}));class m{constructor(e){this.buffer=e,this.pos=0}read(e){const t=this.buffer.slice(this.pos,this.pos+e);return this.pos+=t.byteLength,t}}class v{constructor(){this.buffers=[]}get buffer(){return a.VSBuffer.concat(this.buffers)}write(e){this.buffers.push(e)}}function y(e){const t=a.VSBuffer.alloc(4);return t.writeUInt32BE(e,0),t}function E(e){return e.read(4).readUInt32BE(0)}function w(e){const t=a.VSBuffer.alloc(1);return t.writeUInt8(e,0),t}!function(e){e[e.Undefined=0]="Undefined",e[e.String=1]="String",e[e.Buffer=2]="Buffer",e[e.VSBuffer=3]="VSBuffer",e[e.Array=4]="Array",e[e.Object=5]="Object"}(f||(f={}));const _={Undefined:w(f.Undefined),String:w(f.String),Buffer:w(f.Buffer),VSBuffer:w(f.VSBuffer),Array:w(f.Array),Object:w(f.Object)},b="undefined"!=typeof Buffer;function S(e,t){
if(void 0===t)e.write(_.Undefined);else if("string"==typeof t){const i=a.VSBuffer.fromString(t);e.write(_.String),e.write(y(i.byteLength)),e.write(i)}else if(b&&Buffer.isBuffer(t)){const i=a.VSBuffer.wrap(t);e.write(_.Buffer),e.write(y(i.byteLength)),e.write(i)}else if(t instanceof a.VSBuffer)e.write(_.VSBuffer),e.write(y(t.byteLength)),e.write(t);else if(Array.isArray(t)){e.write(_.Array),e.write(y(t.length));for(const i of t)S(e,i)}else{const i=a.VSBuffer.fromString(JSON.stringify(t));e.write(_.Object),e.write(y(i.byteLength)),e.write(i)}}function C(e){switch(e.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return e.read(E(e)).toString();case f.Buffer:return e.read(E(e)).buffer;case f.VSBuffer:return e.read(E(e));case f.Array:{const t=E(e),i=[];for(let r=0;r<t;r++)i.push(C(e));return i}case f.Object:return JSON.parse(e.read(E(e)).toString())}}class x{constructor(e,t,i=null,r=1e3){this.protocol=e,this.ctx=t,this.logger=i,this.timeoutDelay=r,this.channels=new Map,this.activeRequests=new Map,
this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(e=>this.onRawMessage(e)),this.sendResponse({type:200})}registerChannel(e,t){this.channels.set(e,t),setTimeout(()=>this.flushPendingRequests(e),0)}sendResponse(e){switch(e.type){case 200:{const t=this.send([e.type]);return void(this.logger&&this.logger.logOutgoing(t,0,1,g(e.type)))}case 201:case 202:case 204:case 203:{const t=this.send([e.type,e.id],e.data);return void(this.logger&&this.logger.logOutgoing(t,e.id,1,g(e.type),e.data))}}}send(e,t){const i=new v;return S(i,e),S(i,t),this.sendBuffer(i.buffer)}sendBuffer(e){try{return this.protocol.send(e),e.byteLength}catch(e){return 0}}onRawMessage(e){const t=new m(e),i=C(t),r=C(t),n=i[0];switch(n){case 100:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],1,`${p(n)}: ${i[2]}.${i[3]}`,r),this.onPromise({type:n,id:i[1],channelName:i[2],name:i[3],arg:r});case 102:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],1,`${p(n)}: ${i[2]}.${i[3]}`,r),this.onEventListen({
type:n,id:i[1],channelName:i[2],name:i[3],arg:r});case 101:case 103:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],1,`${p(n)}`),this.disposeActiveRequest({type:n,id:i[1]})}}onPromise(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const i=new s.CancellationTokenSource;let n;try{n=t.call(this.ctx,e.name,e.arg,i.token)}catch(e){n=Promise.reject(e)}const o=e.id;n.then(t=>{this.sendResponse({id:o,data:t,type:201}),this.activeRequests.delete(e.id)},t=>{t instanceof Error?this.sendResponse({id:o,data:{message:t.message,name:t.name,stack:t.stack?t.stack.split?t.stack.split("\n"):t.stack:void 0},type:202}):this.sendResponse({id:o,data:t,type:203}),this.activeRequests.delete(e.id)});const a=r.toDisposable(()=>i.cancel());this.activeRequests.set(e.id,a)}onEventListen(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const i=e.id,r=t.listen(this.ctx,e.name,e.arg)(e=>this.sendResponse({id:i,data:e,type:204}))
;this.activeRequests.set(e.id,r)}disposeActiveRequest(e){const t=this.activeRequests.get(e.id);t&&(t.dispose(),this.activeRequests.delete(e.id))}collectPendingRequest(e){let t=this.pendingRequests.get(e.channelName);t||(t=[],this.pendingRequests.set(e.channelName,t));const i=setTimeout(()=>{console.error(`Unknown channel: ${e.channelName}`),100===e.type&&this.sendResponse({id:e.id,data:{name:"Unknown channel",message:`Channel name '${e.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);t.push({request:e,timeoutTimer:i})}flushPendingRequests(e){const t=this.pendingRequests.get(e);if(t){for(const e of t)switch(clearTimeout(e.timeoutTimer),e.request.type){case 100:this.onPromise(e.request);break;case 102:this.onEventListen(e.request)}this.pendingRequests.delete(e)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelServer=x,function(e){
e[e.LocalSide=0]="LocalSide",e[e.OtherSide=1]="OtherSide"}(t.RequestInitiator||(t.RequestInitiator={}));class I{constructor(e,t=null){this.protocol=e,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new i.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(e=>this.onBuffer(e)),this.logger=t}getChannel(e){const t=this;return{call:(i,r,n)=>t.requestPromise(e,i,r,n),listen:(i,r)=>t.requestEvent(e,i,r)}}requestPromise(e,t,i,a=s.CancellationToken.None){const l=this.lastRequestId++,c={id:l,type:100,channelName:e,name:t,arg:i};if(a.isCancellationRequested)return Promise.reject(o.canceled());let u;return new Promise((e,t)=>{if(a.isCancellationRequested)return t(o.canceled());const i=()=>{this.handlers.set(l,i=>{switch(i.type){case 201:this.handlers.delete(l),e(i.data);break;case 202:this.handlers.delete(l);const r=new Error(i.data.message);r.stack=i.data.stack,r.name=i.data.name,t(r);break
;case 203:this.handlers.delete(l),t(i.data)}}),this.sendRequest(c)};let s=null;this.state===d.Idle?i():(s=n.createCancelablePromise(e=>this.whenInitialized())).then(()=>{s=null,i()});const h=()=>{s?(s.cancel(),s=null):this.sendRequest({id:l,type:101}),t(o.canceled())},f=a.onCancellationRequested(h);u=r.combinedDisposable(r.toDisposable(h),f),this.activeRequests.add(u)}).finally(()=>{this.activeRequests.delete(u)})}requestEvent(e,t,r){const s=this.lastRequestId++,o={id:s,type:102,channelName:e,name:t,arg:r};let a=null;const l=new i.Emitter({onFirstListenerAdd:()=>{(a=n.createCancelablePromise(e=>this.whenInitialized())).then(()=>{a=null,this.activeRequests.add(l),this.sendRequest(o)})},onLastListenerRemove:()=>{a?(a.cancel(),a=null):(this.activeRequests.delete(l),this.sendRequest({id:s,type:103}))}});return this.handlers.set(s,e=>l.fire(e.data)),l.event}sendRequest(e){switch(e.type){case 100:case 102:{const t=this.send([e.type,e.id,e.channelName,e.name],e.arg)
;return void(this.logger&&this.logger.logOutgoing(t,e.id,0,`${p(e.type)}: ${e.channelName}.${e.name}`,e.arg))}case 101:case 103:{const t=this.send([e.type,e.id]);return void(this.logger&&this.logger.logOutgoing(t,e.id,0,p(e.type)))}}}send(e,t){const i=new v;return S(i,e),S(i,t),this.sendBuffer(i.buffer)}sendBuffer(e){try{return this.protocol.send(e),e.byteLength}catch(e){return 0}}onBuffer(e){const t=new m(e),i=C(t),r=C(t),n=i[0];switch(n){case 200:return this.logger&&this.logger.logIncoming(e.byteLength,0,0,g(n)),this.onResponse({type:i[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],0,g(n),r),this.onResponse({type:i[0],id:i[1],data:r})}}onResponse(e){if(200===e.type)return this.state=d.Idle,void this._onDidInitialize.fire();const t=this.handlers.get(e.id);t&&t(e)}whenInitialized(){return this.state===d.Idle?Promise.resolve():i.Event.toPromise(this.onDidInitialize)}dispose(){this.protocolListener&&(this.protocolListener.dispose(),
this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelClient=I;t.IPCServer=class{constructor(e){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new i.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new i.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,e(({protocol:e,onDidClientDisconnect:t})=>{i.Event.once(e.onMessage)(i=>{const r=C(new m(i)),n=new x(e,r),s=new I(e);this.channels.forEach((e,t)=>n.registerChannel(t,e));const o={channelServer:n,channelClient:s,ctx:r};this._connections.add(o),this._onDidAddConnection.fire(o),t(()=>{n.dispose(),s.dispose(),this._connections.delete(o),this._onDidRemoveConnection.fire(o)})})})}get connections(){const e=[];return this._connections.forEach(t=>e.push(t)),e}getChannel(e,t){const r=this;return{call(n,s,o){let a;if(c.isFunction(t)){let e=l.getRandomElement(r.connections.filter(t))
;a=e?Promise.resolve(e):i.Event.toPromise(i.Event.filter(r.onDidAddConnection,t))}else a=t.routeCall(r,n,s);return P(a.then(t=>t.channelClient.getChannel(e))).call(n,s,o)},listen(i,n){if(c.isFunction(t))return r.getMulticastEvent(e,t,i,n);return P(t.routeEvent(r,i,n).then(t=>t.channelClient.getChannel(e))).listen(i,n)}}}getMulticastEvent(e,t,n,s){const o=this;let a=new r.DisposableStore;const l=new i.Emitter({onFirstListenerAdd:()=>{a=new r.DisposableStore;const c=new i.EventMultiplexer,u=new Map,h=t=>{const i=t.channelClient.getChannel(e).listen(n,s),r=c.add(i);u.set(t,r)};o.connections.filter(t).forEach(h),i.Event.filter(o.onDidAddConnection,t)(h,void 0,a),o.onDidRemoveConnection(e=>{const t=u.get(e);t&&(t.dispose(),u.delete(e))},void 0,a),c.event(l.fire,l,a),a.add(c)},onLastListenerRemove:()=>{a.dispose()}});return l.event}registerChannel(e,t){this.channels.set(e,t),this._connections.forEach(i=>{i.channelServer.registerChannel(e,t)})}dispose(){this.channels.clear(),this._connections.clear(),
this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}};function P(e){return{call:(t,i,r)=>e.then(e=>e.call(t,i,r)),listen(t,r){const n=new i.Relay;return e.then(e=>n.input=e.listen(t,r)),n.event}}}t.IPCClient=class{constructor(e,t,i=null){const r=new v;S(r,t),e.send(r.buffer),this.channelClient=new I(e,i),this.channelServer=new x(e,t,i)}getChannel(e){return this.channelClient.getChannel(e)}registerChannel(e,t){this.channelServer.registerChannel(e,t)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}},t.getDelayedChannel=P,t.getNextTickChannel=function(e){let t=!1;return{call:(i,r,s)=>t?e.call(i,r,s):n.timeout(0).then(()=>t=!0).then(()=>e.call(i,r,s)),listen(r,s){if(t)return e.listen(r,s);const o=new i.Relay;return n.timeout(0).then(()=>t=!0).then(()=>o.input=e.listen(r,s)),o.event}}};function T(e){return"o"===e[0]&&"n"===e[1]&&h.isUpperAsciiLetter(e.charCodeAt(2))}t.StaticRouter=class{constructor(e){this.fn=e}routeCall(e){return this.route(e)}routeEvent(e){
return this.route(e)}async route(e){for(const t of e.connections)if(await Promise.resolve(this.fn(t.ctx)))return Promise.resolve(t);return await i.Event.toPromise(e.onDidAddConnection),await this.route(e)}},t.createChannelReceiver=function(e,t){const r=e,n=t&&t.disableMarshalling,s=new Map;for(const e in r)T(e)&&s.set(e,i.Event.buffer(r[e],!0));return new class{listen(e,t){const i=s.get(t);if(i)return i;throw new Error(`Event not found: ${t}`)}call(e,t,i){const s=r[t];if("function"==typeof s){if(!n&&Array.isArray(i))for(let e=0;e<i.length;e++)i[e]=u.revive(i[e]);return s.apply(r,i)}throw new Error(`Method not found: ${t}`)}}},t.createChannelSender=function(e,t){const i=t&&t.disableMarshalling;return new Proxy({},{get(r,n){var s;if("string"==typeof n)return(null===(s=null==t?void 0:t.properties)||void 0===s?void 0:s.has(n))?t.properties.get(n):T(n)?e.listen(n):async function(...r){let s;s=t&&!c.isUndefinedOrNull(t.context)?[t.context,...r]:r;const o=await e.call(n,s);return i?o:u.revive(o)}
;throw new Error(`Property not found: ${String(n)}`)}})};const k=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function L(e){if(Array.isArray(e))return e;if(e&&"object"==typeof e&&"function"==typeof e.toString){let t=e.toString();if("[object Object]"!==t)return t}return e}function O(e,t,i,r,n,s,o){o=function(e){return Array.isArray(e)?e.map(L):L(e)}(o);const a=k[n],l=a[r%a.length];let c=[`%c[${e}]%c[${String(t).padStart(7," ")}]%c[len: ${String(i).padStart(5," ")}]%c${String(r).padStart(5," ")} - ${s}`,"color: darkgreen","color: grey","color: grey",`color: ${l}`];/\($/.test(s)?(c=c.concat(o)).push(")"):c.push(o),console.log.apply(console,c)}t.logWithColors=O;t.IPCLogger=class{constructor(e,t){this._outgoingPrefix=e,this._incomingPrefix=t,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(e,t,i,r,n){this._totalOutgoing+=e,O(this._outgoingPrefix,this._totalOutgoing,e,t,i,r,n)}logIncoming(e,t,i,r,n){this._totalIncoming+=e,
O(this._incomingPrefix,this._totalIncoming,e,t,i,r,n)}}})),define(t[66],i([0,1,6,35,2,17,5,41]),(function(e,t,i,r,n,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PersistentProtocol=t.BufferedEmitter=t.Client=t.Protocol=t.ProtocolConstants=t.ChunkStream=void 0;let l=null;function c(){return l||(l=s.VSBuffer.alloc(0)),l}class u{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(e){this._chunks.push(e),this._totalLength+=e.byteLength}read(e){return this._read(e,!0)}peek(e){return this._read(e,!1)}_read(e,t){if(0===e)return c();if(e>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===e){const i=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=e),i}if(this._chunks[0].byteLength>e){const i=this._chunks[0].slice(0,e);return t&&(this._chunks[0]=this._chunks[0].slice(e),this._totalLength-=e),i}let i=s.VSBuffer.alloc(e),r=0,n=0;for(;e>0;){const s=this._chunks[n];if(s.byteLength>e){
const o=s.slice(0,e);i.set(o,r),r+=e,t&&(this._chunks[n]=s.slice(e),this._totalLength-=e),e-=e}else i.set(s,r),r+=s.byteLength,t?(this._chunks.shift(),this._totalLength-=s.byteLength):n++,e-=s.byteLength}return i}}var h;t.ChunkStream=u,function(e){e[e.None=0]="None",e[e.Regular=1]="Regular",e[e.Control=2]="Control",e[e.Ack=3]="Ack",e[e.KeepAlive=4]="KeepAlive",e[e.Disconnect=5]="Disconnect"}(h||(h={})),function(e){e[e.HeaderLength=13]="HeaderLength",e[e.AcknowledgeTime=2e3]="AcknowledgeTime",e[e.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",e[e.KeepAliveTime=5e3]="KeepAliveTime",e[e.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",e[e.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",e[e.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"}(t.ProtocolConstants||(t.ProtocolConstants={}));class d{constructor(e,t,i,r){this.type=e,this.id=t,this.ack=i,this.data=r,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends n.Disposable{constructor(e){super(),
this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=e,this._isDisposed=!1,this._incomingData=new u,this._register(this._socket.onData(e=>this.acceptChunk(e))),this.lastReadTime=Date.now()}acceptChunk(e){if(e&&0!==e.byteLength)for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;){const e=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=e.readUInt32BE(9),this._state.messageType=e.readUInt8(0),this._state.id=e.readUInt32BE(1),this._state.ack=e.readUInt32BE(5);else{const t=this._state.messageType,i=this._state.id,r=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(t,i,r,e)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}
dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(e){this._isDisposed=!1,this._socket=e,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){this.flush(),this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(e){if(this._isDisposed)return;e.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=s.VSBuffer.alloc(13);t.writeUInt8(e.type,0),t.writeUInt32BE(e.id,1),t.writeUInt32BE(e.ack,5),t.writeUInt32BE(e.data.byteLength,9),this._writeSoon(t,e.data)}_bufferAdd(e,t){const i=0===this._totalLength;return this._data.push(e,t),this._totalLength+=e.byteLength+t.byteLength,i}_bufferTake(){const e=s.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,e}_writeSoon(e,t){this._bufferAdd(e,t)&&o.setImmediate(()=>{this._writeNow()})}_writeNow(){0!==this._totalLength&&this._socket.write(this._bufferTake())}}class g extends n.Disposable{constructor(e){super(),this._onMessage=new i.Emitter,
this.onMessage=this._onMessage.event,this._onClose=new i.Emitter,this.onClose=this._onClose.event,this._socket=e,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(e=>{1===e.type&&this._onMessage.fire(e.data)})),this._register(this._socket.onClose(()=>this._onClose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(e){this._socketWriter.write(new d(1,0,0,e))}}t.Protocol=g;class m extends r.IPCClient{constructor(e,t,i=null){super(e,t,i),this.protocol=e}static fromSocket(e,t){return new m(new g(e),t)}get onClose(){return this.protocol.onClose}dispose(){super.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end()}}t.Client=m;class v{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,
a.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(e){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(e):this._emitter.fire(e):this._bufferedMessages.push(e)}flushBuffer(){this._bufferedMessages=[]}}t.BufferedEmitter=v;class y{constructor(e){this.data=e,this.next=null}}class E{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let e=[],t=0,i=this._first;for(;i;)e[t++]=i.data,i=i.next;return e}pop(){if(this._first)return this._first===this._last?(this._first=null,void(this._last=null)):void(this._first=this._first.next)}push(e){const t=new y(e);if(!this._first)return this._first=t,void(this._last=t);this._last.next=t,this._last=t}}
class w{constructor(){this.lastRuns=[];const e=Date.now();for(let t=0;t<w._HISTORY_LENGTH;t++)this.lastRuns[t]=e-1e3*t;setInterval(()=>{for(let e=w._HISTORY_LENGTH;e>=1;e--)this.lastRuns[e]=this.lastRuns[e-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return w._INSTANCE||(w._INSTANCE=new w),w._INSTANCE}load(){const e=Date.now(),t=1e3*(1+w._HISTORY_LENGTH);let i=0;for(let r=0;r<w._HISTORY_LENGTH;r++)e-this.lastRuns[r]<=t&&i++;return 1-i/w._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}w._HISTORY_LENGTH=10,w._INSTANCE=null;t.PersistentProtocol=class{constructor(e,t=null){this._loadEstimator=w.getInstance(),this._onControlMessage=new v,this.onControlMessage=this._onControlMessage.event,this._onMessage=new v,this.onMessage=this._onMessage.event,this._onClose=new v,this.onClose=this._onClose.event,this._onSocketClose=new v,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new v,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new E,
this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._socketDisposables=[],this._socket=e,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),t&&this._socketReader.acceptChunk(t),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),
this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=n.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const e=new d(5,0,0,c());this._socketWriter.write(e),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const e=Date.now()-this._socketWriter.lastWriteTime;if(e>=5e3){const e=new d(4,0,0,c());return this._socketWriter.write(e),void this._sendKeepAliveCheck()}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-e+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const e=Date.now()-this._socketReader.lastReadTime;e>=2e4&&!this._loadEstimator.hasHighLoad()?this._onSocketTimeout.fire(void 0):this._incomingKeepAliveTimeout=setTimeout(()=>{
this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-e,0)+5)}getSocket(){return this._socket}beginAcceptReconnection(e,t){this._isReconnecting=!0,this._socketDisposables=n.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._socket=e,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1;const e=this._outgoingUnackMsg.toArray();for(let t=0,i=e.length;t<i;t++)this._socketWriter.write(e[t]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onClose.fire()}
_receiveMessage(e){if(e.ack>this._outgoingAckId)for(this._outgoingAckId=e.ack;;){const t=this._outgoingUnackMsg.peek();if(!(t&&t.id<=e.ack))break;this._outgoingUnackMsg.pop()}1===e.type?e.id>this._incomingMsgId&&(e.id!==this._incomingMsgId+1&&console.error(`PROTOCOL CORRUPTION, LAST SAW MSG ${this._incomingMsgId} AND HAVE NOW RECEIVED MSG ${e.id}`),this._incomingMsgId=e.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(e.data)):2===e.type?this._onControlMessage.fire(e.data):5===e.type&&this._onClose.fire()}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(e){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const i=new d(1,t,this._incomingAckId,e);this._outgoingUnackMsg.push(i),this._isReconnecting||(this._socketWriter.write(i),this._recvAckCheck())}sendControl(e){const t=new d(2,0,0,e);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId)return
;if(this._incomingAckTimeout)return;const e=Date.now()-this._incomingMsgLastTime;e>=2e3?this._sendAck():this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-e+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId)return;if(this._outgoingAckTimeout)return;const e=this._outgoingUnackMsg.peek(),t=Date.now()-e.writtenTime;t>=2e4&&!this._loadEstimator.hasHighLoad()?this._onSocketTimeout.fire(void 0):this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-t,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const e=new d(3,0,this._incomingAckId,c());this._socketWriter.write(e)}}})),define(t[52],i([0,1,108,203,6,35,3,27,26,2,17,66,14,5]),(function(e,t,i,r,n,s,o,a,l,c,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.connect=t.serve=t.Server=t.createStaticIPCHandle=t.createRandomIPCHandle=t.XDG_RUNTIME_DIR=t.WebSocketNodeSocket=t.NodeSocket=void 0;class p{constructor(e){this.socket=e}dispose(){this.socket.destroy()}onData(e){const t=t=>e(u.VSBuffer.wrap(t));return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(e){return this.socket.on("close",e),{dispose:()=>this.socket.off("close",e)}}onEnd(e){return this.socket.on("end",e),{dispose:()=>this.socket.off("end",e)}}write(e){if(!this.socket.destroyed)try{this.socket.write(e.buffer)}catch(e){if("EPIPE"===e.code)return;d.onUnexpectedError(e)}}end(){this.socket.end()}drain(){return new Promise((e,t)=>{if(0===this.socket.bufferSize)return void e();const i=()=>{this.socket.off("close",i),this.socket.off("end",i),this.socket.off("error",i),this.socket.off("timeout",i),this.socket.off("drain",i),e()};this.socket.on("close",i),this.socket.on("end",i),this.socket.on("error",i),this.socket.on("timeout",i),this.socket.on("drain",i)})}}var g,m;t.NodeSocket=p,
function(e){e[e.MinHeaderByteSize=2]="MinHeaderByteSize"}(g||(g={})),function(e){e[e.PeekHeader=1]="PeekHeader",e[e.ReadHeader=2]="ReadHeader",e[e.ReadBody=3]="ReadBody",e[e.Fin=4]="Fin"}(m||(m={}));class v extends c.Disposable{constructor(e){super(),this._onData=this._register(new n.Emitter),this._state={state:1,readLen:2,mask:0},this.socket=e,this._incomingData=new h.ChunkStream,this._register(this.socket.onData(e=>this._acceptChunk(e)))}dispose(){this.socket.dispose()}onData(e){return this._onData.event(e)}onClose(e){return this.socket.onClose(e)}onEnd(e){return this.socket.onEnd(e)}write(e){let t=2;e.byteLength<126?t+=0:e.byteLength<65536?t+=2:t+=8;const i=u.VSBuffer.alloc(t);if(i.writeUInt8(130,0),e.byteLength<126)i.writeUInt8(e.byteLength,1);else if(e.byteLength<65536){i.writeUInt8(126,1);let t=1;i.writeUInt8(e.byteLength>>>8&255,++t),i.writeUInt8(e.byteLength>>>0&255,++t)}else{i.writeUInt8(127,1);let t=1;i.writeUInt8(0,++t),i.writeUInt8(0,++t),i.writeUInt8(0,++t),i.writeUInt8(0,++t),
i.writeUInt8(e.byteLength>>>24&255,++t),i.writeUInt8(e.byteLength>>>16&255,++t),i.writeUInt8(e.byteLength>>>8&255,++t),i.writeUInt8(e.byteLength>>>0&255,++t)}this.socket.write(u.VSBuffer.concat([i,e]))}end(){this.socket.end()}_acceptChunk(e){if(0!==e.byteLength)for(this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;)if(1===this._state.state){const e=this._incomingData.peek(this._state.readLen).readUInt8(1),t=(128&e)>>>7,i=127&e;this._state.state=2,this._state.readLen=2+(t?4:0)+(126===i?2:0)+(127===i?8:0),this._state.mask=0}else if(2===this._state.state){const e=this._incomingData.read(this._state.readLen),t=e.readUInt8(1),i=(128&t)>>>7;let r=127&t,n=1;126===r?r=256*e.readUInt8(++n)+e.readUInt8(++n):127===r&&(r=0*e.readUInt8(++n)+0*e.readUInt8(++n)+0*e.readUInt8(++n)+0*e.readUInt8(++n)+e.readUInt8(++n)*2**24+65536*e.readUInt8(++n)+256*e.readUInt8(++n)+e.readUInt8(++n));let s=0;i&&(s=e.readUInt8(++n)*2**24+65536*e.readUInt8(++n)+256*e.readUInt8(++n)+e.readUInt8(++n)),
this._state.state=3,this._state.readLen=r,this._state.mask=s}else if(3===this._state.state){const e=this._incomingData.read(this._state.readLen);y(e,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._onData.fire(e)}}drain(){return this.socket.drain()}}function y(e,t){if(0===t)return;let i=e.byteLength>>>2;for(let r=0;r<i;r++){const i=e.readUInt32BE(4*r);e.writeUInt32BE(i^t,4*r)}let r=4*i,n=e.byteLength-r;const s=t>>>24&255,o=t>>>16&255,a=t>>>8&255;n>=1&&e.writeUInt8(e.readUInt8(r)^s,r),n>=2&&e.writeUInt8(e.readUInt8(r+1)^o,r+1),n>=3&&e.writeUInt8(e.readUInt8(r+2)^a,r+2)}t.WebSocketNodeSocket=v,t.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const E={2:107,1:103};function w(e){const t=E[f.platform];"number"==typeof t&&e.length>=t&&console.warn(`WARNING: IPC handle "${e}" is longer than ${t} chars, try a shorter --user-data-dir`)}t.createRandomIPCHandle=function(){const e=l.generateUuid();if("win32"===process.platform)return`\\\\.\\pipe\\vscode-ipc-${e}-sock`;let i
;return w(i=t.XDG_RUNTIME_DIR?o.join(t.XDG_RUNTIME_DIR,`vscode-ipc-${e}.sock`):o.join(a.tmpdir(),`vscode-ipc-${e}.sock`)),i},t.createStaticIPCHandle=function(e,r,n){const s=i.createHash("md5").update(e).digest("hex");if("win32"===process.platform)return`\\\\.\\pipe\\${s}-${n}-${r}-sock`;let a;return w(a=t.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o.join(t.XDG_RUNTIME_DIR,`vscode-${s.substr(0,8)}-${n}-${r}.sock`):o.join(e,`${n}-${r}.sock`)),a};class _ extends s.IPCServer{constructor(e){super(_.toClientConnectionEvent(e)),this.server=e}static toClientConnectionEvent(e){const t=n.Event.fromNodeEventEmitter(e,"connection");return n.Event.map(t,e=>({protocol:new h.Protocol(new p(e)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(e,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}t.Server=_,t.serve=function(e){return new Promise((t,i)=>{const n=r.createServer();n.on("error",i),n.listen(e,()=>{n.removeListener("error",i),t(new _(n))})})},
t.connect=function(e,t){return new Promise((i,n)=>{const s=r.createConnection(e,()=>{s.removeListener("error",n),i(h.Client.fromSocket(new p(s),t))});s.once("error",n)})}})),define(t[109],i([8,9]),(function(e,t){return e.create("vs/base/common/actions",t)})),define(t[110],i([0,1,109,2,6]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.RadioGroup=t.ActionRunner=t.Action=void 0;class s extends r.Disposable{constructor(e,t="",i="",r=!0,s){super(),this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._checked=!1,this._id=e,this._label=t,this._cssClass=i,this._enabled=r,this._actionCallback=s}get id(){return this._id}get label(){return this._label}set label(e){this._setLabel(e)}_setLabel(e){this._label!==e&&(this._label=e,this._onDidChange.fire({label:e}))}get tooltip(){return this._tooltip||""}set tooltip(e){this._setTooltip(e)}_setTooltip(e){
this._tooltip!==e&&(this._tooltip=e,this._onDidChange.fire({tooltip:e}))}get class(){return this._cssClass}set class(e){this._setClass(e)}_setClass(e){this._cssClass!==e&&(this._cssClass=e,this._onDidChange.fire({class:e}))}get enabled(){return this._enabled}set enabled(e){this._setEnabled(e)}_setEnabled(e){this._enabled!==e&&(this._enabled=e,this._onDidChange.fire({enabled:e}))}get checked(){return this._checked}set checked(e){this._setChecked(e)}_setChecked(e){this._checked!==e&&(this._checked=e,this._onDidChange.fire({checked:e}))}run(e,t){return this._actionCallback?this._actionCallback(e):Promise.resolve(!0)}}t.Action=s;class o extends r.Disposable{constructor(){super(...arguments),this._onDidBeforeRun=this._register(new n.Emitter),this.onDidBeforeRun=this._onDidBeforeRun.event,this._onDidRun=this._register(new n.Emitter),this.onDidRun=this._onDidRun.event}async run(e,t){if(!e.enabled)return Promise.resolve(null);this._onDidBeforeRun.fire({action:e});try{const i=await this.runAction(e,t)
;this._onDidRun.fire({action:e,result:i})}catch(t){this._onDidRun.fire({action:e,error:t})}}runAction(e,t){const i=t?e.run(t):e.run();return Promise.resolve(i)}}t.ActionRunner=o;class a extends r.Disposable{constructor(e){super(),this.actions=e;for(const t of e)this._register(t.onDidChange(i=>{if(i.checked&&t.checked)for(const i of e)i!==t&&(i.checked=!1)}))}}t.RadioGroup=a;class l extends s{constructor(e){super(l.ID,e,e?"separator text":"separator"),this.checked=!1,this.enabled=!1}}t.Separator=l,l.ID="vs.actions.separator";t.SubmenuAction=class extends s{constructor(e,t,i,r){super(e,t,r,!0),this._actions=i}get actions(){return this._actions}};class c extends s{constructor(){super(c.ID,i.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=c,c.ID="vs.actions.empty"})),define(t[111],i([8,9]),(function(e,t){return e.create("vs/base/common/date",t)})),define(t[112],i([0,1,111]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0
;const r=60,n=60*r,s=24*n,o=7*s,a=30*s,l=365*s;t.fromNow=function e(t,c){"number"!=typeof t&&(t=t.getTime());const u=Math.round(((new Date).getTime()-t)/1e3);if(u<-30)return i.localize(0,null,e((new Date).getTime()+1e3*u,!1));if(u<30)return i.localize(1,null);let h;return u<r?(h=u,c?1===h?i.localize(2,null,h):i.localize(3,null,h):1===h?i.localize(4,null,h):i.localize(5,null,h)):u<n?(h=Math.floor(u/r),c?1===h?i.localize(6,null,h):i.localize(7,null,h):1===h?i.localize(8,null,h):i.localize(9,null,h)):u<s?(h=Math.floor(u/n),c?1===h?i.localize(10,null,h):i.localize(11,null,h):1===h?i.localize(12,null,h):i.localize(13,null,h)):u<o?(h=Math.floor(u/s),c?1===h?i.localize(14,null,h):i.localize(15,null,h):1===h?i.localize(16,null,h):i.localize(17,null,h)):u<a?(h=Math.floor(u/o),c?1===h?i.localize(18,null,h):i.localize(19,null,h):1===h?i.localize(20,null,h):i.localize(21,null,h)):u<l?(h=Math.floor(u/a),
c?1===h?i.localize(22,null,h):i.localize(23,null,h):1===h?i.localize(24,null,h):i.localize(25,null,h)):(h=Math.floor(u/l),c?1===h?i.localize(26,null,h):i.localize(27,null,h):1===h?i.localize(28,null,h):i.localize(29,null,h))},t.toLocalISOString=function(e){return e.getFullYear()+"-"+String(e.getMonth()+1).padStart(2,"0")+"-"+String(e.getDate()).padStart(2,"0")+"T"+String(e.getHours()).padStart(2,"0")+":"+String(e.getMinutes()).padStart(2,"0")+":"+String(e.getSeconds()).padStart(2,"0")+"."+(e.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}})),define(t[113],i([8,9]),(function(e,t){return e.create("vs/base/common/errorMessage",t)})),define(t[45],i([0,1,113,11,19]),(function(e,t,i,r,n){"use strict";function s(e,t){return t&&(e.stack||e.stacktrace)?i.localize(0,null,a(e),o(e.stack)||o(e.stacktrace)):a(e)}function o(e){return Array.isArray(e)?e.join("\n"):e}function a(e){return"string"==typeof e.code&&"number"==typeof e.errno&&"string"==typeof e.syscall?i.localize(1,null,e.message):e.message||i.localize(2,null)}
Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0,t.toErrorMessage=function e(t=null,o=!1){if(!t)return i.localize(3,null);if(Array.isArray(t)){const r=n.coalesce(t),s=e(r[0],o);return r.length>1?i.localize(4,null,s,r.length):s}if(r.isString(t))return t;if(t.detail){const e=t.detail;if(e.error)return s(e.error,o);if(e.exception)return s(e.exception,o)}return t.stack?s(t,o):t.message?t.message:i.localize(5,null)}})),define(t[114],i([8,9]),(function(e,t){return e.create("vs/base/common/jsonErrorMessages",t)})),define(t[115],i([0,1,114]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getParseErrorMessage=void 0,t.getParseErrorMessage=function(e){switch(e){case 1:return i.localize(0,null);case 2:return i.localize(1,null);case 3:return i.localize(2,null);case 4:return i.localize(3,null);case 5:return i.localize(4,null);case 6:return i.localize(5,null);case 7:return i.localize(6,null);case 8:return i.localize(7,null);case 9:return i.localize(8,null);default:
return""}}})),define(t[116],i([8,9]),(function(e,t){return e.create("vs/base/node/processes",t)})),define(t[67],i([0,1,3,21,37,38,116,11,20,33,5,65,10]),(function(e,t,i,r,n,s,o,a,l,c,u,h,d){"use strict";function f(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(e=process.env){return e.comspec||"cmd.exe"}Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,t.getWindowsShell=p;class g{constructor(e,t,i,r){if(void 0!==t&&void 0!==i&&void 0!==r)this.cmd=e,this.args=t,this.shell=i,this.options=r;else{const t=e;this.cmd=t.command,this.shell=t.isShellCommand,this.args=t.args.slice(0),this.options=t.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const e=Object.create(null);Object.keys(process.env).forEach(t=>{e[t]=process.env[t]}),Object.keys(this.options.env).forEach(t=>{e[t]=this.options.env[t]
}),this.options.env=e}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const t=e.lastIndexOf(i.sep);return-1!==t&&(e=e.substring(t+1)),g.WellKnowCommands[e]?e:"other"}start(e){return u.isWindows&&(this.options&&this.options.cwd&&c.isUNC(this.options.cwd)||!this.options&&c.isUNC(process.cwd()))?Promise.reject(new Error(o.localize(0,null))):this.useExec().then(t=>{let i,r;const n=new Promise((e,t)=>{i=e,r=t});if(t){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=s.exec(t,this.options,(t,n,s)=>{this.childProcess=null;t&&t.killed?r({killed:this.terminateRequested,stdout:n.toString(),stderr:s.toString()}):this.handleExec(i,e,t,n,s)})}else{let t=null;const n=t=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(t,i,e,r);const n={terminated:this.terminateRequested};a.isNumber(t)&&(n.cmdCode=t),i(n)};if(this.shell&&u.isWindows){const e=l.deepClone(this.options);e.windowsVerbatimArguments=!0,e.detached=!1;let i=!1,r=!1;const n=[];let o=this.ensureQuotes(this.cmd)
;n.push(o.value),i=o.quoted,this.args&&this.args.forEach(e=>{o=this.ensureQuotes(e),n.push(o.value),r=r&&o.quoted});const a=["/s","/c"];i?r?a.push('"'+n.join(" ")+'"'):n.length>1?a.push('"'+n[0]+'" '+n.slice(1).join(" ")):a.push('"'+n[0]+'"'):a.push(n.join(" ")),t=s.spawn(p(),a,e)}else this.cmd&&(t=s.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(a.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",e=>{this.childProcess=null,r({terminated:this.terminateRequested,error:e})}),t.pid&&(this.childProcess.on("close",n),this.handleSpawn(t,i,e,r,!0)))}return n})}handleClose(e,t,i,r){}ensureQuotes(e){return g.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&'"'===e[0]&&'"'===e[e.length-1]}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){
return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,function(t,i){if(u.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};i&&(e.cwd=i);const r=s.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise((e,t)=>{r.once("error",t=>{e({success:!1,error:t})}),r.once("exit",(t,i)=>{e(0===t?{success:!0}:{success:!1,code:null!==t?t:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?f(e.status):1})}else if(u.isLinux||u.isMacintosh)try{const i=d.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",e).fsPath;return new Promise((e,r)=>{s.execFile(i,[t.pid.toString()],{encoding:"utf8",shell:!0},(t,i,r)=>{e(t?{success:!1,error:t}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}(t,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{
if(!this.shell||!u.isWindows)return e(!1);const t=s.spawn(p(),["/s","/c"]);t.on("error",t=>e(!0)),t.on("exit",t=>e(!1))})}}t.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;t.LineProcess=class extends g{constructor(e,t,i,r){super(e,t,i,r),this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,t,i,r,n){[r,n].forEach((e,i)=>{const r=new h.LineDecoder;r.write(e).forEach(e=>{t({line:e,source:0===i?0:1})});const n=r.end();n&&t({line:n,source:0===i?0:1})}),e({terminated:this.terminateRequested,error:i})}handleSpawn(e,t,i,r,n){const s=new h.LineDecoder,o=new h.LineDecoder;e.stdout.on("data",e=>{s.write(e).forEach(e=>i({line:e,source:0}))}),e.stderr.on("data",e=>{o.write(e).forEach(e=>i({line:e,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=o}handleClose(e,t,i,r){
const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&i({line:s,source:1})}},t.createQueuedSender=function(e){let t=[],i=!1;const r=function(n){if(i)return void t.push(n);e.send(n,e=>{if(e&&console.error(e),i=!1,t.length>0){const e=t.slice(0);t=[],e.forEach(e=>r(e))}})&&!u.isWindows||(i=!0)};return{send:r}},function(e){e.findExecutable=async function(e,t,s){if(i.isAbsolute(e))return e;if(void 0===t&&(t=process.cwd()),"."!==i.dirname(e))return i.join(t,e);if(void 0===s&&a.isString(process.env.PATH)&&(s=process.env.PATH.split(i.delimiter)),void 0===s||0===s.length)return i.join(t,e);async function o(e){return!!await n.promisify(r.exists)(e)&&!(await n.promisify(r.stat)(e)).isDirectory()}for(let r of s){let n;if(n=i.isAbsolute(r)?i.join(r,e):i.join(t,r,e),await o(n))return n;let s=n+".com";if(await o(s))return s;if(s=n+".exe",await o(s))return s}return i.join(t,e)}}(t.win32||(t.win32={}))})),
define(t[68],i([0,1,38,2,15,20,6,67,35,99,23,14,17,5]),(function(e,t,i,r,n,s,o,a,l,c,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class p extends l.ChannelServer{constructor(e){super({send:e=>{try{process.send&&process.send(e.buffer.toString("base64"))}catch(e){}},onMessage:o.Event.fromNodeEventEmitter(process,"message",e=>d.VSBuffer.wrap(Buffer.from(e,"base64")))},e),process.once("disconnect",()=>this.dispose())}}t.Server=p;t.Client=class{constructor(e,t){this.modulePath=e,this.options=t,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new o.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const i=t&&t.timeout?t.timeout:6e4;this.disposeDelayer=new n.Delayer(i),this.child=null,this._client=null}getChannel(e){const t=this;return{call:(i,r,n)=>t.requestPromise(e,i,r,n),listen:(i,r)=>t.requestEvent(e,i,r)}}requestPromise(e,t,i,s=u.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"))
;if(s.isCancellationRequested)return Promise.reject(h.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(e),a=n.createCancelablePromise(e=>o.call(t,i,e)),l=s.onCancellationRequested(()=>a.cancel()),c=r.toDisposable(()=>a.cancel());return this.activeRequests.add(c),a.finally(()=>{l.dispose(),this.activeRequests.delete(c),0===this.activeRequests.size&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(e,t,i){if(!this.disposeDelayer)return o.Event.None;let r;this.disposeDelayer.cancel();const n=new o.Emitter({onFirstListenerAdd:()=>{const s=this.getCachedChannel(e).listen(t,i);r=s(n.fire,n),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),0===this.activeRequests.size&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return n.event}get client(){if(!this._client){const e=this.options&&this.options.args?this.options.args:[],t=Object.create(null)
;t.env=Object.assign(Object.assign({},s.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(t.env=Object.assign(Object.assign({},t.env),this.options.env)),this.options&&this.options.freshExecArgv&&(t.execArgv=[]),this.options&&"number"==typeof this.options.debug&&(t.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&"number"==typeof this.options.debugBrk&&(t.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.isMacintosh&&t.env&&delete t.env.DYLD_LIBRARY_PATH,this.child=i.fork(this.modulePath,e,t);const n=new o.Emitter;o.Event.fromNodeEventEmitter(this.child,"message",e=>e)(e=>{c.isRemoteConsoleLog(e)?c.log(e,`IPC Library: ${this.options.serverName}`):n.fire(d.VSBuffer.wrap(Buffer.from(e,"base64")))});const u=this.options.useQueue?a.createQueuedSender(this.child):this.child,h={send:e=>this.child&&this.child.connected&&u.send(e.buffer.toString("base64")),onMessage:n.event};this._client=new l.ChannelClient(h)
;const p=()=>this.disposeClient();process.once("exit",p),this.child.on("error",e=>console.warn('IPC "'+this.options.serverName+'" errored with '+e)),this.child.on("exit",(e,t)=>{process.removeListener("exit",p),this.activeRequests.forEach(e=>r.dispose(e)),this.activeRequests.clear(),0!==e&&"SIGTERM"!==t&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+e+" and signal "+t),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:e,signal:t})})}return this._client}getCachedChannel(e){let t=this.channels.get(e);return t||(t=this.client.getChannel(e),this.channels.set(e,t)),t}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}})),define(t[117],i([8,9]),(function(e,t){return e.create("vs/base/node/zip",t)
})),define(t[118],i([8,9]),(function(e,t){return e.create("vs/code/node/cliProcessMain",t)})),define(t[119],i([8,9]),(function(e,t){return e.create("vs/platform/configuration/common/configurationRegistry",t)})),define(t[120],i([8,9]),(function(e,t){return e.create("vs/platform/extensionManagement/common/extensionManagement",t)})),define(t[121],i([8,9]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionManagementService",t)})),define(t[122],i([8,9]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)})),define(t[123],i([8,9]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionsScanner",t)})),define(t[124],i([8,9]),(function(e,t){return e.create("vs/platform/extensions/common/extensionValidator",t)})),define(t[125],i([8,9]),(function(e,t){return e.create("vs/platform/files/common/fileService",t)})),define(t[126],i([8,9]),(function(e,t){return e.create("vs/platform/files/common/files",t)})),
define(t[127],i([8,9]),(function(e,t){return e.create("vs/platform/files/common/io",t)})),define(t[128],i([8,9]),(function(e,t){return e.create("vs/platform/files/node/diskFileSystemProvider",t)})),define(t[129],i([8,9]),(function(e,t){return e.create("vs/platform/request/common/request",t)})),define(t[130],i([8,9]),(function(e,t){return e.create("vs/platform/telemetry/common/telemetryService",t)})),define(t[131],i([8,9]),(function(e,t){return e.create("vs/platform/workspaces/common/workspaces",t)})),define(t[132],i([8,9]),(function(e,t){return e.create("vs/server/node/marketplace",t)})),define(t[133],i([8,9]),(function(e,t){return e.create("vs/server/node/server",t)})),define(t[134],i([8,9]),(function(e,t){return e.create("vs/workbench/common/editor",t)})),define(t[135],i([8,9]),(function(e,t){return e.create("vs/workbench/contrib/terminal/common/terminal",t)})),define(t[136],i([8,9]),(function(e,t){return e.create("vs/workbench/contrib/terminal/node/terminalProcess",t)})),
define(t[137],i([8,9]),(function(e,t){return e.create("vs/workbench/services/configurationResolver/common/variableResolver",t)})),define(t[138],i([8,9]),(function(e,t){return e.create("vs/workbench/services/extensions/node/extensionPoints",t)})),define(t[139],i([0,1,6,2]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionHostDebugChannelClient=t.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this._onCloseEmitter=new i.Emitter,this._onReloadEmitter=new i.Emitter,this._onTerminateEmitter=new i.Emitter,this._onLogToEmitter=new i.Emitter,this._onAttachEmitter=new i.Emitter}call(e,t,i){switch(t){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:i[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:i[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:i[0]}));case"log":return Promise.resolve(this._onLogToEmitter.fire({sessionId:i[0],log:i[1]}));case"attach":
return Promise.resolve(this._onAttachEmitter.fire({sessionId:i[0],port:i[1],subId:i[2]}))}throw new Error("Method not implemented.")}listen(e,t,i){switch(t){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"log":return this._onLogToEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}t.ExtensionHostDebugBroadcastChannel=n,n.ChannelName="extensionhostdebugservice";class s extends r.Disposable{constructor(e){super(),this.channel=e}reload(e){this.channel.call("reload",[e])}get onReload(){return this.channel.listen("reload")}close(e){this.channel.call("close",[e])}get onClose(){return this.channel.listen("close")}attachSession(e,t,i){this.channel.call("attach",[e,t,i])}get onAttachSession(){return this.channel.listen("attach")}logToSession(e,t){this.channel.call("log",[e,t])}get onLogToSession(){return this.channel.listen("log")}terminateSession(e,t){
this.channel.call("terminate",[e,t])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(e,t,i){return this.channel.call("openExtensionDevelopmentHostWindow",[e,t,i])}}t.ExtensionHostDebugChannelClient=s})),define(t[140],i([0,1,6,7,51,20]),(function(e,t,i,r,n,s){"use strict";function o(e,t){return r.URI.revive(t?t.transformIncoming(e):e)}function a(e,t){t=t||n.DefaultURITransformer;const i=e.manifest,r=n.transformAndReviveIncomingURIs(Object.assign(Object.assign({},e),{manifest:void 0}),t);return Object.assign(Object.assign({},r),{manifest:i})}function l(e,t){return t?s.cloneAndChange(e,e=>e instanceof r.URI?t.transformOutgoingURI(e):void 0):e}Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionTipsChannel=t.ExtensionManagementChannelClient=t.ExtensionManagementChannel=void 0;t.ExtensionManagementChannel=class{constructor(e,t){this.service=e,this.getUriTransformer=t,this.onInstallExtension=i.Event.buffer(e.onInstallExtension,!0),
this.onDidInstallExtension=i.Event.buffer(e.onDidInstallExtension,!0),this.onUninstallExtension=i.Event.buffer(e.onUninstallExtension,!0),this.onDidUninstallExtension=i.Event.buffer(e.onDidUninstallExtension,!0)}listen(e,t){const r=this.getUriTransformer(e);switch(t){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return i.Event.map(this.onDidInstallExtension,e=>Object.assign(Object.assign({},e),{local:e.local?l(e.local,r):e.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(e,t,i){const r=this.getUriTransformer(e);switch(t){case"zip":return this.service.zip(a(i[0],r)).then(e=>(function(e,t){return t?t.transformOutgoingURI(e):e})(e,r));case"unzip":return this.service.unzip(o(i[0],r));case"install":return this.service.install(o(i[0],r));case"getManifest":return this.service.getManifest(o(i[0],r));case"canInstall":return this.service.canInstall(i[0])
;case"installFromGallery":return this.service.installFromGallery(i[0],i[1]);case"uninstall":return this.service.uninstall(a(i[0],r),i[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(a(i[0],r));case"getInstalled":return this.service.getInstalled(i[0]).then(e=>e.map(e=>l(e,r)));case"updateMetadata":return this.service.updateMetadata(a(i[0],r),i[1]).then(e=>l(e,r));case"updateExtensionScope":return this.service.updateExtensionScope(a(i[0],r),i[1]).then(e=>l(e,r));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}};t.ExtensionManagementChannelClient=class{constructor(e){this.channel=e}get onInstallExtension(){return this.channel.listen("onInstallExtension")}get onDidInstallExtension(){return i.Event.map(this.channel.listen("onDidInstallExtension"),e=>Object.assign(Object.assign({},e),{local:e.local?a(e.local,null):e.local}))}get onUninstallExtension(){return this.channel.listen("onUninstallExtension")}get onDidUninstallExtension(){
return this.channel.listen("onDidUninstallExtension")}zip(e){return Promise.resolve(this.channel.call("zip",[e]).then(e=>r.URI.revive(e)))}unzip(e){return Promise.resolve(this.channel.call("unzip",[e]))}install(e){return Promise.resolve(this.channel.call("install",[e])).then(e=>a(e,null))}getManifest(e){return Promise.resolve(this.channel.call("getManifest",[e]))}async canInstall(e){return!0}installFromGallery(e,t){return Promise.resolve(this.channel.call("installFromGallery",[e,t])).then(e=>a(e,null))}uninstall(e,t=!1){return Promise.resolve(this.channel.call("uninstall",[e,t]))}reinstallFromGallery(e){return Promise.resolve(this.channel.call("reinstallFromGallery",[e]))}getInstalled(e=null){return Promise.resolve(this.channel.call("getInstalled",[e])).then(e=>e.map(e=>a(e,null)))}updateMetadata(e,t){return Promise.resolve(this.channel.call("updateMetadata",[e,t])).then(e=>a(e,null))}updateExtensionScope(e,t){return Promise.resolve(this.channel.call("updateExtensionScope",[e,t])).then(e=>a(e,null))}
getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}};t.ExtensionTipsChannel=class{constructor(e){this.service=e}listen(e,t){throw new Error("Invalid listen")}call(e,t,i){switch(t){case"getConfigBasedTips":return this.service.getConfigBasedTips(r.URI.revive(i[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}})),define(t[141],i([0,1,20]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const r=/^%([\w\d.-]+)%$/i;t.localizeManifest=function(e,t){return i.cloneAndChange(e,e=>{if("string"!=typeof e)return;const i=r.exec(e);return i?t[i[1]]||e:void 0})}})),define(t[53],i([0,1,124]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const r=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function n(e){return"*"===(e=e.trim())||r.test(e)}function s(e){if(!n(e))return null;if("*"===(e=e.trim()))return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let t=e.match(r);return t?{hasCaret:"^"===t[1],hasGreaterEquals:">="===t[1],majorBase:"x"===t[2]?0:parseInt(t[2],10),majorMustEqual:"x"!==t[2],minorBase:"x"===t[4]?0:parseInt(t[4],10),minorMustEqual:"x"!==t[4],patchBase:"x"===t[6]?0:parseInt(t[6],10),patchMustEqual:"x"!==t[6],preRelease:t[8]||null}:null}function o(e){if(!e)return null;let t=e.majorBase,i=e.majorMustEqual,r=e.minorBase,n=e.minorMustEqual,s=e.patchBase,o=e.patchMustEqual;return e.hasCaret&&(0===t?o=!1:(n=!1,o=!1)),{majorBase:t,majorMustEqual:i,minorBase:r,minorMustEqual:n,patchBase:s,patchMustEqual:o,
isMinimum:e.hasGreaterEquals}}function a(e,t){let i,r;if(i="string"==typeof e?o(s(e)):e,r="string"==typeof t?o(s(t)):t,!i||!r)return!1;let n=i.majorBase,a=i.minorBase,l=i.patchBase,c=r.majorBase,u=r.minorBase,h=r.patchBase,d=r.majorMustEqual,f=r.minorMustEqual,p=r.patchMustEqual;return r.isMinimum?n>c||!(n<c)&&(a>u||!(a<u)&&l>=h):(1!==n||0!==c||d&&f&&p||(c=1,u=0,h=0,d=!0,f=!1,p=!1),!(n<c)&&(n>c?!d:!(a<u)&&(a>u?!f:!(l<h)&&(!(l>h)||!p))))}function l(e,t,r=[]){let n=o(s(t));if(!n)return r.push(i.localize(0,null,t)),!1;if(0===n.majorBase){if(!n.majorMustEqual||!n.minorMustEqual)return r.push(i.localize(1,null,t)),!1}else if(!n.majorMustEqual)return r.push(i.localize(2,null,t)),!1;return!!a(e,n)||(r.push(i.localize(3,null,e,t)),!1)}t.isValidVersionStr=n,t.parseVersion=s,t.normalizeVersion=o,t.isValidVersion=a,t.isValidExtensionVersion=function(e,t,i){return!(!t.isBuiltin&&void 0!==t.main)||l(e,t.engines.vscode,i)},t.isEngineValid=function(e,t){return"*"===e||l(t,e)},t.isVersionValid=l})),
define(t[142],i([0,1,35,68,2,10]),(function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class o extends n.Disposable{constructor(e,t,i,r){super(),this.folders=e,this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=r,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const t=this._register(new r.Client(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",PIPE_LOGGING:"true",VERBOSE_LOGGING:"true"}}));this._register(t.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=o.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=i.createChannelSender(i.getNextTickChannel(t.getChannel("watcher"))),
this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(e=>!this.isDisposed&&this.onDidFilesChange(e))),this._register(this.service.onDidLogMessage(e=>this.onLogMessage(e))),this.setFolders(this.folders)}setVerboseLogging(e){this.verboseLogging=e,!this.isDisposed&&this.service&&this.service.setVerboseLogging(e)}error(e){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${e}`})}setFolders(e){this.folders=e,this.service&&this.service.setRoots(e)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=o,o.MAX_RESTARTS=5})),define(t[143],i([0,1,35,68,2,10]),(function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class o extends n.Disposable{constructor(e,t,i,r,n={}){super(),this.folders=e,this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=r,this.watcherOptions=n,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){
const t=this._register(new r.Client(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",PIPE_LOGGING:"true",VERBOSE_LOGGING:"true"}}));this._register(t.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=o.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=i.createChannelSender(i.getNextTickChannel(t.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(e=>!this.isDisposed&&this.onDidFilesChange(e))),this._register(this.service.onDidLogMessage(e=>this.onLogMessage(e))),this.service.setRoots(this.folders)}error(e){this.onLogMessage({type:"error",
message:`[File Watcher (chokidar)] ${e}`})}setVerboseLogging(e){this.verboseLogging=e,this.service&&this.service.setVerboseLogging(e)}setFolders(e){this.folders=e,this.service&&this.service.setRoots(e)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=o,o.MAX_RESTARTS=5})),define(t[144],i([0,1,38,65,63,10]),(function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class o{constructor(e,t,i,r,s){this.watchedFolder=e,this.eventCallback=i,this.logCallback=r,this.verboseLogging=s,this.restartCounter=0,Array.isArray(t)?this.ignored=t.map(e=>n.parse(e)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${e}`),this.startWatcher()}startWatcher(){const t=[this.watchedFolder];this.verboseLogging&&t.push("-verbose"),this.handle=i.spawn(s.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",e).fsPath,t);const n=new r.LineDecoder;this.handle.stdout.on("data",e=>{const t=[];n.write(e).forEach(e=>{
const i=e.split("|");if(2===i.length){const e=Number(i[0]),r=i[1];if(e>=0&&e<3){if(this.ignored&&this.ignored.some(e=>e(r)))return void(this.verboseLogging&&this.log(r));t.push({type:o.changeTypeMap[e],path:r})}else this.log(i[1])}}),t.length>0&&this.eventCallback(t)}),this.handle.on("error",e=>this.onError(e)),this.handle.stderr.on("data",e=>this.onError(e)),this.handle.on("exit",(e,t)=>this.onExit(e,t))}onError(e){this.error("process error: "+e.toString())}onExit(e,t){this.handle&&(this.error(`terminated unexpectedly (code: ${e}, signal: ${t})`),this.restartCounter<=o.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(e){this.logCallback({type:"error",message:`[File Watcher (C#)] ${e}`})}log(e){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${e}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}
t.OutOfProcessWin32FolderWatcher=o,o.MAX_RESTARTS=5,o.changeTypeMap=[0,1,2]})),define(t[145],i([0,1,144,3,16]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;t.FileWatcher=class{constructor(e,t,i,s){this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=s,this.service=void 0,this.folder=e[0],0===this.folder.path.indexOf("\\\\")&&this.folder.path.endsWith(r.posix.sep)&&(this.folder.path=n.rtrim(this.folder.path,r.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new i.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,e=>this.onFileEvents(e),e=>this.onLogMessage(e),this.verboseLogging)}setVerboseLogging(e){this.verboseLogging=e,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(e){this.isDisposed||e.length>0&&this.onDidFilesChange(e)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}})),
define(t[54],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class i{constructor(e,t=[],i=!1){this.ctor=e,this.staticArguments=t,this.supportsDelayedInstantiation=i}}t.SyncDescriptor=i;t.createSyncDescriptor=(e,...t)=>new i(e,t)})),define(t[146],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class i{constructor(e){this.incoming=new Map,this.outgoing=new Map,this.data=e}}t.Node=i;t.Graph=class{constructor(e){this._hashFn=e,this._nodes=new Map}roots(){const e=[];for(let t of this._nodes.values())0===t.outgoing.size&&e.push(t);return e}insertEdge(e,t){const i=this.lookupOrInsertNode(e),r=this.lookupOrInsertNode(t);i.outgoing.set(this._hashFn(t),r),r.incoming.set(this._hashFn(e),i)}removeNode(e){const t=this._hashFn(e);this._nodes.delete(t);for(let e of this._nodes.values())e.outgoing.delete(t),e.incoming.delete(t)}lookupOrInsertNode(e){const t=this._hashFn(e)
;let r=this._nodes.get(t);return r||(r=new i(e),this._nodes.set(t,r)),r}lookup(e){return this._nodes.get(this._hashFn(e))}isEmpty(){return 0===this._nodes.size}toString(){let e=[];for(let[t,i]of this._nodes)e.push(`${t}, (incoming)[${[...i.incoming.keys()].join(", ")}], (outgoing)[${[...i.outgoing.keys()].join(",")}]`);return e.join("\n")}}})),define(t[4],i([0,1]),(function(e,t){"use strict";var i;function r(e,t,r,n){t[i.DI_TARGET]===t?t[i.DI_DEPENDENCIES].push({id:e,index:r,optional:n}):(t[i.DI_DEPENDENCIES]=[{id:e,index:r,optional:n}],t[i.DI_TARGET]=t)}function n(e){if(i.serviceIds.has(e))return i.serviceIds.get(e);const t=function(e,i,n){if(3!==arguments.length)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(t,e,n,!1)};return t.toString=()=>e,i.serviceIds.set(e,t),t}Object.defineProperty(t,"__esModule",{value:!0}),t.optional=t.createDecorator=t.IInstantiationService=t._util=void 0,function(e){e.serviceIds=new Map,e.DI_TARGET="$di$target",
e.DI_DEPENDENCIES="$di$dependencies",e.getServiceDependencies=function(t){return t[e.DI_DEPENDENCIES]||[]}}(i=t._util||(t._util={})),t.IInstantiationService=n("instantiationService"),t.createDecorator=n,t.optional=function(e){return function(t,i,n){if(3!==arguments.length)throw new Error("@optional-decorator can only be used to decorate a parameter");r(e,t,n,!0)}}})),define(t[69],i([0,1,16,4,5]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SET_CONTEXT_COMMAND_ID=t.IContextKeyService=t.RawContextKey=t.ContextKeyOrExpr=t.ContextKeyAndExpr=t.ContextKeyNotRegexExpr=t.ContextKeyRegexExpr=t.ContextKeyNotExpr=t.ContextKeyNotEqualsExpr=t.ContextKeyNotInExpr=t.ContextKeyInExpr=t.ContextKeyEqualsExpr=t.ContextKeyDefinedExpr=t.ContextKeyTrueExpr=t.ContextKeyFalseExpr=t.ContextKeyExpr=t.ContextKeyExprType=void 0;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",n.isMacintosh),s.set("isLinux",n.isLinux),s.set("isWindows",n.isWindows),s.set("isWeb",n.isWeb),
s.set("isMacNative",n.isMacintosh&&!n.isWeb);const o=Object.prototype.hasOwnProperty;!function(e){e[e.False=0]="False",e[e.True=1]="True",e[e.Defined=2]="Defined",e[e.Not=3]="Not",e[e.Equals=4]="Equals",e[e.NotEquals=5]="NotEquals",e[e.And=6]="And",e[e.Regex=7]="Regex",e[e.NotRegex=8]="NotRegex",e[e.Or=9]="Or",e[e.In=10]="In",e[e.NotIn=11]="NotIn"}(t.ContextKeyExprType||(t.ContextKeyExprType={}));class a{static false(){return c.INSTANCE}static true(){return u.INSTANCE}static has(e){return h.create(e)}static equals(e,t){return d.create(e,t)}static notEquals(e,t){return g.create(e,t)}static regex(e,t){return v.create(e,t)}static in(e,t){return f.create(e,t)}static not(e){return m.create(e)}static and(...e){return E.create(e)}static or(...e){return w.create(e)}static deserialize(e,t=!1){if(e)return this._deserializeOrExpression(e,t)}static _deserializeOrExpression(e,t){let i=e.split("||");return w.create(i.map(e=>this._deserializeAndExpression(e,t)))}static _deserializeAndExpression(e,t){let i=e.split("&&")
;return E.create(i.map(e=>this._deserializeOne(e,t)))}static _deserializeOne(e,t){if((e=e.trim()).indexOf("!=")>=0){let i=e.split("!=");return g.create(i[0].trim(),this._deserializeValue(i[1],t))}if(e.indexOf("==")>=0){let i=e.split("==");return d.create(i[0].trim(),this._deserializeValue(i[1],t))}if(e.indexOf("=~")>=0){let i=e.split("=~");return v.create(i[0].trim(),this._deserializeRegexValue(i[1],t))}if(e.indexOf(" in ")>=0){let t=e.split(" in ");return f.create(t[0].trim(),t[1].trim())}return/^\!\s*/.test(e)?m.create(e.substr(1).trim()):h.create(e)}static _deserializeValue(e,t){if("true"===(e=e.trim()))return!0;if("false"===e)return!1;let i=/^'([^']*)'$/.exec(e);return i?i[1].trim():e}static _deserializeRegexValue(e,t){if(i.isFalsyOrWhitespace(e)){if(t)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let r=e.indexOf("/"),n=e.lastIndexOf("/");if(r===n||r<0){if(t)throw new Error(`bad regexp-value '${e}', missing /-enclosure`)
;return console.warn(`bad regexp-value '${e}', missing /-enclosure`),null}let s=e.slice(r+1,n),o="i"===e[n+1]?"i":"";try{return new RegExp(s,o)}catch(i){if(t)throw new Error(`bad regexp-value '${e}', parse error: ${i}`);return console.warn(`bad regexp-value '${e}', parse error: ${i}`),null}}}function l(e,t){return e.cmp(t)}t.ContextKeyExpr=a;class c{constructor(){this.type=0}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}evaluate(e){return!1}serialize(){return"false"}keys(){return[]}map(e){return this}negate(){return u.INSTANCE}}t.ContextKeyFalseExpr=c,c.INSTANCE=new c;class u{constructor(){this.type=1}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}evaluate(e){return!0}serialize(){return"true"}keys(){return[]}map(e){return this}negate(){return c.INSTANCE}}t.ContextKeyTrueExpr=u,u.INSTANCE=new u;class h{constructor(e){this.key=e,this.type=2}static create(e){const t=s.get(e);return"boolean"==typeof t?t?u.INSTANCE:c.INSTANCE:new h(e)}cmp(e){
return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:0}equals(e){return e.type===this.type&&this.key===e.key}evaluate(e){return!!e.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(e){return e.mapDefined(this.key)}negate(){return m.create(this.key)}}t.ContextKeyDefinedExpr=h;class d{constructor(e,t){this.key=e,this.value=t,this.type=4}static create(e,t){if("boolean"==typeof t)return t?h.create(e):m.create(e);const i=s.get(e);if("boolean"==typeof i){return t===(i?"true":"false")?u.INSTANCE:c.INSTANCE}return new d(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.value===e.value)}evaluate(e){return e.getValue(this.key)==this.value}serialize(){return this.key+" == '"+this.value+"'"}keys(){return[this.key]}map(e){return e.mapEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}
t.ContextKeyEqualsExpr=d;class f{constructor(e,t){this.key=e,this.valueKey=t,this.type=10}static create(e,t){return new f(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.valueKey<e.valueKey?-1:this.valueKey>e.valueKey?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.valueKey===e.valueKey)}evaluate(e){const t=e.getValue(this.valueKey),i=e.getValue(this.key);return Array.isArray(t)?t.indexOf(i)>=0:"string"==typeof i&&"object"==typeof t&&null!==t&&o.call(t,i)}serialize(){return this.key+" in '"+this.valueKey+"'"}keys(){return[this.key,this.valueKey]}map(e){return e.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}t.ContextKeyInExpr=f;class p{constructor(e){this._actual=e,this.type=11}static create(e){return new p(e)}cmp(e){return e.type!==this.type?this.type-e.type:this._actual.cmp(e._actual)}equals(e){return e.type===this.type&&this._actual.equals(e._actual)}evaluate(e){return!this._actual.evaluate(e)}serialize(){
throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(e){return new p(this._actual.map(e))}negate(){return this._actual}}t.ContextKeyNotInExpr=p;class g{constructor(e,t){this.key=e,this.value=t,this.type=5}static create(e,t){if("boolean"==typeof t)return t?m.create(e):h.create(e);const i=s.get(e);if("boolean"==typeof i){return t===(i?"true":"false")?c.INSTANCE:u.INSTANCE}return new g(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.value===e.value)}evaluate(e){return e.getValue(this.key)!=this.value}serialize(){return this.key+" != '"+this.value+"'"}keys(){return[this.key]}map(e){return e.mapNotEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}t.ContextKeyNotEqualsExpr=g;class m{constructor(e){this.key=e,this.type=3}static create(e){const t=s.get(e);return"boolean"==typeof t?t?c.INSTANCE:u.INSTANCE:new m(e)}
cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:0}equals(e){return e.type===this.type&&this.key===e.key}evaluate(e){return!e.getValue(this.key)}serialize(){return"!"+this.key}keys(){return[this.key]}map(e){return e.mapNot(this.key)}negate(){return h.create(this.key)}}t.ContextKeyNotExpr=m;class v{constructor(e,t){this.key=e,this.regexp=t,this.type=7}static create(e,t){return new v(e,t)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.key<e.key)return-1;if(this.key>e.key)return 1;const t=this.regexp?this.regexp.source:"",i=e.regexp?e.regexp.source:"";return t<i?-1:t>i?1:0}equals(e){if(e.type===this.type){const t=this.regexp?this.regexp.source:"",i=e.regexp?e.regexp.source:"";return this.key===e.key&&t===i}return!1}evaluate(e){let t=e.getValue(this.key);return!!this.regexp&&this.regexp.test(t)}serialize(){const e=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${e}`}keys(){return[this.key]}map(e){
return e.mapRegex(this.key,this.regexp)}negate(){return y.create(this)}}t.ContextKeyRegexExpr=v;class y{constructor(e){this._actual=e,this.type=8}static create(e){return new y(e)}cmp(e){return e.type!==this.type?this.type-e.type:this._actual.cmp(e._actual)}equals(e){return e.type===this.type&&this._actual.equals(e._actual)}evaluate(e){return!this._actual.evaluate(e)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(e){return new y(this._actual.map(e))}negate(){return this._actual}}t.ContextKeyNotRegexExpr=y;class E{constructor(e){this.expr=e,this.type=6}static create(e){return E._normalizeArr(e)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let t=0,i=this.expr.length;t<i;t++){const i=l(this.expr[t],e.expr[t]);if(0!==i)return i}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1
;for(let t=0,i=this.expr.length;t<i;t++)if(!this.expr[t].equals(e.expr[t]))return!1;return!0}return!1}evaluate(e){for(let t=0,i=this.expr.length;t<i;t++)if(!this.expr[t].evaluate(e))return!1;return!0}static _normalizeArr(e){const t=[];let i=!1;for(const r of e)if(r)if(1!==r.type){if(0===r.type)return c.INSTANCE;6!==r.type?t.push(r):t.push(...r.expr)}else i=!0;if(0===t.length&&i)return u.INSTANCE;if(0!==t.length){if(1===t.length)return t[0];for(t.sort(l);t.length>1;){const e=t[t.length-1];if(9!==e.type)break;t.pop();const i=t.pop(),r=w.create(e.expr.map(e=>E.create([e,i])));r&&(t.push(r),t.sort(l))}return 1===t.length?t[0]:new E(t)}}serialize(){return this.expr.map(e=>e.serialize()).join(" && ")}keys(){const e=[];for(let t of this.expr)e.push(...t.keys());return e}map(e){return new E(this.expr.map(t=>t.map(e)))}negate(){let e=[];for(let t of this.expr)e.push(t.negate());return w.create(e)}}t.ContextKeyAndExpr=E;class w{constructor(e){this.expr=e,this.type=9}static create(e){const t=w._normalizeArr(e)
;if(0!==t.length)return 1===t.length?t[0]:new w(t)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let t=0,i=this.expr.length;t<i;t++){const i=l(this.expr[t],e.expr[t]);if(0!==i)return i}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1;for(let t=0,i=this.expr.length;t<i;t++)if(!this.expr[t].equals(e.expr[t]))return!1;return!0}return!1}evaluate(e){for(let t=0,i=this.expr.length;t<i;t++)if(this.expr[t].evaluate(e))return!0;return!1}static _normalizeArr(e){let t=[],i=!1;if(e){for(let r=0,n=e.length;r<n;r++){const n=e[r];if(n)if(0!==n.type){if(1===n.type)return[u.INSTANCE];9!==n.type?t.push(n):t=t.concat(n.expr)}else i=!0}if(0===t.length&&i)return[c.INSTANCE];t.sort(l)}return t}serialize(){return this.expr.map(e=>e.serialize()).join(" || ")}keys(){const e=[];for(let t of this.expr)e.push(...t.keys());return e}map(e){return new w(this.expr.map(t=>t.map(e)))}negate(){let e=[]
;for(let t of this.expr)e.push(t.negate());const t=e=>9===e.type?e.expr:[e];for(;e.length>1;){const i=e.shift(),r=e.shift(),n=[];for(const e of t(i))for(const i of t(r))n.push(a.and(e,i));e.unshift(a.or(...n))}return e[0]}}t.ContextKeyOrExpr=w;t.RawContextKey=class extends h{constructor(e,t){super(e),this._defaultValue=t}bindTo(e){return e.createKey(this.key,this._defaultValue)}getValue(e){return e.getContextKeyValue(this.key)}toNegated(){return a.not(this.key)}isEqualTo(e){return a.equals(this.key,e)}notEqualsTo(e){return a.notEquals(this.key,e)}},t.IContextKeyService=r.createDecorator("contextKeyService"),t.SET_CONTEXT_COMMAND_ID="setContext"})),define(t[147],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=i.createDecorator("downloadService")})),define(t[22],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,
t.IEnvironmentService=i.createDecorator("environmentService"),t.INativeEnvironmentService=i.createDecorator("nativeEnvironmentService")}));var s=this&&this.__decorate||function(e,t,i,r){var n,s=arguments.length,o=s<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,i):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,i,r);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(o=(s<3?n(o):s>3?n(t,i,o):n(t,i))||o);return s>3&&o&&Object.defineProperty(t,i,o),o},o=this&&this.__param||function(e,t){return function(i,r){t(i,r,e)}};define(t[148],i([0,1,22,3,12,14,2]),(function(e,t,i,r,n,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogsDataCleaner=void 0;let c=class extends l.Disposable{constructor(e){super(),this.environmentService=e,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let e=setTimeout(()=>{e=void 0;const t=r.basename(this.environmentService.logsPath),i=r.dirname(this.environmentService.logsPath);n.readdir(i).then(e=>{
const s=e.filter(e=>/^\d{8}T\d{6}$/.test(e)).sort().filter((e,i)=>e!==t),o=s.slice(0,Math.max(0,s.length-9));return Promise.all(o.map(e=>n.rimraf(r.join(i,e))))}).then(null,a.onUnexpectedError)},1e4);this._register(l.toDisposable(()=>{e&&(clearTimeout(e),e=void 0)}))}};c=s([o(0,i.IEnvironmentService)],c),t.LogsDataCleaner=c})),define(t[31],i([0,1,120,4,10]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,
t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=5]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"}(t.SortBy||(t.SortBy={})),function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"}(t.SortOrder||(t.SortOrder={})),function(e){e.Uninstall="uninstall"}(t.StatisticType||(t.StatisticType={})),function(e){e[e.None=0]="None",e[e.Install=1]="Install",e[e.Update=2]="Update"}(t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=r.createDecorator("extensionGalleryService"),
t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class s extends Error{constructor(e,t){super(e),this.code=t}}t.ExtensionManagementError=s,t.IExtensionManagementService=r.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=r.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=r.createDecorator("IExtensionTipsService"),t.DefaultIconPath=n.FileAccess.asBrowserUri("./media/defaultIcon.png",e).toString(!0),t.ExtensionsLabel=i.localize(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=i.localize(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"}})),define(t[39],i([0,1,16,4]),(function(e,t,i,r){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"],function(e){e[e.System=0]="System",e[e.User=1]="User"}(t.ExtensionType||(t.ExtensionType={}));t.ExtensionIdentifier=class{constructor(e){this.value=e,this._lower=e.toLowerCase()}static equals(e,t){
if(null==e)return null==t;if(null==t)return!1;if("string"==typeof e||"string"==typeof t){let r="string"==typeof e?e:e.value,n="string"==typeof t?t:t.value;return i.equalsIgnoreCase(r,n)}return e._lower===t._lower}static toKey(e){return"string"==typeof e?e.toLowerCase():e._lower}},t.isLanguagePackExtension=function(e){return!(!e.contributes||!e.contributes.localizations)&&e.contributes.localizations.length>0},t.isAuthenticaionProviderExtension=function(e){return!(!e.contributes||!e.contributes.authentication)&&e.contributes.authentication.length>0},t.IBuiltinExtensionsScannerService=r.createDecorator("IBuiltinExtensionsScannerService")})),define(t[32],i([0,1,16,39]),(function(e,t,i,r){"use strict";function n(e,t){return e.uuid&&t.uuid?e.uuid===t.uuid:e.id===t.id||0===i.compareIgnoreCase(e.id,t.id)}Object.defineProperty(t,"__esModule",{value:!0}),
t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0,t.areSameExtensions=n;class s{constructor(e,t){this.version=t,this.id=e.id,this.uuid=e.uuid}key(){return`${this.id}-${this.version}`}equals(e){return e instanceof s&&(n(this,e)&&this.version===e.version)}}t.ExtensionIdentifierWithVersion=s,t.adoptToGalleryExtensionId=function(e){return e.toLocaleLowerCase()},t.getGalleryExtensionId=function(e,t){return`${e.toLocaleLowerCase()}.${t.toLocaleLowerCase()}`},t.groupByExtension=function(e,t){const i=[],r=e=>{for(const r of i)if(r.some(i=>n(t(i),t(e))))return r;return null};for(const t of e){const e=r(t);e?e.push(t):i.push([t])}return i},t.getLocalExtensionTelemetryData=function(e){return{id:e.identifier.id,name:e.manifest.name,galleryId:null,publisherId:e.publisherId,publisherName:e.manifest.publisher,
publisherDisplayName:e.publisherDisplayName,dependencies:e.manifest.extensionDependencies&&e.manifest.extensionDependencies.length>0}},t.getGalleryExtensionTelemetryData=function(e){return Object.assign({id:e.identifier.id,name:e.name,galleryId:e.identifier.uuid,publisherId:e.publisherId,publisherName:e.publisher,publisherDisplayName:e.publisherDisplayName,dependencies:!!(e.properties.dependencies&&e.properties.dependencies.length>0)},e.telemetryData)},t.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge"),t.getMaliciousExtensionsSet=function(e){const t=new Set;for(const i of e)i.malicious&&t.add(i.id.id);return t}})),define(t[149],i([0,1,2,3,39,12]),(function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class o extends i.Disposable{constructor(e,t){super(),this.environmentService=e,this.extensionsManifestCache=r.join(this.environmentService.userDataPath,n.MANIFEST_CACHE_FOLDER,n.USER_MANIFEST_CACHE_FILE),
this._register(t.onDidInstallExtension(e=>this.onDidInstallExtension(e))),this._register(t.onDidUninstallExtension(e=>this.onDidUnInstallExtension(e)))}onDidInstallExtension(e){e.error||this.invalidate()}onDidUnInstallExtension(e){e.error||this.invalidate()}invalidate(){s.rimraf(this.extensionsManifestCache,s.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=o})),define(t[24],i([0,1,126,3,7,4,16,11,25]),(function(e,t,i,r,n,s,o,a,l){"use strict";var c;Object.defineProperty(t,"__esModule",{value:!0}),
t.BinarySize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FileType=t.IFileService=void 0,t.IFileService=s.createDecorator("fileService"),function(e){e[e.Unknown=0]="Unknown",e[e.File=1]="File",e[e.Directory=2]="Directory",e[e.SymbolicLink=64]="SymbolicLink"}(t.FileType||(t.FileType={})),function(e){e[e.FileReadWrite=2]="FileReadWrite",
e[e.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",e[e.FileReadStream=16]="FileReadStream",e[e.FileFolderCopy=8]="FileFolderCopy",e[e.PathCaseSensitive=1024]="PathCaseSensitive",e[e.Readonly=2048]="Readonly",e[e.Trash=4096]="Trash"}(t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={})),t.hasReadWriteCapability=function(e){return!!(2&e.capabilities)},t.hasFileFolderCopyCapability=function(e){return!!(8&e.capabilities)},t.hasOpenReadWriteCloseCapability=function(e){return!!(4&e.capabilities)},t.hasFileReadStreamCapability=function(e){return!!(16&e.capabilities)},function(e){e.FileExists="EntryExists",e.FileNotFound="EntryNotFound",e.FileNotADirectory="EntryNotADirectory",e.FileIsADirectory="EntryIsADirectory",e.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",e.FileTooLarge="EntryTooLarge",e.NoPermissions="NoPermissions",e.Unavailable="Unavailable",e.Unknown="Unknown"}(c=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class u extends Error{constructor(e,t){super(e),
this.code=t}}function h(e,t){const i=new u(e.toString(),t);return d(i,t),i}function d(e,t){return e.name=t?`${t} (FileSystemError)`:"FileSystemError",e}function f(e){if(!e)return c.Unknown;if(e instanceof u)return e.code;const t=/^(.+) \(FileSystemError\)$/.exec(e.name);if(!t)return c.Unknown;switch(t[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}t.FileSystemProviderError=u,t.createFileSystemProviderError=h,t.ensureFileSystemProviderError=function(e){return e||h(i.localize(0,null),c.Unknown)},t.markAsFileSystemProviderError=d,t.toFileSystemProviderErrorCode=f,t.toFileOperationResult=function(e){if(e instanceof g)return e.fileOperationResult;switch(f(e)){
case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}},function(e){e[e.CREATE=0]="CREATE",e[e.DELETE=1]="DELETE",e[e.MOVE=2]="MOVE",e[e.COPY=3]="COPY"}(t.FileOperation||(t.FileOperation={}));t.FileOperationEvent=class{constructor(e,t,i){this.resource=e,this.operation=t,this.target=i}isOperation(e){return this.operation===e}},function(e){e[e.UPDATED=0]="UPDATED",e[e.ADDED=1]="ADDED",e[e.DELETED=2]="DELETED"}(t.FileChangeType||(t.FileChangeType={}));class p{constructor(e,t){this.ignorePathCasing=t,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=e;for(const t of e)switch(t.type){case 1:this.added||(this.added=l.TernarySearchTree.forUris(this.ignorePathCasing)),this.added.set(t.resource,t);break;case 0:this.updated||(this.updated=l.TernarySearchTree.forUris(this.ignorePathCasing)),
this.updated.set(t.resource,t);break;case 2:this.deleted||(this.deleted=l.TernarySearchTree.forUris(this.ignorePathCasing)),this.deleted.set(t.resource,t)}}contains(e,...t){return this.doContains(e,{includeChildren:!1},...t)}affects(e,...t){return this.doContains(e,{includeChildren:!0},...t)}doContains(e,t,...i){var r,n,s,o,a,l;if(!e)return!1;const c=i.length>0;if(!c||i.includes(1)){if(null===(r=this.added)||void 0===r?void 0:r.get(e))return!0;if(t.includeChildren&&(null===(n=this.added)||void 0===n?void 0:n.findSuperstr(e)))return!0}if(!c||i.includes(0)){if(null===(s=this.updated)||void 0===s?void 0:s.get(e))return!0;if(t.includeChildren&&(null===(o=this.updated)||void 0===o?void 0:o.findSuperstr(e)))return!0}if(!c||i.includes(2)){if(null===(a=this.deleted)||void 0===a?void 0:a.findSubstr(e))return!0;if(t.includeChildren&&(null===(l=this.deleted)||void 0===l?void 0:l.findSuperstr(e)))return!0}return!1}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}
gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(e){const t=[],i=1===e?this.added:0===e?this.updated:this.deleted;if(i)for(const[,e]of i)t.push(e);return t}filter(e){return new p(this.changes.filter(t=>e(t)),this.ignorePathCasing)}}t.FileChangesEvent=p,t.isParent=function(e,t,i){return!(!e||!t||e===t)&&(!(t.length>e.length)&&(t.charAt(t.length-1)!==r.sep&&(t+=r.sep),i?o.startsWithIgnoreCase(e,t):0===e.indexOf(t)))};class g extends Error{constructor(e,t,i){super(e),this.fileOperationResult=t,this.options=i}static isFileOperationError(e){return e instanceof Error&&!a.isUndefinedOrNull(e.fileOperationResult)}}t.FileOperationError=g,function(e){e[e.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",e[e.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",e[e.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",e[e.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",e[e.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",e[e.FILE_READ_ONLY=5]="FILE_READ_ONLY",
e[e.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",e[e.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",e[e.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",e[e.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",e[e.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",e[e.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"}(t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",function(e){e[e.FILE=0]="FILE",e[e.FOLDER=1]="FOLDER",e[e.ROOT_FOLDER=2]="ROOT_FOLDER"}(t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="",t.etag=function(e){if("number"==typeof e.size&&"number"==typeof e.mtime)return e.mtime.toString(29)+e.size.toString(31)},t.whenProviderRegistered=function(e,t){return t.canHandleResource(n.URI.from({scheme:e.scheme
}))?Promise.resolve():new Promise(i=>{const r=t.onDidChangeFileSystemProviderRegistrations(t=>{t.scheme===e.scheme&&t.added&&(r.dispose(),i())})})},t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class m{static formatSize(e){return a.isNumber(e)||(e=0),e<m.KB?i.localize(1,null,e.toFixed(0)):e<m.MB?i.localize(2,null,(e/m.KB).toFixed(2)):e<m.GB?i.localize(3,null,(e/m.MB).toFixed(2)):e<m.TB?i.localize(4,null,(e/m.GB).toFixed(2)):i.localize(5,null,(e/m.TB).toFixed(2))}}t.BinarySize=m,m.KB=1024,m.MB=m.KB*m.KB,m.GB=m.MB*m.KB,m.TB=m.GB*m.KB})),define(t[70],i([0,1,127,17,24,14]),(function(e,t,i,r,n,s){"use strict";function o(e){if(e.isCancellationRequested)throw s.canceled();return!0}function a(e,t){if(null==t?void 0:t.limits){if("number"==typeof t.limits.memory&&e>t.limits.memory)throw n.createFileSystemProviderError(i.localize(0,null),n.FileSystemProviderErrorCode.FileExceedsMemoryLimit)
;if("number"==typeof t.limits.size&&e>t.limits.size)throw n.createFileSystemProviderError(i.localize(1,null),n.FileSystemProviderErrorCode.FileTooLarge)}return!0}Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0,t.readFileIntoStream=async function(e,t,i,s,l,c){let u=void 0;try{await async function(e,t,i,s,l,c){o(c);const u=await e.open(t,{create:!1});o(c);try{let t=0,n=0,h=l&&"number"==typeof l.length?l.length:void 0,d=r.VSBuffer.alloc(Math.min(l.bufferSize,"number"==typeof h?h:l.bufferSize)),f=l&&"number"==typeof l.position?l.position:0,p=0;do{n=await e.read(u,f,d.buffer,p,d.byteLength-p),f+=n,t+=n,"number"==typeof h&&(h-=n),(p+=n)===d.byteLength&&(await i.write(s(d)),d=r.VSBuffer.alloc(Math.min(l.bufferSize,"number"==typeof h?h:l.bufferSize)),p=0)}while(n>0&&("number"!=typeof h||h>0)&&o(c)&&a(t,l));if(p>0){let e=p;"number"==typeof h&&(e=Math.min(p,h)),i.write(s(d.slice(0,e)))}}catch(e){throw n.ensureFileSystemProviderError(e)}finally{await e.close(u)}}(e,t,i,s,l,c)}catch(e){u=e
}finally{u&&l.errorTransformer&&(u=l.errorTransformer(u)),i.end(u)}}})),define(t[71],i([0,1,7,24,5]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0,t.toFileChanges=function(e){return e.map(e=>({type:e.type,resource:i.URI.file(e.path)}))},t.normalizeFileChanges=function(e){const t=new s;for(const i of e)t.processEvent(i);return t.normalize()};class s{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(e){const t=this.mapPathToChange.get(e.path);if(t){const i=t.type,r=e.type;1===i&&2===r?(this.mapPathToChange.delete(e.path),this.normalized.splice(this.normalized.indexOf(t),1)):2===i&&1===r?t.type=0:1===i&&0===r||(t.type=r)}else this.normalized.push(e),this.mapPathToChange.set(e.path,e)}normalize(){const e=[],t=[];return this.normalized.filter(t=>2===t.type||(e.push(t),!1)).sort((e,t)=>e.path.length-t.path.length).filter(e=>!t.some(t=>r.isParent(e.path,t,!n.isLinux))&&(t.push(e.path),!0)).concat(e)}}})),
define(t[150],i([0,1,71,2,12,105,107,15,3]),(function(e,t,i,r,n,s,o,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class c extends r.Disposable{constructor(e,t,i,r){super(),this.path=e,this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=r,this.fileChangesDelayer=this._register(new a.ThrottledDelayer(2*o.CHANGE_BUFFER_DELAY)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(e){this.verboseLogging=e}async startWatching(){try{const{stat:e,symbolicLink:t}=await n.statLink(this.path);if(this.isDisposed)return;let i=this.path;if(t)try{i=await s.realpath(i)}catch(e){this.onError(e)}e.isDirectory()?this._register(o.watchFolder(i,(e,t)=>{this.onFileChange({type:"changed"===e?0:"added"===e?1:2,path:l.join(this.path,l.basename(t))})},e=>this.onError(e))):this._register(o.watchFile(i,e=>{this.onFileChange({type:"changed"===e?0:2,path:this.path})},e=>this.onError(e)))}catch(e){this.onError(e)}}onFileChange(e){this.fileChangesBuffer.push(e),
this.verboseLogging&&this.onVerbose(`${1===e.type?"[ADDED]":2===e.type?"[DELETED]":"[CHANGED]"} ${e.path}`),this.fileChangesDelayer.trigger(async()=>{const e=this.fileChangesBuffer;this.fileChangesBuffer=[];const t=i.normalizeFileChanges(e);this.verboseLogging&&t.forEach(e=>{this.onVerbose(`>> normalized ${1===e.type?"[ADDED]":2===e.type?"[DELETED]":"[CHANGED]"} ${e.path}`)}),t.length>0&&this.onDidFilesChange(t)})}onError(e){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${e}`})}onVerbose(e){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${e}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=c})),define(t[55],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;t.ServiceCollection=class{constructor(...e){this._entries=new Map;for(let[t,i]of e)this.set(t,i)}set(e,t){const i=this._entries.get(e);return this._entries.set(e,t),i}has(e){return this._entries.has(e)}get(e){
return this._entries.get(e)}}})),define(t[72],i([0,1,14,146,54,4,55,15]),(function(e,t,i,r,n,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class c extends Error{constructor(e){super("cyclic dependency between services"),this.message=e.toString()}}class u{constructor(e=new o.ServiceCollection,t=!1,i){this._services=e,this._strict=t,this._parent=i,this._services.set(s.IInstantiationService,this)}createChild(e){return new u(e,this._strict,this)}invokeFunction(e,...t){let r=d.traceInvocation(e),n=!1;try{return e({get:(e,t)=>{if(n)throw i.illegalState("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(e,r);if(!o&&t!==s.optional)throw new Error(`[invokeFunction] unknown service '${e}'`);return o}},...t)}finally{n=!0,r.stop()}}createInstance(e,...t){let i,r;return e instanceof n.SyncDescriptor?(i=d.traceCreation(e.ctor),
r=this._createInstance(e.ctor,e.staticArguments.concat(t),i)):(i=d.traceCreation(e),r=this._createInstance(e,t,i)),i.stop(),r}_createInstance(e,t=[],i){let r=s._util.getServiceDependencies(e).sort((e,t)=>e.index-t.index),n=[];for(const t of r){let r=this._getOrCreateServiceInstance(t.id,i);if(!r&&this._strict&&!t.optional)throw new Error(`[createInstance] ${e.name} depends on UNKNOWN service ${t.id}.`);n.push(r)}let o=r.length>0?r[0].index:t.length;if(t.length!==o){console.warn(`[createInstance] First service dependency of ${e.name} at position ${o+1} conflicts with ${t.length} static arguments`);let i=o-t.length;t=i>0?t.concat(new Array(i)):t.slice(0,o)}return new e(...[...t,...n])}_setServiceInstance(e,t){if(this._services.get(e)instanceof n.SyncDescriptor)this._services.set(e,t);else{if(!this._parent)throw new Error("illegalState - setting UNKNOWN service instance");this._parent._setServiceInstance(e,t)}}_getServiceInstanceOrDescriptor(e){let t=this._services.get(e)
;return!t&&this._parent?this._parent._getServiceInstanceOrDescriptor(e):t}_getOrCreateServiceInstance(e,t){let i=this._getServiceInstanceOrDescriptor(e);return i instanceof n.SyncDescriptor?this._createAndCacheServiceInstance(e,i,t.branch(e,!0)):(t.branch(e,!1),i)}_createAndCacheServiceInstance(e,t,i){const o=new r.Graph(e=>e.id.toString());let a=0;const l=[{id:e,desc:t,_trace:i}];for(;l.length;){const t=l.pop();if(o.lookupOrInsertNode(t),a++>1e3)throw new c(o);for(let i of s._util.getServiceDependencies(t.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(i.id);if(r||i.optional||console.warn(`[createInstance] ${e} depends on ${i.id} which is NOT registered.`),r instanceof n.SyncDescriptor){const e={id:i.id,desc:r,_trace:t._trace.branch(i.id,!0)};o.insertEdge(t,e),l.push(e)}}}for(;;){const e=o.roots();if(0===e.length){if(!o.isEmpty())throw new c(o);break}for(const{data:t}of e){if(this._getServiceInstanceOrDescriptor(t.id)instanceof n.SyncDescriptor){
const e=this._createServiceInstanceWithOwner(t.id,t.desc.ctor,t.desc.staticArguments,t.desc.supportsDelayedInstantiation,t._trace);this._setServiceInstance(t.id,e)}o.removeNode(t)}}return this._getServiceInstanceOrDescriptor(e)}_createServiceInstanceWithOwner(e,t,i=[],r,s){if(this._services.get(e)instanceof n.SyncDescriptor)return this._createServiceInstance(t,i,r,s);if(this._parent)return this._parent._createServiceInstanceWithOwner(e,t,i,r,s);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}_createServiceInstance(e,t=[],i,r){if(i){const i=new a.IdleValue(()=>this._createInstance(e,t,r));return new Proxy(Object.create(null),{get(e,t){if(t in e)return e[t];let r=i.value,n=r[t];return"function"!=typeof n?n:(n=n.bind(r),e[t]=n,n)},set:(e,t,r)=>(i.value[t]=r,!0)})}return this._createInstance(e,t,r)}}var h;t.InstantiationService=u,function(e){e[e.Creation=0]="Creation",e[e.Invocation=1]="Invocation",e[e.Branch=2]="Branch"}(h||(h={}));class d{constructor(e,t){this.type=e,this.name=t,
this._start=Date.now(),this._dep=[]}static traceInvocation(e){return l?new d(1,e.name||e.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(e){return l?new d(0,e.name):d._None}branch(e,t){let i=new d(2,e.toString());return this._dep.push([e,t,i]),i}stop(){let e=Date.now()-this._start;d._totals+=e;let t=!1;let i=[`${0===this.type?"CREATE":"CALL"} ${this.name}`,`${function e(i,r){let n=[],s=new Array(i+1).join("\t");for(const[o,a,l]of r._dep)if(a&&l){t=!0,n.push(`${s}CREATES -> ${o}`);let r=e(i+1,l);r&&n.push(r)}else n.push(`${s}uses -> ${o}`);return n.join("\n")}(1,this)}`,`DONE, took ${e.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(e>2||t)&&console.log(i.join("\n"))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0})),define(t[151],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ILabelService=void 0,t.ILabelService=i.createDecorator("labelService")})),
define(t[73],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=i.createDecorator("localizationsService"),t.isValidLocalization=function(e){if("string"!=typeof e.languageId)return!1;if(!Array.isArray(e.translations)||0===e.translations.length)return!1;for(const t of e.translations){if("string"!=typeof t.id)return!1;if("string"!=typeof t.path)return!1}return(!e.languageName||"string"==typeof e.languageName)&&(!e.localizedLanguageName||"string"==typeof e.localizedLanguageName)}})),define(t[13],i([0,1,4,2,5,6,45]),(function(e,t,i,r,n,s,o){"use strict";function a(){return(new Date).toISOString()}var l;Object.defineProperty(t,"__esModule",{value:!0}),
t.getLogLevel=t.NullLogService=t.DelegatedLogService=t.MultiplexLogService=t.ConsoleLogInMainService=t.LogServiceAdapter=t.ConsoleLogService=t.ConsoleLogMainService=t.AbstractLogService=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=i.createDecorator("logService"),t.ILoggerService=i.createDecorator("loggerService"),function(e){e[e.Trace=0]="Trace",e[e.Debug=1]="Debug",e[e.Info=2]="Info",e[e.Warning=3]="Warning",e[e.Error=4]="Error",e[e.Critical=5]="Critical",e[e.Off=6]="Off"}(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;class c extends r.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new s.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogService=c;t.ConsoleLogMainService=class extends c{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e),
this.useColors=!n.isWindows}trace(e,...t){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}debug(e,...t){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}info(e,...t){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}warn(e,...t){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${a()}][0m`,e,...t):console.warn(`[main ${a()}]`,e,...t))}error(e,...t){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}critical(e,...t){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}dispose(){}flush(){}};t.ConsoleLogService=class extends c{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e)}trace(e,...t){
this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...t)}error(e,...t){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}};class u extends c{constructor(e,i=t.DEFAULT_LOG_LEVEL){super(),this.adapter=e,this.setLevel(i)}trace(e,...t){this.getLevel()<=l.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=l.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=l.Info&&this.adapter.consoleLog("info",[this.extractMessage(e),...t])}warn(e,...t){
this.getLevel()<=l.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=l.Error&&this.adapter.consoleLog("error",[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=l.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(e),...t])}extractMessage(e){return"string"==typeof e?e:o.toErrorMessage(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.LogServiceAdapter=u;t.ConsoleLogInMainService=class extends u{constructor(e,i=t.DEFAULT_LOG_LEVEL){super({consoleLog:(t,i)=>e.consoleLog(t,i)},i)}};t.MultiplexLogService=class extends c{constructor(e){super(),this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const i of this.logServices)i.trace(e,...t)}debug(e,...t){for(const i of this.logServices)i.debug(e,...t)}info(e,...t){for(const i of this.logServices)i.info(e,...t)}warn(e,...t){for(const i of this.logServices)i.warn(e,...t)}error(e,...t){
for(const i of this.logServices)i.error(e,...t)}critical(e,...t){for(const i of this.logServices)i.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}};class h extends r.Disposable{constructor(e){super(),this.logService=e,this._register(e)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(e){this.logService.setLevel(e)}getLevel(){return this.logService.getLevel()}trace(e,...t){this.logService.trace(e,...t)}debug(e,...t){this.logService.debug(e,...t)}info(e,...t){this.logService.info(e,...t)}warn(e,...t){this.logService.warn(e,...t)}error(e,...t){this.logService.error(e,...t)}critical(e,...t){this.logService.critical(e,...t)}flush(){this.logService.flush()}}t.DelegatedLogService=h;t.NullLogService=class{constructor(){this.onDidChangeLogLevel=(new s.Emitter).event}setLevel(e){}getLevel(){return l.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}},
t.getLogLevel=function(e){if(e.verbose)return l.Trace;if("string"==typeof e.logLevel){switch(e.logLevel.toLowerCase()){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}return t.DEFAULT_LOG_LEVEL}})),define(t[152],i([0,1,2,24,31,22,7,18,32,13,26,46]),(function(e,t,i,r,n,a,l,c,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends i.Disposable{constructor(e,t,i,r){super(),this.fileService=t,this.extensionGalleryService=i,this.logService=r,this.extensionsDownloadDir=l.URI.file(e.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(e,t){await this.cleanUpPromise;const i=c.joinPath(this.extensionsDownloadDir,this.getName(e));return await this.download(e,i,t),i}async delete(e){}async download(e,t,i){
await this.fileService.exists(t)||await this.extensionGalleryService.download(e,t,i)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir))return void this.logService.trace("Extension VSIX downlads cache dir does not exist");const e=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(e.children){const t=[],i=[];for(const t of e.children){const e=this.parse(t.name);e&&i.push([e,t])}const r=u.groupByExtension(i,([e])=>e),n=[];for(const e of r)e.sort((e,t)=>f.rcompare(e[0].version,t[0].version)),t.push(...e.slice(1).map(e=>e[1].resource)),n.push(e[0][1]);n.sort((e,t)=>e.mtime-t.mtime),t.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(e=>e.resource)),await Promise.all(t.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(e){this.logService.error(e)}}getName(e){return this.cache?new u.ExtensionIdentifierWithVersion(e.identifier,e.version).key().toLowerCase():d.generateUuid()}parse(e){const t=p.exec(e)
;return t&&t[1]&&t[2]?new u.ExtensionIdentifierWithVersion({id:t[1]},t[2]):null}};g=s([o(0,a.INativeEnvironmentService),o(1,r.IFileService),o(2,n.IExtensionGalleryService),o(3,h.ILogService)],g),t.ExtensionsDownloader=g})),define(t[153],i([0,1,2,13,38,45,3,15,6,10,12,22]),(function(e,t,i,r,n,a,l,c,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let p=class extends i.Disposable{constructor(e,t){super(),this.environmentService=e,this.logService=t,this.processesLimiter=new c.Limiter(5)}async postUninstall(e){const t=this.parseScript(e,"uninstall");return t&&(this.logService.info(e.identifier.id,e.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(t.script,"uninstall",t.args,!0,e).then(()=>this.logService.info(e.identifier.id,e.manifest.version,"Finished running post uninstall script"),t=>this.logService.error(e.identifier.id,e.manifest.version,`Failed to run post uninstall script: ${t}`)))),
d.rimraf(this.getExtensionStoragePath(e)).then(void 0,e=>this.logService.error("Error while removing extension storage path",e))}parseScript(e,t){const i=`vscode:${t}`;if(e.location.scheme===h.Schemas.file&&e.manifest&&e.manifest.scripts&&"string"==typeof e.manifest.scripts[i]){const t=e.manifest.scripts[i].split(" ");return t.length<2||"node"!==t[0]||!t[1]?(this.logService.warn(e.identifier.id,e.manifest.version,`${i} should be a node script`),null):{script:l.join(e.location.fsPath,t[1]),args:t.slice(2)||[]}}return null}runLifecycleHook(e,t,i,r,n){return new Promise((s,o)=>{const l=this.start(e,t,i,n);let c;const u=e=>{c&&(clearTimeout(c),c=null),e?o(e):s(void 0)};l.on("error",e=>{u(a.toErrorMessage(e)||"Unknown")}),l.on("exit",(e,i)=>{u(e?`post-${t} process exited with code ${e}`:void 0)}),r&&(c=setTimeout(()=>{c=null,l.kill(),o("timed out")},5e3))})}start(e,t,i,r){const s={silent:!0,execArgv:void 0},o=n.fork(e,[`--type=extension-post-${t}`,...i],s);o.stdout.setEncoding("utf8"),o.stderr.setEncoding("utf8")
;const a=u.Event.fromNodeEventEmitter(o.stdout,"data"),l=u.Event.fromNodeEventEmitter(o.stderr,"data");a(e=>this.logService.info(r.identifier.id,r.manifest.version,`post-${t}`,e)),l(e=>this.logService.error(r.identifier.id,r.manifest.version,`post-${t}`,e));const c=u.Event.any(u.Event.map(a,e=>({data:`%c${e}`,format:[""]})),u.Event.map(l,e=>({data:`%c${e}`,format:["color: red"]})));return u.Event.debounce(c,(e,t)=>e?{data:e.data+t.data,format:[...e.format,...t.format]}:{data:t.data,format:t.format},100)(e=>{console.group(r.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),o}getExtensionStoragePath(e){return l.join(this.environmentService.globalStorageHome.fsPath,e.identifier.id.toLowerCase())}};p=s([o(0,f.IEnvironmentService),o(1,r.ILogService)],p),t.ExtensionsLifecycle=p})),define(t[74],i([0,1,2,24,6,18,125,25,19,43,13,17,42,15,23,10,70,62]),(function(e,t,i,r,n,a,l,c,u,h,d,f,p,g,m,v,y,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0
;let w=class extends i.Disposable{constructor(e){super(),this.logService=e,this.BUFFER_SIZE=65536,this._onDidChangeFileSystemProviderRegistrations=this._register(new n.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new n.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new n.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new n.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new n.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new n.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(e,t){
if(this.provider.has(e))throw new Error(`A filesystem provider for the scheme '${e}' is already registered.`);this.provider.set(e,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:e,provider:t});const n=new i.DisposableStore;return n.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new r.FileChangesEvent(e,!this.isPathCaseSensitive(t))))),n.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:e}))),"function"==typeof t.onDidErrorOccur&&n.add(t.onDidErrorOccur(e=>this._onError.fire(new Error(e)))),i.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:e,provider:t}),this.provider.delete(e),i.dispose(n)})}async activateProvider(e){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:e,join(e){e&&t.push(e)}}),this.provider.has(e)||await Promise.all(t)}canHandleResource(e){return this.provider.has(e.scheme)}hasCapability(e,t){const i=this.provider.get(e.scheme)
;return!!(i&&i.capabilities&t)}listCapabilities(){return E.Iterable.map(this.provider,([e,t])=>({scheme:e,capabilities:t.capabilities}))}async withProvider(e){if(!a.isAbsolutePath(e))throw new r.FileOperationError(l.localize(0,null,this.resourceForError(e)),8);await this.activateProvider(e.scheme);const t=this.provider.get(e.scheme);if(!t){const t=new Error;throw t.name="ENOPRO",t.message=l.localize(1,null,e.toString()),t}return t}async withReadProvider(e){const t=await this.withProvider(e);if(r.hasOpenReadWriteCloseCapability(t)||r.hasReadWriteCapability(t)||r.hasFileReadStreamCapability(t))return t;throw new Error(`Filesystem provider for scheme '${e.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(e){const t=await this.withProvider(e);if(r.hasOpenReadWriteCloseCapability(t)||r.hasReadWriteCapability(t))return t
;throw new Error(`Filesystem provider for scheme '${e.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(e,t){try{return await this.doResolveFile(e,t)}catch(t){if(r.toFileSystemProviderErrorCode(t)===r.FileSystemProviderErrorCode.FileNotFound)throw new r.FileOperationError(l.localize(2,null,this.resourceForError(e)),1);throw r.ensureFileSystemProviderError(t)}}async doResolveFile(e,t){const i=await this.withProvider(e),r=null==t?void 0:t.resolveTo,n=null==t?void 0:t.resolveSingleChildDescendants,s=null==t?void 0:t.resolveMetadata,o=await i.stat(e);let a;return this.toFileStat(i,e,o,void 0,!!s,(t,i)=>(a||((a=c.TernarySearchTree.forUris()).set(e,!0),u.isNonEmptyArray(r)&&r.forEach(e=>a.set(e,!0))),!!Boolean(a.findSuperstr(t.resource)||a.get(t.resource))||!(!t.isDirectory||!n)&&1===i))}async toFileStat(e,t,i,n,s,o){const l={resource:t,name:h.getBaseLabel(t),isFile:0!=(i.type&r.FileType.File),
isDirectory:0!=(i.type&r.FileType.Directory),isSymbolicLink:0!=(i.type&r.FileType.SymbolicLink),mtime:i.mtime,ctime:i.ctime,size:i.size,etag:r.etag({mtime:i.mtime,size:i.size})};if(l.isDirectory&&o(l,n)){try{const i=await e.readdir(t),r=await Promise.all(i.map(async([r,n])=>{try{const l=a.joinPath(t,r),c=s?await e.stat(l):{type:n};return await this.toFileStat(e,l,c,i.length,s,o)}catch(e){return this.logService.trace(e),null}}));l.children=u.coalesce(r)}catch(e){this.logService.trace(e),l.children=[]}return l}return l}async resolveAll(e){return Promise.all(e.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(e){const t=await this.withProvider(e);try{return!!await t.stat(e)}catch(e){return!1}}async canCreateFile(e,t){try{await this.doValidateCreateFile(e,t)}catch(e){return e}return!0}async doValidateCreateFile(e,t){
if(!(null==t?void 0:t.overwrite)&&await this.exists(e))throw new r.FileOperationError(l.localize(3,null,this.resourceForError(e)),3,t)}async createFile(e,t=f.VSBuffer.fromString(""),i){await this.doValidateCreateFile(e,i);const n=await this.writeFile(e,t);return this._onDidRunOperation.fire(new r.FileOperationEvent(e,0,n)),n}async writeFile(e,t,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);try{let s;if(await this.validateWriteFile(n,e,i)||await this.mkdirp(n,a.dirname(e)),!r.hasReadWriteCapability(n)||t instanceof f.VSBuffer)s=t;else if(p.isReadableStream(t)){const e=await p.peekStream(t,3);s=e.ended?f.VSBuffer.concat(e.buffer):e}else s=p.peekReadable(t,e=>f.VSBuffer.concat(e),3);!r.hasOpenReadWriteCloseCapability(n)||r.hasReadWriteCapability(n)&&s instanceof f.VSBuffer?await this.doWriteUnbuffered(n,e,s):await this.doWriteBuffered(n,e,s instanceof f.VSBuffer?f.bufferToReadable(s):s)}catch(t){
throw new r.FileOperationError(l.localize(4,null,this.resourceForError(e),r.ensureFileSystemProviderError(t).toString()),r.toFileOperationResult(t),i)}return this.resolve(e,{resolveMetadata:!0})}async validateWriteFile(e,t,i){let n=void 0;try{n=await e.stat(t)}catch(e){return}if(0!=(n.type&r.FileType.Directory))throw new r.FileOperationError(l.localize(5,null,this.resourceForError(t)),0,i);if(i&&"number"==typeof i.mtime&&"string"==typeof i.etag&&i.etag!==r.ETAG_DISABLED&&"number"==typeof n.mtime&&"number"==typeof n.size&&i.mtime<n.mtime&&i.etag!==r.etag({mtime:i.mtime,size:n.size}))throw new r.FileOperationError(l.localize(6,null),3,i);return n}async readFile(e,t){const i=await this.withReadProvider(e),r=await this.doReadAsFileStream(i,e,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await f.streamToBuffer(r.value)})}async readFileStream(e,t){const i=await this.withReadProvider(e);return this.doReadAsFileStream(i,e,t)}async doReadAsFileStream(e,t,i){
const n=new m.CancellationTokenSource,s=this.validateReadFile(t,i).then(e=>e,e=>{throw n.cancel(),e});try{let o;i&&"string"==typeof i.etag&&i.etag!==r.ETAG_DISABLED&&await s,o=!r.hasOpenReadWriteCloseCapability(e)&&!r.hasFileReadStreamCapability(e)||r.hasReadWriteCapability(e)&&(null==i?void 0:i.preferUnbuffered)?this.readFileUnbuffered(e,t,i):r.hasFileReadStreamCapability(e)?Promise.resolve(this.readFileStreamed(e,t,n.token,i)):Promise.resolve(this.readFileBuffered(e,t,n.token,i));const[a,l]=await Promise.all([s,o]);return Object.assign(Object.assign({},a),{value:l})}catch(e){throw new r.FileOperationError(l.localize(7,null,this.resourceForError(t),r.ensureFileSystemProviderError(e).toString()),r.toFileOperationResult(e),i)}}readFileStreamed(e,t,i,n=Object.create(null)){const s=e.readFileStream(t,n,i);return p.transform(s,{data:e=>e instanceof f.VSBuffer?e:f.VSBuffer.wrap(e),
error:e=>new r.FileOperationError(l.localize(8,null,this.resourceForError(t),r.ensureFileSystemProviderError(e).toString()),r.toFileOperationResult(e),n)},e=>f.VSBuffer.concat(e))}readFileBuffered(e,t,i,n=Object.create(null)){const s=f.newWriteableBufferStream();return y.readFileIntoStream(e,t,s,e=>e,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:e=>new r.FileOperationError(l.localize(9,null,this.resourceForError(t),r.ensureFileSystemProviderError(e).toString()),r.toFileOperationResult(e),n)}),i),s}async readFileUnbuffered(e,t,i){let r=await e.readFile(t);return i&&"number"==typeof i.position&&(r=r.slice(i.position)),i&&"number"==typeof i.length&&(r=r.slice(0,i.length)),this.validateReadFileLimits(t,r.byteLength,i),f.bufferToStream(f.VSBuffer.wrap(r))}async validateReadFile(e,t){const i=await this.resolve(e,{resolveMetadata:!0});if(i.isDirectory)throw new r.FileOperationError(l.localize(10,null,this.resourceForError(e)),0,t)
;if(t&&"string"==typeof t.etag&&t.etag!==r.ETAG_DISABLED&&t.etag===i.etag)throw new r.FileOperationError(l.localize(11,null),2,t);return this.validateReadFileLimits(e,i.size,t),i}validateReadFileLimits(e,t,i){if(null==i?void 0:i.limits){let n=void 0;if("number"==typeof i.limits.memory&&t>i.limits.memory&&(n=9),"number"==typeof i.limits.size&&t>i.limits.size&&(n=7),"number"==typeof n)throw new r.FileOperationError(l.localize(12,null,this.resourceForError(e)),n)}}async canMove(e,t,i){return this.doCanMoveCopy(e,t,"move",i)}async canCopy(e,t,i){return this.doCanMoveCopy(e,t,"copy",i)}async doCanMoveCopy(e,t,i,r){if(e.toString()!==t.toString())try{const n="move"===i?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e):await this.withReadProvider(e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(n,e,s,t,i,r)}catch(e){return e}return!0}async move(e,t,i){
const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(n,e,s,t,"move",!!i),a=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new r.FileOperationEvent(e,"move"===o?2:3,a)),a}async copy(e,t,i){const n=await this.withReadProvider(e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(n,e,s,t,"copy",!!i),a=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new r.FileOperationEvent(e,"copy"===o?3:2,a)),a}async doMoveCopy(e,t,i,n,s,o){if(t.toString()===n.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(e,t,i,n,s,o);if(l&&!c&&o&&await this.del(n,{recursive:!0}),await this.mkdirp(i,a.dirname(n)),"copy"===s){if(e===i&&r.hasFileFolderCopyCapability(e))await e.copy(t,n,{overwrite:o});else{const r=await this.resolve(t)
;r.isDirectory?await this.doCopyFolder(e,r,i,n):await this.doCopyFile(e,t,i,n)}return s}return e===i?(await e.rename(t,n,{overwrite:o}),s):(await this.doMoveCopy(e,t,i,n,"copy",o),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(e,t,i,n){return r.hasOpenReadWriteCloseCapability(e)&&r.hasOpenReadWriteCloseCapability(i)?this.doPipeBuffered(e,t,i,n):r.hasOpenReadWriteCloseCapability(e)&&r.hasReadWriteCapability(i)?this.doPipeBufferedToUnbuffered(e,t,i,n):r.hasReadWriteCapability(e)&&r.hasOpenReadWriteCloseCapability(i)?this.doPipeUnbufferedToBuffered(e,t,i,n):r.hasReadWriteCapability(e)&&r.hasReadWriteCapability(i)?this.doPipeUnbuffered(e,t,i,n):void 0}async doCopyFolder(e,t,i,r){await i.mkdir(r),Array.isArray(t.children)&&await Promise.all(t.children.map(async t=>{const n=a.joinPath(r,t.name);return t.isDirectory?this.doCopyFolder(e,await this.resolve(t.resource),i,n):this.doCopyFile(e,t.resource,i,n)}))}async doValidateMoveCopy(e,t,i,n,s,o){let a=!1;if(e===i){
const{extUri:i,isPathCaseSensitive:r}=this.getExtUri(e);if(r||(a=i.isEqual(t,n)),a&&"copy"===s)throw new Error(l.localize(13,null,this.resourceForError(t),this.resourceForError(n)));if(!a&&i.isEqualOrParent(n,t))throw new Error(l.localize(14,null,this.resourceForError(t),this.resourceForError(n)))}const c=await this.exists(n);if(c&&!a){if(!o)throw new r.FileOperationError(l.localize(15,null,this.resourceForError(t),this.resourceForError(n)),4);if(e===i){const{extUri:i}=this.getExtUri(e);if(i.isEqualOrParent(t,n))throw new Error(l.localize(16,null,this.resourceForError(t),this.resourceForError(n)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(e){const t=this.isPathCaseSensitive(e);return{extUri:t?a.extUri:a.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(e){return!!(1024&e.capabilities)}async createFolder(e){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(e),e);await this.mkdirp(t,e);const i=await this.resolve(e,{resolveMetadata:!0})
;return this._onDidRunOperation.fire(new r.FileOperationEvent(e,0,i)),i}async mkdirp(e,t){const i=[],{extUri:n}=this.getExtUri(e);for(;!n.isEqual(t,a.dirname(t));)try{if(0==((await e.stat(t)).type&r.FileType.Directory))throw new Error(l.localize(17,null,this.resourceForError(t)));break}catch(e){if(r.toFileSystemProviderErrorCode(e)!==r.FileSystemProviderErrorCode.FileNotFound)throw e;i.push(a.basename(t)),t=a.dirname(t)}for(let n=i.length-1;n>=0;n--){t=a.joinPath(t,i[n]);try{await e.mkdir(t)}catch(e){if(r.toFileSystemProviderErrorCode(e)!==r.FileSystemProviderErrorCode.FileExists)throw e}}}async canDelete(e,t){try{await this.doValidateDelete(e,t)}catch(e){return e}return!0}async doValidateDelete(e,t){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(e),e);if(!!(null==t?void 0:t.useTrash)&&!(4096&i.capabilities))throw new Error(l.localize(18,null,this.resourceForError(e)));const n=await this.exists(e);if(!n)throw new r.FileOperationError(l.localize(19,null,this.resourceForError(e)),1)
;if(!!!(null==t?void 0:t.recursive)&&n){const t=await this.resolve(e);if(t.isDirectory&&Array.isArray(t.children)&&t.children.length>0)throw new Error(l.localize(20,null,this.resourceForError(e)))}return i}async del(e,t){const i=await this.doValidateDelete(e,t),n=!!(null==t?void 0:t.useTrash),s=!!(null==t?void 0:t.recursive);await i.delete(e,{recursive:s,useTrash:n}),this._onDidRunOperation.fire(new r.FileOperationEvent(e,1))}watch(e,t={recursive:!1,excludes:[]}){let r=!1,n=i.toDisposable(()=>r=!0);return this.doWatch(e,t).then(e=>{r?i.dispose(e):n=e},e=>this.logService.error(e)),i.toDisposable(()=>i.dispose(n))}async doWatch(e,t){const r=await this.withProvider(e),n=this.toWatchKey(r,e,t),s=this.activeWatchers.get(n)||{count:0,disposable:r.watch(e,t)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,s),s.count+=1,i.toDisposable(()=>{s.count--,0===s.count&&(i.dispose(s.disposable),this.activeWatchers.delete(n))})}toWatchKey(e,t,i){const{extUri:r}=this.getExtUri(e)
;return[r.getComparisonKey(t),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(e=>i.dispose(e.disposable)),this.activeWatchers.clear()}ensureWriteQueue(e,t){const{extUri:r}=this.getExtUri(e),s=r.getComparisonKey(t);let o=this.writeQueues.get(s);if(!o){o=new g.Queue,this.writeQueues.set(s,o),n.Event.once(o.onFinished)(()=>{this.writeQueues.delete(s),i.dispose(o)})}return o}async doWriteBuffered(e,t,i){return this.ensureWriteQueue(e,t).queue(async()=>{const n=await e.open(t,{create:!0});try{p.isReadableStream(i)||p.isReadableBufferedStream(i)?await this.doWriteStreamBufferedQueued(e,n,i):await this.doWriteReadableBufferedQueued(e,n,i)}catch(e){throw r.ensureFileSystemProviderError(e)}finally{await e.close(n)}})}async doWriteStreamBufferedQueued(e,t,i){let r,n=0;if(p.isReadableBufferedStream(i)){if(i.buffer.length>0){const r=f.VSBuffer.concat(i.buffer);await this.doWriteBuffer(e,t,r,r.byteLength,n,0),n+=r.byteLength}if(i.ended)return;r=i.stream}else r=i
;return new Promise(async(i,s)=>{r.on("data",async i=>{r.pause();try{await this.doWriteBuffer(e,t,i,i.byteLength,n,0)}catch(e){return s(e)}n+=i.byteLength,setTimeout(()=>r.resume())}),r.on("error",e=>s(e)),r.on("end",()=>i())})}async doWriteReadableBufferedQueued(e,t,i){let r,n=0;for(;null!==(r=i.read());)await this.doWriteBuffer(e,t,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(e,t,i,r,n,s){let o=0;for(;o<r;){o+=await e.write(t,n+o,i.buffer,s+o,r-o)}}async doWriteUnbuffered(e,t,i){return this.ensureWriteQueue(e,t).queue(()=>this.doWriteUnbufferedQueued(e,t,i))}async doWriteUnbufferedQueued(e,t,i){let r;r=i instanceof f.VSBuffer?i:p.isReadableStream(i)?await f.streamToBuffer(i):p.isReadableBufferedStream(i)?await f.bufferedStreamToBuffer(i):f.readableToBuffer(i),await e.writeFile(t,r.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(e,t,i,r){return this.ensureWriteQueue(i,r).queue(()=>this.doPipeBufferedQueued(e,t,i,r))}async doPipeBufferedQueued(e,t,i,n){let s=void 0,o=void 0;try{
s=await e.open(t,{create:!1}),o=await i.open(n,{create:!0});const r=f.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,l=0,c=0;do{c=await e.read(s,a,r.buffer,l,r.byteLength-l),await this.doWriteBuffer(i,o,r,c,a,l),a+=c,(l+=c)===r.byteLength&&(l=0)}while(c>0)}catch(e){throw r.ensureFileSystemProviderError(e)}finally{await Promise.all(["number"==typeof s?e.close(s):Promise.resolve(),"number"==typeof o?i.close(o):Promise.resolve()])}}async doPipeUnbuffered(e,t,i,r){return this.ensureWriteQueue(i,r).queue(()=>this.doPipeUnbufferedQueued(e,t,i,r))}async doPipeUnbufferedQueued(e,t,i,r){return i.writeFile(r,await e.readFile(t),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(e,t,i,r){return this.ensureWriteQueue(i,r).queue(()=>this.doPipeUnbufferedToBufferedQueued(e,t,i,r))}async doPipeUnbufferedToBufferedQueued(e,t,i,n){const s=await i.open(n,{create:!0});try{const r=await e.readFile(t);await this.doWriteBuffer(i,s,f.VSBuffer.wrap(r),r.byteLength,0,0)}catch(e){throw r.ensureFileSystemProviderError(e)}finally{
await i.close(s)}}async doPipeBufferedToUnbuffered(e,t,i,r){const n=await f.streamToBuffer(this.readFileBuffered(e,t,m.CancellationToken.None));await this.doWriteUnbuffered(i,r,n)}throwIfFileSystemIsReadonly(e,t){if(2048&e.capabilities)throw new r.FileOperationError(l.localize(21,null,this.resourceForError(t)),6);return e}resourceForError(e){return e.scheme===v.Schemas.file?e.fsPath:e.toString(!0)}};w=s([o(0,d.ILogService)],w),t.FileService=w})),define(t[56],i([0,1,21,37,2,24,6,5,12,3,18,33,15,13,128,71,143,145,142,150,42,70,19,17]),(function(e,t,i,r,n,s,o,a,l,c,u,h,d,f,p,g,m,v,y,E,w,_,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class C extends n.Disposable{constructor(e,t){var i;super(),this.logService=e,this.options=t,this.BUFFER_SIZE=(null===(i=this.options)||void 0===i?void 0:i.bufferSize)||65536,this.onDidChangeCapabilities=o.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,
this._onDidWatchErrorOccur=this._register(new o.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new o.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new d.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=30,a.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:t,symbolicLink:i}=await l.statLink(this.toFilePath(e));return{type:this.toType(t,i),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(e){throw this.toFileSystemProviderError(e)}}async readdir(e){try{const t=await l.readdirWithFileTypes(this.toFilePath(e)),i=[];return await Promise.all(t.map(async t=>{try{let r;r=t.isSymbolicLink()?(await this.stat(u.joinPath(e,t.name))).type:this.toType(t),i.push([t.name,r])}catch(e){this.logService.trace(e)}})),i}catch(e){throw this.toFileSystemProviderError(e)}}toType(e,t){let i
;return i=(null==t?void 0:t.dangling)?s.FileType.Unknown:e.isFile()?s.FileType.File:e.isDirectory()?s.FileType.Directory:s.FileType.Unknown,t&&(i|=s.FileType.SymbolicLink),i}async readFile(e){try{const t=this.toFilePath(e);return await l.readFile(t)}catch(e){throw this.toFileSystemProviderError(e)}}readFileStream(e,t,i){const r=w.newWriteableStream(e=>S.VSBuffer.concat(e.map(e=>S.VSBuffer.wrap(e))).buffer);return _.readFileIntoStream(this,e,r,e=>e.buffer,Object.assign(Object.assign({},t),{bufferSize:this.BUFFER_SIZE}),i),r}async writeFile(e,t,i){let r=void 0;try{const n=this.toFilePath(e);if(!i.create||!i.overwrite){if(await l.exists(n)){if(!i.overwrite)throw s.createFileSystemProviderError(p.localize(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw s.createFileSystemProviderError(p.localize(1,null),s.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(e,{create:!0}),await this.write(r,0,t,0,t.byteLength)}catch(e){throw this.toFileSystemProviderError(e)}finally{
"number"==typeof r&&await this.close(r)}}async open(e,t){try{const n=this.toFilePath(e);let s=void 0;if(t.create){if(a.isWindows&&await l.exists(n))try{await l.truncate(n,0),s="r+"}catch(e){this.logService.trace(e)}s||(s="w")}else s="r";const o=await r.promisify(i.open)(n,s);return this.mapHandleToPos.set(o,0),t.create&&this.writeHandles.add(o),o}catch(e){throw this.toFileSystemProviderError(e)}}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await r.promisify(i.fdatasync)(e)}catch(e){this.canFlush=!1,this.logService.error(e)}return await r.promisify(i.close)(e)}catch(e){throw this.toFileSystemProviderError(e)}}async read(e,t,n,s,o){const a=this.normalizePos(e,t);let l=null;try{const t=await r.promisify(i.read)(e,n,s,o,a);return l="number"==typeof t?t:t.bytesRead}catch(e){throw this.toFileSystemProviderError(e)}finally{this.updatePos(e,a,l)}}normalizePos(e,t){return t===this.mapHandleToPos.get(e)?null:t}updatePos(e,t,i){const r=this.mapHandleToPos.get(e)
;"number"==typeof r&&("number"==typeof t||("number"==typeof i?this.mapHandleToPos.set(e,r+i):this.mapHandleToPos.delete(e)))}async write(e,t,i,r,n){return d.retry(()=>this.doWrite(e,t,i,r,n),100,3)}async doWrite(e,t,n,s,o){const a=this.normalizePos(e,t);let l=null;try{const t=await r.promisify(i.write)(e,n,s,o,a);return l="number"==typeof t?t:t.bytesWritten}catch(e){throw this.toFileSystemProviderError(e)}finally{this.updatePos(e,a,l)}}async mkdir(e){try{await r.promisify(i.mkdir)(this.toFilePath(e))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(e,t){try{const i=this.toFilePath(e);await this.doDelete(i,t)}catch(e){throw this.toFileSystemProviderError(e)}}async doDelete(e,t){t.recursive?await l.rimraf(e,l.RimRafMode.MOVE):await l.unlink(e)}async rename(e,t,i){const r=this.toFilePath(e),n=this.toFilePath(t);if(r!==n)try{await this.validateTargetDeleted(e,t,"move",i.overwrite),await l.move(r,n)}catch(e){
throw"EINVAL"!==e.code&&"EBUSY"!==e.code&&"ENAMETOOLONG"!==e.code||(e=new Error(p.localize(2,null,c.basename(r),c.basename(c.dirname(n)),e.toString()))),this.toFileSystemProviderError(e)}}async copy(e,t,i){const r=this.toFilePath(e),n=this.toFilePath(t);if(r!==n)try{await this.validateTargetDeleted(e,t,"copy",i.overwrite),await l.copy(r,n)}catch(e){throw"EINVAL"!==e.code&&"EBUSY"!==e.code&&"ENAMETOOLONG"!==e.code||(e=new Error(p.localize(3,null,c.basename(r),c.basename(c.dirname(n)),e.toString()))),this.toFileSystemProviderError(e)}}async validateTargetDeleted(e,t,i,r){const n=this.toFilePath(e),o=this.toFilePath(t);let a=!1;if(!!(1024&this.capabilities)||(a=h.isEqual(n,o,!0)),a&&"copy"===i)throw s.createFileSystemProviderError(p.localize(4,null),s.FileSystemProviderErrorCode.FileExists);if(!a&&await l.exists(o)){if(!r)throw s.createFileSystemProviderError(p.localize(5,null),s.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}watch(e,t){
return t.recursive?this.watchRecursive(e,t.excludes):this.watchNonRecursive(e)}watchRecursive(e,t){const i={path:this.toFilePath(e),excludes:t},r=b.insert(this.recursiveFoldersToWatch,i);return this.refreshRecursiveWatchers(),n.toDisposable(()=>{r(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var e,t,i;if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(n.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,n=void 0;(null===(t=null===(e=this.options)||void 0===e?void 0:e.watcher)||void 0===t?void 0:t.usePolling)?(r=m.FileWatcher,n=null===(i=this.options)||void 0===i?void 0:i.watcher):r=1===this.recursiveFoldersToWatch.length?a.isWindows?v.FileWatcher:m.FileWatcher:y.FileWatcher,
this.recursiveWatcher=new r(this.recursiveFoldersToWatch,e=>this._onDidChangeFile.fire(g.toFileChanges(e)),e=>{"error"===e.type&&this._onDidWatchErrorOccur.fire(e.message),this.logService[e.type](e.message)},this.logService.getLevel()===f.LogLevel.Trace,n),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))}}watchNonRecursive(e){const t=new E.FileWatcher(this.toFilePath(e),e=>this._onDidChangeFile.fire(g.toFileChanges(e)),e=>{"error"===e.type&&this._onDidWatchErrorOccur.fire(e.message),this.logService[e.type](e.message)},this.logService.getLevel()===f.LogLevel.Trace),i=this.logService.onDidChangeLogLevel(()=>{t.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return n.combinedDisposable(t,i)}toFilePath(e){return c.normalize(e.fsPath)}toFileSystemProviderError(e){if(e instanceof s.FileSystemProviderError)return e
;let t;switch(e.code){case"ENOENT":t=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=s.FileSystemProviderErrorCode.NoPermissions;break;default:t=s.FileSystemProviderErrorCode.Unknown}return s.createFileSystemProviderError(e,t)}dispose(){super.dispose(),n.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,n.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=C})),define(t[75],i([0,1,12,108,31,2,22,15,32,13,73,19,6,10,3]),(function(e,t,i,r,n,a,l,c,u,h,d,f,p,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let v=class extends a.Disposable{constructor(e,t,i){super(),this.extensionManagementService=e,this.logService=i,
this._onDidLanguagesChange=this._register(new p.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new y(t,i)),this._register(e.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(e.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(e=>{const t=["en",...Object.keys(e)];return f.distinct(t)})}onDidInstallExtension(e){e&&e.manifest&&e.manifest.contributes&&e.manifest.contributes.localizations&&e.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",e.identifier.id),this.update().then(e=>{e&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(e){this.cache.getLanguagePacks().then(t=>{Object.keys(t).some(i=>t[i]&&t[i].extensions.some(t=>u.areSameExtensions(t.extensionIdentifier,e)))&&(this.logService.debug("Removing language packs from the extension",e.id),this.update().then(e=>{
e&&this._onDidLanguagesChange.fire()}))})}update(){return Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]).then(([e,t])=>this.cache.update(t).then(t=>!f.equals(Object.keys(e),Object.keys(t))))}};v=s([o(0,n.IExtensionManagementService),o(1,l.INativeEnvironmentService),o(2,h.ILogService)],v),t.LocalizationsService=v;let y=class extends a.Disposable{constructor(e,t){super(),this.logService=t,this.languagePacks={},this.languagePacksFilePath=m.join(e.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new c.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(e){return this.withLanguagePacks(t=>{Object.keys(t).forEach(e=>delete t[e]),this.createLanguagePacksFromExtensions(t,...e)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(e,...t){
for(const i of t)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(e,i);Object.keys(e).forEach(t=>this.updateHash(e[t]))}createLanguagePacksFromExtension(e,t){const i=t.identifier,r=t.manifest.contributes&&t.manifest.contributes.localizations?t.manifest.contributes.localizations:[];for(const n of r)if(t.location.scheme===g.Schemas.file&&d.isValidLocalization(n)){let r=e[n.languageId];r||(r={hash:"",extensions:[],translations:{}},e[n.languageId]=r);let s=r.extensions.filter(e=>u.areSameExtensions(e.extensionIdentifier,i))[0];s?s.version=t.manifest.version:r.extensions.push({extensionIdentifier:i,version:t.manifest.version});for(const e of n.translations)r.translations[e.id]=m.join(t.location.fsPath,e.path)}}updateHash(e){if(e){const t=r.createHash("md5");for(const i of e.extensions)t.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);e.hash=t.digest("hex")}}
withLanguagePacks(e=(()=>null)){return this.languagePacksFileLimiter.queue(()=>{let t=null;return i.readFile(this.languagePacksFilePath,"utf8").then(void 0,e=>"ENOENT"===e.code?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch(e){return{}}}).then(i=>(t=e(i),i)).then(e=>{for(const t of Object.keys(e))e[t]||delete e[t];this.languagePacks=e,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),i.writeFile(this.languagePacksFilePath,t)}).then(()=>t,e=>this.logService.error(e))})}};y=s([o(0,l.INativeEnvironmentService),o(1,h.ILogService)],y)})),define(t[154],i([0,1,13]),(function(e,t,i){"use strict";function r(e,t){switch(t){case i.LogLevel.Trace:return e.trace;case i.LogLevel.Debug:return e.debug;case i.LogLevel.Info:return e.info;case i.LogLevel.Warning:return e.warn;case i.LogLevel.Error:return e.error;case i.LogLevel.Critical:return e.critical;default:throw new Error("Invalid log level")}}
Object.defineProperty(t,"__esModule",{value:!0}),t.BufferLogService=void 0;class n extends i.AbstractLogService{constructor(e=i.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(e),this._register(this.onDidChangeLogLevel(e=>{this._logger&&this._logger.setLevel(e)}))}set logger(e){this._logger=e;for(const{level:t,args:i}of this.buffer){r(e,t).apply(e,i)}this.buffer=[]}_log(e,...t){if(this._logger){r(this._logger,e).apply(this._logger,t)}else this.getLevel()<=e&&this.buffer.push({level:e,args:t})}trace(e,...t){this._log(i.LogLevel.Trace,e,...t)}debug(e,...t){this._log(i.LogLevel.Debug,e,...t)}info(e,...t){this._log(i.LogLevel.Info,e,...t)}warn(e,...t){this._log(i.LogLevel.Warning,e,...t)}error(e,...t){this._log(i.LogLevel.Error,e,...t)}critical(e,...t){this._log(i.LogLevel.Critical,e,...t)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}t.BufferLogService=n})),define(t[155],i([0,1,13,24,15,17,18,2,4,154]),(function(e,t,i,r,n,a,l,c,u,h){
"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileLoggerService=t.FileLogService=void 0;let d=class extends i.AbstractLogService{constructor(e,t,i,r){super(),this.name=e,this.resource=t,this.fileService=r,this.backupIndex=1,this.setLevel(i),this.queue=this._register(new n.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=i.LogLevel.Trace&&this._log(i.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=i.LogLevel.Debug&&this._log(i.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=i.LogLevel.Info&&this._log(i.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=i.LogLevel.Warning&&this._log(i.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=i.LogLevel.Error){const e=arguments[0];if(e instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=e.stack,this._log(i.LogLevel.Error,this.format(t))}else this._log(i.LogLevel.Error,this.format(arguments))}}critical(){
this.getLevel()<=i.LogLevel.Critical&&this._log(i.LogLevel.Critical,this.format(arguments))}flush(){}log(e,t){this._log(e,this.format(t))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(e){if(3!==e.fileOperationResult)throw e}}_log(e,t){this.queue.queue(async()=>{await this.initializePromise;let i=await this.loadContent();i.length>5242880&&(await this.fileService.writeFile(this.getBackupResource(),a.VSBuffer.fromString(i)),i=""),i+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(e)}] ${t}\n`,await this.fileService.writeFile(this.resource,a.VSBuffer.fromString(i))})}getCurrentTimestamp(){const e=e=>e<10?`0${e}`:e,t=new Date;return`${t.getFullYear()}-${e(t.getMonth()+1)}-${e(t.getDate())} ${e(t.getHours())}:${e(t.getMinutes())}:${e(t.getSeconds())}.${(e=>e<10?`00${e}`:e<100?`0${e}`:e)(t.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,
l.joinPath(l.dirname(this.resource),`${l.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(e){return""}}stringifyLogLevel(e){switch(e){case i.LogLevel.Critical:return"critical";case i.LogLevel.Debug:return"debug";case i.LogLevel.Error:return"error";case i.LogLevel.Info:return"info";case i.LogLevel.Trace:return"trace";case i.LogLevel.Warning:return"warning"}return""}format(e){let t="";for(let i=0;i<e.length;i++){let r=e[i];if("object"==typeof r)try{r=JSON.stringify(r)}catch(e){}t+=(i>0?" ":"")+r}return t}};d=s([o(3,r.IFileService)],d),t.FileLogService=d;let f=class extends c.Disposable{constructor(e,t,i){super(),this.logService=e,this.instantiationService=t,this.fileService=i,this.loggers=new Map,this._register(e.onDidChangeLogLevel(e=>this.loggers.forEach(t=>t.setLevel(e))))}getLogger(e){let t=this.loggers.get(e.toString());return t||(t=new h.BufferLogService(this.logService.getLevel()),
this.loggers.set(e.toString(),t),r.whenProviderRegistered(e,this.fileService).then(()=>t.logger=this.instantiationService.createInstance(d,l.basename(e),e,this.logService.getLevel()))),t}dispose(){this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}};f=s([o(0,i.ILogService),o(1,u.IInstantiationService),o(2,r.IFileService)],f),t.FileLoggerService=f})),define(t[156],i([0,1,13,6]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FollowerLogService=t.LoggerChannelClient=t.LoggerChannel=void 0;t.LoggerChannel=class{constructor(e){this.service=e,this.onDidChangeLogLevel=r.Event.buffer(e.onDidChangeLogLevel,!0)}listen(e,t){switch(t){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"setLevel":return this.service.setLevel(i),Promise.resolve();case"consoleLog":return this.consoleLog(i[0],i[1]),Promise.resolve()}throw new Error(`Call not found: ${t}`)}consoleLog(e,t){let i=console.log
;switch(e){case"error":i=console.error;break;case"warn":i=console.warn;break;case"info":i=console.info}i.call(console,...t)}};class n{constructor(e){this.channel=e}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(e){n.setLevel(this.channel,e)}static setLevel(e,t){return e.call("setLevel",t)}consoleLog(e,t){this.channel.call("consoleLog",[e,t])}}t.LoggerChannelClient=n;class s extends i.DelegatedLogService{constructor(e,t){super(t),this.parent=e,this._register(e.onDidChangeLogLevel(e=>t.setLevel(e)))}setLevel(e){super.setLevel(e),this.parent.setLevel(e)}}t.FollowerLogService=s})),define(t[57],i([0,1,3,13]),(function(e,t,i,r){"use strict";function n(e,t,i){switch(t){case r.LogLevel.Trace:e.trace(i);break;case r.LogLevel.Debug:e.debug(i);break;case r.LogLevel.Info:e.info(i);break;case r.LogLevel.Warning:e.warn(i);break;case r.LogLevel.Error:e.error(i);break;case r.LogLevel.Critical:e.critical(i);break;default:throw new Error("Invalid log level")}}
Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogService=t.createRotatingLogger=void 0,t.createRotatingLogger=function(t,i,r,n){return e.__$__nodeRequire("spdlog").createRotatingLogger(t,i,r,n)};class s extends r.AbstractLogService{constructor(e,t,i){super(),this.name=e,this.logsFolder=t,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(i),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(e=>{this._logger&&this._logger.setLevel(e)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=async function(t,r){try{const n=await new Promise((t,i)=>{e(["spdlog"],t,i)});n.setAsyncMode(8192,500);const s=i.join(r,`${t}.log`);return n.createRotatingLoggerAsync(t,s,5242880,6)}catch(e){console.error(e)}return null}(this.name,this.logsFolder).then(e=>{if(e){this._logger=e,this._logger.setLevel(this.getLevel());for(const{level:e,message:t}of this.buffer)n(this._logger,e,t);this.buffer=[]}})),this._loggerCreationPromise}_log(e,t){
this._logger?n(this._logger,e,t):this.getLevel()<=e&&this.buffer.push({level:e,message:t})}trace(e,...t){this.getLevel()<=r.LogLevel.Trace&&this._log(r.LogLevel.Trace,this.format([e,...t]))}debug(e,...t){this.getLevel()<=r.LogLevel.Debug&&this._log(r.LogLevel.Debug,this.format([e,...t]))}info(e,...t){this.getLevel()<=r.LogLevel.Info&&this._log(r.LogLevel.Info,this.format([e,...t]))}warn(e,...t){this.getLevel()<=r.LogLevel.Warning&&this._log(r.LogLevel.Warning,this.format([e,...t]))}error(e,...t){if(this.getLevel()<=r.LogLevel.Error)if(e instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=e.stack,this._log(r.LogLevel.Error,this.format(t))}else this._log(r.LogLevel.Error,this.format([e,...t]))}critical(e,...t){this.getLevel()<=r.LogLevel.Critical&&this._log(r.LogLevel.Critical,this.format([e,...t]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){
this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(e){let t="";for(let i=0;i<e.length;i++){let r=e[i];if("object"==typeof r)try{r=JSON.stringify(r)}catch(e){}t+=(i>0?" ":"")+r}return t}}t.SpdLogService=s})),define(t[157],i([0,1,13,2,18,10,155,4,57]),(function(e,t,i,r,n,a,l,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LoggerService=void 0;let h=class extends r.Disposable{constructor(e,t){super(),this.logService=e,this.instantiationService=t,this.loggers=new Map,this._register(e.onDidChangeLogLevel(e=>this.loggers.forEach(t=>t.setLevel(e))))}getLogger(e){let t=this.loggers.get(e.toString());if(!t){if(e.scheme===a.Schemas.file){const i=n.basename(e),r=n.extname(e);t=new u.SpdLogService(i.substring(0,i.length-r.length),n.dirname(e).fsPath,this.logService.getLevel())
}else t=this.instantiationService.createInstance(l.FileLogService,n.basename(e),e,this.logService.getLevel());this.loggers.set(e.toString(),t)}return t}dispose(){this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}};h=s([o(0,i.ILogService),o(1,c.IInstantiationService)],h),t.LoggerService=h})),define(t[158],i([0,1,97,4,6]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NoOpProgress=t.NoOpNotification=t.NotificationsFilter=t.NeverShowAgainScope=t.INotificationService=t.Severity=void 0,t.Severity=i.default,t.INotificationService=r.createDecorator("notificationService"),function(e){e[e.WORKSPACE=0]="WORKSPACE",e[e.GLOBAL=1]="GLOBAL"}(t.NeverShowAgainScope||(t.NeverShowAgainScope={})),function(e){e[e.OFF=0]="OFF",e[e.SILENT=1]="SILENT",e[e.ERROR=2]="ERROR"}(t.NotificationsFilter||(t.NotificationsFilter={}));t.NoOpNotification=class{constructor(){this.progress=new s,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(e){}
updateMessage(e){}updateActions(e){}close(){}};class s{infinite(){}done(){}total(e){}worked(e){}}t.NoOpProgress=s})),define(t[28],i([0,1,5,41,10,18]),(function(e,t,i,r,n,s){"use strict";let o;if(Object.defineProperty(t,"__esModule",{value:!0}),i.isWeb||void 0===e||"function"!=typeof e.__$__nodeRequire){o={},0===Object.keys(o).length&&Object.assign(o,{version:"1.51.0-dev",nameShort:i.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:i.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/master/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.references-view","ms-vscode.github-browser"]});const e=document.getElementById("vscode-remote-product-configuration"),t=e&&e.getAttribute("data-settings");t&&Object.assign(o,JSON.parse(t))
}else{const t=s.dirname(n.FileAccess.asFileUri("",e));o=e.__$__nodeRequire(s.joinPath(t,"product.json").fsPath);const i=e.__$__nodeRequire(s.joinPath(t,"package.json").fsPath);r.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`}),Object.assign(o,{version:i.version})}t.default=o})),define(t[76],i([0,1,104,27,3,18,92,28,112,10,7,52]),(function(e,t,i,r,n,o,a,l,c,u,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseUserDataDir=t.parsePathArg=t.parseSearchPort=t.parseExtensionHostPort=t.NativeEnvironmentService=void 0;class f{constructor(e){if(this._args=e,!process.env.VSCODE_LOGS){const e=c.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");process.env.VSCODE_LOGS=n.join(this.userDataPath,"logs",e)}this.logsPath=process.env.VSCODE_LOGS}get args(){return this._args}get appRoot(){return n.dirname(u.FileAccess.asFileUri("",e).fsPath)}get userHome(){return h.URI.file(r.homedir())}get userDataPath(){
const e=process.env.VSCODE_PORTABLE;return e?n.join(e,"user-data"):v(this._args,process)}get appSettingsHome(){return h.URI.file(n.join(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(r.tmpdir())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return o.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return o.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return h.URI.file(n.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return o.joinPath(h.URI.file(n.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return h.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return h.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return o.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return o.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}
get argvResource(){const e=process.env.VSCODE_PORTABLE;return e?h.URI.file(n.join(e,"argv.json")):o.joinPath(this.userHome,l.default.dataFolderName,"argv.json")}get snippetsHome(){return o.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file(n.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return n.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const t=m(this._args["builtin-extensions-dir"],process);return t||n.normalize(n.join(u.FileAccess.asFileUri("",e).fsPath,"..","extensions"))}get extensionsDownloadPath(){const e=m(this._args["extensions-download-dir"],process);return e||n.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const e=m(this._args["extensions-dir"],process);if(e)return e;const t=process.env.VSCODE_EXTENSIONS;if(t)return t;const i=process.env.VSCODE_PORTABLE
;return i?n.join(i,"extensions"):o.joinPath(this.userHome,l.default.dataFolderName,"extensions").fsPath}get extraExtensionPaths(){return(this._args["extra-extensions-dir"]||[]).map(e=>m(e,process))}get extraBuiltinExtensionPaths(){return(this._args["extra-builtin-extensions-dir"]||[]).map(e=>m(e,process))}get extensionDevelopmentLocationURI(){const e=this._args.extensionDevelopmentPath;if(Array.isArray(e))return e.map(e=>/^[^:/?#]+?:\/\//.test(e)?h.URI.parse(e):h.URI.file(n.normalize(e)))}get extensionTestsLocationURI(){const e=this._args.extensionTestsPath;if(e)return/^[^:/?#]+?:\/\//.test(e)?h.URI.parse(e):h.URI.file(n.normalize(e))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const e=this._args["disable-extension"];if(e){if("string"==typeof e)return[e];if(Array.isArray(e)&&e.length>0)return e}return!1}get debugExtensionHost(){return p(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){
return!!this._args.verbose}get logLevel(){return this._args.log}get sharedIPCHandle(){return d.createStaticIPCHandle(this.userDataPath,"shared",l.default.version)}get serviceMachineIdResource(){return o.joinPath(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return h.URI.file(n.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}function p(e,t){return g(e["inspect-extensions"],e["inspect-brk-extensions"],5870,t,e.debugId)}function g(e,t,i,r,n){const s=Number(t||e)||(r?null:i);return{port:s,break:!!s&&Boolean(!!t),debugId:n}}function m(e,t){if(!e)return;const i=n.resolve(e);return n.normalize(e)===i?i:n.resolve(t.env.VSCODE_CWD||t.cwd(),e)}function v(e,t){return m(e["user-data-dir"],t)||n.resolve(i.getDefaultUserDataPath(t.platform))}
s([a.memoize],f.prototype,"appRoot",null),s([a.memoize],f.prototype,"userHome",null),s([a.memoize],f.prototype,"userDataPath",null),s([a.memoize],f.prototype,"appSettingsHome",null),s([a.memoize],f.prototype,"tmpDir",null),s([a.memoize],f.prototype,"userRoamingDataHome",null),s([a.memoize],f.prototype,"settingsResource",null),s([a.memoize],f.prototype,"userDataSyncHome",null),s([a.memoize],f.prototype,"userDataSyncLogResource",null),s([a.memoize],f.prototype,"sync",null),s([a.memoize],f.prototype,"machineSettingsResource",null),s([a.memoize],f.prototype,"globalStorageHome",null),s([a.memoize],f.prototype,"workspaceStorageHome",null),s([a.memoize],f.prototype,"keybindingsResource",null),s([a.memoize],f.prototype,"keyboardLayoutResource",null),s([a.memoize],f.prototype,"argvResource",null),s([a.memoize],f.prototype,"snippetsHome",null),s([a.memoize],f.prototype,"isExtensionDevelopment",null),s([a.memoize],f.prototype,"untitledWorkspacesHome",null),s([a.memoize],f.prototype,"installSourcePath",null),
s([a.memoize],f.prototype,"builtinExtensionsPath",null),s([a.memoize],f.prototype,"extensionsPath",null),s([a.memoize],f.prototype,"extraExtensionPaths",null),s([a.memoize],f.prototype,"extraBuiltinExtensionPaths",null),s([a.memoize],f.prototype,"extensionDevelopmentLocationURI",null),s([a.memoize],f.prototype,"extensionTestsLocationURI",null),s([a.memoize],f.prototype,"debugExtensionHost",null),s([a.memoize],f.prototype,"sharedIPCHandle",null),s([a.memoize],f.prototype,"serviceMachineIdResource",null),s([a.memoize],f.prototype,"telemetryLogResource",null),t.NativeEnvironmentService=f,t.parseExtensionHostPort=p,t.parseSearchPort=function(e,t){return g(e["inspect-search"],e["inspect-brk-search"],5876,t)},t.parsePathArg=m,t.parseUserDataDir=v})),define(t[47],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=i.createDecorator("productService")})),define(t[29],i([0,1,11,91]),(function(e,t,i,r){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;t.Registry=new class{constructor(){this.data=new Map}add(e,t){r.ok(i.isString(e)),r.ok(i.isObject(t)),r.ok(!this.data.has(e),"There is already an extension with this id"),this.data.set(e,t)}knows(e){return this.data.has(e)}as(e){return this.data.get(e)||null}}})),define(t[159],i([0,1,29,6]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};const n=new class{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(e,t){var i;this.schemasById[(i=e,i.length>0&&"#"===i.charAt(i.length-1)?i.substring(0,i.length-1):i)]=t,this._onDidChangeSchema.fire(e)}notifySchemaChanged(e){this._onDidChangeSchema.fire(e)}getSchemaContributions(){return{schemas:this.schemasById}}};i.Registry.add(t.Extensions.JSONContribution,n)})),
define(t[40],i([0,1,119,6,29,11,159]),(function(e,t,i,r,n,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"},function(e){e[e.APPLICATION=1]="APPLICATION",e[e.MACHINE=2]="MACHINE",e[e.WINDOW=3]="WINDOW",e[e.RESOURCE=4]="RESOURCE",e[e.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",e[e.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"}(t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},
patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const a=n.Registry.as(o.Extensions.JSONContribution);function l(e){return e.substring(1,e.length-1)}function c(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.OVERRIDE_PROPERTY_PATTERN=new RegExp("\\[.*\\]$"),t.overrideIdentifierFromKey=l,t.getDefaultValue=c;const u=new class{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:i.localize(0,null),properties:{}},
this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(e,t=!0){this.registerConfigurations([e],t)}registerConfigurations(e,i=!0){const r=[];e.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,i)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(e){const i=[],r=e=>{if(e.properties)for(const t in e.properties)i.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,e.properties[t])
;e.allOf&&e.allOf.forEach(e=>r(e))};for(const t of e){r(t);const e=this.configurationContributors.indexOf(t);-1!==e&&this.configurationContributors.splice(e,1)}a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(i)}registerDefaultConfigurations(e){const r=[],n=[];for(const s of e)for(const e in s)if(r.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]=Object.assign(Object.assign({},this.defaultValues[e]||{}),s[e]);const r={type:"object",default:this.defaultValues[e],description:i.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};n.push(l(e)),this.configurationProperties[e]=r,this.defaultLanguageConfigurationOverridesNode.properties[e]=r}else{this.defaultValues[e]=s[e];const t=this.configurationProperties[e];t&&(this.updatePropertyDefaultValue(e,t),this.updateSchema(e,t))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}
deregisterDefaultConfigurations(e){const i=[];for(const r of e)for(const e in r)if(i.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const t=this.configurationProperties[e];t&&(this.updatePropertyDefaultValue(e,t),this.updateSchema(e,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(i)}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const t of e)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(e,i=!0,r=3){r=s.isUndefinedOrNull(e.scope)?r:e.scope;let n=[],o=e.properties;if(o)for(let e in o){if(i&&h(e)){delete o[e];continue}const a=o[e];this.updatePropertyDefaultValue(e,a),t.OVERRIDE_PROPERTY_PATTERN.test(e)?a.scope=void 0:a.scope=s.isUndefinedOrNull(a.scope)?r:a.scope,
!o[e].hasOwnProperty("included")||o[e].included?(this.configurationProperties[e]=o[e],!o[e].deprecationMessage&&o[e].markdownDeprecationMessage&&(o[e].deprecationMessage=o[e].markdownDeprecationMessage),n.push(e)):(this.excludedConfigurationProperties[e]=o[e],delete o[e])}let a=e.allOf;if(a)for(let e of a)n.push(...this.validateAndRegisterProperties(e,i,r));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(e){const t=e=>{let i=e.properties;if(i)for(const e in i)this.updateSchema(e,i[e]);let r=e.allOf;r&&r.forEach(t)};t(e)}updateSchema(e,i){switch(t.allSettings.properties[e]=i,i.scope){case 1:t.applicationSettings.properties[e]=i;break;case 2:t.machineSettings.properties[e]=i;break;case 6:t.machineOverridableSettings.properties[e]=i;break;case 3:t.windowSettings.properties[e]=i;break;case 4:t.resourceSettings.properties[e]=i
;break;case 5:t.resourceSettings.properties[e]=i,this.resourceLanguageSettingsSchema.properties[e]=i}}removeFromSchema(e,i){switch(delete t.allSettings.properties[e],i.scope){case 1:delete t.applicationSettings.properties[e];break;case 2:delete t.machineSettings.properties[e];break;case 6:delete t.machineOverridableSettings.properties[e];break;case 3:delete t.windowSettings.properties[e];break;case 4:case 5:delete t.resourceSettings.properties[e]}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const r=`[${e}]`,n={type:"object",description:i.localize(2,null),errorMessage:i.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,n),t.allSettings.properties[r]=n,t.applicationSettings.properties[r]=n,t.machineSettings.properties[r]=n,t.machineOverridableSettings.properties[r]=n,t.windowSettings.properties[r]=n,t.resourceSettings.properties[r]=n}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,t){let i=this.defaultValues[e]
;s.isUndefined(i)&&(i=t.default),s.isUndefined(i)&&(i=c(t.type)),t.default=i}};function h(e){return t.OVERRIDE_PROPERTY_PATTERN.test(e)?i.localize(4,null,e):void 0!==u.getConfigurationProperties()[e]?i.localize(5,null,e):null}n.Registry.add(t.Extensions.Configuration,u),t.validateProperty=h,t.getScopes=function(){const e=[],t=u.getConfigurationProperties();for(const i of Object.keys(t))e.push([i,t[i].scope]);return e.push(["launch",4]),e.push(["task",4]),e}})),define(t[30],i([0,1,20,11,7,29,4,40]),(function(e,t,i,r,n,s,o,a){"use strict";function l(e,t){const i=Object.create(null);for(let r in e)c(i,r,e[r],t);return i}function c(e,t,i,r){const n=t.split("."),s=n.pop();let o=e;for(let e=0;e<n.length;e++){let i=n[e],s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:return void r(`Ignoring ${t} as ${n.slice(0,e+1).join(".")} is ${JSON.stringify(s)}`)}o=s}if("object"==typeof o&&null!==o)try{o[s]=i}catch(e){
r(`Ignoring ${t} as ${n.join(".")} is ${JSON.stringify(o)}`)}else r(`Ignoring ${t} as ${n.join(".")} is ${JSON.stringify(o)}`)}function u(e,t,i){const r=function(e,t){let i=e;for(const e of t){if("object"!=typeof i||null===i)return;i=i[e]}return i}(e,t.split("."));return void 0===r?i:r}function h(e){return`[${e}]`}Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=o.createDecorator("configurationService"),t.isConfigurationOverrides=function(e){return e&&"object"==typeof e&&(!e.overrideIdentifier||"string"==typeof e.overrideIdentifier)&&(!e.resource||e.resource instanceof n.URI)},function(e){e[e.USER=1]="USER",e[e.USER_LOCAL=2]="USER_LOCAL",e[e.USER_REMOTE=3]="USER_REMOTE",
e[e.WORKSPACE=4]="WORKSPACE",e[e.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",e[e.DEFAULT=6]="DEFAULT",e[e.MEMORY=7]="MEMORY"}(t.ConfigurationTarget||(t.ConfigurationTarget={})),t.ConfigurationTargetToString=function(e){switch(e){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}},t.compare=function e(t,r){const n=r?t?r.keys.filter(e=>-1===t.keys.indexOf(e)):[...r.keys]:[],s=t?r?t.keys.filter(e=>-1===r.keys.indexOf(e)):[...t.keys]:[],o=[];if(r&&t)for(const e of t.keys)if(-1!==r.keys.indexOf(e)){const n=u(t.contents,e),s=u(r.contents,e);i.equals(n,s)||o.push(e)}const l=[],c=e=>{const t={};for(const i of e)for(const e of i.identifiers)t[h(e)]=i;return t},d=r?c(r.overrides):{},f=t?c(t.overrides):{};if(Object.keys(d).length)for(const e of n){const t=d[e];t&&l.push([a.overrideIdentifierFromKey(e),t.keys])}if(Object.keys(f).length)for(const e of s){const t=f[e]
;t&&l.push([a.overrideIdentifierFromKey(e),t.keys])}if(Object.keys(d).length&&Object.keys(f).length)for(const t of o){const i=f[t],r=d[t];if(i&&r){const n=e({contents:i.contents,keys:i.keys,overrides:[]},{contents:r.contents,keys:r.keys,overrides:[]});l.push([a.overrideIdentifierFromKey(t),[...n.added,...n.removed,...n.updated]])}}return{added:n,removed:s,updated:o,overrides:l}},t.toOverrides=function(e,t){const i=[];for(const r of Object.keys(e))if(a.OVERRIDE_PROPERTY_PATTERN.test(r)){const n={};for(const t in e[r])n[t]=e[r][t];i.push({identifiers:[a.overrideIdentifierFromKey(r).trim()],keys:Object.keys(n),contents:l(n,t)})}return i},t.toValuesTree=l,t.addToValueTree=c,t.removeFromValueTree=function(e,t){!function e(t,i){const r=i.shift();if(0===i.length)return void delete t[r];if(-1!==Object.keys(t).indexOf(r)){const n=t[r];"object"!=typeof n||Array.isArray(n)||(e(n,i),0===Object.keys(n).length&&delete t[r])}}(e,t.split("."))},t.getConfigurationValue=u,t.merge=function e(t,i,n){Object.keys(i).forEach(s=>{
"__proto__"!==s&&(s in t?r.isObject(t[s])&&r.isObject(i[s])?e(t[s],i[s],n):n&&(t[s]=i[s]):t[s]=i[s])})},t.getConfigurationKeys=function(){const e=s.Registry.as(a.Extensions.Configuration).getConfigurationProperties();return Object.keys(e)},t.getDefaultValues=function(){const e=Object.create(null),t=s.Registry.as(a.Extensions.Configuration).getConfigurationProperties();for(let i in t){c(e,i,t[i].default,e=>console.error(`Conflict in default settings: ${e}`))}return e},t.keyFromOverrideIdentifier=h,t.getMigratedSettingValue=function(e,t,i){const r=e.inspect(t),n=e.inspect(i);return void 0!==r.userValue||void 0!==r.workspaceValue||void 0!==r.workspaceFolderValue?r.value:void 0!==n.userValue||void 0!==n.workspaceValue||void 0!==n.workspaceFolderValue?n.value:r.defaultValue}})),define(t[160],i([0,1,36,25,19,11,20,7,40,30,29,2,6,18]),(function(e,t,i,r,n,s,o,a,l,c,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class p{constructor(e={},t=[],i=[]){this._contents=e,this._keys=t,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return 0===this._keys.length&&0===Object.keys(this._contents).length&&0===this._overrides.length}getValue(e){return e?c.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,t){const i=this.getContentsForOverrideIdentifer(t);return i?e?c.getConfigurationValue(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.keys;return[]}override(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||"object"!=typeof t||!Object.keys(t).length)return this;let i={}
;for(const e of n.distinct([...Object.keys(this.contents),...Object.keys(t)])){let r=this.contents[e],n=t[e];n&&("object"==typeof r&&"object"==typeof n?(r=o.deepClone(r),this.mergeContents(r,n)):r=n),i[e]=r}return new p(i,this.keys,this.overrides)}merge(...e){const t=o.deepClone(this.contents),i=o.deepClone(this.overrides),r=[...this.keys];for(const s of e){this.mergeContents(t,s.contents);for(const e of s.overrides){const[t]=i.filter(t=>n.equals(t.identifiers,e.identifiers));t?this.mergeContents(t.contents,e.contents):i.push(o.deepClone(e))}for(const e of s.keys)-1===r.indexOf(e)&&r.push(e)}return new p(t,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(e,t){for(const i of Object.keys(t))i in e&&s.isObject(e[i])&&s.isObject(t[i])?this.mergeContents(e[i],t[i]):e[i]=o.deepClone(t[i])}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?o.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.contents;return null}toJSON(){return{
contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),c.addToValueTree(this.contents,e,t,e=>{throw new Error(e)})}removeValue(e){this.removeKey(e)&&c.removeFromValueTree(this.contents,e)}addKey(e){let t=this.keys.length;for(let i=0;i<t;i++)0===e.indexOf(this.keys[i])&&(t=i);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return-1!==t&&(this.keys.splice(t,1),!0)}}t.ConfigurationModel=p;t.DefaultConfigurationModel=class extends p{constructor(){const e=c.getDefaultValues(),t=c.getConfigurationKeys(),i=[];for(const t of Object.keys(e))l.OVERRIDE_PROPERTY_PATTERN.test(t)&&i.push({identifiers:[l.overrideIdentifierFromKey(t).trim()],keys:Object.keys(e[t]),contents:c.toValuesTree(e[t],e=>console.error(`Conflict in default settings file: ${e}`))});super(e,t,i)}};class g{constructor(e,t){this._name=e,this._scopes=t,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get errors(){
return this._parseErrors}parseContent(e){if(!s.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t)}}parseRaw(e){this._raw=e;const t=this.doParseRaw(e);this._configurationModel=new p(t.contents,t.keys,t.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let t={},r=null,n=[],s=[],o=[];function a(e){Array.isArray(n)?n.push(e):r&&(n[r]=e)}let l={onObjectBegin:()=>{let e={};a(e),s.push(n),n=e,r=null},onObjectProperty:e=>{r=e},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{let e=[];a(e),s.push(n),n=e,r=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:a,onError:(e,t,i)=>{o.push({error:e,offset:t,length:i})}};if(e)try{i.visit(e,l),t=n[0]||{}}catch(e){console.error(`Error while parsing settings file ${this._name}: ${e}`),this._parseErrors=[e]}return t}doParseRaw(e){if(this._scopes){const t=u.Registry.as(l.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,t,!0,this._scopes)}return{
contents:c.toValuesTree(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`)),keys:Object.keys(e),overrides:c.toOverrides(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`))}}filterByScope(e,t,i,r){const n={};for(let s in e)if(l.OVERRIDE_PROPERTY_PATTERN.test(s)&&i)n[s]=this.filterByScope(e[s],t,!1,r);else{const i=this.getScope(s,t);void 0!==i&&-1===r.indexOf(i)||(n[s]=e[s])}return n}getScope(e,t){const i=t[e];return i?void 0!==i.scope?i.scope:3:void 0}}t.ConfigurationModelParser=g;class m extends h.Disposable{constructor(e,t,i){super(),this.userSettingsResource=e,this.scopes=t,this.fileService=i,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(f.dirname(this.userSettingsResource))),this._register(d.Event.filter(this.fileService.onDidFilesChange,e=>e.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}
async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new p}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}t.UserSettings=m;class v{constructor(e,t,i=new p,n=new p,s=new r.ResourceMap,o=new p,a=new r.ResourceMap,l=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=i,this._workspaceConfiguration=n,this._folderConfigurations=s,this._memoryConfiguration=o,this._memoryConfigurationByResource=a,this._freeze=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new r.ResourceMap,this._userConfiguration=null}getValue(e,t,i){return this.getConsolidateConfigurationModel(t,i).getValue(e)}updateValue(e,t,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource))||(r=new p,this._memoryConfigurationByResource.set(i.resource,r)):r=this._memoryConfiguration,
void 0===t?r.removeValue(e):r.setValue(e,t),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,i){
const r=this.getConsolidateConfigurationModel(t,i),s=this.getFolderConfigurationModelForResource(t.resource,i),o=t.resource&&this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration,a=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),l=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),c=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),u=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),h=i?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,d=s?t.overrideIdentifier?s.freeze().override(t.overrideIdentifier).getValue(e):s.freeze().getValue(e):void 0,f=t.overrideIdentifier?o.override(t.overrideIdentifier).getValue(e):o.getValue(e),p=r.getValue(e),g=n.distinct(n.flatten(r.overrides.map(e=>e.identifiers))).filter(t=>void 0!==r.getOverrideValue(e,t))
;return{defaultValue:a,userValue:l,userLocalValue:c,userRemoteValue:u,workspaceValue:h,workspaceFolderValue:d,memoryValue:f,value:p,default:void 0!==a?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:void 0!==l?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:void 0!==c?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:void 0!==u?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:void 0!==h?{value:this._workspaceConfiguration.freeze().getValue(e),
override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:void 0!==d?{value:null==s?void 0:s.freeze().getValue(e),override:t.overrideIdentifier?null==s?void 0:s.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:void 0!==f?{value:o.getValue(e),override:t.overrideIdentifier?o.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:g.length?g:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,
this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,t){const i=t.filter(e=>l.OVERRIDE_PROPERTY_PATTERN.test(e)).map(t=>{
const i=l.overrideIdentifierFromKey(t),r=this._defaultConfiguration.getKeysForOverrideIdentifier(i),n=e.getKeysForOverrideIdentifier(i),s=[...n.filter(e=>-1===r.indexOf(e)),...r.filter(e=>-1===n.indexOf(e)),...r.filter(t=>!o.equals(this._defaultConfiguration.override(i).getValue(t),e.override(i).getValue(t)))];return[i,s]});return this.updateDefaultConfiguration(e),{keys:t,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:i,removed:r,overrides:n}=c.compare(this.localUserConfiguration,e),s=[...t,...i,...r];return s.length&&this.updateLocalUserConfiguration(e),{keys:s,overrides:n}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:i,removed:r,overrides:n}=c.compare(this.remoteUserConfiguration,e);let s=[...t,...i,...r];return s.length&&this.updateRemoteUserConfiguration(e),{keys:s,overrides:n}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:i,removed:r,overrides:n}=c.compare(this.workspaceConfiguration,e);let s=[...t,...i,...r]
;return s.length&&this.updateWorkspaceConfiguration(e),{keys:s,overrides:n}}compareAndUpdateFolderConfiguration(e,t){const i=this.folderConfigurations.get(e),{added:r,updated:n,removed:s,overrides:o}=c.compare(i,t);let a=[...r,...n,...s];return!a.length&&i||this.updateFolderConfiguration(e,t),{keys:a,overrides:o}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:r,removed:n,overrides:s}=c.compare(t,void 0);return{keys:[...i,...r,...n],overrides:s}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){
return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let i=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},t){let i=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const r=t.getFolder(e);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const n=this._memoryConfigurationByResource.get(e);n&&(i=i.merge(n))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){
let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(t=i.merge(r),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=i}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const i=t.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:i,overrides:r,keys:n}=this._folderConfigurations.get(t);return e.push([t,{contents:i,overrides:r,keys:n}]),e},[])}}allKeys(){
const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e))),[...t.values()]}static parse(e){const t=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),n=this.parseConfigurationModel(e.workspace),s=e.folders.reduce((e,t)=>(e.set(a.URI.revive(t[0]),this.parseConfigurationModel(t[1])),e),new r.ResourceMap);return new v(t,i,new p,n,s,new p,new r.ResourceMap,!1)}
static parseConfigurationModel(e){return new p(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=v,t.mergeChanges=function(...e){if(0===e.length)return{keys:[],overrides:[]};if(1===e.length)return e[0];const t=new Set,i=new Map;for(const n of e)n.keys.forEach(e=>t.add(e)),n.overrides.forEach(([e,t])=>{const n=r.getOrSet(i,e,new Set);t.forEach(e=>n.add(e))});const n=[];return i.forEach((e,t)=>n.push([t,[...e.values()]])),{keys:[...t.values()],overrides:n}};class y{constructor(e,t,i,r){this.change=e,this.previous=t,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const n=new Set;e.keys.forEach(e=>n.add(e)),e.overrides.forEach(([,e])=>e.forEach(e=>n.add(e))),this.affectedKeys=[...n.values()];const s=new p;this.affectedKeys.forEach(e=>s.setValue(e,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}
affectsConfiguration(e,t){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(e,t,null===(i=this.previous)||void 0===i?void 0:i.workspace):void 0,n=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!o.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let i,r=c.toValuesTree({[t]:!0},()=>{});for(;"object"==typeof r&&(i=Object.keys(r)[0]);){if(!(e=e[i]))return!1;r=r[i]}return!0}}t.ConfigurationChangeEvent=y;t.AllKeysConfigurationChangeEvent=class extends y{constructor(e,t,i,r){super({keys:e.allKeys(),overrides:[]},void 0,e,t),this.source=i,this.sourceConfig=r}}})),define(t[77],i([0,1,29,40,2,30,160,6,15]),(function(e,t,i,r,n,s,o,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class c extends n.Disposable{constructor(e,t){super(),this.settingsResource=e,this._onDidChangeConfiguration=this._register(new a.Emitter),
this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new o.UserSettings(this.settingsResource,void 0,t)),this.configuration=new o.Configuration(new o.DefaultConfigurationModel,new o.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new l.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(i.Registry.as(r.Extensions.Configuration).onDidUpdateConfiguration(e=>this.onDidDefaultConfigurationChange(e))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const e=await this.userConfiguration.loadConfiguration();this.configuration=new o.Configuration(new o.DefaultConfigurationModel,e)}getConfigurationData(){return this.configuration.toData()}getValue(e,t){const i="string"==typeof e?e:void 0,r=s.isConfigurationOverrides(e)?e:s.isConfigurationOverrides(t)?t:{};return this.configuration.getValue(i,r,void 0)}updateValue(e,t,i,r){
return Promise.reject(new Error("not supported"))}inspect(e){return this.configuration.inspect(e,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const e=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(e)}onDidChangeUserConfiguration(e){const t=this.configuration.toData(),i=this.configuration.compareAndUpdateLocalUserConfiguration(e);this.trigger(i,t,1)}onDidDefaultConfigurationChange(e){const t=this.configuration.toData(),i=this.configuration.compareAndUpdateDefaultConfiguration(new o.DefaultConfigurationModel,e);this.trigger(i,t,6)}trigger(e,t,i){const r=new o.ConfigurationChangeEvent(e,{data:t},this.configuration);r.source=i,r.sourceConfig=this.getTargetConfiguration(i),this._onDidChangeConfiguration.fire(r)}getTargetConfiguration(e){switch(e){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=c})),define(t[161],i([0,1,4]),(function(e,t,i){
"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteAuthorityResolverError=t.RemoteAuthorityResolverErrorCode=t.IRemoteAuthorityResolverService=void 0,t.IRemoteAuthorityResolverService=i.createDecorator("remoteAuthorityResolverService"),function(e){e.Unknown="Unknown",e.NotAvailable="NotAvailable",e.TemporarilyNotAvailable="TemporarilyNotAvailable",e.NoResolverFound="NoResolverFound"}(r=t.RemoteAuthorityResolverErrorCode||(t.RemoteAuthorityResolverErrorCode={}));class n extends Error{constructor(e,t=r.Unknown,i){super(e),this._message=e,this._code=t,this._detail=i,this.isHandled=t===r.NotAvailable&&!0===i,"function"==typeof Object.setPrototypeOf&&Object.setPrototypeOf(this,n.prototype)}static isTemporarilyNotAvailable(e){return e instanceof n&&e._code===r.TemporarilyNotAvailable}static isNoResolverFound(e){return e instanceof n&&e._code===r.NoResolverFound}static isHandled(e){return e instanceof n&&e.isHandled}}t.RemoteAuthorityResolverError=n})),
define(t[162],i([0,1,10]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemoteName=t.getRemoteAuthority=void 0,t.getRemoteAuthority=function(e){return e.scheme===i.Schemas.vscodeRemote?e.authority:void 0},t.getRemoteName=function(e){if(!e)return;const t=e.indexOf("+");return t<0?e:e.substr(0,t)}})),define(t[58],i([0,1,129,4,40,29,17]),(function(e,t,i,r,n,s,o){"use strict";function a(e){return e.res.statusCode&&e.res.statusCode>=200&&e.res.statusCode<300||1223===e.res.statusCode}function l(e){return 204===e.res.statusCode}Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=r.createDecorator("requestService"),t.isSuccess=a,t.asText=async function(e){if(!a(e))throw new Error("Server returned "+e.res.statusCode);return l(e)?null:(await o.streamToBuffer(e.stream)).toString()},t.asJson=async function(e){if(!a(e))throw new Error("Server returned "+e.res.statusCode);if(l(e))return null
;const t=(await o.streamToBuffer(e.stream)).toString();try{return JSON.parse(t)}catch(e){throw e.message+=":\n"+t,e}},s.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:i.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:i.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:i.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:i.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[i.localize(4,null),i.localize(5,null),i.localize(6,null)],default:"override",description:i.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:i.localize(8,null)}}})})),define(t[163],i([0,1,23,17]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestChannelClient=t.RequestChannel=void 0
;t.RequestChannel=class{constructor(e){this.service=e}listen(e,t){throw new Error("Invalid listen")}call(e,t,n){switch(t){case"request":return this.service.request(n[0],i.CancellationToken.None).then(async({res:e,stream:t})=>{const i=await r.streamToBuffer(t);return[{statusCode:e.statusCode,headers:e.headers},i]})}throw new Error("Invalid call")}};class n{constructor(e){this.channel=e}async request(e,t){return n.request(this.channel,e,t)}static async request(e,t,i){const[n,s]=await e.call("request",[t]);return{res:n,stream:r.bufferToStream(s)}}}t.RequestChannelClient=n})),define(t[164],i([0,1,165,11]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0,t.getProxyAgent=async function(t,n={}){const s=i.parse(t),o=n.proxyUrl||function(e){return"http:"===e.protocol?process.env.HTTP_PROXY||process.env.http_proxy||null:"https:"===e.protocol&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}(s)
;if(!o)return null;const a=i.parse(o);if(!/^https?:$/.test(a.protocol||""))return null;const l={host:a.hostname||"",port:a.port||("https"===a.protocol?"443":"80"),auth:a.auth,rejectUnauthorized:!r.isBoolean(n.strictSSL)||n.strictSSL};return"http:"===s.protocol?new(await new Promise((t,i)=>{e(["http-proxy-agent"],t,i)}))(l):new(await new Promise((t,i)=>{e(["https-proxy-agent"],t,i)}))(l)}})),define(t[166],i([0,1,26,17]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0,t.getServiceMachineId=async function(e,t,n){let s=n&&n.get("storage.serviceMachineId",0)||null;if(s)return s;try{const r=(await t.readFile(e.serviceMachineIdResource)).value.toString();s=i.isUUID(r)?r:null}catch(e){s=null}if(!s){s=i.generateUuid();try{await t.writeFile(e.serviceMachineIdResource,r.VSBuffer.fromString(s))}catch(e){}}return n&&n.store("storage.serviceMachineId",s,0),s}})),define(t[167],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0
}),t.IStateService=void 0,t.IStateService=i.createDecorator("stateService")})),define(t[168],i([0,1,3,21,22,12,11,13]),(function(e,t,i,r,n,a,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class u{constructor(e,t){this.dbPath=e,this.onError=t,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(this._database)return;const e=await this.loadAsync();this._database||(this._database=e)}loadSync(){try{return this.lastFlushedSerializedDatabase=r.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(e){return"ENOENT"!==e.code&&this.onError(e),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await a.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(e){return"ENOENT"!==e.code&&this.onError(e),{}}}getItem(e,t){const i=this.database[e];return l.isUndefinedOrNull(i)?t:i
}setItem(e,t){if(l.isUndefinedOrNull(t))return this.removeItem(e);("string"!=typeof t&&"number"!=typeof t&&"boolean"!=typeof t||this.database[e]!==t)&&(this.database[e]=t,this.saveSync())}removeItem(e){l.isUndefined(this.database[e])||(this.database[e]=void 0,this.saveSync())}saveSync(){const e=JSON.stringify(this.database,null,4);if(e!==this.lastFlushedSerializedDatabase)try{a.writeFileSync(this.dbPath,e),this.lastFlushedSerializedDatabase=e}catch(e){this.onError(e)}}}t.FileStorage=u;let h=class e{constructor(t,r){this.fileStorage=new u(i.join(t.userDataPath,e.STATE_FILE),e=>r.error(e))}init(){return this.fileStorage.init()}getItem(e,t){return this.fileStorage.getItem(e,t)}setItem(e,t){this.fileStorage.setItem(e,t)}removeItem(e){this.fileStorage.removeItem(e)}};h.STATE_FILE="storage.json",h=s([o(0,n.INativeEnvironmentService),o(1,c.ILogService)],h),t.StateService=h})),define(t[169],i([0,1,4,6,2,11]),(function(e,t,i,r,n,s){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),
t.logStorage=t.InMemoryStorageService=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker",t.IStorageService=i.createDecorator("storageService"),function(e){e[e.NONE=0]="NONE",e[e.SHUTDOWN=1]="SHUTDOWN"}(o=t.WillSaveStateReason||(t.WillSaveStateReason={})),function(e){e[e.GLOBAL=0]="GLOBAL",e[e.WORKSPACE=1]="WORKSPACE"}(t.StorageScope||(t.StorageScope={}));class a extends n.Disposable{constructor(){super(...arguments),this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.globalCache=new Map,this.workspaceCache=new Map}getCache(e){return 0===e?this.globalCache:this.workspaceCache}get(e,t,i){const r=this.getCache(t).get(e);return s.isUndefinedOrNull(r)?i:r}getBoolean(e,t,i){const r=this.getCache(t).get(e);return s.isUndefinedOrNull(r)?i:"true"===r}getNumber(e,t,i){
const r=this.getCache(t).get(e);return s.isUndefinedOrNull(r)?i:parseInt(r,10)}store(e,t,i){if(s.isUndefinedOrNull(t))return this.remove(e,i);const r=String(t);return this.getCache(i).get(e)===r?Promise.resolve():(this.getCache(i).set(e,r),this._onDidChangeStorage.fire({scope:i,key:e}),Promise.resolve())}remove(e,t){return this.getCache(t).delete(e)?(this._onDidChangeStorage.fire({scope:t,key:e}),Promise.resolve()):Promise.resolve()}logStorage(){l(this.globalCache,this.workspaceCache,"inMemory","inMemory")}async migrate(e){}flush(){this._onWillSaveState.fire({reason:o.NONE})}isNew(){return!0}async close(){}}async function l(e,t,i,r){const n=e=>{try{return JSON.parse(e)}catch(t){return e}},s=new Map,o=new Map;e.forEach((e,t)=>{s.set(t,e),o.set(t,n(e))});const a=new Map,l=new Map;t.forEach((e,t)=>{a.set(t,e),l.set(t,n(e))}),console.group(`Storage: Global (path: ${i})`);let c=[];s.forEach((e,t)=>{c.push({key:t,value:e})}),console.table(c),console.groupEnd(),console.log(o),
console.group(`Storage: Workspace (path: ${r})`);let u=[];a.forEach((e,t)=>{u.push({key:t,value:e})}),console.table(u),console.groupEnd(),console.log(l)}t.InMemoryStorageService=a,t.logStorage=l})),define(t[170],i([0,1,19,14,2,20]),(function(e,t,i,r,n,s){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.ErrorEvent=void 0,function(e){e.compare=function(e,t){return e.callstack<t.callstack?-1:e.callstack>t.callstack?1:0}}(o=t.ErrorEvent||(t.ErrorEvent={}));class a{constructor(e,t=a.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new n.DisposableStore,this._telemetryService=e,this._flushDelay=t;const i=r.errorHandler.addListener(e=>this._onErrorEvent(e));this._disposables.add(n.toDisposable(i)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(e){if(!e)return;e.detail&&e.detail.stack&&(e=e.detail)
;let t=Array.isArray(e.stack)?e.stack.join("\n"):e.stack,i=e.message?e.message:s.safeStringify(e);t&&this._enqueue({msg:i,callstack:t})}_enqueue(e){const t=i.binarySearch(this._buffer,e,o.compare);t<0?(e.count=1,this._buffer.splice(~t,0,e)):(this._buffer[t].count||(this._buffer[t].count=0),this._buffer[t].count+=1),-1===this._flushHandle&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let e of this._buffer)this._telemetryService.publicLogError2("UnhandledError",e);this._buffer.length=0}}t.default=a,a.ERROR_FLUSH_TIMEOUT=5e3})),define(t[171],i([0,1,2,5,170]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class s extends n.default{installErrorListeners(){let e,t=this;"function"==typeof r.globals.onerror&&(e=r.globals.onerror),r.globals.onerror=function(i,r,n,s,o){t._onUncaughtError(i,r,n,s,o),e&&e.apply(this,arguments)},this._disposables.add(i.toDisposable(()=>{e&&(r.globals.onerror=e)}))}
_onUncaughtError(e,t,i,r,n){let s={callstack:e,msg:e,file:t,line:i,column:r};if(n){let{name:e,message:t,stack:i}=n;s.uncaught_error_name=e,t&&(s.uncaught_error_msg=t),i&&(s.callstack=Array.isArray(n.stack)?n.stack=n.stack.join("\n"):n.stack)}this._enqueue(s)}}t.default=s})),define(t[48],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ITelemetryService=void 0,t.ITelemetryService=i.createDecorator("telemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"})),define(t[78],i([0,1,14,31,32,20,48,58,53,22,23,13,24,7,47,169,166,4,18]),(function(e,t,i,r,n,a,l,c,u,h,d,f,p,g,m,v,y,E,w){"use strict";var _,b
;Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0,function(e){e[e.None=0]="None",e[e.IncludeVersions=1]="IncludeVersions",e[e.IncludeFiles=2]="IncludeFiles",e[e.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",e[e.IncludeSharedAccounts=8]="IncludeSharedAccounts",e[e.IncludeVersionProperties=16]="IncludeVersionProperties",e[e.ExcludeNonValidated=32]="ExcludeNonValidated",e[e.IncludeInstallationTargets=64]="IncludeInstallationTargets",e[e.IncludeAssetUri=128]="IncludeAssetUri",e[e.IncludeStatistics=256]="IncludeStatistics",e[e.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",e[e.Unpublished=4096]="Unpublished"}(_||(_={})),function(e){e[e.Tag=1]="Tag",e[e.ExtensionId=4]="ExtensionId",e[e.Category=5]="Category",e[e.ExtensionName=7]="ExtensionName",e[e.Target=8]="Target",e[e.Featured=9]="Featured",e[e.SearchText=10]="SearchText",e[e.ExcludeWithFlags=12]="ExcludeWithFlags"}(b||(b={}));const S={
Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},C={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},x={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:_.None,criteria:[],assetTypes:[]};class I{constructor(e=x){this.state=e}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}
withPage(e,t=this.state.pageSize){return new I(Object.assign(Object.assign({},this.state),{pageNumber:e,pageSize:t}))}withFilter(e,...t){const i=[...this.state.criteria,...t.length?t.map(t=>({filterType:e,value:t})):[{filterType:e}]];return new I(Object.assign(Object.assign({},this.state),{criteria:i}))}withSortBy(e){return new I(Object.assign(Object.assign({},this.state),{sortBy:e}))}withSortOrder(e){return new I(Object.assign(Object.assign({},this.state),{sortOrder:e}))}withFlags(...e){return new I(Object.assign(Object.assign({},this.state),{flags:e.reduce((e,t)=>e|t,0)}))}withAssetTypes(...e){return new I(Object.assign(Object.assign({},this.state),{assetTypes:e}))}get raw(){const{criteria:e,pageNumber:t,pageSize:i,sortBy:r,sortOrder:n,flags:s,assetTypes:o}=this.state;return{filters:[{criteria:e,pageNumber:t,pageSize:i,sortBy:r,sortOrder:n}],assetTypes:o,flags:s}}get searchText(){const e=this.state.criteria.filter(e=>e.filterType===b.SearchText)[0];return e&&e.value?e.value:""}}function P(e,t){
const i=(e||[]).filter(e=>e.statisticName===t)[0];return i?i.value:0}function T(e){return e.files.filter(e=>0===e.assetType.indexOf("Microsoft.VisualStudio.Code.Translation.")).reduce((t,i)=>{const r=D(e,i.assetType);return r&&t.push([i.assetType.substring("Microsoft.VisualStudio.Code.Translation.".length),r]),t},[])}function k(e){if(e.properties){const t=e.properties.filter(e=>e.key===S.Repository),i=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),r=t.filter(e=>i.test(e.value))[0];return r?{uri:r.value,fallbackUri:r.value}:null}return D(e,S.Repository)}function L(e){return{uri:`${e.fallbackAssetUri}/${S.VSIX}?redirect=true`,fallbackUri:`${e.fallbackAssetUri}/${S.VSIX}`}}function O(e){const t=D(e,S.Icon);if(t)return t;const i=r.DefaultIconPath;return{uri:i,fallbackUri:i}}function D(e,t){return e.files.filter(e=>e.assetType===t)[0]?{uri:`${e.assetUri}/${t}`,fallbackUri:`${e.fallbackAssetUri}/${t}`}:null}function R(e,t){
const i=e.properties?e.properties.filter(e=>e.key===t):[],r=i.length>0&&i[0].value;return r?r.split(",").map(e=>n.adoptToGalleryExtensionId(e)):[]}function A(e){const t=e.properties?e.properties.filter(e=>e.key===C.Engine):[];return t.length>0&&t[0].value||""}function F(e){const t=e.properties?e.properties.filter(e=>e.key===C.LocalizedLanguages):[],i=t.length>0&&t[0].value||"";return i?i.split(","):[]}function N(e){const t=e.properties?e.properties.find(e=>e.key===C.WebExtension):void 0;return!!t&&"true"===t.value}function M(e){return e.files.some(e=>e.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?w.joinPath(g.URI.parse(e.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function U(e,t,i,r,s){const o={manifest:D(t,S.Manifest),readme:D(t,S.Details),changelog:D(t,S.Changelog),license:D(t,S.License),repository:k(t),download:L(t),icon:O(t),coreTranslations:T(t)};return{identifier:{id:n.getGalleryExtensionId(e.publisher.publisherName,e.extensionName),uuid:e.extensionId},
name:e.extensionName,version:t.version,date:t.lastUpdated,displayName:e.displayName,publisherId:e.publisher.publisherId,publisher:e.publisher.publisherName,publisherDisplayName:e.publisher.displayName,description:e.shortDescription||"",installCount:P(e.statistics,"install"),rating:P(e.statistics,"averagerating"),ratingCount:P(e.statistics,"ratingcount"),assetUri:g.URI.parse(t.assetUri),webResource:M(t),assetTypes:t.files.map(({assetType:e})=>e),assets:o,properties:{dependencies:R(t,C.Dependency),extensionPack:R(t,C.ExtensionPack),engine:A(t),localizedLanguages:F(t),webExtension:N(t)},telemetryData:{index:(r.pageNumber-1)*r.pageSize+i,searchText:r.searchText,querySource:s},preview:(a=e.flags,-1!==a.indexOf("preview"))};var a}let j=class{constructor(e,t,i,r,n,s,o){this.requestService=e,this.logService=t,this.environmentService=i,this.telemetryService=r,this.fileService=n,this.productService=s;const a=s.extensionsGallery;this.extensionsGalleryUrl=a&&a.serviceUrl,this.extensionsControlUrl=a&&a.controlUrl,
this.commonHeadersPromise=z(s.version,this.environmentService,this.fileService,o)}api(e=""){return`${this.extensionsGalleryUrl}${e}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(e,t){const i=[];let{total:r,firstPage:n,getPage:s}=await this.query({names:e,pageSize:e.length},t);i.push(...n);for(let e=1;i.length<r&&(n=await s(e,t)).length;e++)i.push(...n);return i}async getCompatibleExtension(e,t){const i=await this.getCompatibleExtensionByEngine(e,t);return(null==i?void 0:i.properties.webExtension)?i.webResource?i:null:i}async getCompatibleExtensionByEngine(e,t){const i=r.isIExtensionIdentifier(e)?null:e;if(i&&i.properties.engine&&u.isEngineValid(i.properties.engine,this.productService.version))return i;const{id:n,uuid:s}=i?i.identifier:e;let o=(new I).withFlags(_.IncludeAssetUri,_.IncludeStatistics,_.IncludeFiles,_.IncludeVersionProperties).withPage(1,1).withFilter(b.Target,"Microsoft.VisualStudio.Code");o=s?o.withFilter(b.ExtensionId,s):o.withFilter(b.ExtensionName,n)
;const{galleryExtensions:a}=await this.queryGallery(o,d.CancellationToken.None),[l]=a;if(!l||!l.versions.length)return null;if(t){const e=l.versions.filter(e=>e.version===t)[0];if(e){const t=U(l,e,0,o);if(t.properties.engine&&u.isEngineValid(t.properties.engine,this.productService.version))return t}return null}const c=await this.getLastValidExtensionVersion(l,l.versions);return c?U(l,c,0,o):null}async query(e,t){const r=d.CancellationToken.isCancellationToken(e)?{}:e,n=d.CancellationToken.isCancellationToken(e)?e:t;if(!this.isEnabled())throw new Error("No extension gallery service configured.");const s=r.names?"ids":r.text?"text":"all";let o=r.text||"";const l=a.getOrDefault(r,e=>e.pageSize,50);this.telemetryService.publicLog2("galleryService:query",{type:s,text:o});let c=(new I).withFlags(_.IncludeLatestVersionOnly,_.IncludeAssetUri,_.IncludeStatistics,_.IncludeFiles,_.IncludeVersionProperties).withPage(1,l).withFilter(b.Target,"Microsoft.VisualStudio.Code")
;o?((o=(o=(o=(o=o.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(e,t,i)=>(c=c.withFilter(b.Category,i||t),""))).replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(e,t,i)=>(c=c.withFilter(b.Tag,i||t),""))).replace(/\bfeatured(\s+|\b|$)/g,()=>(c=c.withFilter(b.Featured),""))).trim())&&(o=o.length<200?o:o.substring(0,200),c=c.withFilter(b.SearchText,o)),c=c.withSortBy(0)):c=r.ids?c.withFilter(b.ExtensionId,...r.ids):r.names?c.withFilter(b.ExtensionName,...r.names):c.withSortBy(4),"number"==typeof r.sortBy&&(c=c.withSortBy(r.sortBy)),"number"==typeof r.sortOrder&&(c=c.withSortOrder(r.sortOrder));const{galleryExtensions:u,total:h}=await this.queryGallery(c,n);return{firstPage:u.map((e,t)=>U(e,e.versions[0],t,c,r.source)),total:h,pageSize:c.pageSize,getPage:async(e,t)=>{if(t.isCancellationRequested)throw i.canceled();const n=c.withPage(e+1),{galleryExtensions:s}=await this.queryGallery(n,t);return s.map((e,t)=>U(e,e.versions[0],t,n,r.source))}}}async queryGallery(e,t){
if(!this.isEnabled())throw new Error("No extension gallery service configured.");e=e.withFlags(e.flags,_.ExcludeNonValidated).withFilter(b.ExcludeWithFlags,function(...e){return String(e.reduce((e,t)=>e|t,0))}(_.Unpublished));const i=await this.commonHeadersPromise,r=JSON.stringify(e.raw),n=Object.assign(Object.assign({},i),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(r.length)}),s=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:r,headers:n},t);if(s.res.statusCode&&s.res.statusCode>=400&&s.res.statusCode<500)return{galleryExtensions:[],total:0};const o=await c.asJson(s);if(o){const e=o.results[0],t=e.extensions,i=e.resultMetadata&&e.resultMetadata.filter(e=>"ResultCount"===e.metadataType)[0];return{galleryExtensions:t,total:i&&i.metadataItems.filter(e=>"TotalCount"===e.name)[0].count||0}}return{galleryExtensions:[],total:0}}async reportStatistic(e,t,i,r){if(!this.isEnabled())return
;const n=await this.commonHeadersPromise,s=Object.assign(Object.assign({},n),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${e}/extensions/${t}/${i}/stats?statType=${r}`),headers:s},d.CancellationToken.None)}catch(e){}}async download(e,t,i){this.logService.trace("ExtensionGalleryService#download",e.identifier.id);const r=n.getGalleryExtensionTelemetryData(e),s=(new Date).getTime(),o=1===i?"install":2===i?"update":"",a=o?{uri:`${e.assets.download.uri}&${o}=true`,fallbackUri:`${e.assets.download.fallbackUri}?${o}=true`}:e.assets.download,l=await this.getAsset(a);await this.fileService.writeFile(t,l.stream),(e=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},r),{duration:e})))((new Date).getTime()-s)}async getReadme(e,t){if(e.assets.readme){const i=await this.getAsset(e.assets.readme,{},t);return await c.asText(i)||""}return""}async getManifest(e,t){if(e.assets.manifest){
const i=await this.getAsset(e.assets.manifest,{},t),r=await c.asText(i);return r?JSON.parse(r):null}return null}async getCoreTranslation(e,t){const i=e.assets.coreTranslations.filter(e=>e[0]===t.toUpperCase())[0];if(i){const e=await this.getAsset(i[1]),t=await c.asText(e);return t?JSON.parse(t):null}return null}async getChangelog(e,t){if(e.assets.changelog){const i=await this.getAsset(e.assets.changelog,{},t);return await c.asText(i)||""}return""}async getAllVersions(e,t){let i=(new I).withFlags(_.IncludeVersions,_.IncludeFiles,_.IncludeVersionProperties).withPage(1,1).withFilter(b.Target,"Microsoft.VisualStudio.Code");i=e.identifier.uuid?i.withFilter(b.ExtensionId,e.identifier.uuid):i.withFilter(b.ExtensionName,e.identifier.id);const r=[],{galleryExtensions:n}=await this.queryGallery(i,d.CancellationToken.None);return n.length&&(t?await Promise.all(n[0].versions.map(async e=>{let t;try{t=await this.getEngine(e)}catch(e){}t&&u.isEngineValid(t,this.productService.version)&&r.push({version:e.version,
date:e.lastUpdated})})):r.push(...n[0].versions.map(e=>({version:e.version,date:e.lastUpdated})))),r}async getAsset(e,t={},r=d.CancellationToken.None){const n=await this.commonHeadersPromise,s=Object.assign(Object.assign({},n),t.headers||{});t=Object.assign(Object.assign(Object.assign({},t),{type:"GET"}),{headers:s});const o=e.uri,a=e.fallbackUri,l=Object.assign(Object.assign({},t),{url:o});try{const e=await this.requestService.request(l,r);if(200===e.res.statusCode)return e;const t=await c.asText(e);throw new Error(`Expected 200, got back ${e.res.statusCode} instead.\n\n${t}`)}catch(e){if(i.isPromiseCanceledError(e))throw e;const n=i.getErrorMessage(e);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:o,message:n});const s=Object.assign(Object.assign({},t),{url:a});return this.requestService.request(s,r)}}async getLastValidExtensionVersion(e,t){const i=this.getLastValidExtensionVersionFromProperties(e,t);return i||this.getLastValidExtensionVersionRecursively(e,t)}
getLastValidExtensionVersionFromProperties(e,t){for(const e of t){const t=A(e);if(!t)return null;if(u.isEngineValid(t,this.productService.version))return e}return null}async getEngine(e){const t=A(e);if(t)return t;const i=D(e,S.Manifest);if(!i)throw new Error("Manifest was not found");const r=await this.getAsset(i,{headers:{"Accept-Encoding":"gzip"}}),n=await c.asJson(r);if(n)return n.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(e,t){if(!t.length)return null;const i=t[0],r=await this.getEngine(i);return u.isEngineValid(r,this.productService.version)?(i.properties=i.properties||[],i.properties.push({key:C.Engine,value:r}),i):this.getLastValidExtensionVersionRecursively(e,t.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const e=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},d.CancellationToken.None)
;if(200!==e.res.statusCode)throw new Error("Could not get extensions report.");const t=await c.asJson(e),i=new Map;if(t)for(const e of t.malicious){const t=i.get(e)||{id:{id:e},malicious:!0,slow:!1};t.malicious=!0,i.set(e,t)}return[...i.values()]}};async function z(e,t,i,r){const n={"X-Market-Client-Id":`VSCode ${e}`,"User-Agent":`VSCode ${e}`},s=await y.getServiceMachineId(t,i,r);return n["X-Market-User-Id"]=s,n}j=s([o(0,c.IRequestService),o(1,f.ILogService),o(2,h.IEnvironmentService),o(3,l.ITelemetryService),o(4,p.IFileService),o(5,m.IProductService),o(6,E.optional(v.IStorageService))],j),t.ExtensionGalleryService=j,t.resolveMarketplaceHeaders=z})),define(t[79],i([0,1,28,130,16,4,30,40,2,20,29]),(function(e,t,i,r,n,a,l,c,u,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let f=class{constructor(e,t){this._configurationService=t,this._experimentProperties={},this._disposables=new u.DisposableStore,this._cleanupPatterns=[],this._appender=e.appender,
this._commonProperties=e.commonProperties||Promise.resolve({}),this._piiPaths=e.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!e.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let e of this._piiPaths)this._cleanupPatterns.push(new RegExp(n.escapeRegExpCharacters(e),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(e=>{const t=/^[a-f0-9]+$/i.test(e["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!t})}))}setExperimentProperty(e,t){this._experimentProperties[e]=t}setEnabled(e){this._enabled=e}_updateUserOptIn(){var e;const t=null===(e=this._configurationService)||void 0===e?void 0:e.getValue(p);this._userOptIn=t?t.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){
const e=await this._commonProperties;return{sessionId:e.sessionID,instanceId:e["common.instanceId"],machineId:e["common.machineId"],msftInternal:e["common.msftInternal"]}}dispose(){this._disposables.dispose()}publicLog(e,t,i){return this.isOptedIn?this._commonProperties.then(r=>{t=h.mixin(t,r),t=h.mixin(t,this._experimentProperties),t=h.cloneAndChange(t,e=>{if("string"==typeof e)return this._cleanupInfo(e,i)}),this._appender.log(e,t)},e=>{console.error(e)}):Promise.resolve(void 0)}publicLog2(e,t,i){return this.publicLog(e,t,i)}publicLogError(e,t){return this.sendErrorTelemetry?this.publicLog(e,t,!0):Promise.resolve(void 0)}publicLogError2(e,t){return this.publicLogError(e,t)}_cleanupInfo(e,t){let i=e;if(t){const t=[];for(let i of this._cleanupPatterns)for(;;){const r=i.exec(e);if(!r)break;t.push([r.index,i.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(i="";;){const o=n.exec(e)
;if(!o)break;!r.test(o[0])&&t.every(([e,t])=>o.index<e||o.index>=t)&&(i+=e.substring(s,o.index)+"<REDACTED: user-file-path>",s=n.lastIndex)}s<e.length&&(i+=e.substr(s))}for(let e of this._cleanupPatterns)i=i.replace(e,"");return i}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=s([o(1,a.optional(l.IConfigurationService))],f),t.TelemetryService=f;const p="telemetry";d.Registry.as(c.Extensions.Configuration).registerConfiguration({id:p,order:110,type:"object",title:r.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:i.default.privacyStatementUrl?r.localize(2,null,i.default.privacyStatementUrl):r.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})})),define(t[49],i([0,1,30,20,11]),(function(e,t,i,r,n){"use strict";function s(e){if(!e)return[];const t=[];return function e(t,i,r){r&&"object"==typeof r&&!Array.isArray(r)?Object.keys(r).forEach(n=>e(t,i?`${i}.${n}`:n,r[n])):t.push(i)}(t,"",e),t}Object.defineProperty(t,"__esModule",{
value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(e,t){return Promise.resolve(void 0)}publicLog2(e,t){return this.publicLog(e,t)}publicLogError(e,t){return Promise.resolve(void 0)}publicLogError2(e,t){return this.publicLogError(e,t)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})}},t.combinedAppender=function(...e){return{log:(t,i)=>e.forEach(e=>e.log(t,i)),flush:()=>Promise.all(e.map(e=>e.flush()))}},t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)},t.configurationTelemetry=function(e,t){return t.onDidChangeConfiguration(t=>{6!==t.source&&e.publicLog2("updateConfiguration",{configurationSource:i.ConfigurationTargetToString(t.source),configurationKeys:s(t.sourceConfig)})
})},t.validateTelemetryData=function(e){const t=Object.create(null),i=Object.create(null),s=Object.create(null);!function e(t,i,s=0,o){if(!t)return;for(let a of Object.getOwnPropertyNames(t)){const l=t[a],c=o?o+a:a;Array.isArray(l)?i[c]=r.safeStringify(l):l instanceof Date?i[c]=l.toISOString():n.isObject(l)?s<2?e(l,i,s+1,c+"."):i[c]=r.safeStringify(l):i[c]=l}}(e,s);for(let e in s){const r=s[e=e.length>150?e.substr(e.length-149):e];"number"==typeof r?i[e]=r:"boolean"==typeof r?i[e]=r?1:0:"string"==typeof r?t[e]=r.substring(0,1023):null!=r&&(t[e]=r)}return{properties:t,measurements:i}},t.cleanRemoteAuthority=function(e){if(!e)return"none";let t="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(i=>{0===e.indexOf(`${i}+`)&&(t=i)}),t}})),define(t[172],i([0,1,2,22,13,49]),(function(e,t,i,r,n,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryLogAppender=void 0;let l=class extends i.Disposable{constructor(e,t){super(),
this.logger=this._register(e.getLogger(t.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(e,t){this.logger.trace(`telemetry/${e}`,a.validateTelemetryData(t))}};l=s([o(0,n.ILoggerService),o(1,r.IEnvironmentService)],l),t.TelemetryLogAppender=l})),define(t[80],i([0,1,204,20,49]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;t.AppInsightsAppender=class{constructor(e,t,r){this._eventPrefix=e,this._defaultData=t,this._defaultData||(this._defaultData=Object.create(null)),"string"==typeof r?this._aiClient=function(e){let t
;return i.defaultClient?(t=new i.TelemetryClient(e)).channel.setUseDiskRetryCaching(!0):(i.setup(e).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),t=i.defaultClient),0===e.indexOf("AIF-")&&(t.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),t}(r):"function"==typeof r&&(this._aiClient=r())}log(e,t){this._aiClient&&(t=r.mixin(t,this._defaultData),t=n.validateTelemetryData(t),this._aiClient.trackEvent({name:this._eventPrefix+"/"+e,properties:t.properties,measurements:t.measurements}))}flush(){return this._aiClient?new Promise(e=>{this._aiClient.flush({callback:()=>{this._aiClient=void 0,e(void 0)}})}):Promise.resolve(void 0)}}})),define(t[81],i([0,1,5,27,26,12]),(function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0,
t.resolveCommonProperties=async function(e,t,o,a,l,c){const u=Object.create(null);u["common.machineId"]=o,u.sessionID=n.generateUuid()+Date.now(),u.commitHash=e,u.version=t,u["common.platformVersion"]=(r.release()||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=i.PlatformToString(i.platform),u["common.nodePlatform"]=process.platform,u["common.nodeArch"]=process.arch,u["common.product"]=c||"desktop";const h=function(e){if(!process||!process.env||!process.env.USERDNSDOMAIN)return!1;const t=process.env.USERDNSDOMAIN.toLowerCase();return e.some(e=>t===e)}(a||[]);h&&(u["common.msftInternal"]=h);let d=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),"linux"===process.platform&&process.env.SNAP&&process.env.SNAP_REVISION&&(u["common.snap"]="true");try{const e=await s.readFile(l,"utf8");u["common.source"]=e.slice(0,30)}catch(e){}return u
}})),define(t[173],i([0,1,12,21,3]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0,t.buildTelemetryMessage=function(e,t){const s=Object.create(null),o=(e,t)=>{const i=JSON.parse(e);s[t]=i};if(t){const e=i.readdirSync(t).filter(e=>{try{return r.statSync(n.join(t,e)).isDirectory()}catch(e){return!1}}),s=[];e.forEach(e=>{1===i.readdirSync(n.join(t,e)).filter(e=>"telemetry.json"===e).length&&s.push(e)}),s.forEach(e=>{const i=r.readFileSync(n.join(t,e,"telemetry.json")).toString();o(i,e)})}let a=r.readFileSync(n.join(e,"telemetry-core.json")).toString();return o(a,"vscode-core"),a=r.readFileSync(n.join(e,"telemetry-extensions.json")).toString(),o(a,"vscode-extensions"),JSON.stringify(s,null,4)}})),define(t[174],i([0,1,4,131,7,5,3,18,94,36,10,43,33,162]),(function(e,t,i,r,n,s,o,a,l,c,u,h,d,f){"use strict";function p(e){return e.hasOwnProperty("folderUri")}function g(e){return m(e)||v(e)}function m(e){
return e&&"object"==typeof e&&"string"==typeof e.path&&(!e.name||"string"==typeof e.name)}function v(e){return e&&"object"==typeof e&&"string"==typeof e.uri&&(!e.name||"string"==typeof e.name)}function y(e){return e instanceof n.URI}Object.defineProperty(t,"__esModule",{value:!0}),t.toStoreData=t.restoreRecentlyOpened=t.useSlashForPath=t.rewriteWorkspaceFileForNewLocation=t.getStoredWorkspaceFolder=t.hasWorkspaceFileExtension=t.isSingleFolderWorkspaceInitializationPayload=t.isUntitledWorkspace=t.toWorkspaceIdentifier=t.isWorkspaceIdentifier=t.isSingleFolderWorkspaceIdentifier=t.isRawUriWorkspaceFolder=t.isRawFileWorkspaceFolder=t.isStoredWorkspaceFolder=t.reviveWorkspaceIdentifier=t.isRecentFile=t.isRecentFolder=t.isRecentWorkspace=t.IWorkspacesService=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_EXTENSION=void 0,t.WORKSPACE_EXTENSION="code-workspace",t.WORKSPACE_FILTER=[{name:r.localize(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json",
t.IWorkspacesService=i.createDecorator("workspacesService"),t.isRecentWorkspace=function(e){return e.hasOwnProperty("workspace")},t.isRecentFolder=p,t.isRecentFile=function(e){return e.hasOwnProperty("fileUri")},t.reviveWorkspaceIdentifier=function(e){return{id:e.id,configPath:n.URI.revive(e.configPath)}},t.isStoredWorkspaceFolder=g,t.isRawFileWorkspaceFolder=m,t.isRawUriWorkspaceFolder=v,t.isSingleFolderWorkspaceIdentifier=y,t.isWorkspaceIdentifier=function(e){const t=e;return t&&"string"==typeof t.id&&t.configPath instanceof n.URI},t.toWorkspaceIdentifier=function(e){return e.configuration?{configPath:e.configuration,id:e.id}:1===e.folders.length?e.folders[0].uri:void 0},t.isUntitledWorkspace=function(e,t){return a.extUriBiasedIgnorePathCase.isEqualOrParent(e,t.untitledWorkspacesHome)},t.isSingleFolderWorkspaceInitializationPayload=function(e){return y(e.folder)};const E="."+t.WORKSPACE_EXTENSION;t.hasWorkspaceFileExtension=function(e){return("string"==typeof e?o.extname(e):a.extname(e))===E};const w="/"
;function _(e,t,i,r,n=!s.isWindows){if(e.scheme!==r.scheme)return{name:i,uri:e.toString(!0)};let o=t?void 0:a.relativePath(r,e);if(void 0!==o)0===o.length?o=".":s.isWindows&&e.scheme===u.Schemas.file&&!n&&(o=o.replace(/\//g,"\\"));else if(e.scheme===u.Schemas.file)o=e.fsPath,s.isWindows&&(o=h.normalizeDriveLetter(o),n&&(o=d.toSlashes(o)));else{if(!a.isEqualAuthority(e.authority,r.authority))return{name:i,uri:e.toString(!0)};o=e.path}return{name:i,path:o}}function b(e){return!s.isWindows||e.some(e=>m(e)&&e.path.indexOf(w)>=0)}t.getStoredWorkspaceFolder=_,t.rewriteWorkspaceFileForNewLocation=function(e,t,i,r){let u=function(e,t){let i=c.parse(t);if(!i||!Array.isArray(i.folders))throw new Error(`${e} looks like an invalid workspace file.`);i.folders=i.folders.filter(e=>g(e));return i}(t,e);const h=a.dirname(t),d=a.dirname(r),p=[],v=b(u.folders);for(const e of u.folders){const t=m(e)?a.resolvePath(h,e.path):n.URI.parse(e.uri);let r;r=!i&&(!m(e)||o.isAbsolute(e.path)),p.push(_(t,r,e.name,d,v))}const y={
insertSpaces:!1,tabSize:4,eol:s.isLinux||s.isMacintosh?"\n":"\r\n"},E=l.setProperty(e,["folders"],p,y);let w=l.applyEdits(e,E);return u.remoteAuthority===f.getRemoteAuthority(r)&&(w=l.applyEdits(w,l.removeProperty(w,["remoteAuthority"],y))),w},t.useSlashForPath=b,t.restoreRecentlyOpened=function(e,t){const i={workspaces:[],files:[]};if(e){const r=function(e,i){for(let r=0;r<e.length;r++)try{i(e[r],r)}catch(i){t.warn(`Error restoring recent entry ${JSON.stringify(e[r])}: ${i.toString()}. Skip entry.`)}},s=e;Array.isArray(s.workspaces3)&&r(s.workspaces3,(e,t)=>{const r=Array.isArray(s.workspaceLabels)&&s.workspaceLabels[t]||void 0;"object"==typeof e&&"string"==typeof e.id&&"string"==typeof e.configURIPath?i.workspaces.push({label:r,workspace:{id:e.id,configPath:n.URI.parse(e.configURIPath)}}):"string"==typeof e&&i.workspaces.push({label:r,folderUri:n.URI.parse(e)})}),Array.isArray(s.files2)&&r(s.files2,(e,t)=>{const r=Array.isArray(s.fileLabels)&&s.fileLabels[t]||void 0;"string"==typeof e&&i.files.push({
label:r,fileUri:n.URI.parse(e)})})}return i},t.toStoreData=function(e){const t={workspaces3:[],files2:[]};let i=!1;const r=[];for(const n of e.workspaces)p(n)?t.workspaces3.push(n.folderUri.toString()):t.workspaces3.push({id:n.workspace.id,configURIPath:n.workspace.configPath.toString()}),r.push(n.label||null),i=i||!!n.label;i&&(t.workspaceLabels=r),i=!1;const n=[];for(const r of e.files)t.files2.push(r.fileUri.toString()),n.push(r.label||null),i=i||!!r.label;return i&&(t.fileLabels=n),t}})),define(t[175],i([0,1,7,18,4,25,174]),(function(e,t,i,r,n,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toWorkspaceFolders=t.toWorkspaceFolder=t.WorkspaceFolder=t.Workspace=t.IWorkspaceFolder=t.IWorkspace=t.WorkbenchState=t.IWorkspaceContextService=void 0,t.IWorkspaceContextService=n.createDecorator("contextService"),function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"}(t.WorkbenchState||(t.WorkbenchState={})),function(e){e.isIWorkspace=function(e){
return!(!e||"object"!=typeof e||"string"!=typeof e.id||!Array.isArray(e.folders))}}(t.IWorkspace||(t.IWorkspace={})),function(e){e.isIWorkspaceFolder=function(e){return!(!e||"object"!=typeof e||!i.URI.isUri(e.uri)||"string"!=typeof e.name||"function"!=typeof e.toResource)}}(t.IWorkspaceFolder||(t.IWorkspaceFolder={}));t.Workspace=class{constructor(e,t=[],i=null){this._id=e,this._configuration=i,this._foldersMap=s.TernarySearchTree.forUris(),this.folders=t}update(e){this._id=e.id,this._configuration=e.configuration,this.folders=e.folders}get folders(){return this._folders}set folders(e){this._folders=e,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(e){this._configuration=e}getFolder(e){return e&&this._foldersMap.findSubstr(e.with({scheme:e.scheme,authority:e.authority,path:e.path}))||null}updateFoldersMap(){this._foldersMap=s.TernarySearchTree.forUris();for(const e of this.folders)this._foldersMap.set(e.uri,e)}toJSON(){return{id:this.id,
folders:this.folders,configuration:this.configuration}}};class a{constructor(e,t){this.raw=t,this.uri=e.uri,this.index=e.index,this.name=e.name}toResource(e){return r.joinPath(this.uri,e)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=a,t.toWorkspaceFolder=function(e){return new a({uri:e,index:0,name:r.basenameOrAuthority(e)},{uri:e.toString()})},t.toWorkspaceFolders=function(e,t){let n=[],s=new Set;const l=r.dirname(t);for(let t of e){let e=null;if(o.isRawFileWorkspaceFolder(t))t.path&&(e=r.resolvePath(l,t.path));else if(o.isRawUriWorkspaceFolder(t))try{"/"!==(e=i.URI.parse(t.uri)).path[0]&&(e=e.with({path:"/"+e.path}))}catch(e){console.warn(e)}if(e){let i=r.getComparisonKey(e);if(!s.has(i)){s.add(i);const o=t.name||r.basenameOrAuthority(e);n.push(new a({uri:e,name:o,index:n.length},t))}}}return n}})),define(t[176],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeProxyChannelClient=t.NodeProxyChannel=t.INodeProxyService=void 0,
t.INodeProxyService=i.createDecorator("nodeProxyService");t.NodeProxyChannel=class{constructor(e){this.service=e}listen(e,t){switch(t){case"onMessage":return this.service.onMessage}throw new Error(`Invalid listen ${t}`)}async call(e,t,i){switch(t){case"send":return this.service.send(i[0])}throw new Error(`Invalid call ${t}`)}};t.NodeProxyChannelClient=class{constructor(e){this.channel=e,this.onMessage=this.channel.listen("onMessage")}send(e){this.channel.call("send",[e])}}})),define(t[177],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryChannelClient=t.TelemetryChannel=void 0;t.TelemetryChannel=class{constructor(e){this.service=e}listen(e,t){throw new Error(`Invalid listen ${t}`)}call(e,t,i){switch(t){case"publicLog":return this.service.publicLog(i[0],i[1],i[2]);case"publicLog2":return this.service.publicLog2(i[0],i[1],i[2]);case"publicLogError":return this.service.publicLogError(i[0],i[1]);case"publicLogError2":return this.service.publicLogError2(i[0],i[1])
;case"setEnabled":return Promise.resolve(this.service.setEnabled(i[0]));case"getTelemetryInfo":return this.service.getTelemetryInfo();case"setExperimentProperty":return Promise.resolve(this.service.setExperimentProperty(i[0],i[1]))}throw new Error(`Invalid call ${t}`)}};t.TelemetryChannelClient=class{constructor(e){this.channel=e,this.isOptedIn=!0,this.sendErrorTelemetry=!0}publicLog(e,t,i){return this.channel.call("publicLog",[e,t,i])}publicLog2(e,t,i){return this.channel.call("publicLog2",[e,t,i])}publicLogError(e,t){return this.channel.call("publicLogError",[e,t])}publicLogError2(e,t){return this.channel.call("publicLogError2",[e,t])}setEnabled(e){this.channel.call("setEnable",[e])}getTelemetryInfo(){return this.channel.call("getTelemetryInfo")}setExperimentProperty(e,t){this.channel.call("setExperimentProperty",[e,t])}}})),define(t[178],i([0,1,205,206,27]),(function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryClient=void 0;class s{get _sender(){
throw new Error("unimplemented")}get _buffer(){throw new Error("unimplemented")}setUseDiskRetryCaching(){throw new Error("unimplemented")}send(){throw new Error("unimplemented")}triggerSend(){throw new Error("unimplemented")}}t.TelemetryClient=class{constructor(){this.context=void 0,this.commonProperties=void 0,this.config={},this.channel=new s}addTelemetryProcessor(){throw new Error("unimplemented")}clearTelemetryProcessors(){throw new Error("unimplemented")}runTelemetryProcessors(){throw new Error("unimplemented")}trackTrace(){throw new Error("unimplemented")}trackMetric(){throw new Error("unimplemented")}trackException(){throw new Error("unimplemented")}trackRequest(){throw new Error("unimplemented")}trackDependency(){throw new Error("unimplemented")}track(){throw new Error("unimplemented")}trackNodeHttpRequestSync(){throw new Error("unimplemented")}trackNodeHttpRequest(){throw new Error("unimplemented")}trackNodeHttpDependency(){throw new Error("unimplemented")}trackEvent(e){
e.properties||(e.properties={}),e.measurements||(e.measurements={});try{const t=n.cpus();e.measurements.cores=t.length,e.properties["common.cpuModel"]=t[0].model}catch(e){}try{e.measurements.memoryFree=n.freemem(),e.measurements.memoryTotal=n.totalmem()}catch(e){}try{e.properties["common.shell"]=n.userInfo().shell,e.properties["common.release"]=n.release(),e.properties["common.arch"]=n.arch()}catch(e){}try{const t=process.env.TELEMETRY_URL||"https://v1.telemetry.coder.com/track",n=(/^http:/.test(t)?r:i).request(t,{method:"POST",headers:{"Content-Type":"application/json"}});n.on("error",()=>{}),n.write(JSON.stringify(e)),n.end()}catch(e){}}flush(e){e.callback&&e.callback("")}}})),define(t[59],i([0,1,34]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logger=void 0,t.logger=i.logger.named("vscode")})),define(t[60],i([0,1,21,44,37,98,101,28]),(function(e,t,i,r,n,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.getLocaleFromConfig=t.getTranslations=t.getNlsConfiguration=t.isInternalConfiguration=void 0;const l=new Map,c=r.join(s.getPathFromAmdModule(e,""),"nls.metadata.json");t.isInternalConfiguration=e=>e&&!!e._languagePackId;const u={locale:"en",availableLanguages:{}};t.getNlsConfiguration=async(e,r)=>{const s=`${e}: ${r}`;return l.has(s)||l.set(s,new Promise(async h=>{const d=a.default.commit&&await n.promisify(i.exists)(c)?await o.getNLSConfiguration(a.default.commit,r,c,e):u;t.isInternalConfiguration(d)&&(d._languagePackSupport=!0),"en"!==d.locale&&"en-us"!==d.locale&&0===Object.keys(d.availableLanguages).length&&l.delete(s),h(d)})),l.get(s)};t.getTranslations=async(e,r)=>{const s=await t.getNlsConfiguration(e,r);if(t.isInternalConfiguration(s))try{return JSON.parse(await n.promisify(i.readFile)(s._translationsConfigFile,"utf8"))}catch(e){}return{}};t.getLocaleFromConfig=async e=>{const t=["locale.json","argv.json"];for(let s=0;s<t.length;++s)try{
const o=r.join(e,"User",t[s]),a=h(await n.promisify(i.readFile)(o,"utf8"));return JSON.parse(a).locale}catch(e){}return"en"};const h=e=>{return e.replace(/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g,(e,t,i,r,n)=>{if(r)return"";if(n){const e=n.length;return e>2&&"\n"===n[e-1]?"\r"===n[e-2]?"\r\n":"\n":""}return e})}})),define(t[179],i([0,1,34,38,6,10,52,60]),(function(e,t,i,r,n,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionHostConnection=t.ManagementConnection=t.Connection=void 0;class l{constructor(e,t){this.protocol=e,this.token=t,this._onClose=new n.Emitter,this.onClose=this._onClose.event,this.disposed=!1}get offline(){return this._offline}reconnect(e,t){this._offline=void 0,this.doReconnect(e,t)}dispose(){this.disposed||(this.disposed=!0,this.doDispose(),this._onClose.fire())}setOffline(){this._offline||(this._offline=Date.now())}}t.Connection=l;t.ManagementConnection=class extends l{constructor(e,t){super(e,t),
this.protocol=e,e.onClose(()=>this.dispose()),e.onSocketClose(()=>this.setOffline())}doDispose(){this.protocol.sendDisconnect(),this.protocol.dispose(),this.protocol.getUnderlyingSocket().destroy()}doReconnect(e,t){this.protocol.beginAcceptReconnection(e,t),this.protocol.endAcceptReconnection()}};t.ExtensionHostConnection=class extends l{constructor(e,t,r,n,s){super(t,n),this.environment=s,this.logger=i.logger.named("exthost",i.field("token",n)),this.protocol.dispose(),this.spawn(e,r).then(e=>this.process=e),this.protocol.getUnderlyingSocket().pause()}doDispose(){this.process&&this.process.kill(),this.protocol.getUnderlyingSocket().destroy()}doReconnect(e,t){this.protocol.beginAcceptReconnection(e,null),this.protocol.dispose(),this.sendInitMessage(t)}sendInitMessage(e){const t=this.protocol.getUnderlyingSocket();t.pause(),this.logger.trace("Sending socket"),this.process.send({type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:e.buffer.toString("base64"),
skipWebSocketFrames:this.protocol.getSocket()instanceof o.NodeSocket},t)}async spawn(t,n){this.logger.trace("Getting NLS configuration...");const o=await a.getNlsConfiguration(t,this.environment.userDataPath);this.logger.trace("Spawning extension host...");const l=r.fork(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,["--type=extensionHost"],{env:Object.assign(Object.assign({},process.env),{AMD_ENTRYPOINT:"vs/workbench/services/extensions/node/extensionHostProcess",PIPE_LOGGING:"true",VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_LOG_LEVEL:process.env.LOG_LEVEL,VSCODE_NLS_CONFIG:JSON.stringify(o)}),silent:!0});return l.on("error",e=>{this.logger.error("Exited unexpectedly",i.field("error",e)),this.dispose()}),l.on("exit",e=>{this.logger.trace("Exited",i.field("code",e)),this.dispose()}),l.stdout&&l.stderr&&(l.stdout.setEncoding("utf8").on("data",e=>this.logger.info(e)),
l.stderr.setEncoding("utf8").on("data",e=>this.logger.error(e))),l.on("message",e=>{switch(e.type){case"__$console":const t=this.logger["log"===e.severity?"info":e.severity];t?t.bind(this.logger)("console",i.field("arguments",e.arguments)):this.logger.error("Unexpected severity",i.field("event",e));break;case"VSCODE_EXTHOST_DISCONNECTED":this.logger.trace("Going offline"),this.setOffline();break;case"VSCODE_EXTHOST_IPC_READY":this.logger.trace("Got ready message"),this.sendInitMessage(n);break;default:this.logger.error("Unexpected message",i.field("event",e))}}),this.logger.trace("Waiting for handshake..."),l}}})),define(t[180],i([0,1,34,17,66,52,59]),(function(e,t,i,r,n,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class a extends n.PersistentProtocol{constructor(e,t){super(t.skipWebSocketFrames?new s.NodeSocket(e):new s.WebSocketNodeSocket(new s.NodeSocket(e))),this.options=t}getUnderlyingSocket(){const e=this.getSocket()
;return e instanceof s.NodeSocket?e.socket:e.socket.socket}handshake(){return o.logger.trace("Protocol handshake",i.field("token",this.options.reconnectionToken)),new Promise((e,t)=>{const r=setTimeout(()=>{o.logger.error("Handshake timed out",i.field("token",this.options.reconnectionToken)),t(new Error("timed out"))},1e4),n=this.onControlMessage(s=>{try{const t=s.toString();o.logger.trace("Protocol message",i.field("token",this.options.reconnectionToken),i.field("message",t));const a=JSON.parse(t);switch(a.type){case"auth":return this.authenticate(a);case"connectionType":return n.dispose(),clearTimeout(r),e(a);default:throw new Error("Unrecognized message type")}}catch(e){n.dispose(),clearTimeout(r),t(e)}});this.authenticate()})}authenticate(e){this.sendMessage({type:"sign",data:""})}tunnel(){throw new Error("Tunnel is not implemented yet")}sendMessage(e){this.sendControl(r.VSBuffer.fromString(JSON.stringify(e)))}}t.Protocol=a})),define(t[82],i([0,1,51]),(function(e,t,i){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.encodePath=t.getUriTransformer=void 0;t.getUriTransformer=e=>new i.URITransformer(e);t.encodePath=e=>e.split("/").map(e=>encodeURIComponent(e)).join("/")})),define(t[181],i([0,1,134,6,11,7,2,4,69,29,110,19]),(function(e,t,i,r,n,s,o,a,l,c,u,h){"use strict";var d;Object.defineProperty(t,"__esModule",{value:!0}),
t.computeEditorAriaLabel=t.EditorsOrder=t.pathsToEditors=t.Extensions=t.CloseDirection=t.EditorResourceAccessor=t.SideBySideEditor=t.EditorCommandsContextActionRunner=t.TextEditorOptions=t.EditorOptions=t.isEditorInputWithOptions=t.EditorModel=t.SideBySideEditorInput=t.isEditorInputWithPreferredResource=t.EncodingMode=t.EditorInput=t.SaveReason=t.Verbosity=t.isTextEditorPane=t.BINARY_DIFF_EDITOR_ID=t.TEXT_DIFF_EDITOR_ID=t.EditorAreaVisibleContext=t.SplitEditorsVertically=t.IsCenteredLayoutContext=t.InEditorZenModeContext=t.EditorsVisibleContext=t.SingleEditorGroupsContext=t.MultipleEditorGroupsContext=t.ActiveEditorGroupLastContext=t.ActiveEditorGroupIndexContext=t.ActiveEditorGroupEmptyContext=t.EditorGroupEditorsCountContext=t.TextCompareEditorActiveContext=t.TextCompareEditorVisibleContext=t.ActiveEditorAvailableEditorIdsContext=t.ActiveEditorContext=t.ActiveEditorReadonlyContext=t.ActiveEditorStickyContext=t.ActiveEditorPinnedContext=t.ActiveEditorDirtyContext=void 0,
t.ActiveEditorDirtyContext=new l.RawContextKey("activeEditorIsDirty",!1),t.ActiveEditorPinnedContext=new l.RawContextKey("activeEditorIsNotPreview",!1),t.ActiveEditorStickyContext=new l.RawContextKey("activeEditorIsPinned",!1),t.ActiveEditorReadonlyContext=new l.RawContextKey("activeEditorIsReadonly",!1),t.ActiveEditorContext=new l.RawContextKey("activeEditor",null),t.ActiveEditorAvailableEditorIdsContext=new l.RawContextKey("activeEditorAvailableEditorIds",""),t.TextCompareEditorVisibleContext=new l.RawContextKey("textCompareEditorVisible",!1),t.TextCompareEditorActiveContext=new l.RawContextKey("textCompareEditorActive",!1),t.EditorGroupEditorsCountContext=new l.RawContextKey("groupEditorsCount",0),t.ActiveEditorGroupEmptyContext=new l.RawContextKey("activeEditorGroupEmpty",!1),t.ActiveEditorGroupIndexContext=new l.RawContextKey("activeEditorGroupIndex",0),t.ActiveEditorGroupLastContext=new l.RawContextKey("activeEditorGroupLast",!1),
t.MultipleEditorGroupsContext=new l.RawContextKey("multipleEditorGroups",!1),t.SingleEditorGroupsContext=t.MultipleEditorGroupsContext.toNegated(),t.EditorsVisibleContext=new l.RawContextKey("editorIsOpen",!1),t.InEditorZenModeContext=new l.RawContextKey("inZenMode",!1),t.IsCenteredLayoutContext=new l.RawContextKey("isCenteredLayout",!1),t.SplitEditorsVertically=new l.RawContextKey("splitEditorsVertically",!1),t.EditorAreaVisibleContext=new l.RawContextKey("editorAreaVisible",!0),t.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",t.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor",t.isTextEditorPane=function(e){const t=e;return"function"==typeof(null==t?void 0:t.getViewState)},function(e){e[e.SHORT=0]="SHORT",e[e.MEDIUM=1]="MEDIUM",e[e.LONG=2]="LONG"}(t.Verbosity||(t.Verbosity={})),function(e){e[e.EXPLICIT=1]="EXPLICIT",e[e.AUTO=2]="AUTO",e[e.FOCUS_CHANGE=3]="FOCUS_CHANGE",e[e.WINDOW_CHANGE=4]="WINDOW_CHANGE"}(t.SaveReason||(t.SaveReason={}));class f extends o.Disposable{constructor(){
super(...arguments),this._onDidChangeDirty=this._register(new r.Emitter),this.onDidChangeDirty=this._onDidChangeDirty.event,this._onDidChangeLabel=this._register(new r.Emitter),this.onDidChangeLabel=this._onDidChangeLabel.event,this._onDispose=this._register(new r.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}getName(){return`Editor ${this.getTypeId()}`}getDescription(e){}getTitle(e){return this.getName()}getAriaLabel(){return this.getTitle(0)}getPreferredEditorId(e){return h.firstOrDefault(e)}getTelemetryDescriptor(){return{typeId:this.getTypeId()}}isReadonly(){return!0}isUntitled(){return!1}isDirty(){return!1}isSaving(){return!1}async resolve(){return null}async save(e,t){return this}async saveAs(e,t){return this}async revert(e,t){}rename(e,t){}supportsSplitEditor(){return!0}matches(e){return this===e}isDisposed(){return this.disposed}dispose(){this.disposed||(this.disposed=!0,this._onDispose.fire()),super.dispose()}}function p(e){return e&&!!e.preferredResource}t.EditorInput=f,function(e){
e[e.Encode=0]="Encode",e[e.Decode=1]="Decode"}(t.EncodingMode||(t.EncodingMode={})),t.isEditorInputWithPreferredResource=p;class g extends f{constructor(e,t,i,r){super(),this.name=e,this.description=t,this._secondary=i,this._primary=r,this.registerListeners()}registerListeners(){const e=r.Event.once(this.secondary.onDispose);this._register(e(()=>{this.isDisposed()||this.dispose()}));const t=r.Event.once(this.primary.onDispose);this._register(t(()=>{this.isDisposed()||this.dispose()})),this._register(this.primary.onDidChangeDirty(()=>this._onDidChangeDirty.fire())),this._register(this.primary.onDidChangeLabel(()=>this._onDidChangeLabel.fire()))}get resource(){}get primary(){return this._primary}get secondary(){return this._secondary}getTypeId(){return g.ID}getName(){return this.name?this.name:i.localize(0,null,this._secondary.getName(),this._primary.getName())}getDescription(){return this.description}isReadonly(){return this.primary.isReadonly()}isUntitled(){return this.primary.isUntitled()}isDirty(){
return this.primary.isDirty()}isSaving(){return this.primary.isSaving()}save(e,t){return this.primary.save(e,t)}saveAs(e,t){return this.primary.saveAs(e,t)}revert(e,t){return this.primary.revert(e,t)}getTelemetryDescriptor(){const e=this.primary.getTelemetryDescriptor();return Object.assign(e,super.getTelemetryDescriptor())}matches(e){return e===this||e instanceof g&&(this.primary.matches(e.primary)&&this.secondary.matches(e.secondary))}}t.SideBySideEditorInput=g,g.ID="workbench.editorinputs.sidebysideEditorInput";class m extends o.Disposable{constructor(){super(...arguments),this._onDispose=this._register(new r.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}async load(){return this}isResolved(){return!0}isDisposed(){return this.disposed}dispose(){this.disposed=!0,this._onDispose.fire(),super.dispose()}}t.EditorModel=m,t.isEditorInputWithOptions=function(e){return!!e&&!!e.editor};class v{static create(e){const t=new v;return t.overwrite(e),t}overwrite(e){
return"boolean"==typeof e.forceReload&&(this.forceReload=e.forceReload),"boolean"==typeof e.revealIfVisible&&(this.revealIfVisible=e.revealIfVisible),"boolean"==typeof e.revealIfOpened&&(this.revealIfOpened=e.revealIfOpened),"boolean"==typeof e.preserveFocus&&(this.preserveFocus=e.preserveFocus),"number"==typeof e.activation&&(this.activation=e.activation),"boolean"==typeof e.pinned&&(this.pinned=e.pinned),"boolean"==typeof e.sticky&&(this.sticky=e.sticky),"boolean"==typeof e.inactive&&(this.inactive=e.inactive),"boolean"==typeof e.ignoreError&&(this.ignoreError=e.ignoreError),"number"==typeof e.index&&(this.index=e.index),"string"!=typeof e.override&&!1!==e.override||(this.override=e.override),"number"==typeof e.context&&(this.context=e.context),this}}t.EditorOptions=v;class y extends v{static from(e){if(null==e?void 0:e.options)return y.create(e.options)}static create(e=Object.create(null)){const t=new y;return t.overwrite(e),t}overwrite(e){var t,i;return super.overwrite(e),e.selection&&(this.selection={
startLineNumber:e.selection.startLineNumber,startColumn:e.selection.startColumn,endLineNumber:null!==(t=e.selection.endLineNumber)&&void 0!==t?t:e.selection.startLineNumber,endColumn:null!==(i=e.selection.endColumn)&&void 0!==i?i:e.selection.startColumn}),e.viewState&&(this.editorViewState=e.viewState),void 0!==e.selectionRevealType&&(this.selectionRevealType=e.selectionRevealType),this}hasOptionsDefined(){return!!this.editorViewState||!!this.selectionRevealType||!!this.selection}static fromEditor(e,t){const i=y.create(t);return i.editorViewState=n.withNullAsUndefined(e.saveViewState()),i}apply(e,t){var i,r;let n=!1;if(this.editorViewState)e.restoreViewState(this.editorViewState),n=!0;else if(this.selection){const s={startLineNumber:this.selection.startLineNumber,startColumn:this.selection.startColumn,endLineNumber:null!==(i=this.selection.endLineNumber)&&void 0!==i?i:this.selection.startLineNumber,endColumn:null!==(r=this.selection.endColumn)&&void 0!==r?r:this.selection.startColumn};e.setSelection(s),
2===this.selectionRevealType?e.revealRangeNearTop(s,t):3===this.selectionRevealType?e.revealRangeNearTopIfOutsideViewport(s,t):1===this.selectionRevealType?e.revealRangeInCenterIfOutsideViewport(s,t):e.revealRangeInCenter(s,t),n=!0}return n}}t.TextEditorOptions=y;class E extends u.ActionRunner{constructor(e){super(),this.context=e}run(e){return super.run(e,this.context)}}t.EditorCommandsContextActionRunner=E,function(e){e[e.PRIMARY=1]="PRIMARY",e[e.SECONDARY=2]="SECONDARY",e[e.BOTH=3]="BOTH"}(d=t.SideBySideEditor||(t.SideBySideEditor={}));t.EditorResourceAccessor=new class{getOriginalUri(e,t){if(!e)return;if((null==t?void 0:t.supportSideBySide)&&e instanceof g){if((null==t?void 0:t.supportSideBySide)===d.BOTH)return{primary:this.getOriginalUri(e.primary,{filterByScheme:t.filterByScheme}),secondary:this.getOriginalUri(e.secondary,{filterByScheme:t.filterByScheme})};e=t.supportSideBySide===d.PRIMARY?e.primary:e.secondary}const i=p(e)?e.preferredResource:e.resource
;return i&&t&&t.filterByScheme?this.filterUri(i,t.filterByScheme):i}getCanonicalUri(e,t){if(!e)return;if((null==t?void 0:t.supportSideBySide)&&e instanceof g){if((null==t?void 0:t.supportSideBySide)===d.BOTH)return{primary:this.getCanonicalUri(e.primary,{filterByScheme:t.filterByScheme}),secondary:this.getCanonicalUri(e.secondary,{filterByScheme:t.filterByScheme})};e=t.supportSideBySide===d.PRIMARY?e.primary:e.secondary}const i=e.resource;return i&&t&&t.filterByScheme?this.filterUri(i,t.filterByScheme):i}filterUri(e,t){if(Array.isArray(t)){if(t.some(t=>e.scheme===t))return e}else if(t===e.scheme)return e}},function(e){e[e.LEFT=0]="LEFT",e[e.RIGHT=1]="RIGHT"}(t.CloseDirection||(t.CloseDirection={}));t.Extensions={EditorInputFactories:"workbench.contributions.editor.inputFactories"},c.Registry.add(t.Extensions.EditorInputFactories,new class{constructor(){this.customEditorInputFactoryInstances=new Map,this.editorInputFactoryConstructors=new Map,this.editorInputFactoryInstances=new Map}start(e){
const t=this.instantiationService=e.get(a.IInstantiationService);this.editorInputFactoryConstructors.forEach((e,i)=>{this.createEditorInputFactory(i,e,t)}),this.editorInputFactoryConstructors.clear()}createEditorInputFactory(e,t,i){const r=i.createInstance(t);this.editorInputFactoryInstances.set(e,r)}registerFileEditorInputFactory(e){this.fileEditorInputFactory=e}getFileEditorInputFactory(){return n.assertIsDefined(this.fileEditorInputFactory)}registerCustomEditorInputFactory(e,t){this.customEditorInputFactoryInstances.set(e,t)}getCustomEditorInputFactory(e){return this.customEditorInputFactoryInstances.get(e)}registerEditorInputFactory(e,t){return this.instantiationService?this.createEditorInputFactory(e,t,this.instantiationService):this.editorInputFactoryConstructors.set(e,t),o.toDisposable(()=>{this.editorInputFactoryConstructors.delete(e),this.editorInputFactoryInstances.delete(e)})}getEditorInputFactory(e){return this.editorInputFactoryInstances.get(e)}}),t.pathsToEditors=async function(e,t){
if(!e||!e.length)return[];const i=await Promise.all(e.map(async e=>{const i=s.URI.revive(e.fileUri);if(!i||!t.canHandleResource(i))return;const r="boolean"==typeof e.exists?e.exists:await t.exists(i);if(!r&&e.openOnlyIfExists)return;const n=r&&"number"==typeof e.lineNumber?{selection:{startLineNumber:e.lineNumber,startColumn:e.columnNumber||1},pinned:!0,override:e.overrideId}:{pinned:!0,override:e.overrideId};let o;return o=r?{resource:i,options:n,forceFile:!0}:{resource:i,options:n,forceUntitled:!0}}));return h.coalesce(i)},function(e){e[e.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",e[e.SEQUENTIAL=1]="SEQUENTIAL"}(t.EditorsOrder||(t.EditorsOrder={})),t.computeEditorAriaLabel=function(e,t,r,n){let s=e.getAriaLabel();return r&&!r.isPinned(e)&&(s=i.localize(1,null,s)),r&&r.isSticky(null!=t?t:e)&&(s=i.localize(2,null,s)),r&&n>1&&(s=`${s}, ${r.ariaLabel}`),s}})),define(t[83],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.EnvironmentVariableMutatorType=t.IEnvironmentVariableService=void 0,t.IEnvironmentVariableService=i.createDecorator("environmentVariableService"),function(e){e[e.Replace=1]="Replace",e[e.Append=2]="Append",e[e.Prepend=3]="Prepend"}(t.EnvironmentVariableMutatorType||(t.EnvironmentVariableMutatorType={}))})),define(t[182],i([0,1,83,5]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MergedEnvironmentVariableCollection=void 0;function n(e,t){if(!t)return e;const i=new Set;t.forEach(e=>i.add(e.extensionIdentifier));const r=[];return e.forEach(e=>{i.has(e.extensionIdentifier)||r.push(e)}),0===r.length?void 0:r}t.MergedEnvironmentVariableCollection=class{constructor(e){this.map=new Map,e.forEach((e,t)=>{const r=e.map.entries();let n=r.next();for(;!n.done;){const e=n.value[0];let s=this.map.get(e);if(s||(s=[],this.map.set(e,s)),s.length>0&&s[0].type===i.EnvironmentVariableMutatorType.Replace){n=r.next();continue}const o=n.value[1];s.unshift({extensionIdentifier:t,value:o.value,
type:o.type}),n=r.next()}})}applyToProcessEnvironment(e){let t;r.isWindows&&(t={},Object.keys(e).forEach(e=>t[e.toLowerCase()]=e)),this.map.forEach((n,s)=>{const o=r.isWindows&&t[s.toLowerCase()]||s;n.forEach(t=>{switch(t.type){case i.EnvironmentVariableMutatorType.Append:e[o]=(e[o]||"")+t.value;break;case i.EnvironmentVariableMutatorType.Prepend:e[o]=t.value+(e[o]||"");break;case i.EnvironmentVariableMutatorType.Replace:e[o]=t.value}})})}diff(e){const t=new Map,i=new Map,r=new Map;if(e.map.forEach((e,i)=>{const r=n(e,this.map.get(i));r&&t.set(i,r)}),this.map.forEach((t,i)=>{const s=n(t,e.map.get(i));s&&r.set(i,s)}),this.map.forEach((t,r)=>{const n=function(e,t){if(!t)return;const i=new Map;t.forEach(e=>i.set(e.extensionIdentifier,e));const r=[];return e.forEach(e=>{const t=i.get(e.extensionIdentifier);!t||e.type===t.type&&e.value===t.value||r.push(t)}),0===r.length?void 0:r}(t,e.map.get(r));n&&i.set(r,n)}),0!==t.size||0!==i.size||0!==r.size)return{added:t,changed:i,removed:r}}}})),
define(t[84],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deserializeEnvironmentVariableCollection=t.serializeEnvironmentVariableCollection=void 0,t.serializeEnvironmentVariableCollection=function(e){return[...e.entries()]},t.deserializeEnvironmentVariableCollection=function(e){return new Map(e)}})),define(t[85],i([0,1,135,69]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.terminalContributionsDescriptor=t.DEFAULT_COMMANDS_TO_SKIP_SHELL=t.TERMINAL_COMMAND_ID=t.TitleEventSource=t.LinuxDistro=t.ProcessState=t.SUGGESTIONS_FONT_WEIGHT=t.DEFAULT_BOLD_FONT_WEIGHT=t.DEFAULT_FONT_WEIGHT=t.MAXIMUM_FONT_WEIGHT=t.MINIMUM_FONT_WEIGHT=t.DEFAULT_LINE_HEIGHT=t.MINIMUM_LETTER_SPACING=t.DEFAULT_LETTER_SPACING=t.TERMINAL_ACTION_CATEGORY=t.TERMINAL_CONFIG_SECTION=t.TerminalCursorStyle=t.EXT_HOST_CREATION_DELAY=t.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY=t.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY=t.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=t.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=t.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=t.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=t.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=t.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY=t.KEYBINDING_CONTEXT_TERMINAL_FOCUS=t.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=t.TERMINAL_VIEW_ID=void 0,
t.TERMINAL_VIEW_ID="terminal",t.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=new r.RawContextKey("terminalIsOpen",!1),t.KEYBINDING_CONTEXT_TERMINAL_FOCUS=new r.RawContextKey("terminalFocus",!1),t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY="terminalShellType",t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=new r.RawContextKey(t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY,void 0),t.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FOCUS.toNegated(),t.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=new r.RawContextKey("terminalA11yTreeFocus",!1),t.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=new r.RawContextKey("terminalTextSelected",!1),t.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=t.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED.toNegated(),t.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=new r.RawContextKey("terminalFindVisible",!1),t.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=t.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE.toNegated(),
t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=new r.RawContextKey("terminalFindInputFocused",!1),t.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=new r.RawContextKey("terminalFindFocused",!1),t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED.toNegated(),t.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=new r.RawContextKey("terminalProcessSupported",!1),t.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY="terminal.integrated.isWorkspaceShellAllowed",t.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY="terminal.integrated.neverMeasureRenderTime",t.EXT_HOST_CREATION_DELAY=100,t.TerminalCursorStyle={BLOCK:"block",LINE:"line",UNDERLINE:"underline"},t.TERMINAL_CONFIG_SECTION="terminal.integrated",t.TERMINAL_ACTION_CATEGORY=i.localize(0,null),t.DEFAULT_LETTER_SPACING=0,t.MINIMUM_LETTER_SPACING=-5,t.DEFAULT_LINE_HEIGHT=1,t.MINIMUM_FONT_WEIGHT=1,t.MAXIMUM_FONT_WEIGHT=1e3,t.DEFAULT_FONT_WEIGHT="normal",t.DEFAULT_BOLD_FONT_WEIGHT="bold",
t.SUGGESTIONS_FONT_WEIGHT=["normal","bold","100","200","300","400","500","600","700","800","900"],function(e){e[e.UNINITIALIZED=0]="UNINITIALIZED",e[e.LAUNCHING=1]="LAUNCHING",e[e.RUNNING=2]="RUNNING",e[e.KILLED_DURING_LAUNCH=3]="KILLED_DURING_LAUNCH",e[e.KILLED_BY_USER=4]="KILLED_BY_USER",e[e.KILLED_BY_PROCESS=5]="KILLED_BY_PROCESS"}(t.ProcessState||(t.ProcessState={})),function(e){e[e.Fedora=0]="Fedora",e[e.Ubuntu=1]="Ubuntu",e[e.Unknown=2]="Unknown"}(t.LinuxDistro||(t.LinuxDistro={})),function(e){e[e.Api=0]="Api",e[e.Process=1]="Process",e[e.Sequence=2]="Sequence"}(t.TitleEventSource||(t.TitleEventSource={})),function(e){e.FIND_NEXT="workbench.action.terminal.findNext",e.FIND_PREVIOUS="workbench.action.terminal.findPrevious",e.TOGGLE="workbench.action.terminal.toggleTerminal",e.KILL="workbench.action.terminal.kill",e.QUICK_KILL="workbench.action.terminal.quickKill",e.COPY_SELECTION="workbench.action.terminal.copySelection",e.SELECT_ALL="workbench.action.terminal.selectAll",
e.DELETE_WORD_LEFT="workbench.action.terminal.deleteWordLeft",e.DELETE_WORD_RIGHT="workbench.action.terminal.deleteWordRight",e.DELETE_TO_LINE_START="workbench.action.terminal.deleteToLineStart",e.MOVE_TO_LINE_START="workbench.action.terminal.moveToLineStart",e.MOVE_TO_LINE_END="workbench.action.terminal.moveToLineEnd",e.NEW="workbench.action.terminal.new",e.NEW_WITH_CWD="workbench.action.terminal.newWithCwd",e.NEW_LOCAL="workbench.action.terminal.newLocal",e.NEW_IN_ACTIVE_WORKSPACE="workbench.action.terminal.newInActiveWorkspace",e.SPLIT="workbench.action.terminal.split",e.SPLIT_IN_ACTIVE_WORKSPACE="workbench.action.terminal.splitInActiveWorkspace",e.RELAUNCH="workbench.action.terminal.relaunch",e.FOCUS_PREVIOUS_PANE="workbench.action.terminal.focusPreviousPane",e.FOCUS_NEXT_PANE="workbench.action.terminal.focusNextPane",e.RESIZE_PANE_LEFT="workbench.action.terminal.resizePaneLeft",e.RESIZE_PANE_RIGHT="workbench.action.terminal.resizePaneRight",e.RESIZE_PANE_UP="workbench.action.terminal.resizePaneUp",
e.RESIZE_PANE_DOWN="workbench.action.terminal.resizePaneDown",e.FOCUS="workbench.action.terminal.focus",e.FOCUS_NEXT="workbench.action.terminal.focusNext",e.FOCUS_PREVIOUS="workbench.action.terminal.focusPrevious",e.PASTE="workbench.action.terminal.paste",e.SELECT_DEFAULT_SHELL="workbench.action.terminal.selectDefaultShell",e.RUN_SELECTED_TEXT="workbench.action.terminal.runSelectedText",e.RUN_ACTIVE_FILE="workbench.action.terminal.runActiveFile",e.SWITCH_TERMINAL="workbench.action.terminal.switchTerminal",e.SCROLL_DOWN_LINE="workbench.action.terminal.scrollDown",e.SCROLL_DOWN_PAGE="workbench.action.terminal.scrollDownPage",e.SCROLL_TO_BOTTOM="workbench.action.terminal.scrollToBottom",e.SCROLL_UP_LINE="workbench.action.terminal.scrollUp",e.SCROLL_UP_PAGE="workbench.action.terminal.scrollUpPage",e.SCROLL_TO_TOP="workbench.action.terminal.scrollToTop",e.CLEAR="workbench.action.terminal.clear",e.CLEAR_SELECTION="workbench.action.terminal.clearSelection",
e.MANAGE_WORKSPACE_SHELL_PERMISSIONS="workbench.action.terminal.manageWorkspaceShellPermissions",e.RENAME="workbench.action.terminal.rename",e.RENAME_WITH_ARG="workbench.action.terminal.renameWithArg",e.FIND_FOCUS="workbench.action.terminal.focusFind",e.FIND_HIDE="workbench.action.terminal.hideFind",e.QUICK_OPEN_TERM="workbench.action.quickOpenTerm",e.SCROLL_TO_PREVIOUS_COMMAND="workbench.action.terminal.scrollToPreviousCommand",e.SCROLL_TO_NEXT_COMMAND="workbench.action.terminal.scrollToNextCommand",e.SELECT_TO_PREVIOUS_COMMAND="workbench.action.terminal.selectToPreviousCommand",e.SELECT_TO_NEXT_COMMAND="workbench.action.terminal.selectToNextCommand",e.SELECT_TO_PREVIOUS_LINE="workbench.action.terminal.selectToPreviousLine",e.SELECT_TO_NEXT_LINE="workbench.action.terminal.selectToNextLine",e.TOGGLE_ESCAPE_SEQUENCE_LOGGING="toggleEscapeSequenceLogging",e.SEND_SEQUENCE="workbench.action.terminal.sendSequence",e.TOGGLE_FIND_REGEX="workbench.action.terminal.toggleFindRegex",
e.TOGGLE_FIND_WHOLE_WORD="workbench.action.terminal.toggleFindWholeWord",e.TOGGLE_FIND_CASE_SENSITIVE="workbench.action.terminal.toggleFindCaseSensitive",e.NAVIGATION_MODE_EXIT="workbench.action.terminal.navigationModeExit",e.NAVIGATION_MODE_FOCUS_NEXT="workbench.action.terminal.navigationModeFocusNext",e.NAVIGATION_MODE_FOCUS_PREVIOUS="workbench.action.terminal.navigationModeFocusPrevious",e.SHOW_ENVIRONMENT_INFORMATION="workbench.action.terminal.showEnvironmentInformation",e.SEARCH_WORKSPACE="workbench.action.terminal.searchWorkspace",e.ATTACH_TO_REMOTE_TERMINAL="workbench.action.terminal.attachToSession"}(t.TERMINAL_COMMAND_ID||(t.TERMINAL_COMMAND_ID={})),
t.DEFAULT_COMMANDS_TO_SKIP_SHELL=["workbench.action.terminal.clearSelection","workbench.action.terminal.clear","workbench.action.terminal.copySelection","workbench.action.terminal.deleteToLineStart","workbench.action.terminal.deleteWordLeft","workbench.action.terminal.deleteWordRight","workbench.action.terminal.focusFind","workbench.action.terminal.hideFind","workbench.action.terminal.findNext","workbench.action.terminal.findPrevious","workbench.action.terminal.toggleFindRegex","workbench.action.terminal.toggleFindWholeWord","workbench.action.terminal.toggleFindCaseSensitive","workbench.action.terminal.focusNextPane","workbench.action.terminal.focusNext","workbench.action.terminal.focusPreviousPane","workbench.action.terminal.focusPrevious","workbench.action.terminal.focus","workbench.action.terminal.kill","workbench.action.terminal.moveToLineEnd","workbench.action.terminal.moveToLineStart","workbench.action.terminal.newInActiveWorkspace","workbench.action.terminal.new","workbench.action.terminal.paste","workbench.action.terminal.resizePaneDown","workbench.action.terminal.resizePaneLeft","workbench.action.terminal.resizePaneRight","workbench.action.terminal.resizePaneUp","workbench.action.terminal.runActiveFile","workbench.action.terminal.runSelectedText","workbench.action.terminal.scrollDown","workbench.action.terminal.scrollDownPage","workbench.action.terminal.scrollToBottom","workbench.action.terminal.scrollToNextCommand","workbench.action.terminal.scrollToPreviousCommand","workbench.action.terminal.scrollToTop","workbench.action.terminal.scrollUp","workbench.action.terminal.scrollUpPage","workbench.action.terminal.sendSequence","workbench.action.terminal.selectAll","workbench.action.terminal.selectToNextCommand","workbench.action.terminal.selectToNextLine","workbench.action.terminal.selectToPreviousCommand","workbench.action.terminal.selectToPreviousLine","workbench.action.terminal.splitInActiveWorkspace","workbench.action.terminal.split","workbench.action.terminal.toggleTerminal","workbench.action.terminal.navigationModeExit","workbench.action.terminal.navigationModeFocusNext","workbench.action.terminal.navigationModeFocusPrevious","editor.action.toggleTabFocusMode","workbench.action.quickOpen","workbench.action.quickOpenPreviousEditor","workbench.action.showCommands","workbench.action.tasks.build","workbench.action.tasks.restartTask","workbench.action.tasks.runTask","workbench.action.tasks.reRunTask","workbench.action.tasks.showLog","workbench.action.tasks.showTasks","workbench.action.tasks.terminate","workbench.action.tasks.test","workbench.action.toggleFullScreen","workbench.action.terminal.focusAtIndex1","workbench.action.terminal.focusAtIndex2","workbench.action.terminal.focusAtIndex3","workbench.action.terminal.focusAtIndex4","workbench.action.terminal.focusAtIndex5","workbench.action.terminal.focusAtIndex6","workbench.action.terminal.focusAtIndex7","workbench.action.terminal.focusAtIndex8","workbench.action.terminal.focusAtIndex9","workbench.action.focusSecondEditorGroup","workbench.action.focusThirdEditorGroup","workbench.action.focusFourthEditorGroup","workbench.action.focusFifthEditorGroup","workbench.action.focusSixthEditorGroup","workbench.action.focusSeventhEditorGroup","workbench.action.focusEighthEditorGroup","workbench.action.focusNextPart","workbench.action.focusPreviousPart","workbench.action.nextPanelView","workbench.action.previousPanelView","workbench.action.nextSideBarView","workbench.action.previousSideBarView","workbench.action.debug.start","workbench.action.debug.stop","workbench.action.debug.run","workbench.action.debug.restart","workbench.action.debug.continue","workbench.action.debug.pause","workbench.action.debug.stepInto","workbench.action.debug.stepOut","workbench.action.debug.stepOver","workbench.action.nextEditor","workbench.action.previousEditor","workbench.action.nextEditorInGroup","workbench.action.previousEditorInGroup","workbench.action.openNextRecentlyUsedEditor","workbench.action.openPreviousRecentlyUsedEditor","workbench.action.openNextRecentlyUsedEditorInGroup","workbench.action.openPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenPreviousRecentlyUsedEditor","workbench.action.quickOpenLeastRecentlyUsedEditor","workbench.action.quickOpenPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenLeastRecentlyUsedEditorInGroup","workbench.action.focusActiveEditorGroup","workbench.action.focusFirstEditorGroup","workbench.action.focusLastEditorGroup","workbench.action.firstEditorInGroup","workbench.action.lastEditorInGroup","workbench.action.navigateUp","workbench.action.navigateDown","workbench.action.navigateRight","workbench.action.navigateLeft","workbench.action.togglePanel","workbench.action.quickOpenView","workbench.action.toggleMaximizedPanel"],
t.terminalContributionsDescriptor={extensionPoint:"terminal",defaultExtensionKind:"workspace",jsonSchema:{description:i.localize(1,null),type:"object",properties:{types:{type:"array",description:i.localize(2,null),items:{type:"object",required:["command","title"],properties:{command:{description:i.localize(3,null),type:"string"},title:{description:i.localize(4,null),type:"string"}}}}}}}})),define(t[183],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminalDataBufferer=void 0;t.TerminalDataBufferer=class{constructor(e){this._callback=e,this._terminalBufferMap=new Map}dispose(){for(const e of this._terminalBufferMap.values())e.dispose()}startBuffering(e,t,i=5){let r;return r=t(t=>{const n="string"==typeof t?t:t.data;let s=this._terminalBufferMap.get(e);if(s)return void s.data.push(n);const o=setTimeout(()=>this._flushBuffer(e),i);s={data:[n],timeoutId:o,dispose:()=>{clearTimeout(o),this._flushBuffer(e),r.dispose()}},this._terminalBufferMap.set(e,s)})}stopBuffering(e){
const t=this._terminalBufferMap.get(e);t&&t.dispose()}_flushBuffer(e){const t=this._terminalBufferMap.get(e);t&&(this._terminalBufferMap.delete(e),this._callback(e,t.data.join("")))}}})),define(t[184],i([0,1,3,5,96]),(function(e,t,i,r,n){"use strict";function s(e,t){if(t)if(r.isWindows)for(const i in t){let r=i;for(const t in e)if(i.toLowerCase()===t.toLowerCase()){r=t;break}const n=t[i];o(e,r,n)}else Object.keys(t).forEach(i=>{const r=t[i];o(e,i,r)})}function o(e,t,i){"string"==typeof i?e[t]=i:delete e[t]}function a(e,t,i,r){e.TERM_PROGRAM="vscode",t&&(e.TERM_PROGRAM_VERSION=t),u(e,r)&&(e.LANG=h(i)),e.COLORTERM="truecolor"}function l(e,t){if(t)for(const i of Object.keys(t)){const r=t[i];r&&(e[i]=r)}}function c(e,t){return Object.keys(t).forEach(i=>{const r=t[i];if("string"==typeof r)try{t[i]=e(r)}catch(e){t[i]=r}}),t}function u(e,t){return"on"===t||"auto"===t&&(!e.LANG||-1===e.LANG.search(/\.UTF\-8$/)&&-1===e.LANG.search(/\.utf8$/))}function h(e){const t=e?e.split("-"):[],i=t.length
;if(0===i)return"en_US.UTF-8";if(1===i){const e={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in e&&t.push(e[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}function d(e,t,i){if(t)try{return t(e)}catch(e){return void(null==i||i.error("Could not resolve terminal cwd",e))}return e}function f(e){return 3===r.platform&&e&&":"===e[1]?e[0].toUpperCase()+e.substr(1):e}function p(e,t,i,n=r.platform){const s=e(`terminal.integrated.${i}.${3===n?"windows":1===n?"osx":"linux"}`);return(t?s.value:s.userValue)||s.defaultValue}Object.defineProperty(t,"__esModule",{value:!0}),
t.createTerminalEnvironment=t.getDefaultShellArgs=t.getDefaultShell=t.createVariableResolver=t.escapeNonWindowsPath=t.getCwd=t.getLangEnvVariable=t.shouldSetLangEnvVariable=t.addTerminalEnvironmentKeys=t.mergeEnvironments=void 0,t.mergeEnvironments=s,t.addTerminalEnvironmentKeys=a,t.shouldSetLangEnvVariable=u,t.getLangEnvVariable=h,t.getCwd=function(e,t,r,n,s,o){if(e.cwd){const t="object"==typeof e.cwd?e.cwd.fsPath:e.cwd;return f(d(t,r)||t)}let a;return!e.ignoreConfigurationCwd&&s&&(r&&(s=d(s,r,o)),s&&(i.isAbsolute(s)?a=s:n&&(a=i.join(n.fsPath,s)))),a||(a=n?n.fsPath:t||""),f(a)},t.escapeNonWindowsPath=function(e){let t=e;return 0!==t.indexOf("\\")&&(t=t.replace(/\\/g,"\\\\")),t||-1===t.indexOf('"')?-1!==t.indexOf(" ")&&(t=t.replace(/ /g,"\\ ")):t="'"+t+"'",t},t.createVariableResolver=function(e,t){if(t)return i=>t.resolve(e,i)},t.getDefaultShell=function(e,t,n,s,o,a,l,c,u=r.platform){let h=null;c&&(h=p(e,t,"automationShell",u)),h||(h=p(e,t,"shell",u));let d=h||n;if(3===u&&!s&&o){
const e=i.join(o,"Sysnative").replace(/\//g,"\\").toLowerCase();d&&0===d.toLowerCase().indexOf(e)&&(d=i.join(o,"System32",d.substr(e.length+1)))}if(d&&3===u&&(d=d.replace(/\//g,"\\")),a)try{d=a(d)}catch(e){l.error("Could not resolve shell",e)}return d},t.getDefaultShellArgs=function(e,t,i,n,s,o=r.platform){if(i&&p(e,t,"automationShell",o))return[];const a=3===o?"windows":1===o?"osx":"linux",l=e(`terminal.integrated.shellArgs.${a}`);let c=(t?l.value:l.userValue)||l.defaultValue;if(!c)return[];if("string"==typeof c&&3===o)return n?n(c):c;if(n){const e=[];for(const t of c)try{e.push(n(t))}catch(i){s.error(`Could not resolve terminal.integrated.shellArgs.${a}`,i),e.push(t)}c=e}return c},t.createTerminalEnvironment=function(e,t,i,o,u,h,d){let f={};if(e.strictEnv)l(f,e.env);else{l(f,d);const p=Object.assign({},o?t.value:t.userValue);i&&(p&&c(i,p),e.env&&c(i,e.env)),n.sanitizeProcessEnvironment(f,"VSCODE_IPC_HOOK_CLI"),s(f,p),s(f,e.env),a(f,u,r.locale,h)}return f}})),
define(t[86],i([0,1,27,5,67,12,85,19,3]),(function(e,t,i,r,n,s,o,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.detectAvailableShells=t.getWindowsBuildNumber=t.linuxDistro=t.getSystemShell=void 0,t.getSystemShell=function(e,t=process.env){return 3===e?r.isWindows?function(e){if(!u){const t=r.isWindows&&parseFloat(i.release())>=10,s=e.hasOwnProperty("PROCESSOR_ARCHITEW6432"),o=`${e.windir}\\${s?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;u=t?o:n.getWindowsShell(e)}return u}(t):n.getWindowsShell(t):r.isLinux&&1===e||r.isMacintosh&&2===e?"/bin/bash":function(e){if(!c){let t="sh";!r.isWindows&&e.SHELL&&"/bin/false"===(t=e.SHELL)&&(t="/bin/bash"),r.isWindows&&(t="/bin/bash"),c=t}return c}(t)};let c=null;let u=null;let h=o.LinuxDistro.Unknown;if(r.isLinux){const e="/etc/os-release";s.fileExists(e).then(async t=>{if(!t)return;const i=(await s.readFile(e)).toString();/NAME="?Fedora"?/.test(i)?h=o.LinuxDistro.Fedora:/NAME="?Ubuntu"?/.test(i)&&(h=o.LinuxDistro.Ubuntu)})}
function d(){const e=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let t=0;return e&&4===e.length&&(t=parseInt(e[3])),t}async function f(t){const i=await new Promise((t,i)=>{e(["vscode-windows-registry"],t,i)});try{const e=i.GetStringRegKey("HKEY_LOCAL_MACHINE",`SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\${t}.exe`,"");return e||""}catch(e){return""}}t.linuxDistro=h,t.getWindowsBuildNumber=d,t.detectAvailableShells=function(){return r.isWindows?async function(){const e=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),t=`${process.env.windir}\\${e?"Sysnative":"System32"}`;let i=!1;d()>=16299&&(i=!0);const r={"Command Prompt":[`${t}\\cmd.exe`],"Windows PowerShell":[`${t}\\WindowsPowerShell\\v1.0\\powershell.exe`],PowerShell:[await f("pwsh")],"WSL Bash":[`${t}\\${i?"wsl.exe":"bash.exe"}`],
"Git Bash":[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`]},n=[];Object.keys(r).forEach(e=>n.push(async function e(t,i){if(0===i.length)return Promise.resolve(void 0);const r=i.shift();if(""===r)return e(t,i);try{const e=await s.stat(l.normalize(r));if(e.isFile||e.isSymbolicLink)return{label:t,path:r}}catch(e){}return e(t,i)}(e,r[e])));const o=await Promise.all(n);return a.coalesce(o)}():async function(){return(await s.readFile("/etc/shells","utf8")).split("\n").filter(e=>0!==e.trim().indexOf("#")&&e.trim().length>0).map(e=>({label:l.basename(e),path:e}))}()}})),define(t[87],i([0,1,5,12,3,11,20]),(function(e,t,i,r,n,s,o){"use strict";let a;Object.defineProperty(t,"__esModule",{value:!0}),t.findExecutable=t.getMainProcessParentEnv=void 0,
t.getMainProcessParentEnv=async function(e=process.env){if(a)return a;if(i.isLinux){const e=process.ppid,t=n.basename(process.argv[0]);let i=0,s=e,o=t;do{i=s,(await r.readFile(`/proc/${i}/status`,"utf8")).split("\n").forEach(e=>{0===e.indexOf("Name:")&&(o=e.replace(/^Name:\s+/,"")),0===e.indexOf("PPid:")&&(s=parseInt(e.replace(/^PPid:\s+/,"")))})}while(o===t);const l=await r.readFile(`/proc/${i}/environ`,"utf8"),c={};l.split("\0").forEach(e=>{const t=e.indexOf("=");c[e.substr(0,t)]=e.substr(t+1)}),a=c}if(i.isMacintosh){a={},["SHELL","SSH_AUTH_SOCK","Apple_PubSub_Socket_Render","XPC_FLAGS","XPC_SERVICE_NAME","HOME","LOGNAME","TMPDIR"].forEach(t=>{e[t]&&(a[t]=e[t])})}return i.isWindows&&(a=e),a},t.findExecutable=async function(e,t,a,l=process.env){if(n.isAbsolute(e))return await r.exists(e)?e:void 0;if(void 0===t&&(t=process.cwd()),"."!==n.dirname(e)){const i=n.join(t,e);return await r.exists(i)?i:void 0}const c=o.getCaseInsensitive(l,"PATH");if(void 0===a&&s.isString(c)&&(a=c.split(n.delimiter)),
void 0===a||0===a.length){const i=n.join(t,e);return await r.exists(i)?i:void 0}for(let s of a){let o;if(o=n.isAbsolute(s)?n.join(s,e):n.join(t,s,e),await r.exists(o))return o;if(i.isWindows){let e=o+".com";if(await r.exists(e))return e;if(e=o+".exe",await r.exists(e))return e}}const u=n.join(t,e);return await r.exists(u)?u:void 0}})),define(t[185],i([0,1,3,5,21,6,86,2,38,13,12,87,7,136]),(function(e,t,i,r,n,a,l,c,u,h,d,f,p,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminalProcess=void 0;let m=class extends c.Disposable{constructor(e,t,n,s,o,c,u,h){var d;let f;super(),this._shellLaunchConfig=e,this._executableEnv=c,this._logService=h,this._currentTitle="",this._isDisposed=!1,this._titleInterval=null,this._writeQueue=[],this._onProcessData=this._register(new a.Emitter),this._onProcessExit=this._register(new a.Emitter),this._onProcessReady=this._register(new a.Emitter),this._onProcessTitleChanged=this._register(new a.Emitter),
f=r.isWindows?i.basename(this._shellLaunchConfig.executable||""):"xterm-256color",this._initialCwd=t;const p=u&&"win32"===process.platform&&l.getWindowsBuildNumber()>=18309;this._ptyOptions={name:f,cwd:t,env:o,cols:n,rows:s,useConpty:p,conptyInheritCursor:p&&!!e.initialText},r.isWindows&&p&&0===n&&0===s&&(null===(d=this._shellLaunchConfig.executable)||void 0===d?void 0:d.endsWith("Git\\bin\\bash.exe"))&&(this._delayedResizer=new v,this._register(this._delayedResizer.onTrigger(e=>{var t;null===(t=this._delayedResizer)||void 0===t||t.dispose(),this._delayedResizer=void 0,e.cols&&e.rows&&this.resize(e.cols,e.rows)})))}get exitMessage(){return this._exitMessage}get onProcessData(){return this._onProcessData.event}get onProcessExit(){return this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}get onProcessTitleChanged(){return this._onProcessTitleChanged.event}async start(){const e=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(e=>void 0!==e);if(e)return e
;try{return void await this.setupPtyProcess(this._shellLaunchConfig,this._ptyOptions)}catch(e){return this._logService.trace("IPty#spawn native exception",e),{message:`A native exception occurred during launch (${e.message})`}}}async _validateCwd(){try{if(!(await d.stat(this._initialCwd)).isDirectory())return{message:g.localize(0,null,this._initialCwd.toString())}}catch(e){if("ENOENT"===(null==e?void 0:e.code))return{message:g.localize(1,null,this._initialCwd.toString())}}}async _validateExecutable(){const e=this._shellLaunchConfig;if(!e.executable)throw new Error("IShellLaunchConfig.executable not set");try{const t=await d.stat(e.executable);if(!t.isFile()&&!t.isSymbolicLink())return{message:g.localize(2,null,e.executable)}}catch(t){if("ENOENT"===(null==t?void 0:t.code)){let t=e.cwd instanceof p.URI?e.cwd.path:e.cwd;const r=e.env&&e.env.PATH?e.env.PATH.split(i.delimiter):void 0;if(!await f.findExecutable(e.executable,t,r,this._executableEnv))return{message:g.localize(3,null,e.executable)}}}}
async setupPtyProcess(t,i){const r=t.args||[];this._logService.trace("IPty#spawn",t.executable,r,i);const n=(await new Promise((t,i)=>{e(["node-pty"],t,i)})).spawn(t.executable,r,i);this._ptyProcess=n,this._processStartupComplete=new Promise(e=>{this.onProcessReady(()=>e())}),n.onData(e=>{this._onProcessData.fire(e),this._closeTimeout&&(clearTimeout(this._closeTimeout),this._queueProcessExit())}),n.onExit(e=>{this._exitCode=e.exitCode,this._queueProcessExit()}),this._setupTitlePolling(n),this._sendProcessId(n.pid)}dispose(){this._isDisposed=!0,this._titleInterval&&clearInterval(this._titleInterval),this._titleInterval=null,this._onProcessData.dispose(),this._onProcessExit.dispose(),this._onProcessReady.dispose(),this._onProcessTitleChanged.dispose(),super.dispose()}_setupTitlePolling(e){setTimeout(()=>{this._sendProcessTitle(e)},0),r.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==e.process&&this._sendProcessTitle(e)},200))}_queueProcessExit(){
this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>this._kill(),250)}async _kill(){if(await this._processStartupComplete,!this._isDisposed){try{this._ptyProcess&&(this._logService.trace("IPty#kill"),this._ptyProcess.kill())}catch(e){}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}_sendProcessId(e){this._onProcessReady.fire({pid:e,cwd:this._initialCwd})}_sendProcessTitle(e){this._isDisposed||(this._currentTitle=e.process,this._onProcessTitleChanged.fire(this._currentTitle))}shutdown(e){e?this._kill():this._queueProcessExit()}input(e){if(!this._isDisposed&&this._ptyProcess){for(let t=0;t<=Math.floor(e.length/50);t++)this._writeQueue.push(e.substr(50*t,50));this._startWrite()}}_startWrite(){void 0===this._writeTimeout&&0!==this._writeQueue.length&&(this._doWrite(),0!==this._writeQueue.length?this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},5):this._writeTimeout=void 0)}_doWrite(){const e=this._writeQueue.shift()
;this._logService.trace("IPty#write",`${e.length} characters`),this._ptyProcess.write(e)}resize(e,t){if(!this._isDisposed&&"number"==typeof e&&"number"==typeof t&&!isNaN(e)&&!isNaN(t)&&this._ptyProcess){if(e=Math.max(e,1),t=Math.max(t,1),this._delayedResizer)return this._delayedResizer.cols=e,void(this._delayedResizer.rows=t);this._logService.trace("IPty#resize",e,t);try{this._ptyProcess.resize(e,t)}catch(e){if(this._logService.trace("IPty#resize exception "+e.message),void 0!==this._exitCode&&"ioctl(2) failed, EBADF"!==e.message)throw e}}}getInitialCwd(){return Promise.resolve(this._initialCwd)}getCwd(){return r.isMacintosh?new Promise(e=>{this._ptyProcess?(this._logService.trace("IPty#pid"),u.exec("lsof -OPl -p "+this._ptyProcess.pid+" | grep cwd",(t,i,r)=>{""!==i&&e(i.substring(i.indexOf("/"),i.length-1))})):e(this._initialCwd)}):r.isLinux?new Promise(e=>{this._ptyProcess?(this._logService.trace("IPty#pid"),n.readlink("/proc/"+this._ptyProcess.pid+"/cwd",(t,i)=>{t&&e(this._initialCwd),e(i)
})):e(this._initialCwd)}):new Promise(e=>{e(this._initialCwd)})}getLatency(){return Promise.resolve(0)}};m=s([o(7,h.ILogService)],m),t.TerminalProcess=m;class v extends c.Disposable{constructor(){super(),this._onTrigger=this._register(new a.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register({dispose:()=>{clearTimeout(this._timeout)}})}get onTrigger(){return this._onTrigger.event}dispose(){super.dispose(),clearTimeout(this._timeout)}}})),define(t[186],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IConfigurationResolverService=void 0,t.IConfigurationResolverService=i.createDecorator("configurationResolverService")})),define(t[187],i([0,1,3,41,11,20,5,43,137]),(function(e,t,i,r,n,s,o,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractVariableResolverService=void 0;class c{constructor(e,t,i,r=!1){if(this._ignoreEditorVariables=r,this._contributedVariables=new Map,this._context=e,
this._labelService=t,i)if(o.isWindows){const e=Object.create(null);this._envVariables=e,Object.keys(i).forEach(t=>{e[t.toLowerCase()]=i[t]})}else this._envVariables=i}resolve(e,t){return this.recursiveResolve(e?e.uri:void 0,t)}resolveAnyBase(e,t,i,r){const n=s.deepClone(t);return o.isWindows&&n.windows?Object.keys(n.windows).forEach(e=>n[e]=n.windows[e]):o.isMacintosh&&n.osx?Object.keys(n.osx).forEach(e=>n[e]=n.osx[e]):o.isLinux&&n.linux&&Object.keys(n.linux).forEach(e=>n[e]=n.linux[e]),delete n.windows,delete n.osx,delete n.linux,this.recursiveResolve(e?e.uri:void 0,n,i,r)}resolveAny(e,t,i){return this.resolveAnyBase(e,t,i)}resolveAnyMap(e,t,i){const r=new Map;return{newConfig:this.resolveAnyBase(e,t,i,r),resolvedVariables:r}}resolveWithInteractionReplace(e,t,i,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(e,t,i,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(e,t){
if(this._contributedVariables.has(e))throw new Error("Variable "+e+" is contributed twice.");this._contributedVariables.set(e,t)}recursiveResolve(e,t,i,r){if(n.isString(t))return this.resolveString(e,t,i,r);if(n.isArray(t))return t.map(t=>this.recursiveResolve(e,t,i,r));if(n.isObject(t)){let n=Object.create(null);return Object.keys(t).forEach(s=>{const o=this.resolveString(e,s,i,r);n[o]=this.recursiveResolve(e,t[s],i,r)}),n}return t}resolveString(e,t,i,r){return t.replace(c.VARIABLE_REGEXP,(t,n)=>{let s=this.evaluateSingleVariable(t,n,e,i);return r&&r.set(n,s),s})}fsPath(e){return this._labelService?this._labelService.getUriLabel(e,{noPrefix:!0}):e.fsPath}evaluateSingleVariable(e,t,s,c){let u;const h=t.split(":");h.length>1&&(t=h[0],u=h[1]);const d=()=>{const t=this._context.getFilePath();if(t)return t;throw new Error(l.localize(0,null,e))},f=(t=!0)=>{if(t&&u){const t=this._context.getFolderUri(u);if(t)return t;throw new Error(l.localize(1,null,e,u))}if(s)return s
;if(this._context.getWorkspaceFolderCount()>1)throw new Error(l.localize(2,null,e));throw new Error(l.localize(3,null,e))};switch(t){case"env":if(u){if(this._envVariables){const e=this._envVariables[o.isWindows?u.toLowerCase():u];if(n.isString(e))return e}return""}throw new Error(l.localize(4,null,e));case"config":if(u){const t=this._context.getConfigurationValue(f(!1),u);if(n.isUndefinedOrNull(t))throw new Error(l.localize(5,null,e,u));if(n.isObject(t))throw new Error(l.localize(6,null,e,u));return t}throw new Error(l.localize(7,null,e));case"command":return this.resolveFromMap(e,u,c,"command");case"input":return this.resolveFromMap(e,u,c,"input");default:switch(t){case"workspaceRoot":case"workspaceFolder":return a.normalizeDriveLetter(this.fsPath(f()));case"cwd":return s||u?a.normalizeDriveLetter(this.fsPath(f())):r.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return i.basename(this.fsPath(f()));case"lineNumber":if(this._ignoreEditorVariables)return e
;const n=this._context.getLineNumber();if(n)return n;throw new Error(l.localize(8,null,e));case"selectedText":if(this._ignoreEditorVariables)return e;const o=this._context.getSelectedText();if(o)return o;throw new Error(l.localize(9,null,e));case"file":return this._ignoreEditorVariables?e:d();case"relativeFile":return this._ignoreEditorVariables?e:s||u?i.relative(this.fsPath(f()),d()):d();case"relativeFileDirname":if(this._ignoreEditorVariables)return e;const h=i.dirname(d());if(s||u){const e=i.relative(this.fsPath(f()),h);return 0===e.length?".":e}return h;case"fileDirname":return this._ignoreEditorVariables?e:i.dirname(d());case"fileExtname":return this._ignoreEditorVariables?e:i.extname(d());case"fileBasename":return this._ignoreEditorVariables?e:i.basename(d());case"fileBasenameNoExtension":if(this._ignoreEditorVariables)return e;const p=i.basename(d());return p.slice(0,p.length-i.extname(p).length);case"execPath":const g=this._context.getExecPath();return g||e;default:try{
return this.resolveFromMap(e,t,c,void 0)}catch(t){return e}}}}resolveFromMap(e,t,i,r){if(t&&i){const n=void 0===r?i[t]:i[r+":"+t];if("string"==typeof n)return n;throw new Error(l.localize(10,null,e))}return e}}t.AbstractVariableResolverService=c,c.VARIABLE_REGEXP=/\$\{(.*?)\}/g})),define(t[188],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SIDE_GROUP=t.ACTIVE_GROUP=t.IEditorService=void 0,t.IEditorService=i.createDecorator("editorService"),t.ACTIVE_GROUP=-1,t.SIDE_GROUP=-2})),define(t[189],i([0,1,11,30,13,161,175,83,84,85,186,181,188,10,151]),(function(e,t,i,r,n,a,l,c,u,h,d,f,p,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteTerminalChannelClient=t.REMOTE_TERMINAL_CHANNEL_NAME=void 0,t.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let v=class{constructor(e,t,i,r,n,s,o,a,l,c){this._remoteAuthority=e,this._channel=t,this._configurationService=i,this._workspaceContextService=r,this._resolverService=n,this._environmentVariableService=s,
this._remoteAuthorityResolverService=o,this._logService=a,this._editorService=l,this._labelService=c}_readSingleTerminalConfiguration(e){const t=this._configurationService.inspect(e);return{userValue:t.userValue,value:t.value,defaultValue:t.defaultValue}}async createTerminalProcess(e,t,r,n,s,o){const a=this._configurationService.getValue(h.TERMINAL_CONFIG_SECTION),l={"terminal.integrated.automationShell.windows":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.windows"),"terminal.integrated.automationShell.osx":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.osx"),"terminal.integrated.automationShell.linux":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.linux"),"terminal.integrated.shell.windows":this._readSingleTerminalConfiguration("terminal.integrated.shell.windows"),"terminal.integrated.shell.osx":this._readSingleTerminalConfiguration("terminal.integrated.shell.osx"),
"terminal.integrated.shell.linux":this._readSingleTerminalConfiguration("terminal.integrated.shell.linux"),"terminal.integrated.shellArgs.windows":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.windows"),"terminal.integrated.shellArgs.osx":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.osx"),"terminal.integrated.shellArgs.linux":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.linux"),"terminal.integrated.env.windows":this._readSingleTerminalConfiguration("terminal.integrated.env.windows"),"terminal.integrated.env.osx":this._readSingleTerminalConfiguration("terminal.integrated.env.osx"),"terminal.integrated.env.linux":this._readSingleTerminalConfiguration("terminal.integrated.env.linux"),"terminal.integrated.inheritEnv":a.inheritEnv,"terminal.integrated.cwd":a.cwd,"terminal.integrated.detectLocale":a.detectLocale},c=Object.create(null),d=t?i.withNullAsUndefined(this._workspaceContextService.getWorkspaceFolder(t)):void 0;let p=void 0;try{
p=await this._resolverService.resolveWithInteraction(d,{shellLaunchConfig:e,configuration:l})}catch(e){this._logService.error(e)}if(p)for(const[e,t]of p.entries())(/^config:/.test(e)||"selectedText"===e||"lineNumber"===e)&&(c[e]=t);const m=[];for(const[e,t]of this._environmentVariableService.collections.entries())m.push([e,u.serializeEnvironmentVariableCollection(t.map)]);const v=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),y=v.options&&v.options.extensionHostEnv,E=this._workspaceContextService.getWorkspace(),w=E.folders,_=t?this._workspaceContextService.getWorkspaceFolder(t):null,b=f.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:f.SideBySideEditor.PRIMARY,filterByScheme:[g.Schemas.file,g.Schemas.userData,g.Schemas.vscodeRemote]}),S={configuration:l,resolvedVariables:c,envVariableCollections:m,shellLaunchConfig:e,workspaceId:E.id,workspaceName:this._labelService.getWorkspaceLabel(E),workspaceFolders:w,activeWorkspaceFolder:_,
activeFileResource:b,shouldPersistTerminal:r,cols:n,rows:s,isWorkspaceShellAllowed:o,resolverEnv:y};return await this._channel.call("$createTerminalProcess",S)}async startTerminalProcess(e){const t={id:e};return this._channel.call("$startTerminalProcess",t)}onTerminalProcessEvent(e){const t={id:e};return this._channel.listen("$onTerminalProcessEvent",t)}sendInputToTerminalProcess(e,t){const i={id:e,data:t};return this._channel.call("$sendInputToTerminalProcess",i)}shutdownTerminalProcess(e,t){const i={id:e,immediate:t};return this._channel.call("$shutdownTerminalProcess",i)}resizeTerminalProcess(e,t,i){const r={id:e,cols:t,rows:i};return this._channel.call("$resizeTerminalProcess",r)}getTerminalInitialCwd(e){const t={id:e};return this._channel.call("$getTerminalInitialCwd",t)}getTerminalCwd(e){const t={id:e};return this._channel.call("$getTerminalCwd",t)}sendCommandResultToTerminalProcess(e,t,i,r){const n={id:e,reqId:t,isError:i,payload:r};return this._channel.call("$sendCommandResultToTerminalProcess",n)}
orphanQuestionReply(e){const t={id:e};return this._channel.call("$orphanQuestionReply",t)}listTerminals(e){const t={isInitialization:e};return this._channel.call("$listTerminals",t)}};v=s([o(2,r.IConfigurationService),o(3,l.IWorkspaceContextService),o(4,d.IConfigurationResolverService),o(5,c.IEnvironmentVariableService),o(6,a.IRemoteAuthorityResolverService),o(7,n.ILogService),o(8,p.IEditorService),o(9,m.ILabelService)],v),t.RemoteTerminalChannelClient=v})),define(t[190],i([0,1,158]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Logger=t.Translations=void 0,function(e){e.equals=function(e,t){if(e===t)return!0;let i=Object.keys(e),r=new Set;for(let e of Object.keys(t))r.add(e);if(i.length!==r.size)return!1;for(let n of i){if(e[n]!==t[n])return!1;r.delete(n)}return 0===r.size}}(t.Translations||(t.Translations={}));t.Logger=class{constructor(e){this._messageHandler=e}error(e,t){this._messageHandler(i.Severity.Error,e,t)}warn(e,t){this._messageHandler(i.Severity.Warning,e,t)}
info(e,t){this._messageHandler(i.Severity.Info,e,t)}}})),define(t[191],i([0,1,138,3,46,36,19,115,11,7,12,32,53,39,190]),(function(e,t,i,r,n,s,o,a,l,c,u,h,d,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionScanner=t.ExtensionScannerInput=void 0;const g="package.json";class m{constructor(e,t,i,n,s){this._ourVersion=e,this._log=t,this._absoluteFolderPath=i,this._isBuiltin=n,this._isUnderDevelopment=s,this._absoluteManifestPath=r.join(i,g)}}class v extends m{parse(){return u.readFile(this._absoluteManifestPath).then(e=>{var t;const r=[],n=s.parse(e.toString(),r);if("object"!==s.getNodeType(n))this._log.error(this._absoluteFolderPath,i.localize(0,null,this._absoluteManifestPath));else{if(0===r.length)return n.__metadata&&(n.uuid=n.__metadata.id),n.isUserBuiltin=!!(null===(t=n.__metadata)||void 0===t?void 0:t.isBuiltin),delete n.__metadata,n;r.forEach(e=>{
this._log.error(this._absoluteFolderPath,i.localize(1,null,this._absoluteManifestPath,e.offset,e.length,a.getParseErrorMessage(e.error)))})}return null},e=>"ENOENT"===e.code?null:(this._log.error(this._absoluteFolderPath,i.localize(2,null,this._absoluteManifestPath,e.message)),null))}}class y extends m{constructor(e,t,i,r,n,s){super(e,t,i,r,n),this._nlsConfig=s}replaceNLS(e){const t=(e,t)=>{t.forEach(t=>{this._log.error(this._absoluteFolderPath,i.localize(3,null,e,a.getParseErrorMessage(t.error)))})},n=e=>{this._log.error(this._absoluteFolderPath,i.localize(4,null,e))};let o=r.extname(this._absoluteManifestPath),l=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-o.length);const c=`${e.publisher}.${e.name}`;let h,d=this._nlsConfig.translations[c];return(h=d?u.readFile(d,"utf8").then(e=>{let i=[],r=s.parse(e,i);if(i.length>0)return t(d,i),{values:void 0,default:`${l}.nls.json`};if("object"!==s.getNodeType(r))return n(d),{values:void 0,default:`${l}.nls.json`};return{
values:r.contents?r.contents.package:void 0,default:`${l}.nls.json`}},e=>({values:void 0,default:`${l}.nls.json`})):u.fileExists(l+".nls"+o).then(e=>{if(e)return y.findMessageBundles(this._nlsConfig,l).then(e=>e.localized?u.readFile(e.localized,"utf8").then(i=>{let r=[],o=s.parse(i,r);return r.length>0?(t(e.localized,r),{values:void 0,default:e.original}):"object"!==s.getNodeType(o)?(n(e.localized),{values:void 0,default:e.original}):{values:o,default:e.original}},t=>({values:void 0,default:e.original})):{values:void 0,default:e.original},e=>{})})).then(i=>{if(void 0===i)return e;let r=[];return y.resolveOriginalMessageBundle(i.default,r).then(o=>{if(r.length>0)return t(i.default,r),e;if("object"!==s.getNodeType(i))return n(i.default),e;const a=i.values||Object.create(null);return y._replaceNLStrings(this._nlsConfig,e,a,o,this._log,this._absoluteFolderPath),e})},t=>e)}static resolveOriginalMessageBundle(e,t){return new Promise((i,r)=>{e?u.readFile(e).then(e=>{i(s.parse(e.toString(),t))},e=>{i(null)}):i(null)
})}static findMessageBundles(e,t){return new Promise((i,r)=>{if(e.devMode||e.pseudo||!e.locale)return i({localized:t+".nls.json",original:null});!function e(t,r){let n=`${t}.nls.${r}.json`;u.fileExists(n).then(s=>{s&&i({localized:n,original:`${t}.nls.json`});let o=r.lastIndexOf("-");-1===o?i({localized:`${t}.nls.json`,original:null}):(r=r.substring(0,o),e(t,r))})}(t,e.locale)})}static _replaceNLStrings(e,t,r,n,s,o){function a(t,c,u){let h=t[c];if(l.isString(h)){let a=h,l=a.length;if(l>1&&"%"===a[0]&&"%"===a[l-1]){let h=a.substr(1,l-2),d=r[h];void 0===d&&n&&(d=n[h]),d?(e.pseudo&&(d="［"+d.replace(/[aouei]/g,"$&$&")+"］"),t[c]=u&&("title"===c||"category"===c)&&n?{value:d,original:n[h]}:d):s.warn(o,i.localize(5,null,h))}}else if(l.isObject(h))for(let e in h)h.hasOwnProperty(e)&&a(h,e,"commands"===e||u);else if(l.isArray(h))for(let e=0;e<h.length;e++)a(h,e,u)}for(let e in t)t.hasOwnProperty(e)&&a(t,e)}}class E extends m{validate(e){let t=e;t.isBuiltin=this._isBuiltin,
t.isUserBuiltin=!this._isBuiltin&&!!t.isUserBuiltin,t.isUnderDevelopment=this._isUnderDevelopment;let i=[];return E.isValidExtensionDescription(this._ourVersion,this._absoluteFolderPath,t,i)?(i.forEach(e=>{this._log.warn(this._absoluteFolderPath,e)}),t.publisher||(t.publisher="undefined_publisher"),t.id=`${t.publisher}.${t.name}`,t.identifier=new f.ExtensionIdentifier(t.id),t.extensionLocation=c.URI.file(this._absoluteFolderPath),t):(i.forEach(e=>{this._log.error(this._absoluteFolderPath,e)}),null)}static isValidExtensionDescription(e,t,r,s){return!!E.baseIsValidExtensionDescription(t,r,s)&&(n.valid(r.version)?d.isValidExtensionVersion(e,r,s):(s.push(i.localize(6,null)),!1))}static baseIsValidExtensionDescription(e,t,n){if(!t)return n.push(i.localize(7,null)),!1;if(void 0!==t.publisher&&"string"!=typeof t.publisher)return n.push(i.localize(8,null)),!1;if("string"!=typeof t.name)return n.push(i.localize(9,null,"name")),!1;if("string"!=typeof t.version)return n.push(i.localize(10,null,"version")),!1
;if(!t.engines)return n.push(i.localize(11,null,"engines")),!1;if("string"!=typeof t.engines.vscode)return n.push(i.localize(12,null,"engines.vscode")),!1;if(void 0!==t.extensionDependencies&&!E._isStringArray(t.extensionDependencies))return n.push(i.localize(13,null,"extensionDependencies")),!1;if(void 0!==t.activationEvents){if(!E._isStringArray(t.activationEvents))return n.push(i.localize(14,null,"activationEvents")),!1;if(void 0===t.main&&void 0===t.browser)return n.push(i.localize(15,null,"activationEvents","main")),!1}if(void 0!==t.main){if("string"!=typeof t.main)return n.push(i.localize(16,null,"main")),!1;{const s=r.join(e,t.main);s.startsWith(e)||n.push(i.localize(17,null,s,e))}if(void 0===t.activationEvents)return n.push(i.localize(18,null,"activationEvents","main")),!1}if(void 0!==t.browser){if("string"!=typeof t.browser)return n.push(i.localize(19,null,"browser")),!1;{const s=r.join(e,t.browser);s.startsWith(e)||n.push(i.localize(20,null,s,e))}
if(void 0===t.activationEvents)return n.push(i.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(e){if(!Array.isArray(e))return!1;for(let t=0,i=e.length;t<i;t++)if("string"!=typeof e[t])return!1;return!0}}class w{constructor(e,t,i,r,n,s,o,a){this.ourVersion=e,this.commit=t,this.locale=i,this.devMode=r,this.absoluteFolderPath=n,this.isBuiltin=s,this.isUnderDevelopment=o,this.translations=a}static createNLSConfig(e){return{devMode:e.devMode,locale:e.locale,pseudo:"pseudo"===e.locale,translations:e.translations}}static equals(e,t){return e.ourVersion===t.ourVersion&&e.commit===t.commit&&e.locale===t.locale&&e.devMode===t.devMode&&e.absoluteFolderPath===t.absoluteFolderPath&&e.isBuiltin===t.isBuiltin&&e.isUnderDevelopment===t.isUnderDevelopment&&e.mtime===t.mtime&&p.Translations.equals(e.translations,t.translations)}}t.ExtensionScannerInput=w;class _{constructor(e){this.root=e}resolveExtensions(){return u.readDirsInDir(this.root).then(e=>e.map(e=>({name:e,path:r.join(this.root,e)
})))}}t.ExtensionScanner=class{static scanExtension(e,t,i,n,s,o){return i=r.normalize(i),new v(e,t,i,n,s).parse().then(r=>{if(null===r)return null;return new y(e,t,i,n,s,o).replaceNLS(r)}).then(r=>{if(null===r)return null;return new E(e,t,i,n,s).validate(r)})}static async scanExtensions(e,t,i=null){const s=e.absoluteFolderPath,a=e.isBuiltin,l=e.isUnderDevelopment;i||(i=new _(s));try{let c={};if(!a)try{const e=await u.readFile(r.join(s,".obsolete"),"utf8");c=JSON.parse(e)}catch(e){}let d=await i.resolveExtensions();d.sort((e,t)=>e.name<t.name?-1:1),a||(d=d.filter(e=>0!==e.name.indexOf(".")));const f=w.createNLSConfig(e);let p=await Promise.all(d.map(i=>this.scanExtension(e.ourVersion,t,i.path,a,l,f))),g=o.coalesce(p);if(g=g.filter(e=>null!==e&&!c[new h.ExtensionIdentifierWithVersion({id:h.getGalleryExtensionId(e.publisher,e.name)},e.version).key()]),!a){g=h.groupByExtension(g,e=>({id:e.identifier.value,uuid:e.uuid})).map(e=>e.sort((e,t)=>n.rcompare(e.version,t.version))[0])}
return g.sort((e,t)=>e.extensionLocation.fsPath<t.extensionLocation.fsPath?-1:1),g}catch(e){return t.error(s,e),[]}}static scanOneOrMultipleExtensions(e,t){const i=e.absoluteFolderPath,n=e.isBuiltin,s=e.isUnderDevelopment;return u.fileExists(r.join(i,g)).then(r=>{if(r){const r=w.createNLSConfig(e);return this.scanExtension(e.ourVersion,t,i,n,s,r).then(e=>null===e?[]:[e])}return this.scanExtensions(e,t)},e=>(t.error(i,e),[]))}static scanSingleExtension(e,t){const i=e.absoluteFolderPath,r=e.isBuiltin,n=e.isUnderDevelopment,s=w.createNLSConfig(e);return this.scanExtension(e.ourVersion,t,i,r,n,s)}static mergeBuiltinExtensions(e,t){return Promise.all([e,t]).then(([e,t])=>{let i=Object.create(null);for(let t=0,r=e.length;t<r;t++)i[f.ExtensionIdentifier.toKey(e[t].identifier)]=e[t];for(let e=0,r=t.length;e<r;e++)i[f.ExtensionIdentifier.toKey(t[e].identifier)]=t[e];let n=Object.keys(i).map(e=>i[e]);return n.sort((e,t)=>{const i=r.basename(e.extensionLocation.fsPath),n=r.basename(t.extensionLocation.fsPath)
;return i<n?-1:i>n?1:0}),n})}}})),define(t[192],i([0,1,34,207,27,44,17,23,6,5,18,7,51,39,56,28,60,82,182,84,183,184,86,87,185,187,191]),(function(e,t,i,r,n,s,o,a,l,c,u,h,d,f,p,g,m,v,y,E,w,_,b,S,C,x,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminalProviderChannel=t.NodeProxyService=t.ExtensionEnvironmentChannel=t.FileProviderChannel=void 0;class P extends p.DiskFileSystemProvider{constructor(){super(...arguments),this.watches=new Map}dispose(){this.watches.forEach(e=>e.dispose()),this.watches.clear(),super.dispose()}_watch(e,t,i){this.watches.set(e,this.watch(t,i))}unwatch(e){this.watches.get(e).dispose(),this.watches.delete(e)}}t.FileProviderChannel=class{constructor(e,t){this.environmentService=e,this.logService=t,this.watchers=new Map,this.provider=new p.DiskFileSystemProvider(this.logService)}listen(e,t,i){switch(t){case"filechange":return this.filechange(e,i[0]);case"readFileStream":return this.readFileStream(i[0],i[1])}throw new Error(`Invalid listen '${t}'`)}filechange(e,t){
const i=new l.Emitter({onFirstListenerAdd:()=>{const r=new P(this.logService);this.watchers.set(t,r);const n=v.getUriTransformer(e.remoteAuthority);r.onDidChangeFile(e=>{i.fire(e.map(e=>Object.assign(Object.assign({},e),{resource:n.transformOutgoing(e.resource)})))}),r.onDidErrorOccur(e=>this.logService.error(e))},onLastListenerRemove:()=>{this.watchers.get(t).dispose(),this.watchers.delete(t)}});return i.event}readFileStream(e,t){const i=new a.CancellationTokenSource,r=this.provider.readFileStream(this.transform(e),t,i.token),n=new l.Emitter({onFirstListenerAdd:()=>{r.on("data",e=>n.fire(o.VSBuffer.wrap(e))),r.on("error",e=>n.fire(e)),r.on("end",()=>n.fire("end"))},onLastListenerRemove:()=>i.cancel()});return n.event}call(e,t,i){switch(t){case"stat":return this.stat(i[0]);case"open":return this.open(i[0],i[1]);case"close":return this.close(i[0]);case"read":return this.read(i[0],i[1],i[2]);case"readFile":return this.readFile(i[0]);case"write":return this.write(i[0],i[1],i[2],i[3],i[4]);case"writeFile":
return this.writeFile(i[0],i[1],i[2]);case"delete":return this.delete(i[0],i[1]);case"mkdir":return this.mkdir(i[0]);case"readdir":return this.readdir(i[0]);case"rename":return this.rename(i[0],i[1],i[2]);case"copy":return this.copy(i[0],i[1],i[2]);case"watch":return this.watch(i[0],i[1],i[2],i[3]);case"unwatch":return this.unwatch(i[0],i[1])}throw new Error(`Invalid call '${t}'`)}dispose(){this.watchers.forEach(e=>e.dispose()),this.watchers.clear()}async stat(e){return this.provider.stat(this.transform(e))}async open(e,t){return this.provider.open(this.transform(e),t)}async close(e){return this.provider.close(e)}async read(e,t,i){const r=o.VSBuffer.alloc(i);return[r,await this.provider.read(e,t,r.buffer,0,i)]}async readFile(e){return o.VSBuffer.wrap(await this.provider.readFile(this.transform(e)))}write(e,t,i,r,n){return this.provider.write(e,t,i.buffer,r,n)}writeFile(e,t,i){return this.provider.writeFile(this.transform(e),t.buffer,i)}async delete(e,t){return this.provider.delete(this.transform(e),t)}
async mkdir(e){return this.provider.mkdir(this.transform(e))}async readdir(e){return this.provider.readdir(this.transform(e))}async rename(e,t,i){return this.provider.rename(this.transform(e),h.URI.from(t),i)}copy(e,t,i){return this.provider.copy(this.transform(e),h.URI.from(t),i)}async watch(e,t,i,r){this.watchers.get(e)._watch(t,this.transform(i),r)}async unwatch(e,t){this.watchers.get(e).unwatch(t)}transform(e){if(/^\/static[^/]*\//.test(e.path))return h.URI.file(this.environmentService.appRoot+e.path.replace(/^\/static[^/]*\//,"/"));if("/vscode-resource"===e.path&&e.query)try{const t=JSON.parse(e.query);if(t.requestResourcePath)return h.URI.file(t.requestResourcePath)}catch(e){}return h.URI.from(e)}};t.ExtensionEnvironmentChannel=class{constructor(e,t,i,r){this.environment=e,this.log=t,this.telemetry=i,this.connectionToken=r}listen(e,t){throw new Error(`Invalid listen '${t}'`)}async call(e,t,i){switch(t){case"getEnvironmentData":
return d.transformOutgoingURIs(await this.getEnvironmentData(),v.getUriTransformer(e.remoteAuthority));case"scanExtensions":return d.transformOutgoingURIs(await this.scanExtensions(i.language),v.getUriTransformer(e.remoteAuthority));case"getDiagnosticInfo":return this.getDiagnosticInfo();case"disableTelemetry":return this.disableTelemetry();case"logTelemetry":return this.logTelemetry(i[0],i[1]);case"flushTelemetry":return this.flushTelemetry()}throw new Error(`Invalid call '${t}'`)}async getEnvironmentData(){return{pid:process.pid,connectionToken:this.connectionToken,appRoot:h.URI.file(this.environment.appRoot),settingsPath:this.environment.settingsResource,logsPath:h.URI.file(this.environment.logsPath),extensionsPath:h.URI.file(this.environment.extensionsPath),extensionHostLogsPath:h.URI.file(s.join(this.environment.logsPath,"extension-host")),globalStorageHome:this.environment.globalStorageHome,workspaceStorageHome:this.environment.workspaceStorageHome,userHome:this.environment.userHome,os:c.OS}}
async scanExtensions(e){const t=await m.getTranslations(e,this.environment.userDataPath),i=(i,r,n)=>Promise.all(n.map(n=>I.ExtensionScanner.scanExtensions(new I.ExtensionScannerInput(g.default.version,g.default.commit,e,!!process.env.VSCODE_DEV,n,i,r,t),this.log)));return Promise.all([(async()=>i(!0,!1,[this.environment.builtinExtensionsPath,...this.environment.extraBuiltinExtensionPaths]))(),(async()=>i(!1,!0,[this.environment.extensionsPath,...this.environment.extraExtensionPaths]))()]).then(e=>{const t=new Map;return e.forEach(e=>{e.forEach(e=>{e.forEach(e=>{const i=f.ExtensionIdentifier.toKey(e.identifier);if(t.has(i)){const r=t.get(i).extensionLocation.fsPath,n=e.extensionLocation.fsPath;this.log.warn(`${r} has been overridden ${n}`)}t.set(i,Object.assign(Object.assign({},e),{extensionKind:"vscodevim.vim"===e.identifier.value?["web"]:e.extensionKind}))})})}),Array.from(t.values())})}getDiagnosticInfo(){throw new Error("not implemented")}async disableTelemetry(){this.telemetry.setEnabled(!1)}
async logTelemetry(e,t){this.telemetry.publicLog(e,t)}async flushTelemetry(){}};t.NodeProxyService=class{constructor(){this._serviceBrand=void 0,this._onMessage=new l.Emitter,this.onMessage=this._onMessage.event,this._$onMessage=new l.Emitter,this.$onMessage=this._$onMessage.event,this._onDown=new l.Emitter,this.onDown=this._onDown.event,this._onUp=new l.Emitter,this.onUp=this._onUp.event,this._onClose=new l.Emitter,this.onClose=this._onClose.event,this.server=new r.Server({onMessage:this.$onMessage,onClose:this.onClose,onDown:this.onDown,onUp:this.onUp,send:e=>{this._onMessage.fire(e)}})}send(e){this._$onMessage.fire(e)}};class T extends x.AbstractVariableResolverService{constructor(e,t,i){super({getFolderUri:e=>{const i=t.workspaceFolders.find(t=>t.name===e);return i&&h.URI.revive(i.uri)},getWorkspaceFolderCount:()=>t.workspaceFolders.length,getConfigurationValue:(e,i)=>t.resolvedVariables[`config:${i}`],getExecPath:()=>t.resolverEnv&&t.resolverEnv.VSCODE_EXEC_PATH||i.VSCODE_EXEC_PATH,getFilePath:()=>{
const i=L(e,t.activeFileResource);if(i)return"file"===i.scheme?i.fsPath:i.path},getSelectedText:()=>t.resolvedVariables.selectedText,getLineNumber:()=>t.resolvedVariables.selectedText},void 0,i)}}class k{constructor(e,t,r,n,s){this.id=e,this._pid=-1,this._title="",this._onDispose=new l.Emitter,this._isOrphan=!0,this.replayData=[],this.maxReplayData=1e4,this.totalReplayData=0,this.disposeDelay=1728e5,this.buffering=!1,this._onEvent=new l.Emitter({onFirstListenerAdd:()=>{i.logger.debug("Terminal bound",i.field("id",this.id)),this._isOrphan=!1,this.buffering||(this.buffering=!0,this.bufferer.startBuffering(this.id,this.process.onProcessData))},onFirstListenerDidAdd:()=>{void 0===this.disposeTimeout&&(clearTimeout(this.disposeTimeout),this.disposeTimeout=void 0,i.logger.debug("Terminal replaying",i.field("id",this.id)),this._onEvent.fire({type:"replay",events:[{cols:this.cols,rows:this.rows,data:this.replayData.join("")}]}))},onLastListenerRemove:()=>{i.logger.debug("Terminal unbound",i.field("id",this.id)),
this._isOrphan=!0,this.persist?this.disposeTimeout=setTimeout(()=>{this.dispose()},this.disposeDelay):this.dispose()}}),this.bufferer=new w.TerminalDataBufferer((e,t)=>{if(this._onEvent.fire({type:"data",data:t}),!this.persist)return;this.replayData.push(t),this.totalReplayData+=t.length;let i=this.totalReplayData-this.maxReplayData;if(i<=0)return;let r=0;for(;r<this.replayData.length&&this.replayData[r].length<=i;++r)i-=this.replayData[r].length;r>0&&this.replayData.splice(0,r),i>0&&this.replayData.length>0&&(this.replayData[0]=this.replayData[0].substring(i)),this.totalReplayData=this.replayData.reduce((e,t)=>e+t.length,0)}),this.workspaceId=r.workspaceId,this.workspaceName=r.workspaceName,this.cols=r.cols,this.rows=r.rows,this.persist=!1,this.process=new C.TerminalProcess(t,t.cwd,this.cols,this.rows,n,process.env,!1,s),this.process.onProcessReady(e=>{this._pid=e.pid,this._onEvent.fire({type:"ready",pid:e.pid,cwd:e.cwd})}),this.process.onProcessTitleChanged(e=>{this._title=e,this._onEvent.fire({
type:"titleChanged",title:e})}),this.process.onProcessExit(e=>{i.logger.debug("Terminal exited",i.field("id",this.id),i.field("code",e)),this._onEvent.fire({type:"exit",exitCode:e}),this.dispose()})}get onDispose(){return this._onDispose.event}get isOrphan(){return this._isOrphan}get onEvent(){return this._onEvent.event}get pid(){return this._pid}get title(){return this._title}dispose(){i.logger.debug("Terminal disposing",i.field("id",this.id)),this._onEvent.dispose(),this.bufferer.dispose(),this.process.dispose(),this.process.shutdown(!0),this._onDispose.fire(),this._onDispose.dispose()}shutdown(e){return this.process.shutdown(e)}getCwd(){return this.process.getCwd()}getInitialCwd(){return this.process.getInitialCwd()}start(){return this.process.start()}input(e){return this.process.input(e)}resize(e,t){return this.cols=e,this.rows=t,this.process.resize(e,t)}}function L(e,t){const i=v.getUriTransformer(e);return t?h.URI.revive(i.transformIncoming(t)):t}t.TerminalProviderChannel=class{constructor(e){
this.logService=e,this.terminals=new Map,this.id=0}listen(e,t,i){switch(t){case"$onTerminalProcessEvent":return this.onTerminalProcessEvent(i)}throw new Error(`Invalid listen '${t}'`)}onTerminalProcessEvent(e){return this.getTerminal(e.id).onEvent}call(e,t,i){switch(t){case"$createTerminalProcess":return this.createTerminalProcess(e.remoteAuthority,i);case"$startTerminalProcess":return this.startTerminalProcess(i);case"$sendInputToTerminalProcess":return this.sendInputToTerminalProcess(i);case"$shutdownTerminalProcess":return this.shutdownTerminalProcess(i);case"$resizeTerminalProcess":return this.resizeTerminalProcess(i);case"$getTerminalInitialCwd":return this.getTerminalInitialCwd(i);case"$getTerminalCwd":return this.getTerminalCwd(i);case"$sendCommandResultToTerminalProcess":return this.sendCommandResultToTerminalProcess(i);case"$orphanQuestionReply":return this.orphanQuestionReply(i[0]);case"$listTerminals":return this.listTerminals(i[0])}throw new Error(`Invalid call '${t}'`)}dispose(){
this.terminals.forEach(e=>e.dispose())}async createTerminalProcess(e,t){var r;const s=this.id++;i.logger.debug("Creating terminal",i.field("id",s),i.field("terminals",this.terminals.size));const o={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:"string"!=typeof t.shellLaunchConfig.cwd?L(e,t.shellLaunchConfig.cwd):t.shellLaunchConfig.cwd,env:t.shellLaunchConfig.env},a=L(e,null===(r=t.activeWorkspaceFolder)||void 0===r?void 0:r.uri),l=a&&t.activeWorkspaceFolder?Object.assign(Object.assign({},t.activeWorkspaceFolder),{uri:a,toResource:e=>u.joinPath(a,e)}):void 0,h=new T(e,t,process.env),d=_.createVariableResolver(l,h),f=Object.assign(Object.assign(Object.assign({},o),(()=>{if(o.executable){const e=h.resolve(l,o.executable);let t=[];if(o.args&&Array.isArray(o.args))for(const e of o.args)t.push(h.resolve(l,e));else o.args&&(t=h.resolve(l,o.args));return{executable:e,args:t}}return{
executable:_.getDefaultShell(e=>t.configuration[e],t.isWorkspaceShellAllowed,b.getSystemShell(c.platform),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,d,this.logService,!1),args:_.getDefaultShellArgs(e=>t.configuration[e],t.isWorkspaceShellAllowed,!1,d,this.logService)}})()),{cwd:(()=>_.getCwd(o,n.homedir(),d,a,t.configuration["terminal.integrated.cwd"],this.logService))()});i.logger.debug("Resolved shell launch configuration",i.field("id",s));const p=_.createTerminalEnvironment(o,(()=>c.isWindows?t.configuration["terminal.integrated.env.windows"]:c.isMacintosh?t.configuration["terminal.integrated.env.osx"]:t.configuration["terminal.integrated.env.linux"])(),d,t.isWorkspaceShellAllowed,g.default.version,t.configuration["terminal.integrated.detectLocale"],!1!==t.configuration["terminal.integrated.inheritEnv"]?process.env:await(async()=>{const e=await S.getMainProcessParentEnv();return e.VSCODE_IPC_HOOK_CLI=process.env.VSCODE_IPC_HOOK_CLI,e})());if(!o.strictEnv){const e=new Map
;for(const[i,r]of t.envVariableCollections)e.set(i,{map:E.deserializeEnvironmentVariableCollection(r)});new y.MergedEnvironmentVariableCollection(e).applyToProcessEnvironment(p)}i.logger.debug("Resolved terminal environment",i.field("id",s));const m=new k(s,f,t,p,this.logService);return this.terminals.set(s,m),i.logger.debug("Created terminal",i.field("id",s)),m.onDispose(()=>this.terminals.delete(s)),{terminalId:s,resolvedShellLaunchConfig:f}}getTerminal(e){const t=this.terminals.get(e);if(!t)throw new Error(`terminal with id ${e} does not exist`);return t}async startTerminalProcess(e){return this.getTerminal(e.id).start()}async sendInputToTerminalProcess(e){return this.getTerminal(e.id).input(e.data)}async shutdownTerminalProcess(e){return this.getTerminal(e.id).shutdown(e.immediate)}async resizeTerminalProcess(e){return this.getTerminal(e.id).resize(e.cols,e.rows)}async getTerminalInitialCwd(e){return this.getTerminal(e.id).getInitialCwd()}async getTerminalCwd(e){return this.getTerminal(e.id).getCwd()}
async sendCommandResultToTerminalProcess(e){throw new Error("not implemented")}async orphanQuestionReply(e){throw new Error("not implemented")}async listTerminals(e){return(await Promise.all(Array.from(this.terminals).map(async([e,t])=>{const i=await t.getCwd();return{id:e,pid:t.pid,title:t.title,cwd:i,workspaceId:t.workspaceId,workspaceName:t.workspaceName,isOrphan:t.isOrphan}}))).filter(e=>e.isOrphan)}}})),define(t[193],i([0,1,6,2,7,26,17,42,14,45]),(function(e,t,i,r,n,s,o,a,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteFileSystemProvider=t.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,t.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class u extends r.Disposable{constructor(e){super(),this.session=s.generateUuid(),this._onDidChange=this._register(new i.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new i.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new i.Emitter),
this.onDidChangeCapabilities=this._onDidChangeCapabilities.event;const r=e.getConnection();this.channel=r.getChannel(t.REMOTE_FILE_SYSTEM_CHANNEL_NAME),this.setCaseSensitive(!0),(async()=>{const t=await e.getEnvironment();this.setCaseSensitive(3===(null==t?void 0:t.os))})(),this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(e=>{if(Array.isArray(e)){const t=e;this._onDidChange.fire(t.map(e=>({resource:n.URI.revive(e.resource),type:e.type})))}else{const t=e;this._onDidWatchErrorOccur.fire(t)}}))}setCaseSensitive(e){let t=30;e&&(t|=1024),this._capabilities=t,this._onDidChangeCapabilities.fire(void 0)}stat(e){return this.channel.call("stat",[e])}open(e,t){return this.channel.call("open",[e,t])}close(e){return this.channel.call("close",[e])}async read(e,t,i,r,n){const[s,o]=await this.channel.call("read",[e,t,n]);return i.set(s.buffer.slice(0,o),r),o}async readFile(e){
return(await this.channel.call("readFile",[e])).buffer}readFileStream(e,t,i){const r=a.newWriteableStream(e=>o.VSBuffer.concat(e.map(e=>o.VSBuffer.wrap(e))).buffer),n=this.channel.listen("readFileStream",[e,t])(e=>{if(e instanceof o.VSBuffer)r.write(e.buffer);else{if("end"===e)r.end();else{let t=e;t instanceof Error||(t=new Error(c.toErrorMessage(t))),r.end(t)}n.dispose()}});return i.onCancellationRequested(()=>{r.end(l.canceled()),n.dispose()}),r}write(e,t,i,r,n){return this.channel.call("write",[e,t,o.VSBuffer.wrap(i),r,n])}writeFile(e,t,i){return this.channel.call("writeFile",[e,o.VSBuffer.wrap(t),i])}delete(e,t){return this.channel.call("delete",[e,t])}mkdir(e){return this.channel.call("mkdir",[e])}readdir(e){return this.channel.call("readdir",[e])}rename(e,t,i){return this.channel.call("rename",[e,t,i])}copy(e,t,i){return this.channel.call("copy",[e,t,i])}watch(e,t){const i=Math.random();return this.channel.call("watch",[this.session,i,e,t]),
r.toDisposable(()=>this.channel.call("unwatch",[this.session,i]))}}t.RemoteFileSystemProvider=u})),define(t[194],i([0,1,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IRemoteAgentService=t.RemoteExtensionLogFileName=void 0,t.RemoteExtensionLogFileName="remoteagent",t.IRemoteAgentService=i.createDecorator("remoteAgentService")})),define(t[50],i([0,1,117,3,21,15,12,208,209,11]),(function(e,t,i,r,n,s,o,a,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class u extends Error{constructor(e,t){let i=t.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`}super(i),this.type=e,this.cause=t}}function h(e){if(e instanceof u)return e;let t=void 0;return/end of central directory record signature not found/.test(e.message)&&(t="CorruptZip"),new u(t,e)}function d(e,t,a,l){let c=s.createCancelablePromise(()=>Promise.resolve()),h=0;return l.onCancellationRequested(()=>{c.cancel(),e.close()}),new Promise((d,f)=>{
const g=new s.Sequencer,m=t=>{t.isCancellationRequested||(h++,e.readEntry())};e.once("error",f),e.once("close",()=>c.then(()=>{l.isCancellationRequested||e.entryCount===h?d():f(new u("Incomplete",new Error(i.localize(1,null,h,e.entryCount))))},f)),e.readEntry(),e.on("entry",u=>{if(l.isCancellationRequested)return;if(!a.sourcePathRegex.test(u.fileName))return void m(l);const h=u.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(h)){const e=r.join(t,h);return void(c=s.createCancelablePromise(t=>o.mkdirp(e).then(()=>m(t)).then(void 0,f)))}const d=p(e,u),v=function(e){const t=e.externalFileAttributes>>16||33188;return[448,56,7].map(e=>t&e).reduce((e,t)=>e+t,61440&t)}(u);c=s.createCancelablePromise(e=>g.queue(()=>d.then(s=>(function(e,t,s,a,l,c){const u=r.dirname(t),h=r.join(a,u);if(!h.startsWith(a))return Promise.reject(new Error(i.localize(0,null,t)));const d=r.join(a,t);let f;return c.onCancellationRequested(()=>{f&&f.destroy()}),Promise.resolve(o.mkdirp(h)).then(()=>new Promise((t,i)=>{
if(!c.isCancellationRequested)try{(f=n.createWriteStream(d,{mode:s})).once("close",()=>t()),f.once("error",i),e.once("error",i),e.pipe(f)}catch(e){i(e)}}))})(s,h,v,t,0,e).then(()=>m(e)))).then(null,f))})})}function f(e,t=!1){return new Promise((i,r)=>{a.open(e,t?{lazyEntries:!0}:void 0,(e,t)=>{e?r(h(e)):i(c.assertIsDefined(t))})})}function p(e,t){return new Promise((i,r)=>{e.openReadStream(t,(e,t)=>{e?r(h(e)):i(c.assertIsDefined(t))})})}t.ExtractError=u,t.zip=function(e,t){return new Promise((i,r)=>{const s=new l.ZipFile;t.forEach(e=>{e.contents?s.addBuffer("string"==typeof e.contents?Buffer.from(e.contents,"utf8"):e.contents,e.path):e.localPath&&s.addFile(e.localPath,e.path)}),s.end();const o=n.createWriteStream(e);s.outputStream.pipe(o),s.outputStream.once("error",r),o.once("error",r),o.once("finish",()=>i(e))})},t.extract=function(e,t,i={},r){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=f(e,!0);return i.overwrite&&(s=s.then(e=>o.rimraf(t).then(()=>e))),s.then(e=>d(e,t,{sourcePathRegex:n
},r))},t.buffer=function(e,t){return function(e,t){return f(e).then(e=>new Promise((r,n)=>{e.on("entry",i=>{i.fileName===t&&p(e,i).then(e=>r(e),e=>n(e))}),e.once("close",()=>n(new Error(i.localize(2,null,t))))}))}(e,t).then(e=>new Promise((t,i)=>{const r=[];e.once("error",i),e.on("data",e=>r.push(e)),e.on("end",()=>t(Buffer.concat(r)))}))}})),define(t[88],i([0,1,50,122]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0,t.getManifest=function(e){return i.buffer(e,"extension/package.json").then(e=>{try{return JSON.parse(e.toString("utf8"))}catch(e){throw new Error(r.localize(0,null))}})}})),define(t[195],i([0,1,46,2,12,3,13,31,32,15,7,22,141,123,47,50,5,19,10]),(function(e,t,i,r,n,a,l,c,u,h,d,f,p,g,m,v,y,E,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let _=class extends r.Disposable{constructor(e,t,i,r){super(),this.beforeRemovingExtension=e,this.logService=t,this.environmentService=i,this.productService=r,
this._devSystemExtensionsPath=null,this.systemExtensionsPath=i.builtinExtensionsPath,this.extensionsPath=i.extensionsPath,this.uninstalledPath=a.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new h.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(e){const t=[];null!==e&&0!==e||t.push(this.scanSystemExtensions().then(null,e=>Promise.reject(new c.ExtensionManagementError(this.joinErrors(e).message,"scanningSystem")))),null!==e&&1!==e||t.push(this.scanUserExtensions(!0).then(null,e=>Promise.reject(new c.ExtensionManagementError(this.joinErrors(e).message,"scanningUser"))));try{const e=await Promise.all(t);return E.flatten(e)}catch(e){throw this.joinErrors(e)}}async scanUserExtensions(e){this.logService.trace("Started scanning user extensions");let[t,r]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()])
;if(r=r.filter(e=>!t[new u.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version).key()]),e){r=u.groupByExtension(r,e=>e.identifier).map(e=>e.sort((e,t)=>i.rcompare(e.manifest.version,t.manifest.version))[0])}return this.logService.trace("Scanned user extensions:",r.length),r}async scanAllUserExtensions(){return this.scanExtensionsInDirs(this.extensionsPath,this.environmentService.extraExtensionPaths,1)}async extractUserExtension(e,t,i){const r=e.key(),s=a.join(this.extensionsPath,`.${r}`),o=a.join(this.extensionsPath,r);try{await n.rimraf(o)}catch(t){try{await n.rimraf(o)}catch(e){}throw new c.ExtensionManagementError(g.localize(0,null,o,e.id),"deleting")}await this.extractAtLocation(e,t,s,i);try{await this.rename(e,s,o,Date.now()+12e4),this.logService.info("Renamed to",o)}catch(e){this.logService.info("Rename failed. Deleting from extracted location",s);try{n.rimraf(s)}catch(e){}throw e}let l=null;try{l=await this.scanExtension(r,this.extensionsPath,1)}catch(e){}if(l)return l
;throw new Error(g.localize(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(e,t){this.setMetadata(e,t),t.isMachineScoped=t.isMachineScoped||void 0,t.isBuiltin=t.isBuiltin||void 0;const i=a.join(e.location.fsPath,"package.json"),r=await n.readFile(i,"utf8"),{manifest:s}=await this.parseManifest(r);return s.__metadata=t,await n.writeFile(i,JSON.stringify(s,null,"\t")),e}getUninstalledExtensions(){return this.withUninstalledExtensions(e=>e)}async withUninstalledExtensions(e){return this.uninstalledFileLimiter.queue(async()=>{let t;try{t=await n.readFile(this.uninstalledPath,"utf8")}catch(e){if("ENOENT"!==e.code)throw e}let i={};if(t)try{i=JSON.parse(t)}catch(e){}const r=e(i);return Object.keys(i).length?await n.writeFile(this.uninstalledPath,JSON.stringify(i)):await n.rimraf(this.uninstalledPath),r})}async removeExtension(e,t){this.logService.trace(`Deleting ${t} extension from disk`,e.identifier.id,e.location.fsPath),await n.rimraf(e.location.fsPath),
this.logService.info("Deleted from disk",e.identifier.id,e.location.fsPath)}async removeUninstalledExtension(e){await this.removeExtension(e,"uninstalled"),await this.withUninstalledExtensions(t=>delete t[new u.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version).key()])}async extractAtLocation(e,t,i,r){this.logService.trace(`Started extracting the extension from ${t} to ${i}`);try{await n.rimraf(i)}catch(e){throw new c.ExtensionManagementError(this.joinErrors(e).message,"deleting")}try{await v.extract(t,i,{sourcePath:"extension",overwrite:!0},r),this.logService.info(`Extracted extension to ${i}:`,e.id)}catch(e){try{await n.rimraf(i)}catch(e){}throw new c.ExtensionManagementError(e.message,e instanceof v.ExtractError&&e.type?e.type:"extracting")}}async rename(e,t,i,r){try{await n.rename(t,i)}catch(n){if(y.isWindows&&n&&"EPERM"===n.code&&Date.now()<r)return this.logService.info(`Failed renaming ${t} to ${i} with 'EPERM' error. Trying again...`,e.id),this.rename(e,t,i,r)
;throw new c.ExtensionManagementError(n.message||g.localize(2,null,t,i),n.code||"renaming")}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const e=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return e;const t=this.scanDevSystemExtensions(),[i,r]=await Promise.all([e,t]);return[...i,...r]}async scanExtensionsInDir(e,t){const i=new h.Limiter(10),r=await n.readdir(e).catch(e=>{if("ENOENT"!==e.code)throw e;return[]});return(await Promise.all(r.map(r=>i.queue(()=>this.scanExtension(r,e,t))))).filter(e=>e&&e.identifier)}async scanExtension(e,t,i){if(1===i&&0===e.indexOf("."))return null;const r=a.join(t,e);try{const e=await n.readdir(r),{manifest:t,metadata:s}=await this.readManifest(r),o=e.filter(e=>/^readme(\.txt|\.md|)$/i.test(e))[0],l=o?d.URI.file(a.join(r,o)):void 0,c=e.filter(e=>/^changelog(\.txt|\.md|)$/i.test(e))[0],h=c?d.URI.file(a.join(r,c)):void 0,f={type:i,identifier:{id:u.getGalleryExtensionId(t.publisher,t.name)},manifest:t,
location:d.URI.file(r),readmeUrl:l,changelogUrl:h,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:0===i};return s&&this.setMetadata(f,s),f}catch(e){return this.logService.trace(e),null}}async scanDefaultSystemExtensions(){const e=await this.scanExtensionsInDirs(this.systemExtensionsPath,this.environmentService.extraBuiltinExtensionPaths,0);return this.logService.trace("Scanned system extensions:",e.length),e}async scanDevSystemExtensions(){const e=this.getDevSystemExtensionsList();if(e.length){const t=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",t.length),t.filter(t=>e.some(e=>u.areSameExtensions(t.identifier,{id:e})))}return[]}setMetadata(e,t){e.publisherDisplayName=t.publisherDisplayName||null,e.publisherId=t.publisherId||null,e.identifier.uuid=t.id,e.isMachineScoped=!!t.isMachineScoped,e.isBuiltin=0===e.type||!!t.isBuiltin}async removeUninstalledExtensions(){
const e=await this.getUninstalledExtensions(),t=await this.scanAllUserExtensions(),r=new Set;for(const i of t)e[new u.ExtensionIdentifierWithVersion(i.identifier,i.manifest.version).key()]||r.add(i.identifier.id.toLowerCase());const n=u.groupByExtension(t,e=>e.identifier);await Promise.all(n.map(async e=>{const t=e.sort((e,t)=>i.rcompare(e.manifest.version,t.manifest.version))[0];r.has(t.identifier.id.toLowerCase())||await this.beforeRemovingExtension(t)}));const s=t.filter(t=>e[new u.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()]);await Promise.all(s.map(e=>this.removeUninstalledExtension(e)))}async removeOutdatedExtensions(){const e=await this.scanAllUserExtensions(),t=[],r=u.groupByExtension(e,e=>e.identifier);t.push(...E.flatten(r.map(e=>e.sort((e,t)=>i.rcompare(e.manifest.version,t.manifest.version)).slice(1)))),await Promise.all(t.map(e=>this.removeExtension(e,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(e=>e.name)}
joinErrors(e){const t=Array.isArray(e)?e:[e];return 1===t.length?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=a.normalize(a.join(w.FileAccess.asFileUri("",e).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(e){const t=[n.readFile(a.join(e,"package.json"),"utf8").then(e=>this.parseManifest(e)),n.readFile(a.join(e,"package.nls.json"),"utf8").then(void 0,e=>"ENOENT"!==e.code?Promise.reject(e):"{}").then(e=>JSON.parse(e))],[{manifest:i,metadata:r},s]=await Promise.all(t);return{manifest:p.localizeManifest(i,s),metadata:r}}parseManifest(e){return new Promise((t,i)=>{try{const i=JSON.parse(e);t({manifest:i,metadata:i.__metadata||null})}catch(e){i(new Error(g.localize(3,null)))}})}async scanExtensionsInDirs(e,t,i){
return(await Promise.all([e,...t].map(e=>this.scanExtensionsInDir(e,i)))).reduce((e,t)=>e.concat(t),[])}};_=s([o(1,l.ILogService),o(2,f.INativeEnvironmentService),o(3,m.IProductService)],_),t.ExtensionsScanner=_})),define(t[89],i([0,1,121,3,12,2,19,50,31,32,22,15,6,46,7,28,5,13,149,45,48,53,18,26,147,4,10,23,88,152,195,153]),(function(e,t,i,r,n,a,l,c,u,h,d,f,p,g,m,v,y,E,w,_,b,S,C,x,I,P,T,k,L,O,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let A=class extends a.Disposable{constructor(e,t,i,r,n,s){super(),this.environmentService=e,this.galleryService=t,this.logService=i,this.downloadService=r,this.telemetryService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new p.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,
this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const o=this._register(s.createInstance(R.ExtensionsLifecycle));this.extensionsScanner=this._register(s.createInstance(D.ExtensionsScanner,e=>o.postUninstall(e))),this.manifestCache=this._register(new w.ExtensionsManifestCache(e,this)),this.extensionsDownloader=this._register(s.createInstance(O.ExtensionsDownloader)),this._register(a.toDisposable(()=>{this.installingExtensions.forEach(e=>e.cancel()),this.uninstallingExtensions.forEach(e=>e.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(e){this.logService.trace("ExtensionManagementService#zip",e.identifier.id);const t=await this.collectFiles(e),i=await c.zip(C.joinPath(this.environmentService.tmpDir,x.generateUuid()).fsPath,t);return m.URI.file(i)}async unzip(e){
return this.logService.trace("ExtensionManagementService#unzip",e.toString()),(await this.install(e)).identifier}async getManifest(e){const t=await this.downloadVsix(e),i=r.resolve(t.fsPath);return L.getManifest(i)}async collectFiles(e){const t=async e=>{let i=await n.readdir(e);i=i.map(t=>r.join(e,t));const s=await Promise.all(i.map(e=>n.stat(e)));let o=Promise.resolve([]);return s.forEach((e,r)=>{const n=i[r];e.isFile()&&(o=o.then(e=>[...e,n])),e.isDirectory()&&(o=o.then(e=>t(n).then(t=>[...e,...t])))}),o};return(await t(e.location.fsPath)).map(t=>({path:`extension/${r.relative(e.location.fsPath,t)}`,localPath:t}))}async install(e,t={}){return this.logService.trace("ExtensionManagementService#install",e.toString()),f.createCancelablePromise(async n=>{const s=await this.downloadVsix(e),o=r.resolve(s.fsPath),a=await L.getManifest(o),l={id:h.getGalleryExtensionId(a.publisher,a.name)};let c=1
;if(a.engines&&a.engines.vscode&&!S.isEngineValid(a.engines.vscode,v.default.version))throw new Error(i.localize(0,null,l.id,v.default.version));const u=new h.ExtensionIdentifierWithVersion(l,a.version),d=(await this.getInstalled(1)).find(e=>h.areSameExtensions(l,e.identifier));if(d)if(t.isMachineScoped=t.isMachineScoped||d.isMachineScoped,t.isBuiltin=t.isBuiltin||d.isBuiltin,c=2,u.equals(new h.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version)))try{await this.extensionsScanner.removeExtension(d,"existing")}catch(e){throw new Error(i.localize(1,null,a.displayName||a.name))}else g.gt(d.manifest.version,a.version)&&await this.uninstallExtension(d);else{const e=await this.unsetUninstalledAndGetLocal(u);if(e)try{await this.extensionsScanner.removeExtension(e,"existing")}catch(e){throw new Error(i.localize(2,null,a.displayName||a.name))}}let f;this.logService.info("Installing the extension:",l.id),this._onInstallExtension.fire({identifier:l,zipPath:o});try{
f=await this.getGalleryMetadata(h.getGalleryExtensionId(a.publisher,a.name))}catch(e){}try{const e=await this.installFromZipPath(u,o,Object.assign(Object.assign({},f||{}),t),t,c,n);return this.logService.info("Successfully installed the extension:",l.id),e}catch(e){throw this.logService.error("Failed to install the extension:",l.id,e.message),e}})}async downloadVsix(e){if(e.scheme===T.Schemas.file)return e;if(!this.downloadService)throw new Error("Download service is not available");const t=C.joinPath(this.environmentService.tmpDir,x.generateUuid());return await this.downloadService.download(e,t),t}async installFromZipPath(e,t,i,r,n,s){try{const o=await this.installExtension({zipPath:t,identifierWithVersion:e,metadata:i},s);try{await this.installDependenciesAndPackExtensions(o,void 0,r)}catch(e){l.isNonEmptyArray(o.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",o.identifier.id,e.message),
l.isNonEmptyArray(o.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",o.identifier.id,e.message)}return this._onDidInstallExtension.fire({identifier:e,zipPath:t,local:o,operation:n}),o}catch(i){throw this._onDidInstallExtension.fire({identifier:e,zipPath:t,operation:n,error:i}),i}}async canInstall(e){return!0}async installFromGallery(e,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(3,null));try{e=await this.checkAndGetCompatibleVersion(e)}catch(t){const i=t&&t.code?t.code:"unknown";throw this.logService.error("Failed to install extension:",e.identifier.id,t?t.message:i),this.reportTelemetry(this.getTelemetryEvent(1),h.getGalleryExtensionTelemetryData(e),void 0,t),t instanceof Error&&(t.name=i),t}const r=new h.ExtensionIdentifierWithVersion(e.identifier,e.version).key();let n=this.installingExtensions.get(r);return n||(n=f.createCancelablePromise(i=>this.doInstallFromGallery(e,t,i)),this.installingExtensions.set(r,n),
n.finally(()=>this.installingExtensions.delete(r))),n}async doInstallFromGallery(e,t,i){const r=(new Date).getTime();let n=1;this.logService.info("Installing extension:",e.identifier.id),this._onInstallExtension.fire({identifier:e.identifier,gallery:e});try{const s=(await this.getInstalled(1)).find(t=>h.areSameExtensions(t.identifier,e.identifier));s&&(n=2);const o=await this.downloadInstallableExtension(e,n);o.metadata.isMachineScoped=t.isMachineScoped||(null==s?void 0:s.isMachineScoped),o.metadata.isBuiltin=t.isBuiltin||(null==s?void 0:s.isBuiltin);const a=await this.installExtension(o,i);try{await this.extensionsDownloader.delete(m.URI.file(o.zipPath))}catch(e){}try{await this.installDependenciesAndPackExtensions(a,s,t)}catch(e){try{await this.uninstall(a)}catch(e){}throw e}return s&&g.neq(s.manifest.version,e.version)&&await this.setUninstalled(s),this.logService.info("Extensions installed successfully:",e.identifier.id),this._onDidInstallExtension.fire({identifier:e.identifier,gallery:e,local:a,
operation:n}),this.reportTelemetry(this.getTelemetryEvent(n),h.getGalleryExtensionTelemetryData(e),(new Date).getTime()-r,void 0),a}catch(t){const i=t&&t.code?t.code:"unknown";throw this.logService.error("Failed to install extension:",e.identifier.id,t?t.message:i),this._onDidInstallExtension.fire({identifier:e.identifier,gallery:e,operation:n,error:i}),this.reportTelemetry(this.getTelemetryEvent(n),h.getGalleryExtensionTelemetryData(e),(new Date).getTime()-r,t),t instanceof Error&&(t.name=i),t}}async checkAndGetCompatibleVersion(e){if(await this.isMalicious(e))throw new u.ExtensionManagementError(i.localize(4,null),u.INSTALL_ERROR_MALICIOUS);const t=await this.galleryService.getCompatibleExtension(e);if(!t)throw new u.ExtensionManagementError(i.localize(5,null,e.identifier.id,v.default.version),u.INSTALL_ERROR_INCOMPATIBLE);return t}async reinstallFromGallery(e){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),
!this.galleryService.isEnabled())throw new Error(i.localize(6,null));const t=await this.findGalleryExtension(e);if(!t)throw new Error(i.localize(7,null));await this.setUninstalled(e);try{await this.extensionsScanner.removeUninstalledExtension(e)}catch(e){throw new Error(i.localize(8,null,_.toErrorMessage(e)))}await this.installFromGallery(t)}getTelemetryEvent(e){return 2===e?"extensionGallery:update":"extensionGallery:install"}async isMalicious(e){const t=await this.getExtensionsReport();return h.getMaliciousExtensionsSet(t).has(e.identifier.id)}async downloadInstallableExtension(e,t){const i={id:e.identifier.uuid,publisherId:e.publisherId,publisherDisplayName:e.publisherDisplayName};let r;try{this.logService.trace("Started downloading extension:",e.identifier.id);const i=await this.extensionsDownloader.downloadExtension(e,t);this.logService.info("Downloaded extension:",e.identifier.id,r),r=i.fsPath}catch(e){throw new u.ExtensionManagementError(this.joinErrors(e).message,"downloading")}try{
const t=await L.getManifest(r);return{zipPath:r,identifierWithVersion:new h.ExtensionIdentifierWithVersion(e.identifier,t.version),metadata:i}}catch(e){throw new u.ExtensionManagementError(this.joinErrors(e).message,"validating")}}async installExtension(e,t){try{const t=await this.unsetUninstalledAndGetLocal(e.identifierWithVersion);if(t)return e.metadata?this.extensionsScanner.saveMetadataForLocalExtension(t,e.metadata):t}catch(e){throw y.isMacintosh?new u.ExtensionManagementError(i.localize(9,null),"unsetUninstalled"):new u.ExtensionManagementError(i.localize(10,null),"unsetUninstalled")}return this.extractAndInstall(e,t)}async unsetUninstalledAndGetLocal(e){return await this.isUninstalled(e)?(this.logService.trace("Removing the extension from uninstalled list:",e.id),await this.unsetUninstalled(e),this.logService.info("Removed the extension from uninstalled list:",e.id),(await this.getInstalled(1)).find(t=>new h.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).equals(e))||null):null}
async extractAndInstall({zipPath:e,identifierWithVersion:t,metadata:i},r){let n=await this.extensionsScanner.extractUserExtension(t,e,r);return this.logService.info("Installation completed.",t.id),i&&(n=await this.extensionsScanner.saveMetadataForLocalExtension(n,i)),n}async installDependenciesAndPackExtensions(e,t,i){if(!this.galleryService.isEnabled())return;const r=e.manifest.extensionDependencies||[];if(e.manifest.extensionPack)for(const i of e.manifest.extensionPack)t&&t.manifest.extensionPack&&t.manifest.extensionPack.some(e=>h.areSameExtensions({id:e},{id:i}))||r.every(e=>!h.areSameExtensions({id:e},{id:i}))&&r.push(i);if(r.length){const e=await this.getInstalled(),t=r.filter(t=>e.every(({identifier:e})=>!h.areSameExtensions(e,{id:t})));if(t.length){const e=(await this.galleryService.query({names:t,pageSize:r.length},k.CancellationToken.None)).firstPage;try{await Promise.all(e.map(e=>this.installFromGallery(e,i)))}catch(t){try{await this.rollback(e)}catch(e){}throw t}}}}async rollback(e){
const t=(await this.getInstalled(1)).filter(t=>e.some(e=>new h.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).equals(new h.ExtensionIdentifierWithVersion(e.identifier,e.version))));await Promise.all(t.map(e=>this.uninstall(e)))}async uninstall(e){this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id);const t=await this.getInstalled(1),r=t.find(t=>h.areSameExtensions(t.identifier,e.identifier));if(!r)throw new Error(i.localize(11,null,e.manifest.displayName||e.manifest.name));try{await this.checkForDependenciesAndUninstall(r,t)}catch(e){throw this.joinErrors(e)}}async updateMetadata(e,t){return this.logService.trace("ExtensionManagementService#updateMetadata",e.identifier.id),e=await this.extensionsScanner.saveMetadataForLocalExtension(e,Object.assign(Object.assign({},e.manifest.__metadata||{}),t)),this.manifestCache.invalidate(),e}async updateExtensionScope(e,t){return this.logService.trace("ExtensionManagementService#updateExtensionScope",e.identifier.id),
e=await this.extensionsScanner.saveMetadataForLocalExtension(e,Object.assign(Object.assign({},e.manifest.__metadata||{}),{isMachineScoped:t})),this.manifestCache.invalidate(),e}async getGalleryMetadata(e){const t=await this.findGalleryExtensionByName(e);return t?{id:t.identifier.uuid,publisherDisplayName:t.publisherDisplayName,publisherId:t.publisherId}:void 0}async findGalleryExtension(e){if(e.identifier.uuid){const t=await this.findGalleryExtensionById(e.identifier.uuid);return t||this.findGalleryExtensionByName(e.identifier.id)}return this.findGalleryExtensionByName(e.identifier.id)}async findGalleryExtensionById(e){return(await this.galleryService.query({ids:[e],pageSize:1},k.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(e){return(await this.galleryService.query({names:[e],pageSize:1},k.CancellationToken.None)).firstPage[0]}joinErrors(e){const t=Array.isArray(e)?e:[e]
;return 1===t.length?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}async checkForDependenciesAndUninstall(e,t){try{await this.preUninstallExtension(e);const i=this.getAllPackExtensionsToUninstall(e,t);i.length?await this.uninstallExtensions(e,i,t):await this.uninstallExtensions(e,[],t)}catch(t){throw await this.postUninstallExtension(e,new u.ExtensionManagementError(t instanceof Error?t.message:t,"local")),t}await this.postUninstallExtension(e)}async uninstallExtensions(e,t,i){const r=[e,...t];for(const t of r)this.checkForDependents(t,r,i,e);await Promise.all([this.uninstallExtension(e),...t.map(e=>this.doUninstall(e))])}checkForDependents(e,t,i,r){const n=this.getDependents(e,i);if(n.length){const i=n.filter(e=>-1===t.indexOf(e));if(i.length)throw new Error(this.getDependentsErrorMessage(e,i,r))}}getDependentsErrorMessage(e,t,r){
return r===e?1===t.length?i.localize(12,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name):2===t.length?i.localize(13,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(14,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):1===t.length?i.localize(15,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name):2===t.length?i.localize(16,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(17,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}
getAllPackExtensionsToUninstall(e,t,i=[]){if(-1!==i.indexOf(e))return[];i.push(e);const r=e.manifest.extensionPack?e.manifest.extensionPack:[];if(r.length){const e=t.filter(e=>!e.isBuiltin&&r.some(t=>h.areSameExtensions({id:t},e.identifier))),n=[];for(const r of e)n.push(...this.getAllPackExtensionsToUninstall(r,t,i));return[...e,...n]}return[]}getDependents(e,t){return t.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(t=>h.areSameExtensions({id:t},e.identifier)))}async doUninstall(e){try{await this.preUninstallExtension(e),await this.uninstallExtension(e)}catch(t){throw await this.postUninstallExtension(e,new u.ExtensionManagementError(t instanceof Error?t.message:t,"local")),t}await this.postUninstallExtension(e)}async preUninstallExtension(e){if(!await n.exists(e.location.fsPath))throw new Error(i.localize(18,null));this.logService.info("Uninstalling extension:",e.identifier.id),this._onUninstallExtension.fire(e.identifier)}async uninstallExtension(e){
let t=this.uninstallingExtensions.get(e.identifier.id);return t||(t=f.createCancelablePromise(async()=>{const t=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...t.filter(t=>h.areSameExtensions(t.identifier,e.identifier)))}),this.uninstallingExtensions.set(e.identifier.id,t),t.finally(()=>this.uninstallingExtensions.delete(e.identifier.id))),t}async postUninstallExtension(e,t){if(t)this.logService.error("Failed to uninstall extension:",e.identifier.id,t.message);else if(this.logService.info("Successfully uninstalled extension:",e.identifier.id),e.identifier.uuid)try{await this.galleryService.reportStatistic(e.manifest.publisher,e.manifest.name,e.manifest.version,"uninstall")}catch(t){}this.reportTelemetry("extensionGallery:uninstall",h.getLocalExtensionTelemetryData(e),void 0,t);const i=t?t instanceof u.ExtensionManagementError?t.code:"unknown":void 0;this._onDidUninstallExtension.fire({identifier:e.identifier,error:i})}getInstalled(e=null){
return this.extensionsScanner.scanExtensions(e)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(e){return 1===(await this.filterUninstalled(e)).length}filterUninstalled(...e){return this.extensionsScanner.withUninstalledExtensions(t=>{const i=[];for(const r of e)t[r.key()]&&i.push(r.key());return i})}setUninstalled(...e){const t=e.map(e=>new h.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version));return this.extensionsScanner.withUninstalledExtensions(e=>(t.forEach(t=>e[t.key()]=!0),e))}unsetUninstalled(e){return this.extensionsScanner.withUninstalledExtensions(t=>delete t[e.key()])}getExtensionsReport(){const e=(new Date).getTime();return(!this.reportedExtensions||e-this.lastReportTimestamp>3e5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=e),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsReport()
;return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${e.length} reported extensions from service`),e}catch(e){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(e,t,i,r){const n=r?r instanceof u.ExtensionManagementError?r.code:"unknown":void 0;this.telemetryService.publicLogError(e,Object.assign(Object.assign({},t),{success:!r,duration:i,errorcode:n}))}};A=s([o(0,d.INativeEnvironmentService),o(1,u.IExtensionGalleryService),o(2,E.ILogService),o(3,P.optional(I.IDownloadService)),o(4,b.ITelemetryService),o(5,P.IInstantiationService)],A),t.ExtensionManagementService=A})),define(t[196],i([0,1,21,44,210,37,12,50,132,28]),(function(e,t,i,r,n,s,o,a,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.enableCustomMarketplace=t.buffer=t.extract=t.tar=void 0;const u=a.extract,h=a.buffer;t.tar=async(e,t)=>{const r=n.pack(),o=[],a=new Promise(e=>{r.on("end",()=>e(Buffer.concat(o)))})
;r.on("data",e=>o.push(e));for(let e=0;e<t.length;e++){const i=t[e];r.entry({name:i.path},i.contents)}return r.finalize(),await s.promisify(i.writeFile)(e,await a),e};t.extract=async(e,t,i={},r)=>{try{await p(e,t,i,r)}catch(n){n.toString().includes("Invalid tar header")&&await u(e,t,i,r)}};t.buffer=(e,t)=>new Promise(async(i,n)=>{try{let n=!1;if(await d(e,new RegExp(t),(e,s)=>{r.normalize(e)===r.normalize(t)&&(n=!0,i(s))}),!n)throw new Error("couldn't find asset "+t)}catch(r){r.toString().includes("Invalid tar header")?h(e,t).then(i).catch(n):n(r)}});const d=async(e,t,r)=>new Promise((s,o)=>{const a=n.extract(),l=e=>{a.destroy(),o(e)};a.once("error",l),a.on("entry",async(e,i,n)=>{const s=e.name;t.test(s)?f(i).then(e=>{r(s,e),n()}).catch(l):(i.on("end",()=>n()),i.resume())}),a.on("finish",s),i.createReadStream(e).pipe(a)}),f=e=>new Promise((t,i)=>{const r=[];e.on("error",i),e.on("end",()=>t(Buffer.concat(r))),e.on("data",e=>r.push(e))}),p=async(e,t,s={},a)=>new Promise((c,u)=>{
const h=new RegExp(s.sourcePath?`^${s.sourcePath}`:""),d=n.extract(),f=e=>{d.destroy(),u(e)};d.once("error",f),d.on("entry",async(e,n,s)=>{const c=()=>{n.on("end",()=>s()),n.resume()},u=r.normalize(e.name);if(a.isCancellationRequested||!h.test(u))return c();const d=u.replace(h,""),p=r.join(t,d);if(/\/$/.test(d))return o.mkdirp(p).then(c);const g=r.dirname(d),m=r.join(t,g);if(0!==m.indexOf(t))return f(new Error(l.localize(0,null,d)));await o.mkdirp(m,void 0);const v=i.createWriteStream(p,{mode:e.mode});v.once("close",()=>s()),v.once("error",f),n.pipe(v)}),d.once("finish",c),i.createReadStream(e).pipe(d)});t.enableCustomMarketplace=()=>{c.default.extensionsGallery=Object.assign({serviceUrl:process.env.SERVICE_URL||"https://extensions.coder.com/api",itemUrl:process.env.ITEM_URL||"",controlUrl:"",recommendationsUrl:""},c.default.extensionsGallery||{});const e=a;e.zip=t.tar,e.extract=t.extract,e.buffer=t.buffer}})),define(t[90],i([0,1,211,165,2,11,14,164,30,13,17]),(function(e,t,i,r,n,a,l,c,u,h,d){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let f=class extends n.Disposable{constructor(e,t){super(),this.logService=t,this.configure(e.getValue()),this._register(e.onDidChangeConfiguration(()=>this.configure(e.getValue()),this))}configure(e){this.proxyUrl=e.http&&e.http.proxy,this.strictSSL=!(!e.http||!e.http.proxyStrictSSL),this.authorization=e.http&&e.http.proxyAuthorization}async request(e,t){this.logService.trace("RequestService#request",e.url);const{proxyUrl:i,strictSSL:r}=this,n=e.agent?e.agent:await c.getProxyAgent(e.url||"",{proxyUrl:i,strictSSL:r});return e.agent=n,e.strictSSL=r,this.authorization&&(e.headers=Object.assign(Object.assign({},e.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(e,t)}async getNodeRequest(t){return("https:"===r.parse(t.url).protocol?await new Promise((t,i)=>{e(["https"],t,i)}):await new Promise((t,i)=>{e(["http"],t,i)})).request}_request(e,t){return new Promise(async(n,s)=>{let o
;const c=r.parse(e.url),u=e.getRawRequest?e.getRawRequest(e):await this.getNodeRequest(e),h={hostname:c.hostname,port:c.port?parseInt(c.port):"https:"===c.protocol?443:80,protocol:c.protocol,path:c.path,method:e.type||"GET",headers:e.headers,agent:e.agent,rejectUnauthorized:!a.isBoolean(e.strictSSL)||e.strictSSL};e.user&&e.password&&(h.auth=e.user+":"+e.password),(o=u(h,r=>{const o=a.isNumber(e.followRedirects)?e.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&o>0&&r.headers.location)this._request(Object.assign(Object.assign({},e),{url:r.headers.location,followRedirects:o-1}),t).then(n,s);else{let e=r;"gzip"===r.headers["content-encoding"]&&(e=r.pipe(i.createGunzip())),n({res:r,stream:d.streamToBufferReadableStream(e)})}})).on("error",s),e.timeout&&o.setTimeout(e.timeout),e.data&&"string"==typeof e.data&&o.write(e.data),o.end(),t.onCancellationRequested(()=>{o.abort(),s(l.canceled())})})}async resolveProxy(e){}};f=s([o(0,u.IConfigurationService),o(1,h.ILogService)],f),
t.RequestService=f})),define(t[197],i([0,1,118,15,46,28,3,55,54,4,72,22,76,31,89,78,48,49,79,81,58,90,30,77,80,12,43,167,168,13,14,32,7,88,39,23,75,10,57,173,74,24,56,2,47]),(function(e,t,i,r,n,a,l,c,u,h,d,f,p,g,m,v,y,E,w,_,b,S,C,x,I,P,T,k,L,O,D,R,A,F,N,M,U,j,z,B,W,V,$,q,G){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=t.Main=t.getIdAndVersion=void 0;const K=e=>i.localize(1,null,e),H=i.localize(2,null,"ms-dotnettools.csharp");function X(e,t){return t?`${e.publisher}.${e.name}@${e.version}`:`${e.publisher}.${e.name}`}const Y=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function Q(e){const t=Y.exec(e);return t&&t[1]?[R.adoptToGalleryExtensionId(t[1]),t[2]]:[R.adoptToGalleryExtensionId(e),void 0]}t.getIdAndVersion=Q;let J=class{constructor(e,t,i,r){this.instantiationService=e,this.environmentService=t,this.extensionManagementService=i,this.extensionGalleryService=r}async run(e){
e["install-source"]?await this.setInstallSource(e["install-source"]):e["list-extensions"]?await this.listExtensions(!!e["show-versions"],e.category):e["install-extension"]||e["install-builtin-extension"]?await this.installExtensions(e["install-extension"]||[],e["install-builtin-extension"]||[],!!e["do-not-sync"],!!e.force):e["uninstall-extension"]?await this.uninstallExtension(e["uninstall-extension"],!!e.force):e["locate-extension"]?await this.locateExtension(e["locate-extension"]):e.telemetry&&console.log(B.buildTelemetryMessage(this.environmentService.appRoot,this.environmentService.extensionsPath?this.environmentService.extensionsPath:void 0))}setInstallSource(e){return P.writeFile(this.environmentService.installSourcePath,e.slice(0,30))}async listExtensions(e,t){let i=await this.extensionManagementService.getInstalled(1);const r=N.EXTENSION_CATEGORIES.map(e=>e.toLowerCase());if(t&&""!==t){
if(r.indexOf(t.toLowerCase())<0)return void console.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");i=i.filter(e=>{if(e.manifest.categories){return e.manifest.categories.map(e=>e.toLowerCase()).indexOf(t.toLowerCase())>-1}return!1})}else if(""===t)return console.log("Possible Categories: "),void r.forEach(e=>{console.log(e)});i.forEach(t=>console.log(X(t.manifest,e)))}async installExtensions(e,t,r,n){const s=[],o=[];e.length&&console.log(i.localize(3,null));const a=[],l=[];for(const t of e)if(/\.vsix$/i.test(t))a.push(t);else{const[e,i]=Q(t);l.push({id:e,version:i,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const e of t){const[t,i]=Q(e);l.push({id:t,version:i,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}a.length&&await Promise.all(a.map(async e=>{try{const t=await this.installVSIX(e,n);t&&o.push(t)}catch(t){console.error(t.message||t.stack||t),s.push(e)}}))
;const[c,u]=await Promise.all([this.getGalleryExtensions(l),this.extensionManagementService.getInstalled(1)]);if(await Promise.all(l.map(async e=>{const t=c.get(e.id.toLowerCase());if(t)try{const i=await this.installFromGallery(e,t,u,n);i&&o.push(i)}catch(t){console.error(t.message||t.stack||t),s.push(e.id)}else console.error(`${(e=>i.localize(0,null,e))(e.version?`${e.id}@${e.version}`:e.id)}\n${H}`),s.push(e.id)})),o.some(e=>N.isLanguagePackExtension(e))&&await this.updateLocalizationsCache(),s.length)throw new Error(i.localize(4,null,s.join(", ")))}async installVSIX(e,t){e=l.isAbsolute(e)?e:l.join(process.cwd(),e);const r=await F.getManifest(e);if(await this.validate(r,t))try{return await this.extensionManagementService.install(A.URI.file(e)),console.log(i.localize(5,null,T.getBaseLabel(e))),r}catch(t){if(D.isPromiseCanceledError(t))return console.log(i.localize(6,null,T.getBaseLabel(e))),null;throw t}return null}async getGalleryExtensions(e){
const t=e.filter(({version:e})=>void 0===e).map(({id:e})=>e),i=e.filter(({version:e})=>void 0!==e),r=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(t,M.CancellationToken.None)).forEach(e=>r.set(e.identifier.id.toLowerCase(),e))})(),Promise.all(i.map(async({id:e,version:t})=>{const i=await this.extensionGalleryService.getCompatibleExtension({id:e},t);i&&r.set(i.identifier.id.toLowerCase(),i)}))]),r}async installFromGallery({id:e,version:t,installOptions:r},n,s,o){const a=await this.extensionGalleryService.getManifest(n,M.CancellationToken.None),l=s.find(e=>R.areSameExtensions(e.identifier,n.identifier));if(l){if(n.version===l.manifest.version)return console.log(i.localize(7,null,t?`${e}@${t}`:e)),null;if(!t&&!o)return console.log(i.localize(8,null,e,l.manifest.version,n.version)),null;console.log(i.localize(9,null,e,n.version))}try{return r.isBuiltin?console.log(i.localize(10,null,e,n.version)):console.log(i.localize(11,null,e,n.version)),
await this.extensionManagementService.installFromGallery(n,r),console.log(i.localize(12,null,e,n.version)),a}catch(t){if(D.isPromiseCanceledError(t))return console.log(i.localize(13,null,e)),null;throw t}}async validate(e,t){if(!e)throw new Error("Invalid vsix");const r={id:R.getGalleryExtensionId(e.publisher,e.name)},s=(await this.extensionManagementService.getInstalled(1)).find(t=>R.areSameExtensions(r,t.identifier)&&n.gt(t.manifest.version,e.version));return!(s&&!t)||(console.log(i.localize(14,null,s.identifier.id,s.manifest.version,e.version)),!1)}async uninstallExtension(e,t){async function r(e){if(!/\.vsix$/i.test(e))return e;const t=l.isAbsolute(e)?e:l.join(process.cwd(),e);return X(await F.getManifest(t))}const n=[];for(const s of e){const e=await r(s),o=(await this.extensionManagementService.getInstalled()).find(t=>R.areSameExtensions(t.identifier,{id:e}));if(!o)throw new Error(`${K(e)}\n${H}`);if(0===o.type)return void console.log(i.localize(15,null,e))
;if(o.isBuiltin&&!t)return void console.log(i.localize(16,null,e));console.log(i.localize(17,null,e)),await this.extensionManagementService.uninstall(o,!0),n.push(o),console.log(i.localize(18,null,e))}n.some(e=>N.isLanguagePackExtension(e.manifest))&&await this.updateLocalizationsCache()}async locateExtension(e){const t=await this.extensionManagementService.getInstalled();e.forEach(e=>{t.forEach(t=>{t.identifier.id!==e||t.location.scheme!==j.Schemas.file||console.log(t.location.fsPath)})})}async updateLocalizationsCache(){const e=this.instantiationService.createInstance(U.LocalizationsService);await e.update(),e.dispose()}};J=s([o(0,h.IInstantiationService),o(1,f.INativeEnvironmentService),o(2,g.IExtensionManagementService),o(3,g.IExtensionGalleryService)],J),t.Main=J;const Z="monacoworkbench";t.main=async function(e){const t=new c.ServiceCollection,i=new q.DisposableStore,n=new p.NativeEnvironmentService(e),s=new z.SpdLogService("cli",n.logsPath,O.getLogLevel(n));process.once("exit",()=>s.dispose()),
s.info("main",e),await Promise.all([n.appSettingsHome.fsPath,n.extensionsPath].map(e=>e?P.mkdirp(e):void 0));const o=new W.FileService(s);i.add(o),t.set(V.IFileService,o);const l=new $.DiskFileSystemProvider(s);i.add(l),o.registerProvider(j.Schemas.file,l);const h=new x.ConfigurationService(n.settingsResource,o);i.add(h),await h.initialize(),t.set(f.IEnvironmentService,n),t.set(f.INativeEnvironmentService,n),t.set(O.ILogService,s),t.set(C.IConfigurationService,h),t.set(k.IStateService,new u.SyncDescriptor(L.StateService)),t.set(G.IProductService,Object.assign({_serviceBrand:void 0},a.default));const T=new d.InstantiationService(t);return T.invokeFunction(async t=>{const s=t.get(k.IStateService),{appRoot:o,extensionsPath:l,extensionDevelopmentLocationURI:h,isBuilt:d,installSourcePath:f}=n,p=new c.ServiceCollection;p.set(b.IRequestService,new u.SyncDescriptor(S.RequestService)),p.set(g.IExtensionManagementService,new u.SyncDescriptor(m.ExtensionManagementService)),
p.set(g.IExtensionGalleryService,new u.SyncDescriptor(v.ExtensionGalleryService));const C=[];if(d&&!h&&!n.disableTelemetry&&a.default.enableTelemetry){a.default.aiConfig&&a.default.aiConfig.asimovKey&&C.push(new I.AppInsightsAppender(Z,null,a.default.aiConfig.asimovKey));const e={appender:E.combinedAppender(...C),sendErrorTelemetry:!1,commonProperties:_.resolveCommonProperties(a.default.commit,a.default.version,s.getItem("telemetry.machineId"),a.default.msftInternalDomains,f),piiPaths:l?[o,l]:[o]};p.set(y.ITelemetryService,new u.SyncDescriptor(w.TelemetryService,[e]))}else p.set(y.ITelemetryService,E.NullTelemetryService);const x=T.createChild(p).createInstance(J);try{await x.run(e),await r.raceTimeout(E.combinedAppender(...C).flush(),1e3)}finally{i.dispose()}})}})),
define(t[198],i([0,1,34,21,44,6,10,7,103,35,148,197,30,77,139,22,76,78,31,140,89,24,74,56,54,72,55,73,75,13,156,157,57,28,47,58,163,90,171,48,172,79,49,80,81,176,177,192,179,178,59,60,180,82,189,193,194,133]),(function(e,t,i,r,n,s,o,a,l,c,u,h,d,f,p,g,m,v,y,E,w,_,b,S,C,x,I,P,T,k,L,O,D,R,A,F,N,M,U,j,z,B,W,V,$,q,G,K,H,X,Y,Q,J,Z,ee,te,ie,re){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Vscode=void 0;t.Vscode=class{constructor(){this._onDidClientConnect=new s.Emitter,this.onDidClientConnect=this._onDidClientConnect.event,this.ipc=new c.IPCServer(this.onDidClientConnect),this.maxExtraOfflineConnections=0,this.connections=new Map,this.services=new I.ServiceCollection}async cli(e){return h.main(e)}async initialize(e){const t=Z.getUriTransformer(e.remoteAuthority);this.servicesPromise||(this.servicesPromise=this.initializeServices(e.args)),await this.servicesPromise;const i=this.services.get(g.IEnvironmentService),r=e.startPath,n=t=>{try{return a.URI.parse(t,!0)}catch(i){return a.URI.from({
scheme:o.Schemas.vscodeRemote,authority:e.remoteAuthority,path:t})}};return{workbenchWebConfiguration:{workspaceUri:r&&r.workspace?n(r.url):void 0,folderUri:r&&!r.workspace?n(r.url):void 0,remoteAuthority:e.remoteAuthority,logLevel:k.getLogLevel(i),workspaceProvider:{payload:[["userDataPath",i.userDataPath],["enableProposedApi",JSON.stringify(e.args["enable-proposed-api"]||[])]]},homeIndicator:{href:e.args.home||"https://github.com/cdr/code-server",icon:"code",title:re.localize(0,null)}},remoteUserDataUri:t.transformOutgoing(a.URI.file(i.userDataPath)),productConfiguration:R.default,nlsConfiguration:await Q.getNlsConfiguration(i.args.locale||await Q.getLocaleFromConfig(i.userDataPath),i.userDataPath),commit:R.default.commit||"development"}}async handleWebSocket(e,t){if(!t.reconnectionToken)throw new Error("Reconnection token is missing from query parameters");const i=new J.Protocol(e,{reconnectionToken:t.reconnectionToken,reconnection:"true"===t.reconnection,skipWebSocketFrames:"true"===t.skipWebSocketFrames
});try{await this.connect(await i.handshake(),i)}catch(e){i.sendMessage({type:"error",reason:e.message}),i.dispose(),i.getSocket().dispose()}return!0}async connect(e,t){switch(R.default.commit&&e.commit!==R.default.commit&&Y.logger.warn(`Version mismatch (${e.commit} instead of ${R.default.commit})`),e.desiredConnectionType){case 2:case 1:this.connections.has(e.desiredConnectionType)||this.connections.set(e.desiredConnectionType,new Map);const r=this.connections.get(e.desiredConnectionType),n=async()=>2===e.desiredConnectionType?{debugPort:await this.getDebugPort()}:{type:"ok"},s=t.options.reconnectionToken;if(t.options.reconnection&&r.has(s)){t.sendMessage(await n());const e=t.readEntireBuffer();return t.dispose(),r.get(s).reconnect(t.getSocket(),e)}if(t.options.reconnection||r.has(s))throw new Error(t.options.reconnection?"Unrecognized reconnection token":"Duplicate reconnection token");let o;if(Y.logger.debug("New connection",i.field("token",s)),t.sendMessage(await n()),
1===e.desiredConnectionType)o=new H.ManagementConnection(t,s),this._onDidClientConnect.fire({protocol:t,onDidClientDisconnect:o.onClose}),this.services.get(q.INodeProxyService)._onUp.fire(),o.onClose(()=>this.services.get(q.INodeProxyService)._onDown.fire());else{const i=t.readEntireBuffer();o=new H.ExtensionHostConnection(e.args?e.args.language:"en",t,i,s,this.services.get(g.IEnvironmentService))}r.set(s,o),o.onClose(()=>{Y.logger.debug("Connection closed",i.field("token",s)),r.delete(s)}),this.disposeOldOfflineConnections(r);break;case 3:return t.tunnel();default:throw new Error("Unrecognized connection type")}}disposeOldOfflineConnections(e){const t=Array.from(e.values()).filter(e=>void 0!==e.offline);for(let e=0,r=t.length-this.maxExtraOfflineConnections;e<r;++e)Y.logger.debug("Disposing offline connection",i.field("token",t[e].token)),t[e].dispose()}async initializeServices(e){const t=new m.NativeEnvironmentService(e);r.mkdirSync(t.globalStorageHome.fsPath,{recursive:!0})
;const i=new D.SpdLogService(ie.RemoteExtensionLogFileName,t.logsPath,k.getLogLevel(t)),s=new b.FileService(i);s.registerProvider(o.Schemas.file,new S.DiskFileSystemProvider(i));const a=[n.join(t.userDataPath,"clp"),t.appRoot,t.extensionsPath,t.builtinExtensionsPath,...t.extraExtensionPaths,...t.extraBuiltinExtensionPaths];this.ipc.registerChannel("logger",new L.LoggerChannel(i)),this.ipc.registerChannel(p.ExtensionHostDebugBroadcastChannel.ChannelName,new p.ExtensionHostDebugBroadcastChannel),this.services.set(k.ILogService,i),this.services.set(g.IEnvironmentService,t),this.services.set(g.INativeEnvironmentService,t),this.services.set(k.ILoggerService,new C.SyncDescriptor(O.LoggerService));const h=new f.ConfigurationService(t.settingsResource,s);await h.initialize(),this.services.set(d.IConfigurationService,h),this.services.set(F.IRequestService,new C.SyncDescriptor(M.RequestService)),this.services.set(_.IFileService,s),this.services.set(A.IProductService,Object.assign({_serviceBrand:void 0},R.default))
;const I=await l.getMachineId();await new Promise(e=>{const r=new x.InstantiationService(this.services);r.invokeFunction(n=>{let s;r.createInstance(u.LogsDataCleaner),s=t.disableTelemetry?W.NullTelemetryService:new B.TelemetryService({appender:W.combinedAppender(new V.AppInsightsAppender("code-server",null,()=>new X.TelemetryClient),new z.TelemetryLogAppender(n.get(k.ILoggerService),t)),sendErrorTelemetry:!0,commonProperties:$.resolveCommonProperties(R.default.commit,R.default.version,I,[],t.installSourcePath,"code-server"),piiPaths:a},h),this.services.set(j.ITelemetryService,s),this.services.set(y.IExtensionManagementService,new C.SyncDescriptor(w.ExtensionManagementService)),this.services.set(y.IExtensionGalleryService,new C.SyncDescriptor(v.ExtensionGalleryService)),this.services.set(P.ILocalizationsService,new C.SyncDescriptor(T.LocalizationsService)),this.services.set(q.INodeProxyService,new C.SyncDescriptor(K.NodeProxyService)),
this.ipc.registerChannel("extensions",new E.ExtensionManagementChannel(n.get(y.IExtensionManagementService),e=>Z.getUriTransformer(e.remoteAuthority))),this.ipc.registerChannel("remoteextensionsenvironment",new K.ExtensionEnvironmentChannel(t,i,s,"")),this.ipc.registerChannel("request",new N.RequestChannel(n.get(F.IRequestService))),this.ipc.registerChannel("telemetry",new G.TelemetryChannel(s)),this.ipc.registerChannel("nodeProxy",new q.NodeProxyChannel(n.get(q.INodeProxyService))),this.ipc.registerChannel("localizations",c.createChannelReceiver(n.get(P.ILocalizationsService))),this.ipc.registerChannel(te.REMOTE_FILE_SYSTEM_CHANNEL_NAME,new K.FileProviderChannel(t,i)),this.ipc.registerChannel(ee.REMOTE_TERMINAL_CHANNEL_NAME,new K.TerminalProviderChannel(i)),e(new U.default(s))})})}async getDebugPort(){}}})),define(t[212],i([0,1,34,14,59,196,198,106]),(function(e,t,i,r,n,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
r.setUnexpectedErrorHandler(e=>n.logger.warn(e instanceof Error?e.message:e)),s.enableCustomMarketplace(),a.monkeyPatch(!0);const l=process.exit;if(process.exit=function(e){n.logger.warn(`process.exit() was prevented: ${e||"unknown code"}.`)},void 0!==process.env.CODE_SERVER_PARENT_PID){const e=parseInt(process.env.CODE_SERVER_PARENT_PID,10);setInterval(()=>{try{process.kill(e,0)}catch(e){l()}},5e3)}else n.logger.error("no parent process"),l(1);const c=new o.Vscode,u=e=>{if(!process.send)throw new Error("not spawned with IPC");process.send(e)};process.on("message",async(e,t)=>{switch(n.logger.debug("got message from code-server",i.field("type",e.type)),n.logger.trace("code-server message content",i.field("message",e)),e.type){case"init":try{const t=await c.initialize(e.options);u({type:"options",id:e.id,options:t})}catch(e){n.logger.error(e.message),n.logger.error(e.stack),l(1)}break;case"cli":try{await c.cli(e.args),l(0)}catch(e){n.logger.error(e.message),n.logger.error(e.stack),l(1)}break;case"socket":
c.handleWebSocket(t,e.query)}}),process.send?u({type:"ready"}):(n.logger.error("not spawned with IPC"),l(1))}))}).call(this);
//# sourceMappingURL=entry.js.map
